--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET lock_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

CREATE TABLE country_name (
    country_code character varying(2),
    name hstore,
    country_default_language_code character varying(2),
    partition integer
);

COPY country_name (country_code, name, country_default_language_code, partition) FROM stdin;
gb	"name"=>"United Kingdom", "name:af"=>"Verenigde Koninkryk", "name:ar"=>"المملكة المتحدة", "name:be"=>"Вялікабрытанія", "name:br"=>"Rouantelezh Unanet", "name:ca"=>"Regne Unit", "name:cy"=>"Y Deyrnas Unedig", "name:da"=>"Storbritannien", "name:de"=>"Vereinigtes Königreich", "name:el"=>"Ηνωμένο Βασίλειο", "name:eo"=>"Unuiĝinta Reĝlando", "name:es"=>"Gran Bretaña", "name:et"=>"Suurbritannia", "name:fa"=>"بریتانیا", "name:fi"=>"Yhdistynyt kuningaskunta", "name:fr"=>"Royaume-Uni", "name:fy"=>"Grut-Brittanje", "name:ga"=>"An Ríocht Aontaithe", "name:gd"=>"An Rìoghachd Aonaichte", "name:gv"=>"Reeriaght Unnaneysit", "name:he"=>"בריטניה", "name:hr"=>"Velika Britanija", "name:hu"=>"Nagy-Britannia", "name:hy"=>"Միացյալ Թագավորություն", "name:id"=>"Britania Raya", "name:is"=>"Bretland", "name:it"=>"Gran Bretagna", "name:ja"=>"イギリス", "name:la"=>"Britanniarum Regnum", "name:lb"=>"Groussbritannien an Nordirland", "name:li"=>"Vereineg Keuninkriek", "name:lt"=>"Jungtinė Karalystė", "name:mn"=>"Нэгдсэн Вант Улс", "name:nl"=>"Verenigd Koninkrijk", "name:no"=>"Storbritania", "name:pl"=>"Wielka Brytania", "name:pt"=>"Reino Unido", "name:ru"=>"Соединенное Королевство", "name:sk"=>"Spojené kráľovstvo", "name:sl"=>"Velika Britanija", "name:sv"=>"Storbritannien", "name:th"=>"สหราชอาณาจักร", "name:tr"=>"Birleşik Krallık", "name:uk"=>"Великобританія", "name:vi"=>"Liên hiệp Vương quốc Anh và Bắc Ireland", "name:zh"=>"英国", "alt_name"=>"United Kingdom; UK; Britain; Great Britain", "name:nds"=>"Vereenigd Königriek", "name:zh_py"=>"Yingguo", "name:zh_pyt"=>"Yīngguó", "official_name"=>"United Kingdom of Great Britain and Northern Ireland", "official_name:be"=>"Злучанае Каралеўства Вялікабрытаніі і Паўночнай Ірландыі", "official_name:br"=>"Rouantelezh Unanet Breizh-Veur ha Norzhiwerzhon", "official_name:el"=>"Ηνωμένο Βασίλειο της Μεγάλης Βρετανίας και της Βορείου Ιρλανδίας", "official_name:es"=>"Reino Unido de Gran Bretaña", "official_name:et"=>"Suurbritannia ja Põhja-Iiri Ühendkuningriik", "official_name:fr"=>"Royaume-Uni de Grande-Bretagne et d'Irlande du Nord", "official_name:id"=>"Perserikatan Kerajaan Britania Raya dan Irlandia Utara", "official_name:ja"=>"グレートブリテン及び北アイルランド連合王国", "official_name:lb"=>"Vereenegt Kinnekräich vu Groussbritannien an Nordirland", "official_name:pl"=>"Zjednoczone Królestwo Wielkiej Brytanii", "official_name:pt"=>"Reino Unido da Grã-Bretanha e Irlanda do Norte", "official_name:ru"=>"Соединенное Королевство Великобритании и Северной Ирландии", "official_name:sk"=>"Spojené kráľovstvo Veľkej Británie a Severného Írska", "official_name:sl"=>"Združeno kraljestvo Velike Britanije in Severne Irske", "official_name:sv"=>"Förenade konungariket Storbritannien och Nordirland"	en	1
us	"name"=>"United States of America", "name:af"=>"Verenigde State van Amerika", "name:ar"=>"الولايات المتحدة الأمريكية", "name:be"=>"Злучаныя Штаты Амерыкі", "name:br"=>"Stadoù Unanet Amerika", "name:ca"=>"Estats Units d'Amèrica", "name:cy"=>"Unol Daleithiau America", "name:da"=>"USA", "name:de"=>"Vereinigte Staaten von Amerika", "name:el"=>"Ηνωμένες Πολιτείες της Αμερικής", "name:en"=>"United States of America", "name:eo"=>"Usono", "name:es"=>"Estados Unidos", "name:et"=>"Ameerika Ühendriigid", "name:fa"=>"ایالات متحده آمریکا", "name:fi"=>"Yhdysvallat", "name:fr"=>"États-Unis", "name:fy"=>"de Feriene Steaten fan Amearika", "name:ga"=>"Stáit Aontaithe Mheiriceá", "name:gd"=>"Na Stàitean Aonaichte", "name:he"=>"ארצות הברית של אמריקה", "name:hr"=>"Sjedinjene Američke Države", "name:hu"=>"Amerikai Egyesült Államok", "name:hy"=>"Ամերիկայի Միացյալ Նահանգներ", "name:id"=>"Amerika Serikat", "name:is"=>"Bandaríkin", "name:it"=>"Stati Uniti d'America", "name:ja"=>"アメリカ合衆国", "name:la"=>"Civitates Foederatae Americae", "name:lb"=>"Vereenegt Staate vun Amerika", "name:li"=>"Vereinegde State van Amerika", "name:lt"=>"Jungtinės Amerikos Valstijos", "name:mn"=>"Америкийн Нэгдсэн Улс", "name:nb"=>"USA", "name:nl"=>"Verenigde Staten van Amerika", "name:nn"=>"USA", "name:no"=>"USA", "name:pl"=>"Stany Zjednoczone Ameryki", "name:pt"=>"Estados Unidos", "name:ru"=>"Соединённые Штаты Америки", "name:sl"=>"Združene države Amerike", "name:sv"=>"USA", "name:th"=>"สหรัฐอเมริกา", "name:tr"=>"Amerika Birleşik Devletleri", "name:uk"=>"Сполучені Штати Америки", "name:vi"=>"Hoa Kỳ", "name:zh"=>"美国", "alt_name"=>"USA;US;The States", "name:zh_py"=>"Meiguo", "name:zh_pyt"=>"Měiguó", "official_name:fr"=>"États-Unis d'Amérique", "official_name:pt"=>"Estados Unidos da América", "official_name:sv"=>"Amerikas förenta stater", "official_name:vi"=>"Hợp chúng quốc Hoa Kỳ"	en	2
de	"name"=>"Deutschland", "name:af"=>"Duitsland", "name:ar"=>"ألمانيا", "name:az"=>"Almaniya", "name:be"=>"Германія", "name:bg"=>"Германия", "name:br"=>"Alamagn", "name:ca"=>"Alemanya", "name:cy"=>"Yr Almaen", "name:da"=>"Tyskland", "name:el"=>"Γερμανία", "name:en"=>"Germany", "name:eo"=>"Germanio", "name:es"=>"Alemania", "name:et"=>"Saksamaa", "name:eu"=>"Alemania", "name:fa"=>"آلمان", "name:fi"=>"Saksa", "name:fr"=>"Allemagne", "name:fy"=>"Dútslân", "name:ga"=>"An Ghearmáin", "name:gd"=>"A' Ghearmailt", "name:he"=>"גרמניה", "name:hr"=>"Njemačka", "name:hu"=>"Németország", "name:hy"=>"Գերմանիա", "name:id"=>"Jerman", "name:is"=>"Þýskaland", "name:it"=>"Germania", "name:ja"=>"ドイツ", "name:ka"=>"გერმანია", "name:ko"=>"독일", "name:la"=>"Germania", "name:lb"=>"Däitschland", "name:li"=>"Duutsland", "name:lt"=>"Vokietija", "name:lv"=>"Vācija", "name:mn"=>"Герман", "name:nl"=>"Duitsland", "name:pl"=>"Niemcy", "name:pt"=>"Alemanha", "name:ru"=>"Германия", "name:sk"=>"Nemecko", "name:sl"=>"Nemčija", "name:sv"=>"Tyskland", "name:th"=>"ประเทศเยอรมนี", "name:tr"=>"Almanya", "name:uk"=>"Німеччина", "name:vi"=>"Đức", "name:zh"=>"德国", "name:haw"=>"Kelemānia", "name:nds"=>"Düütschland", "name:vls"=>"Duutsland", "name:zh_py"=>"Deguo", "name:zh_pyt"=>"Déguó", "official_name:el"=>"Ομοσπονδιακή Δημοκρατία της Γερμανίας", "official_name:fr"=>"République fédérale d'Allemagne", "official_name:gd"=>"Poblachd Caidreachail na Gearmailt", "official_name:id"=>"Republik Federal Jerman", "official_name:it"=>"Repubblica Federale Tedesca", "official_name:lb"=>"Bundesrepublik Däitschland", "official_name:lt"=>"Vokietijos Federacinė Respublika", "official_name:pt"=>"República Federal da Alemanha", "official_name:sk"=>"Nemecká spolková republika", "official_name:sv"=>"Förbundsrepubliken Tyskland", "official_name:vi"=>"Cộng hoà Liên bang Đức"	de	3
fr	"name"=>"France", "name:af"=>"Frankryk", "name:ar"=>"فرنسا", "name:az"=>"Fransa", "name:be"=>"Францыя", "name:bg"=>"Франция", "name:br"=>"Frañs", "name:ca"=>"França", "name:cy"=>"Ffrainc", "name:da"=>"Frankrig", "name:de"=>"Frankreich", "name:el"=>"Γαλλία", "name:en"=>"France", "name:eo"=>"Francio", "name:es"=>"Francia", "name:et"=>"Prantsusmaa", "name:fa"=>"فرانسه", "name:fi"=>"Ranska", "name:fr"=>"France", "name:fy"=>"Frankryk", "name:ga"=>"An Fhrainc", "name:gd"=>"An Fhraing", "name:gv"=>"Yn Rank", "name:he"=>"צרפת", "name:hr"=>"Francuska", "name:hu"=>"Franciaország", "name:hy"=>"Ֆրանսիա", "name:id"=>"Perancis", "name:is"=>"Frakkland", "name:it"=>"Francia", "name:ja"=>"フランス", "name:ka"=>"საფრანგეთი", "name:ko"=>"프랑스", "name:la"=>"Francia", "name:lb"=>"Frankräich", "name:li"=>"Frankriek", "name:lt"=>"Prancūzija", "name:lv"=>"Francija", "name:mn"=>"Франц", "name:nl"=>"Frankrijk", "name:pl"=>"Francja", "name:pt"=>"França", "name:ru"=>"Франция", "name:sk"=>"Francúzsko", "name:sl"=>"Francija", "name:sv"=>"Frankrike", "name:th"=>"ประเทศฝรั่งเศส", "name:tr"=>"Fransa", "name:uk"=>"Франція", "name:vi"=>"Pháp", "name:zh"=>"法国", "name:haw"=>"Palani", "name:nds"=>"Frankriek", "name:zh_py"=>"Faguo", "name:zh_pyt"=>"Fǎguó", "official_name"=>"République française", "official_name:be"=>"Французская Рэспубліка", "official_name:el"=>"Γαλλική Δημοκρατία", "official_name:et"=>"Prantsuse Vabariik", "official_name:gd"=>"Poblachd na Frainge", "official_name:id"=>"Republik Perancis", "official_name:lb"=>"Franséisch Republik", "official_name:lt"=>"Prancūzijos Respublika", "official_name:pt"=>"República Francesa", "official_name:sk"=>"Francúzska republika", "official_name:sv"=>"Republiken Frankrike", "official_name:vi"=>"Cộng hòa Pháp"	fr	4
ch	"name"=>"Switzerland", "name:af"=>"Switserland", "name:am"=>"ስዊዘርላንድ", "name:an"=>"Suiza", "name:ar"=>"سويسرا", "name:az"=>"İsveçrə", "name:be"=>"Швейцарыя", "name:bg"=>"Швейцария", "name:bo"=>"སུད་སི།", "name:br"=>"Suis", "name:bs"=>"Švicarska", "name:ca"=>"Suïssa", "name:cs"=>"Švýcarsko", "name:cv"=>"Швейцари", "name:cy"=>"Y Swistir", "name:da"=>"Schweiz", "name:de"=>"Schweiz", "name:dv"=>"ސުވިޒަލޭންޑު", "name:dz"=>"སུའིཊ་ཛར་ལེན་", "name:ee"=>"Switzerland", "name:el"=>"Ελβετία", "name:en"=>"Switzerland", "name:eo"=>"Svislando", "name:es"=>"Suiza", "name:et"=>"Šveits", "name:eu"=>"Suitza", "name:fa"=>"سوئیس", "name:fi"=>"Sveitsi", "name:fo"=>"Sveis", "name:fr"=>"Suisse", "name:fy"=>"Switserlân", "name:ga"=>"An Eilbhéis", "name:gd"=>"An Eilbheis", "name:gl"=>"Suíza", "name:gv"=>"Yn Elveeish", "name:he"=>"שוויץ", "name:hi"=>"स्विट्ज़रलैंड", "name:hr"=>"Švicarska", "name:ht"=>"Swis", "name:hu"=>"Svájc", "name:hy"=>"Շվեյցարիա", "name:ia"=>"Suissa", "name:id"=>"Swiss", "name:ie"=>"Svissia", "name:io"=>"Suisia", "name:is"=>"Sviss", "name:it"=>"Svizzera", "name:ja"=>"スイス", "name:jv"=>"Swiss", "name:ka"=>"შვეიცარია", "name:kg"=>"Suisi", "name:kk"=>"Швейцария", "name:kl"=>"Schweizi", "name:kn"=>"ಸ್ವಿಟ್ಜರ್ಲ್ಯಾಂಡ್", "name:ko"=>"스위스", "name:ku"=>"Swîsre", "name:kv"=>"Швейцария", "name:kw"=>"Swistir", "name:ky"=>"Швейцария", "name:la"=>"Helvetia", "name:lb"=>"Schwäiz", "name:li"=>"Zweitserland", "name:ln"=>"Swisi", "name:lt"=>"Šveicarija", "name:lv"=>"Šveice", "name:mg"=>"Soisa", "name:mk"=>"Швајцарија", "name:ml"=>"സ്വിറ്റ്സര്‍ലാന്റ്", "name:mn"=>"Швейцари", "name:mr"=>"स्वित्झर्लंड", "name:ms"=>"Switzerland", "name:na"=>"Switzerland", "name:ne"=>"स्विजरल्याण्ड", "name:nl"=>"Zwitserland", "name:nn"=>"Sveits", "name:no"=>"Sveits", "name:oc"=>"Soïssa", "name:os"=>"Швейцари", "name:pl"=>"Szwajcaria", "name:pt"=>"Suíça", "name:qu"=>"Suwisa", "name:rm"=>"Svizra", "name:ro"=>"Elveţia", "name:ru"=>"Швейцария", "name:sa"=>"स्विटजरलैंड", "name:se"=>"Šveica", "name:sk"=>"Švajčiarsko", "name:sl"=>"Švica", "name:so"=>"Iswiizerlaan", "name:sq"=>"Zvicra", "name:sr"=>"Швајцарска", "name:sv"=>"Schweiz", "name:sw"=>"Uswisi", "name:ta"=>"சுவிட்சர்லாந்து", "name:te"=>"స్విట్జర్లాండ్", "name:tg"=>"Швейтсария", "name:th"=>"ประเทศสวิตเซอร์แลนด์", "name:tl"=>"Suwisa", "name:tr"=>"İsviçre", "name:ug"=>"Shwétsariye", "name:uk"=>"Швейцарія", "name:ur"=>"سویٹزر لینڈ", "name:vi"=>"Thụy Sĩ", "name:vo"=>"Jveizän", "name:wo"=>"Suwis", "name:yi"=>"שווייץ", "name:zh"=>"瑞士", "name:als"=>"Schweiz", "name:ang"=>"Sƿissland", "name:arc"=>"ܣܘܝܣܪܐ", "name:arz"=>"سويسرا", "name:ast"=>"Suiza", "name:bar"=>"Schweiz", "name:bcl"=>"Suisa", "name:bpy"=>"সুইজারল্যান্ড", "name:ceb"=>"Swisa", "name:csb"=>"Szwajcarskô", "name:diq"=>"İswiçre", "name:dsb"=>"Šwicarska", "name:eml"=>"Svézzra", "name:frp"=>"Suisse", "name:fur"=>"Svuizare", "name:haw"=>"Kuikilani", "name:hif"=>"Switzerland", "name:hsb"=>"Šwicarska", "name:ilo"=>"Switzerland", "name:jbo"=>"elvetias", "name:ksh"=>"Shwäĳz", "name:lad"=>"Suisa", "name:lij"=>"Svissëa", "name:lmo"=>"Svìzzera", "name:mdf"=>"Швейцария", "name:mhr"=>"Швейцарий", "name:nah"=>"Suiza", "name:nap"=>"Sguizzera", "name:nds"=>"Swiez", "name:nov"=>"Suisia", "name:nrm"=>"Suisse", "name:pag"=>"Switzerland", "name:pam"=>"Suiza", "name:pdc"=>"Schweiz", "name:pih"=>"Switsaland", "name:pms"=>"Svìssera", "name:pnt"=>"Ελβετία", "name:sah"=>"Швейцария", "name:scn"=>"Svìzzira", "name:sco"=>"Swisserland", "name:stq"=>"Swaits", "name:szl"=>"Szwajcaryjo", "name:tet"=>"Suisa", "name:udm"=>"Швейцария", "name:vec"=>"Svìzera", "name:war"=>"Swiza", "name:wuu"=>"瑞士", "name:xal"=>"Свисн Һазр", "name:zea"=>"Zwitserland", "name:zh_py"=>"Ruishi", "name:nds-nl"=>"Zwitserlaand", "name:simple"=>"Switzerland", "name:zh-yue"=>"瑞士", "name:zh_pyt"=>"Ruìshì", "name:bat-smg"=>"Šveicarėjė", "name:fiu-vro"=>"Sveits", "name:be-x-old"=>"Швейцарыя", "name:zh-min-nan"=>"Sūi-se", "official_name:de"=>"Schweizerische Eidgenossenschaft", "official_name:el"=>"Ελβετική Συνομοσπονδία", "official_name:en"=>"Swiss Confederation", "official_name:fr"=>"Confédération suisse", "official_name:id"=>"Konfederasi Swiss", "official_name:it"=>"Confederazione Svizzera", "official_name:ja"=>"スイス連邦", "official_name:la"=>"Confoederatio Helvetica", "official_name:lb"=>"Schwäizeresch Eidgenossenschaft", "official_name:rm"=>"Confederaziun svizra", "official_name:sk"=>"Švajčiarska konfederácia", "official_name:sv"=>"Schweiziska edsförbundet", "official_name:vi"=>"Liên bang Thụy Sĩ", "name:zh-classical"=>"瑞士"	\N	5
ba	"name"=>"Bosna i Hercegovina", "name:af"=>"Bosnië-Herzegowina", "name:an"=>"Bosnia e Erzegobina", "name:ar"=>"البوسنة والهرسك", "name:az"=>"Bosniya və Herseqovina", "name:be"=>"Боснія і Герцагавіна", "name:bg"=>"Босна и Херцеговина", "name:bn"=>"বসনিয়া ও হার্জেগোভিনা", "name:br"=>"Bosnia-ha-Herzegovina", "name:bs"=>"Bosna i Hercegovina", "name:ca"=>"Bòsnia i Hercegovina", "name:cs"=>"Bosna a Hercegovina", "name:cu"=>"Босна́", "name:cv"=>"Босни тата Герцеговина", "name:cy"=>"Bosna a Hercegovina", "name:da"=>"Bosnien-Hercegovina", "name:de"=>"Bosnien und Herzegowina", "name:dv"=>"ބޮސްނިޔާ ހަރުޒެގޮވީނާ", "name:ee"=>"Bosnia and Herzegovina", "name:el"=>"Βοσνία και Ερζεγοβίνη", "name:en"=>"Bosnia and Herzegovina", "name:eo"=>"Bosnio kaj Hercegovino", "name:es"=>"Bosnia y Herzegovina", "name:et"=>"Bosnia ja Hertsegoviina", "name:eu"=>"Bosnia-Herzegovina", "name:fa"=>"بوسنی و هرزگووین", "name:fi"=>"Bosnia ja Hertsegovina", "name:fr"=>"Bosnie-Herzégovine", "name:fy"=>"Bosnje", "name:ga"=>"An Bhoisnia-Heirseagaivéin", "name:gd"=>"Bosna agus Heartsagobhana", "name:gl"=>"Bosnia e Hercegovina", "name:gn"=>"Vonia ha Hesegovina", "name:gv"=>"Bosnia as Herzegovina", "name:he"=>"בוסניה הרצגובינה", "name:hi"=>"बॉस्निया और हर्ज़ेगोविना", "name:hr"=>"Bosna i Hercegovina", "name:ht"=>"Bosni ak Erzegovin", "name:hu"=>"Bosznia-Hercegovina", "name:hy"=>"Բոսնիա և Հերցեգովինա", "name:ia"=>"Bosnia e Herzegovina", "name:id"=>"Bosnia dan Herzegovina", "name:ie"=>"Bosnia e Herzegovina", "name:is"=>"Bosnía og Hersegóvína", "name:it"=>"Bosnia-Erzegovina", "name:ja"=>"ボスニア・ヘルツェゴビナ", "name:jv"=>"Bosnia-Herzegovina", "name:ka"=>"ბოსნია და ჰერცეგოვინა", "name:kg"=>"Bosna", "name:kk"=>"Босния және Герцеговина", "name:kn"=>"ಬೊಸ್ನಿಯ ಮತ್ತು ಹೆರ್ಜೆಗೊವಿನ", "name:ko"=>"보스니아 헤르체고비나", "name:ks"=>"बास्निया", "name:ku"=>"Bosniya û Herzegovîna", "name:kv"=>"Босния да Герцеговина", "name:kw"=>"Bosni–Hercegovina", "name:la"=>"Bosnia et Herzegovina", "name:lb"=>"Bosnien-Herzegowina", "name:li"=>"Bosnië en Hercegovina", "name:ln"=>"Bosnia na Erzegovina", "name:lt"=>"Bosnija ir Hercogovina", "name:lv"=>"Bosnija un Hercegovina", "name:mk"=>"Босна и Херцеговина", "name:ml"=>"ബോസ്നിയ ഹെര്‍സെഗോവിന", "name:mn"=>"Босни-Герцеговин", "name:mr"=>"बॉस्निया आणि हर्झगोव्हिना", "name:ms"=>"Bosnia dan Herzegovina", "name:mt"=>"Bożnija u Ħerżegovina", "name:na"=>"Bosnia me Herzegowina", "name:ne"=>"बोस्निया र हर्जगोविना", "name:nl"=>"Bosnië en Herzegovina", "name:nn"=>"Bosnia-Hercegovina", "name:no"=>"Bosnia-Hercegovina", "name:oc"=>"Bòsnia e Ercegovina", "name:os"=>"Босни æмæ Герцеговинæ", "name:pl"=>"Bośnia i Hercegowina", "name:ps"=>"بوسنيا او هېرزګوينا", "name:pt"=>"Bósnia e Herzegovina", "name:qu"=>"Busna-Hirsiquwina", "name:rm"=>"Bosnia-Erzegovina", "name:ro"=>"Bosnia şi Herţegovina", "name:ru"=>"Босния и Герцеговина", "name:sa"=>"बास्निया", "name:se"=>"Bosnia ja Hercegovina", "name:sh"=>"Bosna i Hercegovina", "name:sk"=>"Bosna a Hercegovina", "name:sl"=>"Bosna in Hercegovina", "name:sq"=>"Bosnja dhe Hercegovina", "name:sr"=>"Босна и Херцеговина", "name:sv"=>"Bosnien och Hercegovina", "name:sw"=>"Bosnia na Herzegovina", "name:ta"=>"பொசுனியா எர்செகோவினா", "name:te"=>"బోస్నియా మరియు హెర్జెగొవీనా", "name:tg"=>"Босния ва Ҳерсеговина", "name:th"=>"ประเทศบอสเนียและเฮอร์เซโกวีนา", "name:tl"=>"Bosnia at Herzegovina", "name:tr"=>"Bosna Hersek", "name:ug"=>"بوسنىيە ۋە ھېرسېگوۋىنا", "name:uk"=>"Боснія і Герцеговина", "name:ur"=>"بوسنیا و ہرزیگووینا", "name:uz"=>"Bosniya va Gerzegovina", "name:vi"=>"Bosna và Hercegovina", "name:vo"=>"Bosnän e Härzegovän", "name:wo"=>"Bosni", "name:zh"=>"波斯尼亚和黑塞哥维纳", "name:als"=>"Bosnie-Herzegowina", "name:ang"=>"Bosnia and Herzegovina", "name:arc"=>"ܒܘܣܢܐ ܘܗܪܣܟ", "name:arz"=>"البوسنه و الهرسك", "name:ast"=>"Bosnia-Herzegovina", "name:bcl"=>"Bosnya asin Hersegobina", "name:bpy"=>"বসনিয়া বারো হার্জেগোভিনা", "name:ceb"=>"Bosnia ug Herzegovina", "name:chr"=>"ᏉᏍᏂᏯ", "name:crh"=>"Bosna ve Hersek", "name:csb"=>"Bòsnijô ë Hercegòwina", "name:diq"=>"Bosna-Hersek", "name:dsb"=>"Bosniska-Hercegowinska", "name:frp"=>"Bosnie-Hèrzègovena", "name:haw"=>"Bosenia me Hesegowina", "name:hif"=>"Bosnia and Herzegovina", "name:hsb"=>"Bosniska a Hercegowina", "name:lij"=>"Bòsnia-Erçegòvina", "name:lmo"=>"Bosnia e Erzegovina", "name:nah"=>"Bosna īhuān Hertzegovina", "name:nap"=>"Bosnia-Erzegovina", "name:nds"=>"Bosnien-Herzegowina", "name:nov"=>"Bosnia e Hertsegovina", "name:pam"=>"Bosnia and Herzegovina", "name:pap"=>"Bosnia Herzogovina", "name:pih"=>"Bosnya a' Hersegowinya", "name:pms"=>"Bòsnia e Erzegòvina", "name:pnb"=>"بوسنیا تے ہرزیگوونا", "name:pnt"=>"Βοσνία και Ερζεγοβίνη", "name:sah"=>"Босния уонна Херцеговина", "name:scn"=>"Bosnia-Erzegovina", "name:sco"=>"Bosnie an Herzegovinae", "name:srn"=>"Bosnikondre", "name:stq"=>"Bosnien un Herzegowina", "name:szl"=>"Bośńa a Hercegowina", "name:udm"=>"Босния но Герцеговина", "name:vec"=>"Bosnia e Erzegòvina", "name:war"=>"Bosnya ngan Hersegovina", "name:wuu"=>"波斯尼亚", "name:zh_py"=>"Bosiniya he Heisaigeweina", "name:simple"=>"Bosnia and Herzegovina", "name:zh-yue"=>"波斯尼亞", "name:zh_pyt"=>"Bōsīníyà hé Hēisāigēwéinà", "name:bat-smg"=>"Bosnėjė ėr Hercuogovėna", "name:fiu-vro"=>"Bosnia ja Hertsegoviina", "name:roa-rup"=>"Bosna shi Hertsegovina", "name:be-x-old"=>"Босьнія і Герцагавіна", "name:zh-min-nan"=>"Bosna kap Hercegovina", "official_name:id"=>"Republik Bosnia dan Herzegovina", "official_name:lv"=>"Bosnijas un Hercegovinas Republika", "official_name:pt"=>"República da Bósnia e Herzegovina"	\N	6
fi	"name"=>"Suomi", "name:af"=>"Finland", "name:am"=>"ፊንላንድ", "name:an"=>"Finlandia", "name:ar"=>"فنلندا", "name:az"=>"Finlandiya", "name:be"=>"Фінляндыя", "name:bg"=>"Финландия", "name:bm"=>"Finland", "name:bn"=>"ফিনল্যান্ড", "name:bo"=>"ཧྥིན་ལན", "name:br"=>"Finland", "name:bs"=>"Finska", "name:ca"=>"Finlàndia", "name:ce"=>"Финлянди", "name:co"=>"Finlandia", "name:cs"=>"Finsko", "name:cu"=>"Соумь", "name:cv"=>"Финлянди", "name:cy"=>"Y Ffindir", "name:da"=>"Finland", "name:de"=>"Finnland", "name:dv"=>"ފިންލޭންޑު", "name:dz"=>"ཕིན་ལེནཌ་", "name:ee"=>"Finland", "name:el"=>"Φινλανδία", "name:en"=>"Finland", "name:eo"=>"Finnlando", "name:es"=>"Finlandia", "name:et"=>"Soome", "name:eu"=>"Finlandia", "name:fa"=>"فنلاند", "name:fi"=>"Suomi", "name:fo"=>"Finnland", "name:fr"=>"Finlande", "name:fy"=>"Finlân", "name:ga"=>"An Fhionlainn", "name:gd"=>"Suòmaidh", "name:gl"=>"Finlandia", "name:gn"=>"Hĩlandia", "name:gv"=>"Finnlynn", "name:he"=>"פינלנד", "name:hi"=>"फ़िनलैंड", "name:hr"=>"Finska", "name:ht"=>"Fenlann", "name:hu"=>"Finnország", "name:hy"=>"Ֆինլանդիա", "name:ia"=>"Finlandia", "name:id"=>"Finlandia", "name:ie"=>"Finland", "name:io"=>"Finlando", "name:is"=>"Finnland", "name:it"=>"Finlandia", "name:ja"=>"フィンランド", "name:ka"=>"ფინეთი", "name:kk"=>"Финландия", "name:kl"=>"Finlandi", "name:ko"=>"핀란드", "name:ks"=>"फिन्लैंड", "name:ku"=>"Fînland", "name:kv"=>"Финляндия", "name:kw"=>"Pow Finn", "name:ky"=>"Финляндия", "name:la"=>"Finnia", "name:lb"=>"Finnland", "name:lg"=>"Finilandi", "name:li"=>"Finland", "name:ln"=>"Finilanda", "name:lt"=>"Suomija", "name:lv"=>"Somija", "name:mk"=>"Финска", "name:mn"=>"Финлянд", "name:ms"=>"Finland", "name:mt"=>"Finlandja", "name:na"=>"Finland", "name:ne"=>"फिनल्याण्ड", "name:nl"=>"Finland", "name:nn"=>"Finland", "name:no"=>"Finland", "name:oc"=>"Finlàndia", "name:os"=>"Финлянди", "name:pl"=>"Finlandia", "name:pt"=>"Finlândia", "name:qu"=>"Phinsuyu", "name:rm"=>"Finlanda", "name:ro"=>"Finlanda", "name:ru"=>"Финляндия", "name:sa"=>"फिन्लैंड", "name:sc"=>"Finlandia", "name:se"=>"Suopma", "name:sh"=>"Finska", "name:sk"=>"Fínsko", "name:sl"=>"Finska", "name:sm"=>"Finalagi", "name:so"=>"Finland", "name:sq"=>"Finlanda", "name:sr"=>"Финска", "name:sv"=>"Finland", "name:sw"=>"Ufini", "name:ta"=>"பின்லாந்து", "name:te"=>"ఫిన్లెండ్", "name:tg"=>"Финланд", "name:th"=>"ประเทศฟินแลนด์", "name:tl"=>"Pinlandiya", "name:tr"=>"Finlandiya", "name:tt"=>"Finlândiä", "name:ug"=>"فىنلاندىيە", "name:uk"=>"Фінляндія", "name:ur"=>"فن لینڈ", "name:uz"=>"Finlandiya", "name:vi"=>"Phần Lan", "name:vo"=>"Suomiyän", "name:wa"=>"Finlande", "name:wo"=>"Finlaand", "name:yi"=>"פינלאנד", "name:yo"=>"Finlandi", "name:zh"=>"芬兰", "name:als"=>"Finnland", "name:ang"=>"Finnland", "name:arc"=>"ܦܢܠܢܕܐ", "name:ast"=>"Finlandia", "name:bar"=>"Finnlånd", "name:bcl"=>"Finlandya", "name:bpy"=>"ফিনল্যান্ড", "name:ceb"=>"Finlandia", "name:crh"=>"Finlandiya", "name:csb"=>"Fińskô", "name:diq"=>"Finlanda", "name:dsb"=>"Finska", "name:frp"=>"Finlande", "name:fur"=>"Finlande", "name:gan"=>"芬蘭", "name:hak"=>"Fûn-làn", "name:haw"=>"Pinilana", "name:hif"=>"Finland", "name:hsb"=>"Finska", "name:ilo"=>"Finlandia", "name:jbo"=>"finland", "name:ksh"=>"Finnlandt", "name:lij"=>"Finlandia", "name:lmo"=>"Finlandia", "name:mdf"=>"Суоми мастор", "name:mhr"=>"Суоми Эл", "name:myv"=>"Суоми Мастор", "name:nah"=>"Fintlālpan", "name:nds"=>"Finnland", "name:new"=>"फिनल्यान्ड", "name:nov"=>"Finlande", "name:nrm"=>"Fînlande", "name:pam"=>"Finland", "name:pih"=>"Finland", "name:pms"=>"Finlandia", "name:pnt"=>"Φινλανδία", "name:rmy"=>"Finland", "name:sah"=>"Финляндия", "name:scn"=>"Finlandia", "name:sco"=>"Finland", "name:stq"=>"Finlound", "name:szl"=>"Finlandyjo", "name:tet"=>"Finlándia", "name:tpi"=>"Pinlan", "name:udm"=>"Финляндия", "name:vec"=>"Finlandia", "name:vls"=>"Finland", "name:war"=>"Finlandya", "name:zea"=>"Finland", "name:zh_py"=>"Fenlan", "name:nds-nl"=>"Finlaand", "name:zh_pyt"=>"Fēnlán", "name:bat-smg"=>"Soumėjė", "name:fiu-vro"=>"Soomõ", "name:roa-rup"=>"Finlanda", "official_name"=>"Suomen tasavalta", "name:zh-min-nan"=>"Suomi", "official_name:be"=>"Фінляндская Рэспубліка", "official_name:da"=>"Repbulikken Finland", "official_name:de"=>"Republik Finnland", "official_name:el"=>"Δημοκρατία της Φινλανδίας", "official_name:en"=>"Republic of Finland", "official_name:es"=>"República de Finlandia", "official_name:et"=>"Soome Vabariik", "official_name:fi"=>"Suomen tasavalta", "official_name:fr"=>"République de Finlande", "official_name:id"=>"Republik Finlandia", "official_name:is"=>"Lýðveldið Finnland", "official_name:it"=>"Repubblica di Finlandia", "official_name:ja"=>"フィンランド共和国", "official_name:lt"=>"Suomijos Respublika", "official_name:nn"=>"Republikken Finland", "official_name:no"=>"Republikken Finland", "official_name:pt"=>"República da Finlândia", "official_name:ru"=>"Финляндская Республика", "official_name:sk"=>"Fínska republika", "official_name:sv"=>"Republiken Finland", "official_name:vi"=>"Cộng hòa Phần Lan"	\N	20
by	"name"=>"Беларусь", "name:af"=>"Wit-Rusland", "name:am"=>"ቤላሩስ", "name:an"=>"Belarrusia", "name:ar"=>"بيلاروس", "name:az"=>"Belorusiya", "name:be"=>"Беларусь", "name:bg"=>"Беларус", "name:bn"=>"বেলারুশ", "name:br"=>"Belarus", "name:bs"=>"Bjelorusija", "name:ca"=>"Bielorússia", "name:ce"=>"Белороссе", "name:cs"=>"Bělorusko", "name:cu"=>"Бѣла́ Роу́сь", "name:cv"=>"Белоруси", "name:cy"=>"Belarws", "name:da"=>"Hviderusland", "name:de"=>"Weißrussland", "name:dv"=>"ބެލާރުސް", "name:dz"=>"བེ་ལ་རུ་སུ།", "name:ee"=>"Belarus", "name:el"=>"Λευκορωσία", "name:en"=>"Belarus", "name:eo"=>"Belorusio", "name:es"=>"Bielorrusia", "name:et"=>"Valgevene", "name:eu"=>"Bielorrusia", "name:fa"=>"بلاروس", "name:fi"=>"Valko-Venäjä", "name:fo"=>"Hvítarussland", "name:fr"=>"Biélorussie", "name:fy"=>"Wyt-Ruslân", "name:ga"=>"An Bhealarúis", "name:gd"=>"A' Bhealaruis", "name:gl"=>"Bielorrusia", "name:gn"=>"Vielorrusia", "name:gv"=>"Yn Velaroosh", "name:he"=>"בלארוס", "name:hi"=>"बेलारूस", "name:hr"=>"Bjelorusija", "name:ht"=>"Byelorisi", "name:hu"=>"Fehéroroszország", "name:hy"=>"Բելառուս", "name:ia"=>"Bielorussia", "name:id"=>"Belarus", "name:ie"=>"Bielorussia", "name:io"=>"Bielorusia", "name:is"=>"Hvíta-Rússland", "name:it"=>"Bielorussia", "name:ja"=>"ベラルーシ", "name:jv"=>"Belarus", "name:ka"=>"ბელარუსი", "name:kg"=>"Belarusia", "name:kk"=>"Беларус", "name:kn"=>"ಬೆಲಾರುಸ್", "name:ko"=>"벨라루스", "name:ku"=>"Bêlarûs", "name:kv"=>"Беларусь", "name:kw"=>"Belarussi", "name:ky"=>"Беларусь", "name:la"=>"Ruthenia Alba", "name:lb"=>"Wäissrussland", "name:li"=>"Wit-Rusland", "name:ln"=>"Bielorusia", "name:lt"=>"Baltarusija", "name:lv"=>"Baltkrievija", "name:mk"=>"Белорусија", "name:ml"=>"ബെലാറസ്", "name:mn"=>"Беларусь", "name:mr"=>"बेलारूस", "name:ms"=>"Belarus", "name:mt"=>"Belarus", "name:na"=>"Belarus", "name:ne"=>"बेलारुस", "name:nl"=>"Wit-Rusland", "name:nn"=>"Kviterussland", "name:no"=>"Hviterussland", "name:oc"=>"Bielorussia", "name:os"=>"Белорусси", "name:pl"=>"Białoruś", "name:ps"=>"بېلاروسيه", "name:pt"=>"Bielorrússia", "name:qu"=>"Bilarus", "name:rm"=>"Bielorussia", "name:ro"=>"Belarus", "name:ru"=>"Беларусь", "name:sa"=>"बेलारूस", "name:se"=>"Vilges-Ruošša", "name:sh"=>"Belorusija", "name:sk"=>"Bielorusko", "name:sl"=>"Belorusija", "name:sq"=>"Bjellorusia", "name:sr"=>"Белорусија", "name:sv"=>"Vitryssland", "name:sw"=>"Belarus", "name:ta"=>"பெலருஸ்", "name:te"=>"బెలారస్", "name:tg"=>"Беларус", "name:th"=>"ประเทศเบลารุส", "name:tk"=>"Belarus", "name:tl"=>"Belarus", "name:tr"=>"Beyaz Rusya", "name:tt"=>"Беларусия", "name:ug"=>"بېلورۇسسىيە", "name:uk"=>"Білорусь", "name:ur"=>"بیلارس", "name:uz"=>"Belarus", "name:vi"=>"Belarus", "name:vo"=>"Belarusän", "name:wo"=>"Belaarus", "name:yi"=>"בעלארוס", "name:zh"=>"白俄罗斯", "name:als"=>"Wiissrussland", "name:ang"=>"Belarus", "name:arc"=>"ܒܠܪܘܣ", "name:ast"=>"Bielorrusia", "name:bcl"=>"Belarus", "name:bpy"=>"বেলারুস", "name:bxr"=>"Белорос", "name:ceb"=>"Belarus", "name:chr"=>"ᏇᎳᎷᏒ", "name:crh"=>"Belarus", "name:csb"=>"Biôłorëskô", "name:diq"=>"Belarus", "name:dsb"=>"Běłoruska", "name:frp"=>"Bièlorussie", "name:hak"=>"Pha̍k-ngò-lò-sṳ̂", "name:haw"=>"Belarusa", "name:hif"=>"Belarus", "name:hsb"=>"Běłoruska", "name:ilo"=>"Belarus", "name:jbo"=>"belrus", "name:lij"=>"Bieloruscia", "name:nah"=>"Belarus", "name:nds"=>"Wittrussland", "name:new"=>"बेलारुस", "name:nov"=>"Belarus", "name:pam"=>"Belarus", "name:pih"=>"Belerus", "name:pms"=>"Bielorussia", "name:pnb"=>"بیلارس", "name:rmy"=>"Belarus", "name:sah"=>"Беларусь", "name:scn"=>"Bielorussia", "name:sco"=>"Belaroushie", "name:szl"=>"Bjołoruś", "name:tpi"=>"Belaras", "name:udm"=>"Белоруссия", "name:vec"=>"Biełorusia", "name:war"=>"Bielorrusya", "name:wuu"=>"白俄罗斯", "name:xal"=>"Цаганoрсн Орн Нутг", "name:de_CH"=>"Weissrussland", "name:zh_py"=>"Baieluosi", "name:nds-nl"=>"Wit-Ruslaand", "name:simple"=>"Belarus", "name:zh-yue"=>"白俄羅斯", "name:zh_pyt"=>"Báiéluósī", "name:bat-smg"=>"Baltarosėjė", "name:fiu-vro"=>"Valgõvinne", "name:roa-rup"=>"Arusia albã", "name:be-x-old"=>"Беларусь", "official_name"=>"Рэспубліка Беларусь", "name:zh-min-nan"=>"Belarus", "official_name:be"=>"Рэспубліка Беларусь", "official_name:br"=>"Republik Belarus", "official_name:el"=>"Δημοκρατία της Λευκορωσίας", "official_name:en"=>"Republic of Belarus", "official_name:es"=>"República de Belarús", "official_name:et"=>"Valgevene Vabariik", "official_name:id"=>"Republik Belarus", "official_name:lv"=>"Baltkrievijas Republika", "official_name:pl"=>"Republika Białoruska", "official_name:pt"=>"República da Bielorrússia", "official_name:ru"=>"Республика Беларусь", "official_name:sk"=>"Bieloruská republika", "official_name:sv"=>"Republiken Vitryssland", "official_name:vi"=>"Cộng hòa Belarus"	\N	40
ck	"name"=>"Cook Islands", "name:af"=>"Cookeilande", "name:ar"=>"جزر كوك", "name:be"=>"Астравы Кука", "name:br"=>"Inizi Cook", "name:ca"=>"Illes Cook", "name:cy"=>"Ynysoedd Cook", "name:da"=>"Cook-øerne", "name:de"=>"Cookinseln", "name:el"=>"Νήσοι Κουκ", "name:en"=>"Cook Islands", "name:eo"=>"Kukinsuloj", "name:es"=>"Islas Cook", "name:et"=>"Cooki saared", "name:eu"=>"Cook Uharteak", "name:fa"=>"جزایر کوک", "name:fi"=>"Cookinsaaret", "name:fr"=>"Îles Cook", "name:fy"=>"de Cookeilannen", "name:ga"=>"Oileáin Cook", "name:he"=>"איי קוק", "name:hr"=>"Cookovi otoci", "name:hu"=>"Cook-szigetek", "name:id"=>"Kepulauan Cook", "name:is"=>"Cooks-eyjar", "name:it"=>"Isole Cook", "name:la"=>"Insulae Cook", "name:lb"=>"Cookinseln", "name:lt"=>"Kuko salos", "name:lv"=>"Kuka salas", "name:mn"=>"Күүкийн Арлууд", "name:nl"=>"Cookeilanden", "name:pl"=>"Wyspy Cooka", "name:ru"=>"Острова Кука", "name:sl"=>"Cookovo otočje", "name:sv"=>"Cooköarna", "name:th"=>"หมู่เกาะคุก", "name:tr"=>"Cook Adaları", "name:uk"=>"Острови Кука", "name:vi"=>"Quần đảo Cook", "name:zh"=>"库克群岛", "name:rar"=>"Kūki 'Āirani"	\N	41
kr	"name"=>"대한민국", "name:af"=>"Suid-Korea", "name:am"=>"ደቡብ ኮርያ", "name:an"=>"Corea d'o Sur", "name:ar"=>"كوريا الجنوبية", "name:az"=>"Cənubi Koreya", "name:be"=>"Паўднёвая Карэя", "name:bg"=>"Южна Корея", "name:bn"=>"দক্ষিণ কোরিয়া", "name:bo"=>"ལྷོ་ཀོ་རི་ཡ།", "name:br"=>"Korea ar Su", "name:bs"=>"Južna Koreja", "name:ca"=>"Corea del Sud", "name:cs"=>"Jižní Korea", "name:cy"=>"De Corea", "name:da"=>"Sydkorea", "name:de"=>"Südkorea", "name:dv"=>"ދެކުނު ކޮރެއާ", "name:dz"=>"ལྷོ་ཀོ་རི་ཡ་", "name:ee"=>"South Korea", "name:el"=>"Νότια Κορέα", "name:en"=>"South Korea", "name:eo"=>"Sud-Koreio", "name:es"=>"Corea del Sur", "name:et"=>"Lõuna-Korea", "name:eu"=>"Hego Korea", "name:fa"=>"کره جنوبی", "name:fi"=>"Etelä-Korea", "name:fr"=>"Corée du Sud", "name:fy"=>"Súd-Korea", "name:ga"=>"An Chóiré Theas", "name:gd"=>"Coirea a Deas", "name:gl"=>"Corea do Sur", "name:gu"=>"દક્ષિણ કોરિયા", "name:gv"=>"Yn Chorea Yiass", "name:he"=>"קוריאה הדרומית", "name:hi"=>"दक्षिण कोरिया", "name:hr"=>"Južna Koreja", "name:ht"=>"Kore disid", "name:hu"=>"Dél-Korea", "name:hy"=>"Հարավային Կորեա", "name:ia"=>"Corea del Sud", "name:id"=>"Korea Selatan", "name:ie"=>"Sud-Korea", "name:io"=>"Sud-Korea", "name:is"=>"Suður-Kórea", "name:it"=>"Corea del Sud", "name:ja"=>"韓国", "name:jv"=>"Koréa Kidul", "name:ka"=>"სამხრეთი კორეა", "name:kk"=>"Оңтүстік Корея", "name:kn"=>"ದಕ್ಷಿಣ ಕೊರಿಯಾ", "name:ko"=>"대한민국", "name:ks"=>"दक्षिण कोरिया", "name:ku"=>"Komara Korêyê", "name:kv"=>"Корея Республика", "name:kw"=>"Korea Dhyhow", "name:la"=>"Corea Meridionalis", "name:lb"=>"Südkorea", "name:li"=>"Zuud-Korea", "name:lt"=>"Pietų Korėja", "name:lv"=>"Dienvidkoreja", "name:mg"=>"Korea Atsimo", "name:mk"=>"Република Кореја", "name:ml"=>"ദക്ഷിണ കൊറിയ", "name:mn"=>"Өмнөд Солонгос", "name:mr"=>"दक्षिण कोरिया", "name:ms"=>"Korea Selatan", "name:mt"=>"Korea t'Isfel", "name:my"=>"တောင်ကိုရီးယားနိုင်ငံ", "name:ne"=>"दक्षिण कोरिया", "name:nl"=>"Zuid-Korea", "name:nn"=>"Sør-Korea", "name:no"=>"Sør-Korea", "name:oc"=>"Corèa del Sud", "name:os"=>"Хуссар Корей", "name:pl"=>"Korea Południowa", "name:ps"=>"سوېلي کوريا", "name:pt"=>"Coreia do Sul", "name:qu"=>"Urin Kuriya", "name:rm"=>"Corea dal sid", "name:ro"=>"Coreea de Sud", "name:ru"=>"Южная Корея", "name:sa"=>"दक्षिण कोरिया", "name:se"=>"Mátta-Korea", "name:sh"=>"Južna Koreja", "name:sk"=>"Južná Kórea", "name:sl"=>"Južna Koreja", "name:sm"=>"Kolea i Saute", "name:sq"=>"Koreja e Jugut", "name:sr"=>"Јужна Кореја", "name:su"=>"Koréa Kidul", "name:sv"=>"Sydkorea", "name:sw"=>"Korea Kusini", "name:ta"=>"தென்கொரியா", "name:te"=>"దక్షిణ కొరియా", "name:th"=>"ประเทศเกาหลีใต้", "name:tk"=>"Günorta Koreýa", "name:tl"=>"Timog Korea", "name:tr"=>"Güney Kore", "name:ug"=>"جەنۇبىي چاۋشيەن", "name:uk"=>"Південна Корея", "name:ur"=>"جنوبی کوریا", "name:uz"=>"Janubiy Koreya", "name:vi"=>"Hàn Quốc", "name:vo"=>"Sulüda-Koreyän", "name:wo"=>"Kore gu Bëj-saalum", "name:yi"=>"דרום קארעע", "name:zh"=>"韩国", "name:ace"=>"Korèa Seulatan", "name:als"=>"Südkorea", "name:arz"=>"كوريا الجنوبيه", "name:ast"=>"Corea del Sur", "name:bar"=>"Südkorea", "name:bcl"=>"Sur nin Korea", "name:bpy"=>"খা কোরিয়া", "name:cdo"=>"Hàng-guók", "name:ceb"=>"Habagatang Korea", "name:chr"=>"ᎤᎦᎾᏭ ᎢᏗᎵ ᎪᎴᎠ", "name:crh"=>"Cenübiy Koreya", "name:csb"=>"Repùblika Kòreji", "name:diq"=>"Korya Veroci", "name:dsb"=>"Pódpołdnjowa Koreja", "name:frp"=>"Corê du Sud", "name:gan"=>"韓國", "name:hak"=>"Thai-hòn mìn-koet", "name:haw"=>"Kōlea Hema", "name:hif"=>"South Korea", "name:hsb"=>"Južna Koreja", "name:ilo"=>"Abagatan a Korea", "name:jbo"=>"snanu zei .xanguk", "name:lij"=>"Corea do Sud", "name:lmo"=>"Curea del Süd", "name:nah"=>"Corea Huitztlāmpa", "name:nap"=>"Corea d''o Sud", "name:nds"=>"Süüdkorea", "name:nov"=>"Sud Korea", "name:nrm"=>"Corée du Sud", "name:pam"=>"Mauling Korea", "name:pms"=>"Coréa dël Sud", "name:pnb"=>"دکھنی کوریا", "name:sah"=>"Соҕуруу Кэриэйэ", "name:scn"=>"Corea dû Sud", "name:szl"=>"Połedńowo Koryjo", "name:tet"=>"Koreia Súl", "name:tpi"=>"Saut Koria", "name:udm"=>"Республика Корея", "name:vec"=>"Corea del Sud", "name:war"=>"Salatan nga Korea", "name:wuu"=>"大韩民国", "name:zh_py"=>"Hanguo", "name:simple"=>"South Korea", "name:zh-yue"=>"大韓民國", "name:zh_pyt"=>"Hánguó", "name:bat-smg"=>"Pėitū Kuoriejė", "name:fiu-vro"=>"Lõunõ-Korea", "name:be-x-old"=>"Рэспубліка Карэя", "official_name"=>"대한민국", "name:zh-min-nan"=>"Hân-kok", "official_name:af"=>"Republiek van Korea", "official_name:br"=>"Republik Korea", "official_name:ca"=>"República de Corea", "official_name:el"=>"Δημοκρατία της Κορέας", "official_name:en"=>"Republic of Korea", "official_name:et"=>"Korea Vabariik", "official_name:fr"=>"République de Corée", "official_name:id"=>"Republik Korea", "official_name:it"=>"Repubblica di Corea", "official_name:ja"=>"大韓民国", "official_name:la"=>"Respublica Coreana", "official_name:lb"=>"Republik Korea", "official_name:lv"=>"Korejas Republika", "official_name:mn"=>"Бүгд Найрамдах Солонгос Улс", "official_name:os"=>"Республикæ Корей", "official_name:pl"=>"Republika Korei", "official_name:pt"=>"República da Coreia", "official_name:ru"=>"Республика Корея", "official_name:sk"=>"Kórejská republika", "official_name:sv"=>"Republiken Korea", "official_name:uz"=>"Koreya Respublikasi", "official_name:cdo"=>"Dâi-hàng Mìng-guók", "official_name:bat-smg"=>"Kuorėjės Respoblėka"	\N	49
ge	"name"=>"Georgia / საქართველო", "name:ab"=>"Қырҭтәыла Аҳәынҭқарра", "name:af"=>"Georgië", "name:an"=>"Cheorchia", "name:ar"=>"جورجيا", "name:av"=>"Гуржи", "name:az"=>"Gürcüstan", "name:be"=>"Грузія", "name:bg"=>"Грузия", "name:bn"=>"জর্জিয়া", "name:br"=>"Jorjia", "name:bs"=>"Gruzija", "name:ca"=>"Geòrgia", "name:cs"=>"Gruzie", "name:cu"=>"Гєѡргі́ꙗ", "name:cv"=>"Грузи", "name:cy"=>"Georgia", "name:da"=>"Georgien", "name:de"=>"Georgien", "name:ee"=>"Georgia", "name:el"=>"Γεωργία", "name:en"=>"Georgia", "name:eo"=>"Kartvelio", "name:es"=>"Georgia", "name:et"=>"Gruusia", "name:eu"=>"Georgia", "name:fa"=>"گرجستان", "name:fi"=>"Georgia", "name:fo"=>"Georgia", "name:fr"=>"Géorgie", "name:fy"=>"Geörgje", "name:ga"=>"An tSeoirsia", "name:gd"=>"Gruisia", "name:gl"=>"Xeorxia", "name:gv"=>"Yn Çhorshey", "name:he"=>"גיאורגיה", "name:hi"=>"जोर्जिया", "name:hr"=>"Gruzija", "name:ht"=>"Jeoji", "name:hu"=>"Grúzia", "name:hy"=>"Վրաստան", "name:ia"=>"Georgia", "name:id"=>"Georgia", "name:ie"=>"Georgia", "name:io"=>"Georgia", "name:is"=>"Georgía", "name:it"=>"Georgia", "name:ja"=>"グルジア", "name:jv"=>"Georgia", "name:ka"=>"საქართველო", "name:kk"=>"Гүржістан", "name:ko"=>"그루지야", "name:ku"=>"Gurcistan", "name:kv"=>"Грузия", "name:kw"=>"Pow Grouzi", "name:ky"=>"Грузия", "name:la"=>"Georgia", "name:lb"=>"Georgien", "name:li"=>"Georgië", "name:lt"=>"Gruzija", "name:lv"=>"Gruzija", "name:mk"=>"Грузија", "name:ml"=>"ജോര്‍ജ്ജിയ", "name:mn"=>"Гүрж", "name:mr"=>"जॉर्जिया", "name:ms"=>"Georgia", "name:mt"=>"Ġeorġja", "name:na"=>"Georgia", "name:nl"=>"Georgië", "name:nn"=>"Georgia", "name:no"=>"Georgia", "name:oc"=>"Georgia", "name:os"=>"Гуырдзыстон", "name:pl"=>"Gruzja", "name:ps"=>"جيورجيا", "name:pt"=>"Geórgia", "name:qu"=>"Kartulsuyu", "name:ro"=>"Georgia", "name:ru"=>"Грузия", "name:se"=>"Georgia", "name:sh"=>"Gruzija", "name:sk"=>"Gruzínsko", "name:sl"=>"Gruzija", "name:sq"=>"Gjeorgjia", "name:sr"=>"Грузија", "name:sv"=>"Georgien", "name:sw"=>"Georgia", "name:ta"=>"சியார்சியா", "name:te"=>"జార్జియా", "name:tg"=>"Гурҷистон", "name:th"=>"ประเทศจอร์เจีย", "name:tk"=>"Gruziýa", "name:tl"=>"Georgia", "name:tr"=>"Gürcistan", "name:tt"=>"Грузия", "name:ug"=>"گرۇزىيە", "name:uk"=>"Грузія", "name:ur"=>"جارجیا", "name:uz"=>"Gurjiston", "name:vi"=>"Gruzia", "name:vo"=>"Grusiyän", "name:wo"=>"Jeoorji", "name:yo"=>"Georgia", "name:zh"=>"乔治亚", "name:als"=>"Georgie", "name:arc"=>"ܓܘܪܓܝܐ", "name:arz"=>"جورجيا", "name:ast"=>"Xorxa", "name:ceb"=>"Georgia", "name:crh"=>"Gürcistan", "name:csb"=>"Grëzóńskô", "name:diq"=>"Gurcıstan", "name:dsb"=>"Georgiska", "name:frp"=>"Jôrg·ie", "name:haw"=>"Keokia", "name:hif"=>"Georgia", "name:hsb"=>"Georgiska", "name:ilo"=>"Georgia", "name:ksh"=>"Gejorgije", "name:lij"=>"Geòrgia", "name:lmo"=>"Georgia", "name:mzn"=>"گورجئون", "name:nds"=>"Georgien", "name:new"=>"ज्योर्जिया", "name:nov"=>"Georgia", "name:pam"=>"Georgia", "name:pih"=>"Jorja", "name:pms"=>"Geòrgia", "name:pnt"=>"Γρουζία", "name:sah"=>"Грузия", "name:scn"=>"Giorgia", "name:sco"=>"Georgie", "name:szl"=>"Gruzyjo", "name:udm"=>"Грузия", "name:war"=>"Georgia", "name:wuu"=>"格鲁吉亚", "name:xal"=>"Гүрҗмүдн Орн Нутг", "name:zea"=>"Georhië", "name:zh_py"=>"Qiaozhiya", "name:simple"=>"Georgia", "name:zh-yue"=>"格魯吉亞", "name:zh_pyt"=>"Qiáozhìyà", "name:bat-smg"=>"Grozėjė", "name:fiu-vro"=>"Gruusia", "name:be-x-old"=>"Грузія", "name:zh-min-nan"=>"Sakartvelo", "official_name:pt"=>"República da Geórgia"	ka	21
gr	"name"=>"Ελλάδα", "name:af"=>"Griekeland", "name:am"=>"ግሪክ", "name:an"=>"Grezia", "name:ar"=>"اليونان", "name:az"=>"Yunanıstan", "name:be"=>"Грэцыя", "name:bg"=>"Гърция", "name:bn"=>"গ্রীস", "name:bo"=>"ཧི་ལ།", "name:br"=>"Gres", "name:bs"=>"Grčka", "name:ca"=>"Grècia", "name:ce"=>"Джелтимохк", "name:cs"=>"Řecko", "name:cu"=>"Грьци", "name:cv"=>"Греци", "name:cy"=>"Gwlad Groeg", "name:da"=>"Grækenland", "name:de"=>"Griechenland", "name:dv"=>"ޔޫނާން", "name:dz"=>"གིརིསི་", "name:ee"=>"Greece", "name:el"=>"Ελλάδα", "name:en"=>"Greece", "name:eo"=>"Grekio", "name:es"=>"Grecia", "name:et"=>"Kreeka", "name:eu"=>"Grezia", "name:fa"=>"یونان", "name:fi"=>"Kreikka", "name:fo"=>"Grikkaland", "name:fr"=>"Grèce", "name:fy"=>"Grikelân", "name:ga"=>"An Ghréig", "name:gd"=>"A' Ghrèig", "name:gl"=>"Grecia", "name:gn"=>"Gyresia", "name:gv"=>"Yn Ghreag", "name:he"=>"יוון", "name:hi"=>"यूनान", "name:hr"=>"Grčka", "name:ht"=>"Grès", "name:hu"=>"Görögország", "name:hy"=>"Հունաստան", "name:ia"=>"Grecia", "name:id"=>"Yunani", "name:ie"=>"Grecia", "name:io"=>"Grekia", "name:is"=>"Grikkland", "name:it"=>"Grecia", "name:ja"=>"ギリシャ", "name:jv"=>"Yunani", "name:ka"=>"საბერძნეთი", "name:kg"=>"Gelesi", "name:kk"=>"Грекия", "name:kn"=>"ಗ್ರೀಸ್", "name:ko"=>"그리스", "name:ku"=>"Yewnanistan", "name:kv"=>"Греция", "name:kw"=>"Pow Grek", "name:ky"=>"Греция", "name:la"=>"Graecia", "name:lb"=>"Griicheland", "name:lg"=>"Buyonaani", "name:li"=>"Griekeland", "name:ln"=>"Gresi", "name:lt"=>"Graikija", "name:lv"=>"Grieķija", "name:mk"=>"Грција", "name:ml"=>"ഗ്രീസ്", "name:mn"=>"Грек", "name:mr"=>"ग्रीस", "name:ms"=>"Greece", "name:mt"=>"Greċja", "name:na"=>"Greece", "name:ne"=>"ग्रीस", "name:nl"=>"Griekenland", "name:nn"=>"Hellas", "name:no"=>"Hellas", "name:oc"=>"Grècia", "name:os"=>"Грекъ", "name:pl"=>"Grecja", "name:ps"=>"يونان", "name:pt"=>"Grécia", "name:qu"=>"Grisya", "name:rm"=>"Grezia", "name:ro"=>"Grecia", "name:ru"=>"Греция", "name:rw"=>"Ubugereki", "name:sa"=>"ग्रीस", "name:se"=>"Greika", "name:sh"=>"Grčka", "name:sk"=>"Grécko", "name:sl"=>"Grčija", "name:so"=>"Giriig", "name:sq"=>"Greqia", "name:sr"=>"Грчка", "name:sv"=>"Grekland", "name:sw"=>"Ugiriki", "name:ta"=>"கிரேக்க நாடு", "name:te"=>"గ్రీస్", "name:tg"=>"Юнон", "name:th"=>"ประเทศกรีซ", "name:tk"=>"Gresiýa", "name:tl"=>"Gresya", "name:tr"=>"Yunanistan", "name:tt"=>"Греция", "name:ug"=>"Grétsiye", "name:uk"=>"Греція", "name:ur"=>"یونان", "name:uz"=>"Yunoniston", "name:vi"=>"Hy Lạp", "name:vo"=>"Grikän", "name:wo"=>"Girees", "name:yi"=>"גריכנלאנד", "name:yo"=>"Gréésì", "name:zh"=>"希腊", "name:zu"=>"IGrisi", "name:als"=>"Griecheland", "name:ang"=>"Crecaland", "name:arc"=>"ܝܘܢ", "name:arz"=>"اليونان", "name:ast"=>"Grecia", "name:bar"=>"Griachaland", "name:bcl"=>"Gresya", "name:bpy"=>"গ্রীস", "name:ceb"=>"Gresya", "name:crh"=>"Yunanistan", "name:csb"=>"Greckô", "name:diq"=>"Yunanıstan", "name:dsb"=>"Grichiska", "name:ext"=>"Grécia", "name:frp"=>"Grèce", "name:fur"=>"Grecie", "name:gan"=>"希臘", "name:hak"=>"Hî-lia̍p", "name:haw"=>"Helene", "name:hif"=>"Greece", "name:hsb"=>"Grjekska", "name:ilo"=>"Grecia", "name:jbo"=>"xesygu'e", "name:lad"=>"Gresia", "name:lij"=>"Greçia", "name:lmo"=>"Grecia", "name:mdf"=>"Грекмастор", "name:mhr"=>"Греций", "name:nah"=>"Grecia", "name:nap"=>"Gracia", "name:nds"=>"Grekenland", "name:nov"=>"Grekia", "name:nrm"=>"Grêce", "name:pam"=>"Greece", "name:pih"=>"Griese", "name:pms"=>"Grecia", "name:pnt"=>"Ελλάδα", "name:sah"=>"Греция", "name:scn"=>"Grecia", "name:sco"=>"Greece", "name:stq"=>"Griechenlound", "name:szl"=>"Grecyjo", "name:tet"=>"Grésia", "name:tpi"=>"Gris", "name:udm"=>"Греция", "name:vec"=>"Gresia", "name:war"=>"Gresya", "name:wuu"=>"希腊", "name:xal"=>"Эллинмүдн Орн Нутг", "name:zh_py"=>"Xila", "name:nds-nl"=>"Griekenlaand", "name:simple"=>"Greece", "name:zh-yue"=>"希臘", "name:zh_pyt"=>"Xīlà", "name:bat-smg"=>"Graikėjė", "name:fiu-vro"=>"Kreeka", "name:roa-rup"=>"Gãrtsia", "name:be-x-old"=>"Грэцыя", "official_name"=>"Ελληνική Δημοκρατία", "name:zh-min-nan"=>"Hi-lia̍p", "official_name:am"=>"የግሪክ ዲሞክራሲ", "official_name:br"=>"Republik hellenek", "official_name:et"=>"Kreeka Vabariik", "official_name:id"=>"Republik Hellenik", "official_name:it"=>"Repubblica Ellenica", "official_name:ja"=>"ギリシャ共和国", "official_name:lb"=>"Hellenesch Republik", "official_name:lt"=>"Graikijos Respublika", "official_name:pt"=>"República Helênica", "official_name:sk"=>"Grécka republika", "official_name:sv"=>"Republiken Grekland", "official_name:vi"=>"Cộng hòa Hy Lạp", "name:zh-classical"=>"希臘共和國"	el	22
gs	"name"=>"South Georgia and South Sandwich Islands", "name:af"=>"Suid-Georgië en die Suidelike Sandwich-eilande", "name:ar"=>"جزر جورجيا الجنوبية وساندويتش الجنوبية", "name:be"=>"Паўднёвая Георгія і Паўднёвыя Сэндвічавы астравы", "name:bg"=>"Южна Джорджия и Южни Сандвичеви острови", "name:br"=>"Jorjia ar Su hag Inizi Sandwich ar Su", "name:bs"=>"Južna Džordžija i Južna Sendvička Ostrva", "name:ca"=>"Illes Geòrgia del Sud i Sandwich del Sud", "name:cs"=>"Jižní Georgie a Jižní Sandwichovy ostrovy", "name:da"=>"Sydgeorgien og Sydsandwichøerne", "name:de"=>"Südgeorgien und die Südlichen Sandwichinseln", "name:el"=>"Νότιος Γεωργία και Νότιοι Σάντουιτς Νήσοι", "name:en"=>"South Georgia and South Sandwich Islands", "name:eo"=>"Sud-Georgio kaj Sud-Sandviĉinsuloj", "name:es"=>"Islas Georgias del Sur y Sandwich del Sur", "name:et"=>"Lõuna-Georgia ja Lõuna-Sandwichi saared", "name:eu"=>"Hegoaldeko Georgiak eta Hegoaldeko Sandwich uharteak", "name:fa"=>"جزایر جورجیای جنوبی و ساندویچ جنوبی", "name:fi"=>"Etelä-Georgia ja Eteläiset Sandwichsaaret", "name:fr"=>"Géorgie du Sud-et-les Îles Sandwich du Sud", "name:fy"=>"Súd-Geörgje en de Súdlike Sandwicheilannen", "name:gd"=>"Seòirsia-a-Deas is na h-Eileanan Shandwich-a-Deas", "name:gl"=>"Illas Xeorxia do Sur e Sandwich do Sur", "name:he"=>"איי ג'ורג'יה הדרומית ואיי סנדוויץ' הדרומיים", "name:hr"=>"Južna Georgija i otočje Južni Sandwich", "name:hu"=>"Déli-Georgia és Déli-Sandwich-szigetek", "name:id"=>"Georgia Selatan dan Kepulauan Sandwich Selatan", "name:is"=>"Suður-Georgía og Suður-Sandvíkureyjar", "name:it"=>"Georgia del Sud e isole Sandwich meridionali", "name:ja"=>"サウスジョージア・サウスサンドウィッチ諸島", "name:ko"=>"사우스조지아 사우스샌드위치 제도", "name:kw"=>"Jeorji Dheghow hag Ynysow Sandwich Deghow", "name:lt"=>"Pietų Džordžija ir Pietų Sandvičo salos", "name:lv"=>"Dienviddžordžija un Dienvidsendviču salas", "name:mr"=>"साउथ जॉर्जिया व साउथ सँडविच द्वीपसमूह", "name:ms"=>"Georgia Selatan dan Kepulauan Sandwich Selatan", "name:nl"=>"Zuid-Georgië en de Zuidelijke Sandwicheilanden", "name:nn"=>"Sør-Georgia og Sør-Sandwichøyane", "name:no"=>"Sør-Georgia og Sør-Sandwichøyene", "name:os"=>"Хуссар Джорджи æмæ Хуссар Сандвичы сакъадæхтæ", "name:pl"=>"Georgia Południowa i Sandwich Południowy", "name:pt"=>"Ilhas Geórgia do Sul e Sandwich do Sul", "name:ro"=>"Georgia de Sud şi Insulele Sandwich de Sud", "name:ru"=>"Южная Джорджия и Южные Сандвичевы острова", "name:se"=>"Lulli Georgia ja Lulli Sandwich-sullot", "name:sl"=>"Južna Georgia in Južni Sandwichevi otoki", "name:sq"=>"Gjeorgjia Jugore dhe Ishujt Jugorë Sanduiç", "name:sr"=>"Јужна Џорџија и Јужна Сендвичка Острва", "name:sv"=>"Sydgeorgien och Sydsandwichöarna", "name:ta"=>"தெற்கு யோர்சியா மற்றும் தெற்கு சண்ட்விச் தீவுகள்", "name:th"=>"เกาะเซาท์จอร์เจียและหมู่เกาะเซาท์แซนด์วิช", "name:tr"=>"Güney Georgia ve Güney Sandwich Adaları", "name:uk"=>"Південна Джорджія та Південні Сандвічеві острови", "name:vi"=>"Quần đảo Nam Georgia và Nam Sandwich", "name:wo"=>"Jeoorji gu Bëj-saalum ak Duni Islaand yi Bëj-saalum", "name:zh"=>"南喬治亞島與南桑威奇群島", "name:dsb"=>"Pódpołdnjowa Georgiska a kupy Pódpołdnjowy Sandwich", "name:lij"=>"Geòrgia do Sud e isoe Sandwich meridionæ", "name:nov"=>"Sud Georgia e li Sud Sandwich Isles", "name:sah"=>"Соҕуруу Георгия уонна Соҕуруу Сэндуич арыылара", "name:simple"=>"South Georgia and the South Sandwich Islands", "name:be-x-old"=>"Паўднёвая Георгія і Паўднёвыя Сэндвічавыя выспы"	en	44
je	"name"=>"Jersey", "name:ar"=>"جيرسي", "name:be"=>"Джэрсі", "name:br"=>"Jerzenez", "name:el"=>"Τζέρσεϊ", "name:eo"=>"Jersey", "name:fi"=>"Jersey", "name:fr"=>"Jersey", "name:ga"=>"Geirsí", "name:he"=>"ג'רזי", "name:hu"=>"Jersey", "name:is"=>"Jersey", "name:la"=>"Andium", "name:lt"=>"Džersis", "name:lv"=>"Džērsija", "name:mn"=>"Жерси", "name:pl"=>"Jersey", "name:ru"=>"Джерси", "name:sk"=>"Jersey", "name:sv"=>"Jersey", "name:th"=>"เจอร์ซีย์", "name:uk"=>"Джерсі", "name:zh"=>"泽西岛", "name:zh_py"=>"Zexi Dao", "name:zh_pyt"=>"Zéxī Dǎo"	en	123
kp	"name"=>"북조선", "name:af"=>"Noord-Korea", "name:an"=>"Corea d'o Norte", "name:ar"=>"كوريا الشمالية", "name:az"=>"Şimali Koreya", "name:be"=>"Паўночная Карэя", "name:bg"=>"Северна Корея", "name:bn"=>"উত্তর কোরিয়া", "name:bo"=>"བྱང་ཀོ་རི་ཡ།", "name:br"=>"Korea an Norzh", "name:bs"=>"Sjeverna Koreja", "name:ca"=>"Corea del Nord", "name:cs"=>"Severní Korea", "name:cy"=>"Gogledd Corea", "name:da"=>"Nordkorea", "name:de"=>"Nordkorea", "name:dv"=>"އުތުރު ކޮރެއާ", "name:dz"=>"བྱང་ཀོ་རི་ཡ་", "name:el"=>"Βόρεια Κορέα", "name:en"=>"North Korea", "name:eo"=>"Nord-Koreio", "name:es"=>"Corea del Norte", "name:et"=>"Põhja-Korea", "name:eu"=>"Ipar Korea", "name:fa"=>"کره شمالی", "name:fi"=>"Pohjois-Korea", "name:fo"=>"Norðurkorea", "name:fr"=>"Corée du Nord", "name:fy"=>"Noard-Korea", "name:ga"=>"An Chóiré Thuaidh", "name:gd"=>"Coirea a Tuath", "name:gl"=>"Corea do Norte", "name:gv"=>"Yn Chorea Twoaie", "name:he"=>"קוריאה הצפונית", "name:hi"=>"उत्तर कोरिया", "name:hr"=>"Sjeverna Koreja", "name:ht"=>"Kore dinò", "name:hu"=>"Észak-Korea", "name:hy"=>"Հյուսիսային Կորեա", "name:ia"=>"Corea del Nord", "name:id"=>"Korea Utara", "name:ie"=>"Nord-Korea", "name:io"=>"Nord-Korea", "name:is"=>"Norður-Kórea", "name:it"=>"Corea del Nord", "name:ja"=>"北朝鮮", "name:jv"=>"Koréa Lor", "name:ka"=>"ჩრდილოეთი კორეა", "name:kk"=>"Солтүстік Корея", "name:kn"=>"ಉತ್ತರ ಕೊರಿಯಾ", "name:ku"=>"Korêya Bakur", "name:kv"=>"Корея Войтыр Демократия Республика", "name:kw"=>"Korea Gledh", "name:la"=>"Corea Septentrionalis", "name:lb"=>"Nordkorea", "name:li"=>"Noord-Korea", "name:lt"=>"Šiaurės Korėja", "name:lv"=>"Ziemeļkoreja", "name:mg"=>"Korea Avaratra", "name:mk"=>"Северна Кореја", "name:ml"=>"ഉത്തര കൊറിയ", "name:mn"=>"Хойд Солонгос", "name:mr"=>"उत्तर कोरिया", "name:ms"=>"Korea Utara", "name:na"=>"Republik Engame Korea", "name:nl"=>"Noord-Korea", "name:nn"=>"Nord-Korea", "name:no"=>"Nord-Korea", "name:oc"=>"Corèa del Nòrd", "name:os"=>"Цæгат Корей", "name:pl"=>"Korea Północna", "name:ps"=>"د کوريا ولسواک خلق جمهوريت", "name:pt"=>"Coreia do Norte", "name:qu"=>"Chinchay Kuriya", "name:ro"=>"Coreea de Nord", "name:ru"=>"Северная Корея", "name:se"=>"Davvi-Korea", "name:sh"=>"Sjeverna Koreja", "name:sk"=>"Severná Kórea", "name:sl"=>"Severna Koreja", "name:sq"=>"Koreja e Veriut", "name:sr"=>"Северна Кореја", "name:su"=>"Koréa Kalér", "name:sv"=>"Nordkorea", "name:sw"=>"Korea Kaskazini", "name:ta"=>"வடகொரியா", "name:te"=>"ఉత్తర కొరియా", "name:tg"=>"Куриёи Шимолӣ", "name:th"=>"ประเทศเกาหลีเหนือ", "name:tk"=>"Demirgazyk Koreýa", "name:tl"=>"Hilagang Korea", "name:tr"=>"Kuzey Kore", "name:ug"=>"شىمالىي چاۋشيەن", "name:uk"=>"Північна Корея", "name:ur"=>"شمالی کوریا", "name:uz"=>"Shimoliy Korea", "name:vi"=>"Triều Tiên", "name:vo"=>"Nolüda-Koreyän", "name:wo"=>"Kore gu Bëj-gànnaar", "name:yi"=>"צפון קארעע", "name:zh"=>"朝鲜", "name:als"=>"Nordkorea", "name:ast"=>"Corea del Norte", "name:bcl"=>"North Korea", "name:bpy"=>"ঔয়াং কোরিয়া", "name:ceb"=>"Amihanang Korea", "name:crh"=>"Şimaliy Koreya", "name:csb"=>"Nordowô Kòreja", "name:diq"=>"Korya Zımey", "name:dsb"=>"Pódpołnocna Koreja", "name:frp"=>"Corê du Nord", "name:hak"=>"Tsêu-siên Mìn-tsú Tsú-ngi Ngìn-mìn Khiung-fò-koet", "name:haw"=>"Kōlea ʻĀkau", "name:hsb"=>"Sewjerna Koreja", "name:jbo"=>"berti zei .xanguk", "name:lad"=>"Korea del Nord", "name:lmo"=>"Corea del Nòrd", "name:nah"=>"Corea Mictlāmpa", "name:nds"=>"Noordkorea", "name:nov"=>"Nord Korea", "name:pam"=>"Pangulung Korea", "name:pms"=>"Coréa dël Nòrd", "name:pnb"=>"اتلا کوریا", "name:sah"=>"Хоту Кэриэйэ", "name:scn"=>"Corea dû Nord", "name:szl"=>"Půłnocno Koryjo", "name:tpi"=>"Not Koria", "name:udm"=>"Корея Калык-Демократи Республика", "name:war"=>"Amihanan nga Korea", "name:wuu"=>"朝鲜", "name:zh_py"=>"Chaoxian", "name:simple"=>"North Korea", "name:zh_pyt"=>"Cháoxiǎn", "name:bat-smg"=>"Šiaurės Kuoriejė", "name:cbk-zam"=>"Corea del Norte", "name:fiu-vro"=>"Põh'a-Korea", "name:be-x-old"=>"Паўночная Карэя", "official_name"=>"조선민주주의인민공화국", "name:zh-min-nan"=>"Tiâu-sián", "official_name:br"=>"Republik Poblel ha Demokratel Korea", "official_name:ca"=>"República Popular Democràtica de Corea", "official_name:en"=>"Democratic People's Republic of Korea (DPRK)", "official_name:es"=>"República Popular Democrática de Corea (RPDC)", "official_name:et"=>"Korea Rahvademokraatlik Vabariik", "official_name:hu"=>"Koreai Népi Demokratikus Köztársaság", "official_name:id"=>"Republik Demokratik Rakyat Korea", "official_name:it"=>"Repubblica Democratica Popolare di Corea", "official_name:ja"=>"朝鮮民主主義人民共和国", "official_name:ko"=>"조선민주주의인민공화국", "official_name:la"=>"Respublica Popularis Democratica Coreana", "official_name:lb"=>"Demokratesch Volleksrepublik Korea", "official_name:lv"=>"Korejas Tautas Demokrātiskā Republika", "official_name:mk"=>"Демократска Народна Република Кореја", "official_name:os"=>"Корейы Адæмон Демократон Республикæ", "official_name:pl"=>"Koreańska Republika Ludowo-Demokratyczna", "official_name:pt"=>"República Democrática Popular da Coreia", "official_name:ru"=>"Народно-Демократическая Республика Корея", "official_name:sh"=>"Demokratska Narodna Republika Koreja", "official_name:sk"=>"Kórejská ľudovodemokratická republika", "official_name:sv"=>"Demokratiska folkrepubliken Korea", "official_name:uz"=>"Koreya Xalq Demokratik Respublikasi", "official_name:vi"=>"Cộng hòa Dân chủ Nhân dân Triều Tiên", "official_name:csb"=>"Kòrejańskô Lëdowò-Demokratnô Repùblika"	ko	48
ma	"name"=>"Maroc", "name:af"=>"Marokko", "name:am"=>"ሞሮኮ", "name:an"=>"Marruecos", "name:ar"=>"المغرب", "name:az"=>"Mərakeş", "name:be"=>"Марока", "name:bg"=>"Мароко", "name:bm"=>"Maroko", "name:bn"=>"মরোক্কো", "name:bo"=>"མའེ་ལོ་ཀོ", "name:br"=>"Maroko", "name:bs"=>"Maroko", "name:ca"=>"Marroc", "name:cs"=>"Maroko", "name:cv"=>"Марокко", "name:cy"=>"Moroco", "name:da"=>"Marokko", "name:de"=>"Marokko", "name:dv"=>"މައުރިބު", "name:el"=>"Μαρόκο", "name:en"=>"Morocco", "name:eo"=>"Maroko", "name:es"=>"Marruecos", "name:et"=>"Maroko", "name:eu"=>"Maroko", "name:fa"=>"مراکش", "name:fi"=>"Marokko", "name:fo"=>"Marokko", "name:fr"=>"Maroc", "name:fy"=>"Marokko", "name:ga"=>"Maracó", "name:gd"=>"Maroco", "name:gl"=>"Marrocos", "name:gv"=>"Yn Varoc", "name:he"=>"מרוקו", "name:hi"=>"मोरक्को", "name:hr"=>"Maroko", "name:ht"=>"Mawòk", "name:hu"=>"Marokkó", "name:ia"=>"Morocco", "name:id"=>"Maroko", "name:ie"=>"Morocco", "name:io"=>"Maroko", "name:is"=>"Marrokkó", "name:it"=>"Marocco", "name:ja"=>"モロッコ", "name:jv"=>"Maroko", "name:ka"=>"მაროკო", "name:kg"=>"Magribia", "name:kk"=>"Мағрибия", "name:kn"=>"ಮೊರಾಕೊ", "name:ko"=>"모로코", "name:ks"=>"मोराको", "name:ku"=>"Maroko", "name:kw"=>"Marokk", "name:la"=>"Marocum", "name:lb"=>"Marokko", "name:li"=>"Marokko", "name:ln"=>"Marɔkɛ", "name:lt"=>"Marokas", "name:lv"=>"Maroka", "name:mk"=>"Мароко", "name:ml"=>"മൊറോക്കൊ", "name:mn"=>"Марокко", "name:mr"=>"मोरोक्को", "name:ms"=>"Maghribi", "name:mt"=>"Marokk", "name:nl"=>"Marokko", "name:nn"=>"Marokko", "name:no"=>"Marokko", "name:oc"=>"Marròc", "name:os"=>"Марокко", "name:pl"=>"Maroko", "name:ps"=>"ماراکو", "name:pt"=>"Marrocos", "name:qu"=>"Maruku", "name:ro"=>"Maroc", "name:ru"=>"Марокко", "name:sa"=>"मोराको", "name:sc"=>"Marocu", "name:se"=>"Marokko", "name:sh"=>"Maroko", "name:sk"=>"Maroko", "name:sl"=>"Maroko", "name:so"=>"Maroc", "name:sq"=>"Maroku", "name:sr"=>"Мароко", "name:sv"=>"Marocko", "name:sw"=>"Moroko", "name:ta"=>"மொரோக்கோ", "name:te"=>"మొరాకో", "name:tg"=>"Марокаш", "name:th"=>"ประเทศโมร็อกโก", "name:ti"=>"ሞሮኮ", "name:tl"=>"Morocco", "name:tr"=>"Fas", "name:ts"=>"Morocco", "name:ug"=>"ماراكەش", "name:uk"=>"Марокко", "name:ur"=>"مراکش", "name:uz"=>"Marokash", "name:vi"=>"Maroc", "name:vo"=>"Marokän", "name:wa"=>"Marok", "name:wo"=>"Marok", "name:yi"=>"מאראקא", "name:yo"=>"Mòrókò", "name:zh"=>"摩洛哥", "name:ace"=>"Maroko", "name:ang"=>"Morocco", "name:arc"=>"ܡܓܪܒ", "name:arz"=>"المغرب", "name:ast"=>"Marruecos", "name:bcl"=>"Moroko", "name:bpy"=>"মরক্কো", "name:ceb"=>"Morocco", "name:crh"=>"Mağrip", "name:diq"=>"Fas", "name:ext"=>"Marruecus", "name:frp"=>"Maroc", "name:haw"=>"Moloko", "name:hif"=>"Morocco", "name:hsb"=>"Marokko", "name:ilo"=>"Morocco", "name:jbo"=>"morgu'e", "name:kab"=>"Merruk", "name:lad"=>"Marroko", "name:lij"=>"Maròcco", "name:lmo"=>"Maroch", "name:nah"=>"Marruecos", "name:nds"=>"Marokko", "name:nov"=>"Moroko", "name:pam"=>"Morocco", "name:pms"=>"Maròch", "name:pnb"=>"مراکش", "name:sah"=>"Марокко", "name:scn"=>"Maroccu", "name:stq"=>"Marokko", "name:szl"=>"Maroko", "name:vec"=>"Maroco", "name:war"=>"Morocco", "name:zea"=>"Marokko", "name:zh_py"=>"Moluoge", "name:simple"=>"Morocco", "name:zh-yue"=>"摩洛哥", "name:zh_pyt"=>"Móluògē", "name:bat-smg"=>"Maruoks", "name:be-x-old"=>"Марока", "official_name"=>"المملكة المغربية", "name:zh-min-nan"=>"Morocco", "official_name:be"=>"Каралеўства Марока", "official_name:br"=>"Rouantelezh Maroko", "official_name:el"=>"Βασίλειο του Μαρόκου", "official_name:en"=>"Kingdom of Morocco", "official_name:et"=>"Maroko Kuningriik", "official_name:fr"=>"Royaume du Maroc", "official_name:id"=>"Kerajaan Maroko", "official_name:lb"=>"Kinnekräich Marokko", "official_name:lt"=>"Maroko Karalystė", "official_name:lv"=>"Marokas Karaliste", "official_name:sv"=>"Konungariket Marocko", "official_name:vi"=>"Vương quốc Maroc"	ar	23
an	"name"=>"De Nederlandse Antillen", "name:af"=>"Nederlandse Antille", "name:an"=>"Antillas Neerlandesas", "name:ar"=>"جزر الأنتيل", "name:be"=>"Нідэрландскія Антылы", "name:bg"=>"Холандски Антили", "name:br"=>"Antilhez Nederlandat", "name:bs"=>"Holandski Antili", "name:ca"=>"Antilles Neerlandeses", "name:cs"=>"Nizozemské Antily", "name:cy"=>"Antilles yr Iseldiroedd", "name:da"=>"Nederlandske Antiller", "name:de"=>"Niederländische Antillen", "name:dv"=>"ނެދަލޭންޑު އެންޓިލޭ", "name:el"=>"Ολλανδικές Αντίλλες", "name:en"=>"Netherlands Antilles", "name:eo"=>"Nederlandaj Antiloj", "name:es"=>"Antillas Neerlandesas;Antillas Holandesas;Indias Occidentales Holandesas", "name:et"=>"Hollandi Antillid", "name:eu"=>"Holandarren Antillak", "name:fa"=>"آنتیل هلند", "name:fi"=>"Alankomaiden Antillit", "name:fo"=>"Niðurlendsku Antillurnar", "name:fr"=>"Antilles néerlandaises", "name:fy"=>"Nederlânske Antillen", "name:ga"=>"Aintillí na hÍsiltíre", "name:gl"=>"Antillas Neerlandesas", "name:he"=>"האנטילים ההולנדיים", "name:hi"=>"नीदरलैंड एंटीलीज़", "name:hr"=>"Nizozemski Antili", "name:hu"=>"Holland Antillák", "name:ia"=>"Antillas Nederlandese", "name:id"=>"Antillen Belanda", "name:io"=>"Nederlandana Antili", "name:is"=>"Hollensku Antillaeyjar", "name:it"=>"Antille Olandesi", "name:ja"=>"オランダ領アンティル", "name:jv"=>"Antillen Walanda", "name:ka"=>"ნიდერლანდის ანტილები", "name:kk"=>"Антийлер", "name:ko"=>"네덜란드령 안틸레스", "name:kw"=>"Antillys Iseldiryek", "name:la"=>"Antillae Nederlandiae", "name:lb"=>"Hollännesch Antillen", "name:li"=>"Nederlandse Antille", "name:ln"=>"Antiya ya Holanda", "name:lt"=>"Nyderlandų Antilai", "name:lv"=>"Antiļas", "name:mn"=>"Нидерландын Антиллийн Арлууд", "name:mr"=>"नेदरलँड्स अँटिल्स", "name:ms"=>"Antillen Belanda", "name:nn"=>"Dei nederlandske Antillane", "name:no"=>"De nederlandske Antillene", "name:pl"=>"Antyle Holenderskie", "name:pt"=>"Antilhas Holandesas", "name:ro"=>"Antilele Olandeze", "name:ru"=>"Нидерландские Антилы", "name:sh"=>"Nizozemski Antili", "name:sk"=>"Holandské Antily", "name:sl"=>"Nizozemski Antili", "name:sr"=>"Холандски Антили", "name:sv"=>"Nederländska Antillerna", "name:sw"=>"Antili za Kiholanzi", "name:ta"=>"நெதர்லாந்து அண்டிலிசு", "name:tg"=>"Антил Ҳоланд", "name:th"=>"เนเธอร์แลนด์แอนทิลลิส", "name:tr"=>"Hollanda Antilleri", "name:uk"=>"Нідерландські Антильські острови", "name:vi"=>"Antille thuộc Hà Lan", "name:zh"=>"荷属安的列斯", "name:bpy"=>"নেদারল্যান্ড এন্টিল্লেস", "name:dsb"=>"Nižozemske Antile", "name:frp"=>"Antiles nêrlandêses", "name:lij"=>"Antille Olandeixi", "name:lmo"=>"Antil Ulandes", "name:nov"=>"Nederlandani Antiles", "name:pap"=>"Antias Hulandes", "name:pms"=>"Antile Olandèise", "name:sah"=>"Недерланд Антиллара", "name:vec"=>"Antiłe Ołandexi", "name:wuu"=>"荷属安地列斯", "name:simple"=>"Netherlands Antilles", "name:be-x-old"=>"Нідэрляндзкія Антылы", "name:zh-min-nan"=>"Kē-tē-kok Antilles", "official_name:lv"=>"Nīderlandes Antiļas"	\N	58
gt	"name"=>"Guatemala", "name:ar"=>"غواتيمالا", "name:be"=>"Гватэмала", "name:br"=>"Guatemala", "name:da"=>"Guatemala", "name:el"=>"Γουατεμάλα", "name:en"=>"Guatemala", "name:eo"=>"Gvatemalo", "name:fa"=>"گواتمالا", "name:fi"=>"Guatemala", "name:fr"=>"Guatemala", "name:fy"=>"Gûatemala", "name:ga"=>"Guatamala", "name:gd"=>"Guatamala", "name:he"=>"גואטמלה", "name:hr"=>"Gvatemala", "name:hu"=>"Guatemala", "name:is"=>"Gvatemala", "name:it"=>"Guatemala", "name:ja"=>"グアテマラ", "name:la"=>"Guatimalia", "name:lt"=>"Gvatemala", "name:lv"=>"Gvatemala", "name:mn"=>"Гватемал", "name:pl"=>"Gwatemala", "name:ru"=>"Гватемала", "name:sl"=>"Gvatemala", "name:sv"=>"Guatemala", "name:th"=>"ประเทศกัวเตมาลา", "name:uk"=>"Гватемала", "name:zh"=>"危地马拉", "official_name"=>"República de Guatemala", "official_name:be"=>"Рэспубліка Гватэмала", "official_name:el"=>"Δημοκρατία της Γουατεμάλας", "official_name:gd"=>"Poblachd Ghuatamala", "official_name:id"=>"Republik Guatemala", "official_name:it"=>"Repubblica del Guatemala", "official_name:lt"=>"Gvatemalos Respublika", "official_name:lv"=>"Gvatemalas Republika", "official_name:sv"=>"Republiken Guatemala", "official_name:vi"=>"Cộng hoà Guatemala"	es	57
nl	"name"=>"Nederland", "name:af"=>"Nederland", "name:an"=>"Países Baxos", "name:ar"=>"هولندا", "name:az"=>"Niderland", "name:be"=>"Нідэрланды", "name:bg"=>"Холандия", "name:bn"=>"নেদারল্যান্ড্‌স", "name:br"=>"Izelvroioù", "name:bs"=>"Holandija", "name:ca"=>"Països Baixos", "name:ce"=>"Нидерланд", "name:cs"=>"Nizozemsko", "name:cv"=>"Нидерланды", "name:cy"=>"Yr Iseldiroedd", "name:da"=>"Holland", "name:de"=>"Niederlande", "name:el"=>"Ολλανδία", "name:en"=>"The Netherlands", "name:eo"=>"Nederlando", "name:es"=>"Países Bajos", "name:et"=>"Holland", "name:eu"=>"Herbehereak", "name:fa"=>"هلند", "name:fi"=>"Alankomaat", "name:fo"=>"Niðurlond", "name:fr"=>"Pays-Bas", "name:fy"=>"Nederlân", "name:ga"=>"An Ísiltír", "name:gd"=>"Na Tìrean Ìsle", "name:gl"=>"Países Baixos", "name:gn"=>"Holanda", "name:gv"=>"Yn Ollan", "name:he"=>"הולנד", "name:hr"=>"Nizozemska", "name:ht"=>"Peyiba", "name:hu"=>"Hollandia", "name:hy"=>"Նիդեռլանդներ", "name:ia"=>"Pais Basse", "name:id"=>"Belanda", "name:ie"=>"Nederland", "name:io"=>"Nederlando", "name:is"=>"Holland", "name:it"=>"Paesi Bassi", "name:ja"=>"オランダ", "name:ko"=>"네덜란드", "name:ks"=>"नेदरलैंड्स", "name:ku"=>"Holanda", "name:la"=>"Nederlandia", "name:lb"=>"Holland", "name:ln"=>"Holanda", "name:lt"=>"Nyderlandai", "name:lv"=>"Nīderlande", "name:mk"=>"Холандија", "name:mn"=>"Нидерланд", "name:mr"=>"नेदरलँड्स", "name:ms"=>"Belanda", "name:na"=>"Eben Eyong", "name:nl"=>"Nederland", "name:nn"=>"Nederland", "name:no"=>"Nederland", "name:oc"=>"Païses Basses", "name:os"=>"Нидерландтæ", "name:pl"=>"Holandia", "name:ps"=>"نېدرلانډ/هالېن", "name:pt"=>"Países Baixos", "name:qu"=>"Urasuyu", "name:ro"=>"Olanda", "name:ru"=>"Нидерланды", "name:rw"=>"U Buholandi", "name:se"=>"Vuolleeatnamat", "name:sh"=>"Nizozemska", "name:sk"=>"Holandsko", "name:sl"=>"Nizozemska", "name:so"=>"Nederland", "name:sq"=>"Holanda", "name:sr"=>"Холандија", "name:st"=>"Hôlanê", "name:su"=>"Walanda", "name:sv"=>"Nederländerna", "name:sw"=>"Uholanzi", "name:ta"=>"நெதர்லாந்து", "name:tg"=>"Нидерланд", "name:th"=>"ประเทศเนเธอร์แลนด์", "name:tl"=>"Netherlands", "name:to"=>"Holani", "name:tr"=>"Hollanda", "name:uk"=>"Нідерланди", "name:uz"=>"Niderlandlar", "name:vi"=>"Hà Lan", "name:vo"=>"Nedän", "name:wa"=>"Bas Payis", "name:wo"=>"Olaand", "name:zh"=>"荷兰", "name:haw"=>"Hōlani", "name:tet"=>"Olanda", "name:vec"=>"Paéxi Basi", "name:vls"=>"Olland", "name:war"=>"Paises Bajos", "name:de_CH"=>"Holland", "name:zh_py"=>"Helan", "name:zh_pyt"=>"Hélán", "official_name"=>"Koninkrijk der Nederlanden", "official_name:be"=>"Каралеўства Нідэрланды", "official_name:fr"=>"Royaume des Pays-Bas", "official_name:lb"=>"Kinneksräich Holland", "official_name:sv"=>"Konungariket Nederländerna", "official_name:vi"=>"Vương quốc Hà Lan"	nl	63
np	"name"=>"Nepal", "name:ar"=>"نيبال", "name:be"=>"Непал", "name:br"=>"Nepal", "name:el"=>"Νεπάλ", "name:en"=>"Nepal", "name:eo"=>"Nepalo", "name:fa"=>"نپال", "name:fi"=>"Nepal", "name:fr"=>"Népal", "name:ga"=>"Neipeal", "name:gd"=>"Neapàl", "name:he"=>"נפאל", "name:hu"=>"Nepál", "name:is"=>"Nepal", "name:it"=>"Nepal", "name:ja"=>"ネパール", "name:la"=>"Nepalia", "name:lt"=>"Nepalas", "name:lv"=>"Nepāla", "name:mn"=>"Балба", "name:ne"=>"नेपाल", "name:pl"=>"Nepal", "name:ru"=>"Непал", "name:sv"=>"Nepal", "name:th"=>"ประเทศเนปาล", "name:uk"=>"Непал", "name:zh"=>"尼泊尔", "name:haw"=>"Nepala", "name:zh_py"=>"Niboer", "name:zh_pyt"=>"Níbóěr", "official_name"=>"Sanghiya Loktantrik Ganatantratmak Nepāl", "official_name:br"=>"Republik Demokratel Kevreadel Nepal", "official_name:fr"=>"République démocratique fédérale du Népal", "official_name:it"=>"Repubblica Federale Democratica del Nepal", "official_name:lt"=>"Nepalo Federacinė Demokratinė Respublika", "official_name:lv"=>"Nepālas Karaliste", "official_name:ne"=>"संघीय लोकतान्त्रिक गणतन्त्रात्मक नेपाल", "official_name:pl"=>"Federalna Demokratyczna Republika Nepalu", "official_name:sv"=>"Demokratiska förbundsrepubliken Nepal", "official_name:vi"=>"Cộng hòa dân chủ liên bang Nepal"	ne	50
tm	"name"=>"Türkmenistan", "name:af"=>"Turkmenistan", "name:ar"=>"تركمانستان", "name:az"=>"Türkmənistan", "name:be"=>"Туркменістан", "name:br"=>"Turkmenistan", "name:da"=>"Turkmenistan", "name:de"=>"Turkmenistan", "name:el"=>"Τουρκμενιστάν", "name:en"=>"Turkmenistan", "name:eo"=>"Turkmenio", "name:es"=>"Turkmenistán", "name:et"=>"Türkmenistan", "name:fa"=>"ترکمنستان", "name:fi"=>"Turkmenistan", "name:fr"=>"Turkménistan", "name:ga"=>"An Tuircméanastáin", "name:gd"=>"Turcmanastàn", "name:he"=>"טורקמניסטן", "name:hr"=>"Turkmenistan", "name:hu"=>"Türkmenisztán", "name:id"=>"Turkmenistan", "name:is"=>"Túrkmenistan", "name:it"=>"Turkmenistan", "name:ja"=>"トルクメニスタン", "name:la"=>"Turcomannia", "name:lt"=>"Turkmenistanas", "name:lv"=>"Turkmenistāna", "name:mn"=>"Туркменистан", "name:nl"=>"Turkmenistan", "name:pl"=>"Turkmenistan", "name:pt"=>"Turcomenistão", "name:ru"=>"Туркмения", "name:sl"=>"Turkmenistan", "name:sv"=>"Turkmenistan", "name:th"=>"ประเทศเติร์กเมนิสถาน", "name:tk"=>"Türkmenistan", "name:tr"=>"Türkmenistan", "name:uk"=>"Туркменістан", "name:vi"=>"Turkmenistan", "name:zh"=>"土库曼斯坦", "alt_name"=>"Turkmenia", "name:haw"=>"Tukemenikana", "name:zh_py"=>"Tukumansitan", "name:zh_pyt"=>"Tǔkùmànsītǎn", "official_name:lb"=>"Presidialrepublik Turkmenistan", "official_name:pt"=>"República do Turcomenistão", "official_name:vi"=>"Cộng hòa Turkmenistan"	tk	54
ye	"name"=>"اليَمَن al-Yaman", "name:af"=>"Jemen", "name:ar"=>"اليمن", "name:be"=>"Йемен", "name:br"=>"Yemen", "name:ca"=>"Iemen", "name:cy"=>"Yemen", "name:da"=>"Yemen", "name:de"=>"Jemen", "name:el"=>"Υεμένη", "name:en"=>"Yemen", "name:eo"=>"Jemeno", "name:es"=>"Yemen", "name:et"=>"Jeemen", "name:fa"=>"يمن", "name:fi"=>"Jemen", "name:fr"=>"Yémen", "name:fy"=>"Jemen", "name:ga"=>"Éimin", "name:gd"=>"Iemen", "name:he"=>"תימן", "name:hr"=>"Jemen", "name:hu"=>"Jemen", "name:id"=>"Yaman", "name:is"=>"Jemen", "name:it"=>"Yemen", "name:ja"=>"イエメン", "name:la"=>"Iemenia", "name:lb"=>"Jemen", "name:li"=>"Jeme", "name:lt"=>"Jemenas", "name:mn"=>"Йемен", "name:nl"=>"Jemen", "name:pl"=>"Jemen", "name:pt"=>"Iêmen", "name:ru"=>"Йемен", "name:sl"=>"Jemen", "name:sv"=>"Jemen", "name:th"=>"ประเทศเยเมน", "name:tr"=>"Yemen", "name:uk"=>"Ємен", "name:vi"=>"Yemen", "name:zh"=>"也门", "name:haw"=>"Iemene", "name:zh_py"=>"Yemen", "name:zh_pyt"=>"Yěmén", "official_name:br"=>"Republik Yemen", "official_name:el"=>"Δημοκρατία της Υεμένης", "official_name:en"=>"Republic of Yemen", "official_name:et"=>"Jeemeni Vabariik", "official_name:fi"=>"Jemenin tasavalta", "official_name:id"=>"Republik Yaman", "official_name:it"=>"Repubblica Unita dello Yemen", "official_name:ja"=>"イエメン共和国", "official_name:lt"=>"Jemeno Respublika", "official_name:pl"=>"Republika Jemeńska", "official_name:pt"=>"República do Iêmen", "official_name:sv"=>"Republiken Jemen", "official_name:vi"=>"Cộng hòa Yemen"	ar	55
td	"name"=>"Tchad / تشاد", "name:af"=>"Tsjaad", "name:ar"=>"تشاد", "name:be"=>"Чад", "name:br"=>"Tchad", "name:ca"=>"Txad", "name:cy"=>"Tchad", "name:da"=>"Tchad", "name:de"=>"Tschad", "name:el"=>"Τσαντ", "name:en"=>"Chad", "name:eo"=>"Ĉado", "name:es"=>"Chad", "name:et"=>"Tšaad", "name:fa"=>"چاد", "name:fi"=>"Tšad", "name:fr"=>"Tchad", "name:fy"=>"Tsjaad", "name:ga"=>"Sead", "name:gd"=>"An t-Siad", "name:he"=>"צ'אד", "name:hr"=>"Čad", "name:hu"=>"Csád", "name:id"=>"Chad", "name:is"=>"Tsjad", "name:it"=>"Ciad", "name:la"=>"Tzadia", "name:lb"=>"Tschad", "name:li"=>"Tsjaad", "name:lt"=>"Čadas", "name:mn"=>"Чад", "name:nl"=>"Tsjaad", "name:pl"=>"Czad", "name:pt"=>"Chade", "name:ru"=>"Чад", "name:sl"=>"Čad", "name:sv"=>"Tchad", "name:th"=>"ประเทศชาด", "name:tr"=>"Çad", "name:uk"=>"Чад", "name:vi"=>"Tchad", "name:zh"=>"乍得", "name:zh_py"=>"Zhade", "name:zh_pyt"=>"Zhàdé", "official_name"=>"République du Tchad;جمهورية تشاد ‎", "official_name:br"=>"Republik Tchad", "official_name:el"=>"Δημοκρατία του Τσαντ", "official_name:en"=>"Republic of Chad", "official_name:et"=>"Tšaadi Vabariik", "official_name:id"=>"Republik Chad", "official_name:pt"=>"República do Chade", "official_name:sv"=>"Republiken Tchad", "official_name:vi"=>"Cộng hoà Tchad"	\N	68
nr	"name"=>"Nauru", "name:ar"=>"ناورو", "name:be"=>"Наўру", "name:br"=>"Nauru", "name:da"=>"Nauru", "name:el"=>"Ναουρού", "name:en"=>"Nauru", "name:eo"=>"Nauro", "name:fa"=>"نائورو", "name:fi"=>"Nauru", "name:fr"=>"Nauru", "name:fy"=>"Naurû", "name:ga"=>"Nárú", "name:he"=>"נאורו", "name:hu"=>"Nauru", "name:is"=>"Nárú", "name:li"=>"Naoeroe", "name:lv"=>"Nauru", "name:mn"=>"Науру", "name:pl"=>"Nauru", "name:ru"=>"Науру", "name:sv"=>"Nauru", "name:th"=>"ประเทศนาอูรู", "name:uk"=>"Науру", "name:zh"=>"瑙魯", "official_name"=>"Republic of Nauru;Republik Naoero", "official_name:el"=>"Δημοκρατία του Ναουρού", "official_name:es"=>"República de Nauru", "official_name:gd"=>"Poblachd Nauru", "official_name:id"=>"Republik Nauru", "official_name:lb"=>"Republik Nauru", "official_name:lt"=>"Nauru Respublika", "official_name:lv"=>"Nauru Republika", "official_name:pl"=>"Republika Nauru", "official_name:sv"=>"Republiken Nauru", "official_name:vi"=>"Cộng hòa Nauru"	\N	70
lu	"name"=>"Luxembourg", "name:af"=>"Luxemburg", "name:ar"=>"لكسمبرغ", "name:be"=>"Люксембург", "name:br"=>"Luksembourg", "name:ca"=>"Luxemburg", "name:cy"=>"Lwcsembwrg", "name:de"=>"Luxemburg", "name:el"=>"Λουξεμβούργο", "name:en"=>"Luxembourg", "name:eo"=>"Luksemburgo", "name:es"=>"Luxemburgo", "name:fa"=>"لوکزامبورگ", "name:fi"=>"Luxemburg", "name:fr"=>"Luxembourg", "name:fy"=>"Lúksemboarch", "name:ga"=>"Lucsamburg", "name:gd"=>"Lucsamburg", "name:he"=>"לוקסמבורג", "name:hr"=>"Luksemburg", "name:hu"=>"Luxemburg", "name:hy"=>"Լյուքսեմբուրգ", "name:id"=>"Luksemburg", "name:is"=>"Lúxemborg", "name:it"=>"Lussemburgo", "name:ja"=>"ルクセンブルク", "name:la"=>"Luxemburgum", "name:lb"=>"Lëtzebuerg", "name:lt"=>"Liuksemburgas", "name:lv"=>"Luksemburga", "name:mn"=>"Люксембург", "name:nl"=>"Luxemburg", "name:pl"=>"Luksemburg", "name:ru"=>"Люксембург", "name:sk"=>"Luxembursko", "name:sl"=>"Luksemburg", "name:sv"=>"Luxemburg", "name:th"=>"ประเทศลักเซมเบิร์ก", "name:tr"=>"Lüksemburg", "name:uk"=>"Люксембург", "name:zh"=>"卢森堡", "name:haw"=>"Lukemapuka", "name:zh_py"=>"Lusenbao", "name:zh_pyt"=>"Lúsenbao", "official_name"=>"Groussherzogtum Lëtzebuerg", "official_name:br"=>"Dugelezh Veur Luksembourg", "official_name:el"=>"Μέγα Δουκάτο του Λουξεμβούργου", "official_name:es"=>"Gran Ducado de Luxemburgo", "official_name:fr"=>"Grand-Duché de Luxembourg", "official_name:id"=>"Keharyapatihan Luksemburg", "official_name:it"=>"Granducato di Lussemburgo", "official_name:ja"=>"ルクセンブルク大公国", "official_name:lb"=>"Groussherzogtum Lëtzebuerg", "official_name:lt"=>"Liuksemburgo Didžioji Hercogystė", "official_name:lv"=>"Luksemburgas Lielhercogiste", "official_name:pl"=>"Wielkie Księstwo Luksemburga", "official_name:sk"=>"Luxemburské veľkovojvodstvo", "official_name:sl"=>"Véliko vójvodstvo Lúksemburg", "official_name:sv"=>"Storhertigdömet Luxemburg", "official_name:vi"=>"Đại công quốc Luxembourg"	\N	74
ec	"name"=>"Ecuador", "name:ar"=>"إكوادور", "name:be"=>"Эквадор", "name:br"=>"Ecuador", "name:ca"=>"Equador", "name:da"=>"Ecuador", "name:de"=>"Ekuador", "name:el"=>"Ισημερινός", "name:en"=>"Ecuador", "name:eo"=>"Ekvadoro", "name:eu"=>"Ekuador", "name:fa"=>"اکوادور", "name:fi"=>"Ecuador", "name:fr"=>"Équateur", "name:fy"=>"Ekwador", "name:ga"=>"Eacuadór", "name:gd"=>"Eacuador", "name:he"=>"אקואדור", "name:hr"=>"Ekvador", "name:hu"=>"Ecuador", "name:id"=>"Ekuador", "name:is"=>"Ekvador", "name:ja"=>"エクアドル", "name:la"=>"Aequatoria", "name:lt"=>"Ekvadoras", "name:lv"=>"Ekvadora", "name:mn"=>"Эквадор", "name:pl"=>"Ekwador", "name:pt"=>"Equador", "name:ru"=>"Эквадор", "name:sk"=>"Ekvádor", "name:sl"=>"Ekvador", "name:sv"=>"Ecuador", "name:th"=>"ประเทศเอกวาดอร์", "name:tr"=>"Ekvador", "name:uk"=>"Еквадор", "name:zh"=>"厄瓜多尔", "official_name"=>"República del Ecuador", "official_name:el"=>"Δημοκρατία του Ισημερινού", "official_name:en"=>"Republic of Ecuador", "official_name:fr"=>"République de l'Équateur", "official_name:gd"=>"Poblachd Eacuador", "official_name:id"=>"Republik Ekuador", "official_name:lt"=>"Ekvadoro Respublika", "official_name:lv"=>"Ekvadoras Republika", "official_name:pl"=>"Republika Ekwadoru", "official_name:pt"=>"República do Equador", "official_name:sk"=>"Ekvádorská republika", "official_name:sv"=>"Republiken Ecuador", "official_name:vi"=>"Cộng hoà Ecuador"	es	78
kg	"name"=>"Kyrgyzstan", "name:af"=>"Kirgisië", "name:ar"=>"قيرغيزستان", "name:az"=>"Qırğızıstan", "name:be"=>"Кыргызстан", "name:br"=>"Kirgizstan", "name:ca"=>"Kirguizistan", "name:da"=>"Kirgisistan", "name:de"=>"Kirgisistan", "name:el"=>"Κιργιζία", "name:en"=>"Kyrgyzstan", "name:eo"=>"Kirgizio", "name:es"=>"Kirguistán", "name:et"=>"Kõrgõzstan", "name:fa"=>"قرقیزستان", "name:fi"=>"Kirgisia", "name:fr"=>"Kirghizistan", "name:fy"=>"Kirgyzje", "name:ga"=>"An Chirgeastáin", "name:gd"=>"Cirgiostàn", "name:he"=>"קירגיסטן", "name:hr"=>"Kirgistan", "name:hu"=>"Kirgizisztán", "name:id"=>"Kirgizstan", "name:is"=>"Kirgistan", "name:it"=>"Kirghizistan", "name:ky"=>"Кыргызстан", "name:la"=>"Chirgisia", "name:lb"=>"Kirgisistan", "name:li"=>"Kirgizië", "name:lt"=>"Kirgizija", "name:lv"=>"Kirgizstāna", "name:mn"=>"Кыргызстан", "name:nl"=>"Kirgizië", "name:pl"=>"Kirgistan", "name:ru"=>"Киргизия", "name:sl"=>"Kirgizistan", "name:sv"=>"Kirgizistan", "name:th"=>"ประเทศคีร์กีซสถาน", "name:tr"=>"Kırgızistan", "name:uk"=>"Киргизстан", "name:zh"=>"吉尔吉斯斯坦", "name:haw"=>"Kaikikana", "name:zh_py"=>"Jierjisisitan", "name:zh_pyt"=>"Jíěrjísīsītǎn", "official_name:el"=>"Δημοκρατία της Κιργιζίας", "official_name:et"=>"Kirgiisi Vabariik", "official_name:it"=>"Repubblica del Kirghizistan", "official_name:lb"=>"Kirgisesch Republik", "official_name:lt"=>"Kirgizijos Respublika", "official_name:lv"=>"Kirgizstānas Republika", "official_name:pl"=>"Republika Kirgistanu", "official_name:sv"=>"Republiken Kirgizistan"	\N	93
kz	"name"=>"Kazakhstan", "name:af"=>"Kasakstan", "name:ar"=>"كازاخستان", "name:az"=>"Qazaxıstan", "name:be"=>"Казахстан", "name:br"=>"Kazakstan", "name:cy"=>"Kazakstan", "name:da"=>"Kasakhstan", "name:de"=>"Kasachstan", "name:en"=>"Kazakhstan", "name:eo"=>"Kazaĥio", "name:es"=>"Kazajistán", "name:et"=>"Kasahstan", "name:fa"=>"قزاقستان", "name:fi"=>"Kazakstan", "name:fr"=>"Kazakhstan", "name:fy"=>"Kazachstan", "name:ga"=>"An Chasacstáin", "name:gd"=>"Casachstan", "name:he"=>"קזחסטן", "name:hr"=>"Kazahstan", "name:hu"=>"Kazahsztán", "name:is"=>"Kasakstan", "name:it"=>"Kazakistan", "name:ja"=>"カザフスタン", "name:kk"=>"Қазақстан (Qazaqstan)", "name:la"=>"Casachia", "name:lb"=>"Kasachstan", "name:li"=>"Kazachstan", "name:lt"=>"Kazachstanas", "name:lv"=>"Kazahstāna", "name:mn"=>"Казахстан", "name:nl"=>"Kazachstan", "name:pl"=>"Kazachstan", "name:ru"=>"Казахстан", "name:sl"=>"Kazahstan", "name:sv"=>"Kazakstan", "name:th"=>"ประเทศคาซัคสถาน", "name:tr"=>"Kazakistan", "name:uk"=>"Казахстан", "name:zh"=>"哈萨克斯坦", "name:haw"=>"Kasakana", "name:zh_py"=>"Hasakesitan", "name:zh_pyt"=>"Hāsàkèsītǎn", "official_name"=>"Republic of Kazakhstan", "official_name:be"=>"Рэспубліка Казахстан", "official_name:et"=>"Kasahstani Vabariik", "official_name:id"=>"Republik Kazakhstan", "official_name:lt"=>"Kazachstano Respublika", "official_name:lv"=>"Kazahstānas Republika", "official_name:pl"=>"Republika Kazachstanu", "official_name:sv"=>"Republiken Kazakstan", "official_name:vi"=>"Cộng hoà Kazakhstan"	\N	94
nf	"name"=>"Norfolk Island", "name:af"=>"Norfolkeiland", "name:ar"=>"جزيرة نورفولك", "name:be"=>"Норфалк", "name:br"=>"Enez Norfolk", "name:ca"=>"Illa Norfolk", "name:cy"=>"Ynys Norfolk", "name:da"=>"Norfolk-øen", "name:de"=>"Norfolkinsel", "name:en"=>"Norfolk Island", "name:eo"=>"Norfolkinsulo", "name:es"=>"Isla Norfolk", "name:et"=>"Norfolki saar", "name:fi"=>"Norfolkinsaari", "name:fr"=>"Île Norfolk", "name:fy"=>"Norfolk", "name:ga"=>"Oileán Norfolk", "name:he"=>"האי נורפוק", "name:hr"=>"Otok Norfolk", "name:hu"=>"Norfolk-sziget", "name:id"=>"Pulau Norfolk", "name:is"=>"Norfolkeyja", "name:it"=>"Isola Norfolk", "name:la"=>"Insula Norfolcia", "name:lt"=>"Norfolko sala", "name:lv"=>"Norfolkas sala", "name:mn"=>"Норфолк Арал", "name:nl"=>"Norfolk", "name:pl"=>"Wyspa Norfolk", "name:ru"=>"Остров Норфолк", "name:sv"=>"Norfolkön", "name:tr"=>"Norfolk Adası", "name:uk"=>"Острів Норфолк", "name:vi"=>"Đảo Norfolk", "name:zh"=>"诺福克岛", "name:pih"=>"Norfuk Ailen", "official_name"=>"Territory of Norfolk Island", "official_name:lv"=>"Norfolkas salas teritorija", "official_name:pl"=>"Terytorium Wyspy Norfolk"	\N	100
gl	"name"=>"Kalaallit Nunaat", "name:af"=>"Groenland", "name:am"=>"ግሪንላንድ", "name:an"=>"Gronlandia", "name:ar"=>"غرينلاند", "name:be"=>"Грэнландыя", "name:bg"=>"Гренландия", "name:bn"=>"গ্রিনল্যান্ড", "name:bo"=>"གེ་རེན་ལ", "name:br"=>"Greunland", "name:bs"=>"Grenland", "name:ca"=>"Grenlàndia", "name:cs"=>"Grónsko", "name:cv"=>"Гренланди", "name:cy"=>"Yr Ynys Las", "name:da"=>"Grønland", "name:de"=>"Grönland", "name:dv"=>"ގުރީންލޭންޑު", "name:el"=>"Γροιλανδία", "name:en"=>"Greenland", "name:eo"=>"Gronlando", "name:es"=>"Groenlandia", "name:et"=>"Gröönimaa", "name:eu"=>"Groenlandia", "name:fa"=>"گرینلند", "name:fi"=>"Grönlanti", "name:fo"=>"Grønland", "name:fr"=>"Groenland", "name:fy"=>"Grienlân", "name:ga"=>"An Ghraonlainn", "name:gd"=>"A' Ghraonlainn", "name:gl"=>"Grenlandia", "name:gv"=>"Greenlynn", "name:he"=>"גרינלנד", "name:hr"=>"Grenland", "name:hu"=>"Grönland", "name:ia"=>"Groenlandia", "name:id"=>"Greenland", "name:io"=>"Grenlando", "name:is"=>"Grænland", "name:it"=>"Groenlandia", "name:iu"=>"ᐊᑯᑭᑦᑐᑦ/akukittut", "name:ja"=>"グリーンランド", "name:jv"=>"Greenland", "name:ka"=>"გრენლანდია", "name:kk"=>"Гренландия", "name:kl"=>"Kalaallit Nunaat", "name:kn"=>"ಗ್ರೀನ್‍ಲ್ಯಾಂಡ್", "name:ko"=>"그린란드", "name:ku"=>"Gronland", "name:kv"=>"Гренландия", "name:kw"=>"Greunland", "name:la"=>"Groenlandia", "name:lb"=>"Grönland", "name:li"=>"Greunland", "name:lt"=>"Grenlandija", "name:lv"=>"Grenlande", "name:mk"=>"Гренланд", "name:ml"=>"ഗ്രീന്‍ലാന്‍ഡ്", "name:mn"=>"Гренланд", "name:mr"=>"ग्रीनलँड", "name:ms"=>"Greenland", "name:nl"=>"Groenland", "name:nn"=>"Grønland", "name:no"=>"Grønland", "name:oc"=>"Groenlàndia", "name:os"=>"Гренланди", "name:pa"=>"ਗਰੀਨਲੈਂਡ", "name:pl"=>"Grenlandia", "name:pt"=>"Gronelândia", "name:qu"=>"Kalalit Nunat", "name:ro"=>"Groenlanda", "name:ru"=>"Гренландия", "name:sh"=>"Grenland", "name:sk"=>"Grónsko", "name:sl"=>"Grenlandija", "name:sq"=>"Grenlanda", "name:sr"=>"Гренланд", "name:sv"=>"Grönland", "name:sw"=>"Greenland", "name:ta"=>"கிறீன்லாந்து", "name:te"=>"గ్రీన్‌లాండ్", "name:tg"=>"Гренландия", "name:th"=>"กรีนแลนด์", "name:tl"=>"Lupanlunti", "name:tr"=>"Grönland", "name:ug"=>"Grénlandiye", "name:uk"=>"Ґренландія", "name:vi"=>"Greenland", "name:wo"=>"Groenlaand", "name:zh"=>"格陵兰岛", "name:ang"=>"Grēneland", "name:ast"=>"Groenlandia", "name:bar"=>"Grönland", "name:bpy"=>"গ্রীনল্যান্ড", "name:dsb"=>"Grónlandska", "name:frp"=>"Grônlande", "name:hif"=>"Greenland", "name:lij"=>"Gròenlandia", "name:nah"=>"Groentlālpan", "name:nds"=>"Gröönland", "name:nov"=>"Verdi-lande", "name:pms"=>"Groenlandia", "name:scn"=>"Groenlannia", "name:szl"=>"Grynlandyjo", "name:tpi"=>"Greenland", "name:vec"=>"Groenłandia", "name:wuu"=>"格陵兰", "name:zh_py"=>"Gelinglan Dao", "name:nds-nl"=>"Gruunlaand", "name:simple"=>"Greenland", "name:zh-yue"=>"格陵蘭", "name:zh_pyt"=>"Gélínglán Dǎo", "name:bat-smg"=>"Grenlandėjė", "name:be-x-old"=>"Грэнляндыя", "name:zh-min-nan"=>"Chheⁿ-tē", "name:zh-classical"=>"格陵蘭"	\N	111
sv	"name:ar"=>"السلفادور", "name:be"=>"Эль-Сальвадор", "name:br"=>"Salvador", "name:da"=>"El Salvador", "name:el"=>"Ελ Σαλβαδόρ", "name:en"=>"El Salvador", "name:eo"=>"Salvadoro", "name:fa"=>"السالوادور", "name:fi"=>"El Salvador", "name:fr"=>"Salvador", "name:ga"=>"An tSalvadóir", "name:gd"=>"El Salbhador", "name:he"=>"אל סלבדור", "name:hr"=>"Salvador", "name:hu"=>"El Salvador", "name:is"=>"El Salvador", "name:it"=>"El Salvador", "name:ja"=>"エルサルバドル", "name:la"=>"Salvatoria", "name:lt"=>"El Salvadoras", "name:lv"=>"Salvadora", "name:mn"=>"Эль Сальвадор", "name:pl"=>"Salwador", "name:ru"=>"Эль-Сальвадор", "name:sl"=>"Salvador", "name:sv"=>"El Salvador", "name:th"=>"ประเทศเอลซัลวาดอร์", "name:uk"=>"Сальвадор", "name:zh"=>"萨尔瓦多", "official_name"=>"República de El Salvador", "official_name:be"=>"Рэспубліка Эль-Сальвадор", "official_name:el"=>"Δημοκρατία του Ελ Σαλβαδόρ", "official_name:id"=>"Republik El Salvador", "official_name:ja"=>"エルサルバドル共和国", "official_name:lv"=>"Salvadoras Republika", "official_name:pl"=>"Republika Salwadoru", "official_name:sv"=>"Republiken El Salvador", "official_name:vi"=>"Cộng hòa El Salvador"	es	103
tc	"name"=>"Turks and Caicos Islands", "name:af"=>"Turks en Caicos Eilande", "name:an"=>"Islas Turcas e Caicos", "name:ar"=>"جزر تركس وكايكوس", "name:bg"=>"Търкс и Кайкос", "name:bn"=>"টার্কস্‌ ও কেইকোস দ্বীপপুঞ্জ", "name:br"=>"Inizi  Turks ha Caicos", "name:bs"=>"Ostrva Turks i Caicos", "name:ca"=>"Illes Turks i Caicos", "name:cs"=>"Turks a Caicos", "name:cv"=>"Тĕркс тата Кайкос", "name:cy"=>"Ynysoedd Turks a Caicos", "name:da"=>"Turks- og Caicosøerne", "name:de"=>"Turks- und Caicosinseln", "name:dv"=>"ޓާކަސް އަދި ކައިކޯ ޖަޒީރާ", "name:el"=>"Τερκς και Κάικος", "name:en"=>"Turks and Caicos Islands", "name:eo"=>"Turkoj kaj Kajkoj", "name:es"=>"Islas Turcas y Caicos", "name:et"=>"Turks ja Caicos", "name:eu"=>"Turks eta Caicos uharteak", "name:fa"=>"جزایر تورکس و کایکوس", "name:fi"=>"Turks- ja Caicossaaret", "name:fr"=>"Îles Turques-et-Caïques", "name:fy"=>"Turks- en Kaikoseilannen", "name:ga"=>"Oileáin na dTurcach agus Caicos", "name:gd"=>"Oileáin na dTurcach agus Caicos", "name:gl"=>"Turks e Caicos", "name:he"=>"איי טרקס וקייקוס", "name:hi"=>"टर्क्स और केकोस द्वीप-समूह", "name:hr"=>"Otoci Turks i Caicos", "name:hu"=>"Turks- és Caicos-szigetek", "name:id"=>"Kepulauan Turks dan Caicos", "name:io"=>"Turks e Kaikos-Insuli", "name:is"=>"Turks- og Caicoseyjar", "name:it"=>"Turks e Caicos", "name:ja"=>"タークス・カイコス諸島", "name:jv"=>"Kapuloan Turks lan Caicos", "name:ko"=>"터크스 케이커스 제도", "name:kw"=>"Turks ha Kaykos", "name:lt"=>"Terkso ir Kaikoso salos", "name:lv"=>"Tērksas un Kaikosas", "name:mn"=>"Туркс ба Кайкосын Арлууд", "name:mr"=>"टर्क्स आणि कैकास द्वीपसमूह", "name:ms"=>"Kepulauan Turks dan Caicos", "name:nl"=>"Turks- en Caicoseilanden", "name:nn"=>"Turks- og Caicosøyane", "name:no"=>"Turks- og Caicosøyene", "name:pl"=>"Turks i Caicos", "name:pt"=>"Turks e Caicos", "name:ro"=>"Insulele Turks şi Caicos", "name:ru"=>"Острова Тёркс и Кайкос", "name:sh"=>"Turks i Caicos Otoci", "name:sk"=>"Turks a Caicos", "name:sq"=>"Turks dhe Kaikos", "name:sr"=>"Туркс и Кајкос", "name:sv"=>"Turks- och Caicosöarna", "name:sw"=>"Visiwa vya Turks na Caicos", "name:ta"=>"துர்கசு கைகோசு தீவுகள்", "name:th"=>"หมู่เกาะเติร์กและไคคอส", "name:tr"=>"Turks ve Caicos Adaları", "name:ug"=>"Turks we Kaykos Taqim Aralliri", "name:uk"=>"Острови Теркс і Кайкос", "name:vi"=>"Quần đảo Turks và Caicos", "name:wo"=>"Turks and Caicos Islands", "name:zh"=>"特克斯和凱科斯群島", "name:ast"=>"Islles Turques y Caicos", "name:bpy"=>"তার্কস বারো কাইকোস দ্বীপমালা", "name:dsb"=>"Turks a Caicos", "name:frp"=>"Iles Turques et Cayiques", "name:lij"=>"Turks e Caicos", "name:lmo"=>"Turks e Caicos", "name:nov"=>"Turks e Kaikos Isles", "name:pms"=>"Turks e Caicos", "name:simple"=>"Turks and Caicos Islands", "name:be-x-old"=>"Тэркс і Кэйкас", "name:zh-min-nan"=>"Turks kap Caicos Kûn-tó", "official_name:et"=>"Turksi ja Caicose saarte asumaa"	en	106
in	"name"=>"India", "name:af"=>"Indië", "name:ar"=>"الهند", "name:be"=>"Індыя", "name:br"=>"India", "name:da"=>"Indien", "name:de"=>"Indien", "name:el"=>"Ινδία", "name:en"=>"India", "name:eo"=>"Barato", "name:fa"=>"هند", "name:fi"=>"Intia", "name:fr"=>"Inde", "name:fy"=>"Yndia", "name:ga"=>"An India", "name:gd"=>"Na h-Innseachan", "name:he"=>"הודו", "name:hi"=>"भारत", "name:hu"=>"India", "name:is"=>"Indland", "name:it"=>"India", "name:iu"=>"ᐃᓐᑎᐊ/intia", "name:ja"=>"インド", "name:lb"=>"Indien", "name:lt"=>"Indija", "name:lv"=>"Indija", "name:mn"=>"Энэтхэг", "name:pl"=>"Indie", "name:ru"=>"Индия", "name:sl"=>"Indija", "name:sv"=>"Indien", "name:th"=>"ประเทศอินเดีย", "name:tr"=>"Hindistan", "name:uk"=>"Індія", "name:vi"=>"Ấn Độ", "name:zh"=>"印度", "name:haw"=>"‘Īnia", "name:zh_py"=>"Yindu", "name:zh_pyt"=>"Yìndù", "official_name"=>"भारत गणराज्य", "official_name:el"=>"Δημοκρατία της Ινδίας", "official_name:en"=>"Republic of India", "official_name:fr"=>"République de l'Inde", "official_name:hi"=>"भारत गणराज्य", "official_name:id"=>"Republik India", "official_name:it"=>"Repubblica dell'India", "official_name:lb"=>"Republik Indien", "official_name:lt"=>"Indijos Respublika", "official_name:lv"=>"Indijas Republika", "official_name:pl"=>"Republika Indii", "official_name:sv"=>"Republiken Indien"	\N	128
tf	"name"=>"Terres australes et antarctiques françaises", "name:af"=>"Franse Suidelike en Antarktiese Gebiede", "name:an"=>"Territorios Australs Franzeses", "name:ar"=>"الأراضي الجنوبية الفرنسية", "name:be"=>"Французскія Паўднёвыя тэрыторыі", "name:bg"=>"Френски южни и антарктически територии", "name:br"=>"Douaroù Aostral hag Antarktikel Frañs", "name:ca"=>"Terres Australs i Antàrtiques Franceses", "name:cs"=>"Francouzská jižní a antarktická území", "name:da"=>"Franske sydlige og Antarktiske territorier", "name:de"=>"Französische Süd- und Antarktisgebiete", "name:el"=>"Γαλλικά νότια και ανταρκτικά εδάφη", "name:en"=>"French Southern Lands", "name:eo"=>"Francaj Sudaj Teritorioj", "name:es"=>"Tierras Australes y Antárticas Francesas", "name:eu"=>"Frantziaren lurralde austral eta antartikoak", "name:fi"=>"Ranskan eteläiset ja antarktiset alueet", "name:fr"=>"Terres australes et antarctiques françaises", "name:fy"=>"Frânske Súdlike en Antarktyske Lannen", "name:gl"=>"Terras Austrais e Antárticas Francesas", "name:hr"=>"Francuski južni i antarktički teritoriji", "name:hu"=>"Francia déli és antarktiszi területek", "name:id"=>"Daratan Selatan dan Antarktika Perancis", "name:is"=>"Frönsku suðlægu landsvæðin", "name:it"=>"Terre Australi e Antartiche Francesi", "name:ja"=>"フランス領南方・南極地域", "name:ko"=>"프랑스령 남부와 남극 지역", "name:kw"=>"Tiryow Deghow hag Antarktik Frynkek", "name:lt"=>"Prancūzijos Pietų Sritys", "name:lv"=>"Francijas Dienvidjūru un Antarktikas Zemes", "name:nl"=>"Franse Zuidelijke en Antarctische Gebieden", "name:no"=>"De franske sørterritorier", "name:oc"=>"Tèrras Australas e Antarticas Francesas", "name:pl"=>"Francuskie Terytoria Południowe i Antarktyczne", "name:pt"=>"Terras Austrais e Antárticas Francesas", "name:ro"=>"Teritoriile australe şi antarctice franceze", "name:ru"=>"Французские Южные и Антарктические территории", "name:sh"=>"Francuske Južne Teritorije", "name:sk"=>"Francúzske južné a antarktické územia", "name:sl"=>"Francoske južne in antarktične dežele", "name:sr"=>"Француске јужне и антарктичке земље", "name:sv"=>"Franska sydterritorierna", "name:ta"=>"பிரெஞ்சு தென்னக நிலங்களும் அண்டாடிக் நிலமும்", "name:tr"=>"Fransız Güney ve Antarktika Toprakları", "name:uk"=>"Французькі Південні та Антарктичні території", "name:vi"=>"Vùng đất phía Nam và châu Nam Cực thuộc Pháp", "name:zh"=>"法属南部领地", "name:lij"=>"Tæritöi Françèisi Meridionâ e dell'Antartigo", "name:be-x-old"=>"Францускія Паўднёвыя Тэрыторыі"	fr	132
er	"name"=>"Eritrea", "name:af"=>"Eritrea", "name:ar"=>"إريتريا", "name:be"=>"Эрытрэя", "name:br"=>"Eritrea", "name:el"=>"Ερυθραία", "name:en"=>"Eritrea", "name:eo"=>"Eritreo", "name:es"=>"Eritrea", "name:fa"=>"اریتره", "name:fi"=>"Eritrea", "name:fr"=>"Érythrée", "name:ga"=>"An Eiritré", "name:gd"=>"Ertra", "name:he"=>"אריתריאה", "name:hr"=>"Eritreja", "name:hu"=>"Eritrea", "name:is"=>"Erítrea", "name:it"=>"Eritrea", "name:ja"=>"エリトリア", "name:la"=>"Erythraea", "name:lt"=>"Eritrėja", "name:lv"=>"Eritreja", "name:mn"=>"Энэтхэг", "name:pl"=>"Erytrea", "name:pt"=>"Eritreia;Eritréia", "name:ru"=>"Эритрея", "name:sl"=>"Eritreja", "name:sv"=>"Eritrea", "name:th"=>"ประเทศเอริเทรีย", "name:tr"=>"Eritre", "name:uk"=>"Еритрея", "name:zh"=>"厄立特里亚", "name:pt@BR"=>"Eritréia", "name:pt@PT"=>"Eritreia", "name:zh_py"=>"Eliteliya", "name:zh_pyt"=>"Èlìtèlǐyà", "official_name:el"=>"Κράτος της Ερυθραίας", "official_name:en"=>"State of Eritrea", "official_name:lv"=>"Eritrejas Valsts", "official_name:pt"=>"Estado da Eritreia;Estado da Eritréia", "official_name:vi"=>"Quốc gia Eritrea", "official_name:pt@BR"=>"Estado da Eritréia", "official_name:pt@PT"=>"Estado da Eritreia"	\N	142
kw	"name"=>"Kuwait / الكويت", "name:af"=>"Koeweit", "name:an"=>"Kuwait", "name:ar"=>"الكويت", "name:az"=>"Küveyt", "name:be"=>"Кувейт", "name:bg"=>"Кувейт", "name:bn"=>"কুয়েত", "name:br"=>"Koweit", "name:bs"=>"Kuvajt", "name:ca"=>"Kuwait", "name:cs"=>"Kuvajt", "name:cv"=>"Кувейт", "name:de"=>"Kuwait", "name:dv"=>"ކުވެއިތު", "name:dz"=>"ཀུ་ཝེཊ་", "name:el"=>"Κουβέιτ", "name:en"=>"Kuwait", "name:eo"=>"Kuvajto", "name:et"=>"Kuveit", "name:eu"=>"Kuwait", "name:fa"=>"کویت", "name:fi"=>"Kuwait", "name:fo"=>"Kuveit", "name:fr"=>"Koweït", "name:fy"=>"Koeweit", "name:ga"=>"Cuáit", "name:gd"=>"Cubhait", "name:gv"=>"Yn Choowait", "name:he"=>"כווית", "name:hi"=>"कुवैत", "name:hr"=>"Kuvajt", "name:ht"=>"Kowet", "name:hu"=>"Kuvait", "name:ia"=>"Kuwait", "name:id"=>"Kuwait", "name:ie"=>"Kuwait", "name:io"=>"Kuwait", "name:is"=>"Kúveit", "name:it"=>"Kuwait", "name:ja"=>"クウェート", "name:jv"=>"Kuwait", "name:ka"=>"ქუვეითი", "name:kk"=>"Кувейт", "name:km"=>"គុយវ៉ែត", "name:kn"=>"ಕುವೈತ್", "name:ko"=>"쿠웨이트", "name:ku"=>"Kuweyt", "name:kv"=>"Кувейт", "name:kw"=>"Kuwait", "name:la"=>"Cuvaitum", "name:li"=>"Koeweit", "name:lt"=>"Kuveitas", "name:lv"=>"Kuveita", "name:mk"=>"Кувајт", "name:ml"=>"കുവൈറ്റ്‌", "name:mn"=>"Кувейт", "name:mr"=>"कुवैत", "name:ms"=>"Kuwait", "name:nl"=>"Koeweit", "name:nn"=>"Kuwait", "name:no"=>"Kuwait", "name:oc"=>"Kowait", "name:os"=>"Кувейт", "name:pl"=>"Kuwejt", "name:pt"=>"Kuwait", "name:qu"=>"Kuwait", "name:ro"=>"Kuweit", "name:ru"=>"Кувейт", "name:sa"=>"कुवैत", "name:se"=>"Kuwait", "name:sh"=>"Kuvajt", "name:sk"=>"Kuvajt", "name:sl"=>"Kuvajt", "name:sq"=>"Kuvajti", "name:sr"=>"Кувајт", "name:sv"=>"Kuwait", "name:sw"=>"Kuwait", "name:ta"=>"குவைத்", "name:te"=>"కువైట్", "name:tg"=>"Кувайт", "name:th"=>"ประเทศคูเวต", "name:tl"=>"Kuwait", "name:tr"=>"Kuveyt", "name:tt"=>"Күвәйт", "name:ug"=>"كۇۋەيت", "name:uk"=>"Кувейт", "name:ur"=>"کویت", "name:uz"=>"Quvayt", "name:vi"=>"Kuwait", "name:vo"=>"Kovätän", "name:wo"=>"Kowet", "name:zh"=>"科威特", "name:ace"=>"Kuwait", "name:als"=>"Kuwait", "name:ang"=>"Cuwait", "name:arc"=>"ܟܘܝܬ", "name:arz"=>"الكويت", "name:ast"=>"Kuwait", "name:bcl"=>"Kuwait", "name:bpy"=>"কুয়েত", "name:ceb"=>"Kuwait", "name:crh"=>"Küveyt", "name:dsb"=>"Kuwait", "name:frp"=>"Koveyit", "name:hak"=>"Khô-vî-thi̍t", "name:haw"=>"Kuete", "name:hif"=>"Kuwait", "name:hsb"=>"Kuwait", "name:ilo"=>"Kuwait", "name:lij"=>"Kuwait", "name:lmo"=>"Kuwait", "name:nah"=>"Cuhuait", "name:nds"=>"Kuwait", "name:nov"=>"Kuwayt", "name:pam"=>"Kuwait", "name:pms"=>"Kuwait", "name:sah"=>"Кувейт", "name:scn"=>"Kuwait", "name:szl"=>"Kuwejt", "name:udm"=>"Кувейт", "name:war"=>"Kuwait", "name:wuu"=>"科威特", "name:zh_py"=>"Keweite", "name:simple"=>"Kuwait", "name:zh_pyt"=>"Kēwēitè", "name:bat-smg"=>"Kovėits", "name:fiu-vro"=>"Kuveit", "name:be-x-old"=>"Кувэйт", "official_name"=>"State of Kuwait", "name:zh-min-nan"=>"Kuwait", "official_name:br"=>"Stad Koweit", "official_name:el"=>"Κράτος του Κουβέιτ", "official_name:en"=>"State of Kuwait", "official_name:et"=>"Kuveidi Riik", "official_name:it"=>"Stato del Kuwait", "official_name:lt"=>"Kuveito Valstybė", "official_name:lv"=>"Kuveitas Valsts", "official_name:pl"=>"Państwo Kuwejt", "official_name:sv"=>"Staten Kuwait", "name:zh-classical"=>"科威特"	ar	127
ro	"name"=>"România", "name:af"=>"Roemenië", "name:ar"=>"رومانيا", "name:be"=>"Румынія", "name:br"=>"Roumania", "name:ca"=>"Romania", "name:cy"=>"Rwmania", "name:da"=>"Rumænien", "name:de"=>"Rumänien", "name:el"=>"Ρουμανία", "name:en"=>"Romania", "name:eo"=>"Rumanio", "name:es"=>"Rumania", "name:et"=>"Rumeenia", "name:fa"=>"رومانی", "name:fi"=>"Romania", "name:fr"=>"Roumanie", "name:fy"=>"Roemeenje", "name:ga"=>"An Rómáin", "name:gd"=>"Ròmainia", "name:he"=>"רומניה", "name:hr"=>"Rumunjska", "name:hu"=>"Románia", "name:id"=>"Rumania", "name:is"=>"Rúmenía", "name:it"=>"Romania", "name:ja"=>"ルーマニア", "name:la"=>"Romania", "name:lb"=>"Rumänien", "name:li"=>"Roemenië", "name:lt"=>"Rumunija", "name:lv"=>"Rumānija", "name:mn"=>"Румын", "name:nl"=>"Roemenië", "name:pl"=>"Rumunia", "name:ro"=>"România", "name:ru"=>"Румыния", "name:sk"=>"Rumunsko", "name:sl"=>"Romunija", "name:sv"=>"Rumänien", "name:th"=>"ประเทศโรมาเนีย", "name:tr"=>"Romanya", "name:uk"=>"Румунія", "name:vi"=>"Romania", "name:zh"=>"罗马尼亚", "name:haw"=>"Romānia", "name:zh_py"=>"Luomaniya", "name:zh_pyt"=>"Luómăníyà"	ro	170
md	"name"=>"Moldova", "name:af"=>"Moldowa", "name:ar"=>"جمهورية مولدوفا", "name:be"=>"Малдова", "name:br"=>"Moldavia", "name:ca"=>"Moldàvia", "name:cy"=>"Moldofa", "name:da"=>"Moldova", "name:de"=>"Moldawien", "name:en"=>"Moldova", "name:eo"=>"Moldavio", "name:es"=>"Moldavia", "name:fa"=>"مولداوی", "name:fi"=>"Moldova", "name:fr"=>"Moldavie", "name:fy"=>"Moldaavje", "name:ga"=>"An Mholdóiv", "name:gd"=>"Moldàibhia", "name:he"=>"מולדובה", "name:hr"=>"Moldavija", "name:hu"=>"Moldova", "name:id"=>"Moldova", "name:is"=>"Moldóva", "name:it"=>"Moldavia", "name:ja"=>"モルドバ", "name:la"=>"Respublica Moldavica", "name:lb"=>"Moldawien", "name:lt"=>"Moldovos Respublika", "name:lv"=>"Moldova", "name:mn"=>"Молдав", "name:nl"=>"Moldavië", "name:pl"=>"Mołdawia", "name:ru"=>"Молдова", "name:sk"=>"Moldavsko", "name:sl"=>"Moldavija", "name:sv"=>"Moldavien", "name:th"=>"ประเทศมอลโดวา", "name:tr"=>"Moldova", "name:uk"=>"Молдова", "name:vi"=>"Moldova", "name:zh"=>"摩尔多瓦", "name:haw"=>"Molodowa", "name:zh_py"=>"Moerduowa", "name:zh_pyt"=>"Móěrduōwǎ", "official_name"=>"Republica Moldova", "official_name:be"=>"Рэспубліка Малдова", "official_name:en"=>"The Republic of Moldova", "official_name:es"=>"República de Moldavia", "official_name:id"=>"Republik Moldova", "official_name:ja"=>"モルドバ共和国", "official_name:lb"=>"Republik Moldawien", "official_name:lv"=>"Moldovas Republika", "official_name:pl"=>"Republika Mołdawii", "official_name:ru"=>"Республика Молдова", "official_name:sk"=>"Moldavská republika", "official_name:sv"=>"Republiken Moldavien", "official_name:vi"=>"Cộng hòa Moldova"	\N	147
tv	"name"=>"Tuvalu", "name:ar"=>"توفالو", "name:be"=>"Тувалу", "name:br"=>"Tuvalu", "name:cy"=>"Twfalw", "name:da"=>"Tuvalu", "name:el"=>"Τουβαλού", "name:en"=>"Tuvalu", "name:eo"=>"Tuvalo", "name:fa"=>"تووالو", "name:fi"=>"Tuvalu", "name:fr"=>"Tuvalu", "name:fy"=>"Tûvalû", "name:ga"=>"Tuvalu", "name:gd"=>"Tubhalu", "name:he"=>"טובלו", "name:hu"=>"Tuvalu", "name:is"=>"Túvalú", "name:ja"=>"ツバル", "name:mn"=>"Тувалу", "name:pl"=>"Tuvalu", "name:ru"=>"Тувалу", "name:sv"=>"Tuvalu", "name:th"=>"ประเทศตูวาลู", "name:uk"=>"Тувалу", "name:zh"=>"吐瓦鲁", "old_name"=>"Ellice Islands"	en	156
uz	"name"=>"Uzbekistan", "name:af"=>"Oesbekistan", "name:ar"=>"أوزبكستان", "name:az"=>"Özbəkistan", "name:be"=>"Узбекістан", "name:br"=>"Ouzbekistan", "name:da"=>"Usbekistan", "name:de"=>"Usbekistan", "name:el"=>"Ουζμπεκιστάν", "name:en"=>"Uzbekistan", "name:eo"=>"Uzbekio", "name:es"=>"Uzbekistán", "name:et"=>"Usbekistan", "name:fa"=>"ازبکستان", "name:fi"=>"Uzbekistan", "name:fr"=>"Ouzbékistan", "name:fy"=>"Oezbekistan", "name:ga"=>"An Úisbéiceastáin", "name:gd"=>"Usbagastàn", "name:he"=>"אוזבקיסטן", "name:hu"=>"Üzbegisztán", "name:is"=>"Úsbekistan", "name:it"=>"Uzbekistan", "name:ja"=>"ウズベキスタン", "name:la"=>"Uzbecia", "name:lb"=>"Usbekistan", "name:lt"=>"Uzbekija", "name:lv"=>"Uzbekistāna", "name:mn"=>"Узбекистан", "name:nl"=>"Oezbekistan", "name:pl"=>"Uzbekistan", "name:pt"=>"Uzbequistão", "name:ru"=>"Узбекистан", "name:sv"=>"Uzbekistan", "name:th"=>"ประเทศอุซเบกิสถาน", "name:tr"=>"Özbekistan", "name:uk"=>"Узбекистан", "name:uz"=>"Ўзбекистон Республикаси (O‘zbekiston Respublikasi)", "name:zh"=>"乌兹别克斯坦", "name:haw"=>"ʻUsepekikana", "name:zh_py"=>"Wuzibiekesitan", "name:zh_pyt"=>"Wūzībiékèsītǎn", "official_name:br"=>"Republik Ouzbekistan", "official_name:el"=>"Δημοκρατία του Ουζμπεκιστάν", "official_name:et"=>"Usbekistani Vabariik", "official_name:gd"=>"Poblachd Usbagastàn", "official_name:id"=>"Republik Usbekistan", "official_name:it"=>"Repubblica dell'Uzbekistan", "official_name:lb"=>"Republik Usbekistan", "official_name:lt"=>"Uzbekistano Respublika", "official_name:pl"=>"Republika Uzbekistanu", "official_name:pt"=>"República do Uzbequistão", "official_name:sv"=>"Republiken Uzbekistan"	\N	157
ly	"name"=>"Libya / ليبيا", "name:af"=>"Libië", "name:am"=>"ሊቢያ", "name:an"=>"Libia", "name:ar"=>"ليبيا", "name:az"=>"Liviya", "name:be"=>"Лівія", "name:bg"=>"Либия", "name:bm"=>"Libya", "name:bn"=>"লিবিয়া", "name:bo"=>"ལིའི་པི་ཡ", "name:br"=>"Libia", "name:bs"=>"Libija", "name:ca"=>"Líbia", "name:cs"=>"Libye", "name:cv"=>"Ливи", "name:cy"=>"Libya", "name:da"=>"Libyen", "name:de"=>"Libyen", "name:el"=>"Λιβύη", "name:en"=>"Libya", "name:eo"=>"Libio", "name:es"=>"Libia", "name:et"=>"Liibüa", "name:eu"=>"Libia", "name:fa"=>"لیبی", "name:fi"=>"Libya", "name:fr"=>"Libye", "name:fy"=>"Libanon", "name:ga"=>"An Libia", "name:gd"=>"Libia", "name:gl"=>"Libia", "name:gv"=>"Yn Leeb", "name:ha"=>"Libya", "name:he"=>"לוב", "name:hi"=>"लीबिया", "name:hr"=>"Libija", "name:ht"=>"Libi", "name:hu"=>"Líbia", "name:hy"=>"Լիբիա", "name:id"=>"Libya", "name:ie"=>"Libya", "name:io"=>"Libia", "name:is"=>"Líbýa", "name:it"=>"Libia", "name:ja"=>"リビア", "name:jv"=>"Libya", "name:ka"=>"ლიბია", "name:kg"=>"Libia", "name:kk"=>"Либия", "name:kn"=>"ಲಿಬ್ಯಾ", "name:ko"=>"리비아", "name:ku"=>"Lîbya", "name:kw"=>"Libi", "name:la"=>"Libya", "name:lb"=>"Libyen", "name:li"=>"Libië", "name:ln"=>"Libîya", "name:lt"=>"Libija", "name:lv"=>"Lībija", "name:mk"=>"Либија", "name:ml"=>"ലിബിയ", "name:mn"=>"Ливи", "name:mr"=>"लिबिया", "name:ms"=>"Libya", "name:nl"=>"Libië", "name:nn"=>"Libya", "name:no"=>"Libya", "name:oc"=>"Libia", "name:os"=>"Ливи", "name:pl"=>"Libia", "name:ps"=>"ليبيا", "name:pt"=>"Líbia", "name:qu"=>"Libya", "name:ro"=>"Libia", "name:ru"=>"Ливия", "name:sa"=>"लिबिया", "name:sc"=>"Lìbia", "name:se"=>"Libya", "name:sh"=>"Libija", "name:si"=>"ලිබියා", "name:sk"=>"Líbya", "name:sl"=>"Libija", "name:sm"=>"Libya", "name:so"=>"Libya", "name:sq"=>"Libia", "name:sr"=>"Либија", "name:sv"=>"Libyen", "name:sw"=>"Libya", "name:ta"=>"லிபியா", "name:te"=>"లిబియా", "name:tg"=>"Либия", "name:th"=>"ประเทศลิเบีย", "name:ti"=>"ሊቢያ", "name:tl"=>"Libya", "name:tr"=>"Libya", "name:ts"=>"Libya", "name:ug"=>"لىۋىيە", "name:uk"=>"Лівія", "name:ur"=>"لیبیا", "name:uz"=>"Liviya", "name:vi"=>"Libya", "name:vo"=>"Lübän", "name:wo"=>"Libi", "name:yi"=>"ליביע", "name:yo"=>"Libya", "name:zh"=>"利比亚", "name:ace"=>"Libya", "name:als"=>"Libye", "name:ang"=>"Libia", "name:arc"=>"ܠܘܒܐ", "name:arz"=>"ليبيا", "name:ast"=>"Libia", "name:bcl"=>"Libya", "name:bpy"=>"লিবিয়া", "name:ceb"=>"Libya", "name:crh"=>"Libiya", "name:diq"=>"Libya", "name:dsb"=>"Libyska", "name:frp"=>"Libie", "name:haw"=>"Libia", "name:hif"=>"Libya", "name:hsb"=>"Libyska", "name:ilo"=>"Libya", "name:jbo"=>"libgu'e", "name:kab"=>"Libya", "name:lij"=>"Libia", "name:nah"=>"Libia", "name:nap"=>"Libbia", "name:nds"=>"Libyen", "name:nov"=>"Libia", "name:pam"=>"Libya", "name:pap"=>"Libia", "name:pms"=>"Libia", "name:pnb"=>"لبیا", "name:sah"=>"Лиибийэ", "name:scn"=>"Libbia", "name:stq"=>"Lybien", "name:szl"=>"Libijo", "name:vec"=>"Łibia", "name:war"=>"Libya", "name:zh_py"=>"Libiya", "name:simple"=>"Libya", "name:zh-yue"=>"利比亞", "name:zh_pyt"=>"Lìbǐyà", "name:bat-smg"=>"Lėbėjė", "name:roa-rup"=>"Libia", "name:be-x-old"=>"Лібія", "official_name"=>"الجماهيرية العربية الليبية الشعبية الإشتراكية العظمى", "name:zh-min-nan"=>"Libya", "official_name:en"=>"Great Socialist People's Libyan Arab Jamahiriya", "official_name:et"=>"Suur Liibüa Araabia Sotsialistlik Rahvadžamahirija", "official_name:lb"=>"Sozialistisch Libysch-Arabisch Volleks-Dschamahirija", "official_name:lt"=>"Libijos Arabų Socialistinė Liaudies Džamahirija", "official_name:lv"=>"Lībijas Sociālistiskā Arābu Tautas Džamāhīrija", "official_name:ru"=>"Ливийская Арабская Джамахирия", "official_name:sv"=>"Libyska arabiska Jamahiriya", "official_name:vi"=>"Đại Dân quốc Ả Rập Libya Nhân dân Xã hội Chủ nghĩa", "name:zh-classical"=>"利比亞"	ar	163
qa	"name"=>"قطر Qatar", "name:af"=>"Katar", "name:ar"=>"قطر", "name:be"=>"Катар", "name:br"=>"Katar", "name:ca"=>"Qatar", "name:cy"=>"Qatar", "name:da"=>"Qatar", "name:de"=>"Katar", "name:el"=>"Κατάρ", "name:en"=>"Qatar", "name:eo"=>"Kataro", "name:es"=>"Qatar", "name:et"=>"Katar", "name:fa"=>"قطر", "name:fi"=>"Qatar", "name:fr"=>"Qatar", "name:fy"=>"Katar", "name:ga"=>"Catar", "name:gd"=>"Catar", "name:he"=>"קטר", "name:hr"=>"Katar", "name:hu"=>"Katar", "name:id"=>"Qatar", "name:is"=>"Katar", "name:it"=>"Qatar", "name:ja"=>"カタール", "name:la"=>"Quataria", "name:lb"=>"Katar", "name:li"=>"Katar", "name:lt"=>"Kataras", "name:lv"=>"Katara", "name:mn"=>"Катар", "name:nl"=>"Qatar", "name:pl"=>"Katar", "name:pt"=>"Qatar", "name:ru"=>"Катар", "name:sl"=>"Katar", "name:sv"=>"Qatar", "name:th"=>"ประเทศกาตาร์", "name:tr"=>"Katar", "name:uk"=>"Катар", "name:vi"=>"Qatar", "name:zh"=>"卡塔尔", "name:haw"=>"Katala", "name:zh_py"=>"Kataer", "name:zh_pyt"=>"Kǎtǎěr", "official_name"=>"دولة قطر", "official_name:el"=>"Κράτος του Κατάρ", "official_name:id"=>"Negara Qatar", "official_name:ja"=>"カタール国", "official_name:lt"=>"Kataro Valstybė", "official_name:lv"=>"Kataras Valsts", "official_name:pt"=>"Estado do Qatar", "official_name:sv"=>"Staten Qatar"	ar	169
nu	"name"=>"Niue", "name:ar"=>"نيوي", "name:be"=>"Ніўэ", "name:br"=>"Niue", "name:da"=>"Niue", "name:el"=>"Νιούε", "name:en"=>"Niue", "name:eo"=>"Niuo", "name:fa"=>"نیووی", "name:fi"=>"Niue", "name:fr"=>"Niue", "name:fy"=>"Niûé", "name:ga"=>"Niue", "name:he"=>"ניואה", "name:hu"=>"Niue", "name:is"=>"Niue", "name:lt"=>"Niujė", "name:lv"=>"Niue", "name:mn"=>"Ниуэ", "name:pl"=>"Niue", "name:ru"=>"Ниуэ", "name:sv"=>"Niue", "name:th"=>"นีอูเอ", "name:uk"=>"Ніуе", "name:zh"=>"紐埃", "alt_name"=>"Rock of Polynesia", "name:niu"=>"Niuē-fekai", "official_name:lt"=>"Niujės Respublika", "official_name:sv"=>"Republiken Niue"	\N	178
tk	"name"=>"Tokelau", "name:ar"=>"توكلو", "name:be"=>"Такелаў", "name:br"=>"Tokelau", "name:da"=>"Tokelau", "name:el"=>"Τοκελάου", "name:en"=>"Tokelau", "name:eo"=>"Tokelao", "name:fa"=>"توکلائو", "name:fi"=>"Tokelau", "name:fr"=>"Tokelau", "name:fy"=>"Tokelaû", "name:ga"=>"Oileáin Tócalá", "name:he"=>"טוקלאו", "name:hu"=>"Tokelau-szigetek", "name:is"=>"Tókelá", "name:mn"=>"Токелау", "name:pl"=>"Tokelau", "name:ru"=>"Токелау", "name:sv"=>"Tokelauöarna", "name:th"=>"โตเกเลา", "name:uk"=>"Токелау", "name:zh"=>"托克劳"	\N	179
me	"name"=>"Crna Gora", "name:af"=>"Montenegro", "name:am"=>"ሞንቴኔግሮ", "name:an"=>"Montenegro", "name:ar"=>"الجبل الأسود", "name:az"=>"Çernoqoriya", "name:be"=>"Чарнагорыя", "name:bg"=>"Черна гора", "name:bn"=>"মন্টিনিগ্রো", "name:br"=>"Montenegro", "name:bs"=>"Crna Gora", "name:by"=>"Чарнагорыя", "name:ca"=>"Montenegro", "name:ce"=>"Черногори", "name:cs"=>"Černá Hora", "name:cu"=>"Чрьна́ Гора́", "name:cv"=>"Черногори", "name:cy"=>"Montenegro", "name:da"=>"Montenegro", "name:de"=>"Montenegro", "name:dv"=>"މޮންޓެނީގުރޯ", "name:ee"=>"Montenegro", "name:el"=>"Μαυροβούνιο", "name:en"=>"Montenegro", "name:eo"=>"Montenegro", "name:es"=>"Montenegro", "name:et"=>"Montenegro", "name:eu"=>"Montenegro", "name:fa"=>"مونته‌نگرو", "name:fi"=>"Montenegro", "name:fo"=>"Montenegro", "name:fr"=>"Monténégro", "name:fy"=>"Montenegro", "name:ga"=>"Montainéagró", "name:gd"=>"Am Monadh Neagrach", "name:gl"=>"Montenegro", "name:gv"=>"Montenegro", "name:he"=>"מונטנגרו", "name:hr"=>"Crna Gora", "name:ht"=>"Montenegwo", "name:hu"=>"Montenegró", "name:hy"=>"Չեռնոգորիա", "name:ia"=>"Montenegro", "name:id"=>"Montenegro", "name:ie"=>"Montenegro", "name:io"=>"Montenegro", "name:is"=>"Svartfjallaland", "name:it"=>"Montenegro", "name:ja"=>"モンテネグロ", "name:jv"=>"Montenégro", "name:ka"=>"მონტენეგრო", "name:kg"=>"Monte Negro", "name:kk"=>"Черногория", "name:kn"=>"ಮಾಂಟೆನೆಗ್ರೊ", "name:ko"=>"몬테네그로", "name:ku"=>"Montenegro", "name:kv"=>"Черногория", "name:kw"=>"Montenegro", "name:ky"=>"Черногория", "name:la"=>"Mons Niger", "name:lb"=>"Montenegro", "name:li"=>"Montenegro", "name:ln"=>"Montenegro", "name:lt"=>"Juodkalnija", "name:lv"=>"Melnkalne", "name:mk"=>"Црна Гора", "name:ml"=>"മോണ്ടെനെഗ്രൊ", "name:mn"=>"Монтенегро", "name:mr"=>"माँटेनिग्रो", "name:ms"=>"Montenegro", "name:nl"=>"Montenegro", "name:nn"=>"Montenegro", "name:no"=>"Montenegro", "name:oc"=>"Montenegro", "name:os"=>"Черногори", "name:pl"=>"Czarnogóra", "name:ps"=>"مانټېنېګرو", "name:pt"=>"Montenegro", "name:qu"=>"Yanaurqu", "name:ro"=>"Muntenegru", "name:ru"=>"Черногория", "name:se"=>"Montenegro", "name:sh"=>"Crna Gora", "name:sk"=>"Čierna Hora", "name:sl"=>"Črna Gora", "name:sq"=>"Mali i Zi", "name:sr"=>"Црна Гора", "name:sv"=>"Montenegro", "name:sw"=>"Montenegro", "name:ta"=>"மொண்டெனேகுரோ", "name:tg"=>"Монтенегро", "name:th"=>"ประเทศมอนเตเนโกร", "name:tl"=>"Montenegro", "name:tr"=>"Karadağ", "name:ug"=>"Chérnogoriye", "name:uk"=>"Чорногорія", "name:ur"=>"مونٹینیگرو", "name:uz"=>"Chernogoriya", "name:vi"=>"Montenegro", "name:vo"=>"Montenegrän", "name:wo"=>"Montenegro", "name:zh"=>"黑山", "name:als"=>"Montenegro", "name:ang"=>"Sweartbeorg", "name:arc"=>"ܛܘܪܐ ܐܘܟܡܐ", "name:arz"=>"مونتينيجرو", "name:ast"=>"Montenegru", "name:bar"=>"Montenegro", "name:bcl"=>"Montenegro", "name:bpy"=>"মন্টিনিগ্রো", "name:ceb"=>"Montenegro", "name:crh"=>"Montenegro", "name:diq"=>"Montenegro", "name:dsb"=>"Carnogórska", "name:frp"=>"Montènègro", "name:haw"=>"Montenegero", "name:hsb"=>"Čorna Hora", "name:ilo"=>"Montenegro", "name:lij"=>"Monteneigro", "name:lmo"=>"Muntnegher", "name:mhr"=>"Шемкурык Эл", "name:nah"=>"Tlīltepēc", "name:nap"=>"Montenegro", "name:nds"=>"Montenegro", "name:nov"=>"Montenegro", "name:nrm"=>"Crna Gora", "name:pap"=>"Montenegro", "name:pih"=>"Montiniegrow", "name:pms"=>"Montnèigr", "name:pnb"=>"مونٹی نیگرو", "name:pnt"=>"Μαυροβούνιον", "name:sah"=>"Монтенегро", "name:scn"=>"Montenegru", "name:sco"=>"Montenegro", "name:szl"=>"Czorno Gůra", "name:vec"=>"Montenégro", "name:war"=>"Montenegro", "name:wuu"=>"黑山共和国", "name:nds-nl"=>"Montenegro", "name:simple"=>"Montenegro", "name:zh-yue"=>"黑山", "name:bat-smg"=>"Joudkalnėjė", "name:fiu-vro"=>"Montõnegro", "name:be-x-old"=>"Чарнагорыя", "name:zh-min-nan"=>"O͘-soaⁿ Kiōng-hô-kok", "official_name:lv"=>"Melnkalnes Republika", "official_name:sk"=>"Čiernohorská republika"	\N	180
aq	"name"=>"Antarctica"	\N	181
as	"name"=>"American Samoa"	\N	182
aw	"name"=>"Aruba"	\N	183
eh	"name"=>"Western Sahara"	\N	186
gu	"name"=>"Guam"	\N	187
hk	"name"=>"Hong Kong"	\N	188
im	"name"=>"Isle of Man"	en	190
mo	"name"=>"Macao"	\N	191
pr	"name"=>"Puerto Rico"	\N	193
ps	"name"=>"Palestinian Territory"	\N	194
pw	"name"=>"Palau"	\N	195
sb	"name"=>"Solomon Islands"	en	201
pf	"name"=>"Polynésie française", "name:af"=>"Franse Polynesië", "name:an"=>"Polinesia Franzesa", "name:ar"=>"بولونيزيا الفرنسية", "name:az"=>"Fransa Polineziyası", "name:be"=>"Французская Палінезія", "name:bg"=>"Френска Полинезия", "name:br"=>"Polinezia Frañs", "name:bs"=>"Francuska Polinezija", "name:ca"=>"Polinèsia Francesa", "name:cs"=>"Francouzská Polynésie", "name:cy"=>"Polynesia Ffrengig", "name:da"=>"Fransk Polynesien", "name:de"=>"Französisch-Polynesien", "name:dv"=>"ފަރަންސޭސި ޕޮލިނޭޝިއާ", "name:el"=>"Γαλλική Πολυνησία", "name:en"=>"French Polynesia", "name:eo"=>"Franca Polinezio", "name:es"=>"Polinesia Francesa", "name:et"=>"Prantsuse Polüneesia", "name:eu"=>"Frantziar Polinesia", "name:fa"=>"پلی‌نزی فرانسه", "name:fi"=>"Ranskan Polynesia", "name:fr"=>"Polynésie française", "name:fy"=>"Frânsk Polyneezje", "name:ga"=>"Polainéis na Fraince", "name:gd"=>"French Polynesia", "name:gl"=>"Polinesia francesa", "name:he"=>"פולינזיה הצרפתית", "name:hi"=>"फ्रेंच पोलीनेशिया", "name:hr"=>"Francuska Polinezija", "name:hu"=>"Francia Polinézia", "name:id"=>"Polinesia Perancis", "name:io"=>"Franca Polinezia", "name:is"=>"Franska Pólýnesía", "name:it"=>"Polinesia francese", "name:ja"=>"フランス領ポリネシア", "name:jv"=>"Polinesia Perancis", "name:kk"=>"Франция Полинезиясы", "name:ko"=>"프랑스령 폴리네시아", "name:kw"=>"Polynesi Frynkek", "name:la"=>"Polynesia Francica", "name:lb"=>"Franséisch-Polynesien", "name:lt"=>"Prancūzijos Polinezija", "name:lv"=>"Franču Polinēzija", "name:mi"=>"Porinīhia Wīwī", "name:mk"=>"Француска Полинезија", "name:mn"=>"Францын Полинез", "name:mr"=>"फ्रेंच पॉलिनेशिया", "name:ms"=>"Polinesia Perancis", "name:nl"=>"Frans-Polynesië", "name:nn"=>"Fransk Polynesia", "name:no"=>"Fransk Polynesia", "name:oc"=>"Polinesia Francesa", "name:os"=>"Францы Полинези", "name:pl"=>"Polinezja Francuska", "name:pt"=>"Polinésia Francesa", "name:qu"=>"Phransis Pulinisya", "name:ro"=>"Polinezia Franceză", "name:ru"=>"Французская Полинезия", "name:se"=>"Frankriikka Polynesia", "name:sh"=>"Francuska Polinezija", "name:sk"=>"Francúzska Polynézia", "name:sl"=>"Francoska Polinezija", "name:sr"=>"Француска Полинезија", "name:sv"=>"Franska Polynesien", "name:sw"=>"Polynesia ya Kifaransa", "name:ta"=>"பிரெஞ்சு பொலினீசியா", "name:th"=>"เฟรนช์โปลินีเซีย", "name:tr"=>"Fransız Polinezyası", "name:ty"=>"Pōrīnetia Farāni", "name:ug"=>"Fransiyige Qarashliq Polinéziye", "name:uk"=>"Французька Полінезія", "name:vi"=>"Polynésie thuộc Pháp", "name:wo"=>"Polineesi gu Faraas", "name:zh"=>"法属波利尼西亚", "name:bpy"=>"ফ্যাঞ্চ পলিনেসিয়া", "name:frp"=>"Polinèsie francêsa", "name:lij"=>"Polinesia Françeise", "name:pam"=>"French Polynesia", "name:simple"=>"French Polynesia", "name:bat-smg"=>"Prancūzėjės Polinezėjė", "name:be-x-old"=>"Француская Палінэзія", "name:zh-min-nan"=>"Hoat-kok Polynésie", "official_name:lv"=>"Francijas Polinēzijas teritorija"	fr	202
mf	"name"=>"Saint Martin"	fr	203
bl	"name"=>"Saint Barthélemy"	fr	204
gh	"name"=>"Ghana", "name:ar"=>"غانا", "name:be"=>"Гана", "name:br"=>"Ghana", "name:da"=>"Ghana", "name:el"=>"Γκάνα", "name:en"=>"Ghana", "name:eo"=>"Ganao", "name:es"=>"Ghana", "name:fa"=>"غنا", "name:fi"=>"Ghana", "name:fr"=>"Ghana", "name:fy"=>"Gana", "name:ga"=>"Gána", "name:gd"=>"Gàna", "name:he"=>"גאנה", "name:hr"=>"Gana", "name:hu"=>"Ghána", "name:is"=>"Gana", "name:it"=>"Ghana", "name:ja"=>"ガーナ", "name:la"=>"Gana", "name:li"=>"Gana", "name:lt"=>"Gana", "name:lv"=>"Gana", "name:mn"=>"Гана", "name:pl"=>"Ghana", "name:pt"=>"Gana", "name:ru"=>"Гана", "name:sl"=>"Gana", "name:sv"=>"Ghana", "name:th"=>"ประเทศกานา", "name:tr"=>"Gana", "name:uk"=>"Ґана", "name:zh"=>"加纳", "name:haw"=>"Gāna", "name:zh_py"=>"Jiana", "name:zh_pyt"=>"Jiānà", "official_name"=>"Republic of Ghana", "official_name:be"=>"Рэспубліка Гана", "official_name:el"=>"Δημοκρατία της Γκάνας", "official_name:gd"=>"Poblachd Ghàna", "official_name:id"=>"Republik Ghana", "official_name:lt"=>"Ganos Respublika", "official_name:lv"=>"Ganas Republika", "official_name:pt"=>"República do Gana", "official_name:sv"=>"Republiken Ghana", "official_name:vi"=>"Cộng hòa Ghana"	en	211
ax	"name"=>"Aland Islands"	sv	184
bv	"name"=>"Bouvet Island"	no	185
cx	"name"=>"Christmas Island", "name:af"=>"Christmas-eiland", "name:ar"=>"جزيرة الميلاد", "name:bg"=>"Рождество", "name:br"=>"Enez Nedeleg", "name:bs"=>"Božićno ostrvo", "name:ca"=>"Illa Christmas", "name:cs"=>"Vánoční ostrov", "name:cy"=>"Ynys y Nadolig", "name:da"=>"Juleøen", "name:de"=>"Weihnachtsinsel", "name:el"=>"Νήσος των Χριστουγέννων", "name:eo"=>"Kristnaskinsulo", "name:es"=>"Isla de Navidad", "name:et"=>"Jõulusaar", "name:eu"=>"Christmas uhartea", "name:fa"=>"جزیره کریسمس", "name:fi"=>"Joulusaari", "name:fr"=>"Île Christmas", "name:fy"=>"Krysteilân", "name:ga"=>"Oileán na Nollag", "name:gl"=>"Illa de Nadal", "name:he"=>"טריטוריית האי חג המולד", "name:hi"=>"क्रिसमस आईलैंड", "name:hr"=>"Božićni otok", "name:hu"=>"Karácsony-sziget", "name:id"=>"Pulau Natal", "name:is"=>"Jólaeyja", "name:it"=>"Isola del Natale", "name:ja"=>"クリスマス島", "name:ka"=>"შობის კუნძული", "name:kk"=>"Кристмас аралы", "name:ko"=>"크리스마스 섬", "name:kw"=>"Ynys Nadelik", "name:lb"=>"Chrëschtdagsinsel", "name:lt"=>"Kalėdų sala", "name:lv"=>"Ziemsvētku sala", "name:mn"=>"Зул Сарын Арал", "name:mr"=>"क्रिसमस द्वीप", "name:ms"=>"Pulau Krismas", "name:nl"=>"Christmaseiland", "name:nn"=>"Christmasøya", "name:no"=>"Christmasøya", "name:pl"=>"Wyspa Bożego Narodzenia", "name:pt"=>"Ilha Christmas", "name:ro"=>"Insula Crăciunului", "name:ru"=>"Остров Рождества", "name:sh"=>"Božićni otok", "name:sk"=>"Vianočný ostrov", "name:sl"=>"Božični otoki", "name:sr"=>"Божићно Острво", "name:sv"=>"Julön", "name:sw"=>"Kisiwa cha Krismasi", "name:ta"=>"கிறிஸ்துமசு தீவு", "name:th"=>"เกาะคริสต์มาส", "name:tr"=>"Christmas Adası", "name:uk"=>"Острів Різдва", "name:vi"=>"Đảo Christmas", "name:wo"=>"Dunu Christmas", "name:zh"=>"圣诞岛", "name:bpy"=>"ক্রিসমাস দ্বীপমালা", "name:lij"=>"Isoa Christmas", "official_name"=>"Territory of Christmas Island", "name:zh-min-nan"=>"Christmas-tó", "official_name:es"=>"Territorio de la Isla de Navidad", "official_name:lv"=>"Ziemsvētku salas teritorija", "official_name:pl"=>"Terytorium Wyspy Bożego Narodzenia"	en	177
hm	"name"=>"Heard Island and MaxDonald Islands"	en	189
mp	"name"=>"Northern Mariana Islands"	ch	192
sh	"name"=>"Saint Helena"	en	196
sj	"name"=>"Svalbard and Jan Mayen"	no	197
sk	"name"=>"Slovensko", "name:af"=>"Slowakye", "name:ar"=>"جمهورية سلوفاكيا", "name:be"=>"Славакія", "name:br"=>"Slovakia", "name:ca"=>"Eslovàquia", "name:cy"=>"Slofacia", "name:da"=>"Slovakiet", "name:de"=>"Slowakei", "name:el"=>"Σλοβακία", "name:en"=>"Slovakia", "name:eo"=>"Slovakio", "name:es"=>"Eslovaquia", "name:et"=>"Slovakkia", "name:fa"=>"اسلواکی", "name:fi"=>"Slovakia", "name:fr"=>"Slovaquie", "name:fy"=>"Slowakije", "name:ga"=>"An tSlóvaic", "name:gd"=>"An t-Slòbhac", "name:he"=>"סלובקיה", "name:hr"=>"Slovačka", "name:hu"=>"Szlovákia", "name:id"=>"Slowakia", "name:is"=>"Slóvakía", "name:it"=>"Slovacchia", "name:la"=>"Slovacia", "name:lb"=>"Slowakei", "name:li"=>"Slowakieë", "name:lt"=>"Slovakija", "name:mn"=>"Словак", "name:nl"=>"Slowakije", "name:pl"=>"Słowacja", "name:pt"=>"Eslováquia", "name:ru"=>"Словакия", "name:sk"=>"Slovenská republika", "name:sl"=>"Slovaška", "name:sv"=>"Slovakien", "name:th"=>"ประเทศสโลวาเกีย", "name:tr"=>"Slovakya", "name:uk"=>"Словаччина", "name:vi"=>"Slovakia", "name:zh"=>"斯洛伐克", "name:haw"=>"Solowakia", "name:zh_py"=>"Siluofake", "name:zh_pyt"=>"Sīluòfákè", "official_name:el"=>"Δημοκρατία της Σλοβακίας", "official_name:et"=>"Slovaki Vabariik", "official_name:fr"=>"République slovaque", "official_name:id"=>"Republik Slowakia", "official_name:lt"=>"Slovakijos Respublika", "official_name:pt"=>"República Eslovaca", "official_name:sv"=>"Republiken Slovakien", "official_name:vi"=>"Cộng hòa Slovakia"	sk	172
um	"name"=>"United States Minor Outlying Islands"	en	198
vi	"name"=>"United States Virgin Islands"	en	199
yt	"name"=>"Mayotte"	fr	200
it	"name"=>"Italia", "name:af"=>"Italië", "name:ar"=>"إيطاليا", "name:be"=>"Італія", "name:br"=>"Italia", "name:ca"=>"Itàlia", "name:cy"=>"Yr Eidal", "name:da"=>"Italien", "name:de"=>"Italien", "name:el"=>"Ιταλία", "name:en"=>"Italy", "name:eo"=>"Italio", "name:et"=>"Itaalia", "name:fa"=>"ایتالیا", "name:fi"=>"Italia", "name:fr"=>"Italie", "name:fy"=>"Itaalje", "name:ga"=>"An Iodáil", "name:gd"=>"An Eadailt", "name:he"=>"איטליה", "name:hr"=>"Italija", "name:hu"=>"Olaszország", "name:hy"=>"Իտալիա", "name:is"=>"Ítalía", "name:it"=>"Italia", "name:ja"=>"イタリア", "name:lb"=>"Italien", "name:li"=>"Italië", "name:lt"=>"Italija", "name:lv"=>"Itālija", "name:mn"=>"Итали", "name:nl"=>"Italië", "name:pl"=>"Włochy", "name:ru"=>"Италия", "name:sk"=>"Taliansko", "name:sl"=>"Italija", "name:sv"=>"Italien", "name:th"=>"ประเทศอิตาลี", "name:tr"=>"İtalya", "name:uk"=>"Італія", "name:vi"=>"Ý", "name:zh"=>"意大利", "name:fur"=>"Italie", "name:haw"=>"ʻĪkālia", "name:zh_py"=>"Yidali", "name:zh_pyt"=>"Yìdàlì", "official_name"=>"Repubblica Italiana", "official_name:be"=>"Італьянская Рэспубліка", "official_name:el"=>"Ιταλική Δημοκρατία", "official_name:et"=>"Itaalia Vabariik", "official_name:fr"=>"République italienne", "official_name:id"=>"Republik Italia", "official_name:it"=>"Repubblica Italiana", "official_name:lb"=>"Italienisch Republik", "official_name:lt"=>"Italijos Respublika", "official_name:sk"=>"Talianska republika", "official_name:sv"=>"Republiken Italien", "official_name:vi"=>"Cộng hoà Ý"	\N	28
gq	"name:af"=>"Ekwatoriaal-Guinee", "name:am"=>"ኢኳቶሪያል ጊኔ", "name:an"=>"Guinea Ecuatorial", "name:ar"=>"غينيا الاستوائية", "name:az"=>"Ekvatorial Qvineya", "name:be"=>"Экватарыяльная Гвінея", "name:bg"=>"Екваториална Гвинея", "name:bm"=>"Cemajan Gine", "name:br"=>"Ginea ar C’heheder", "name:bs"=>"Ekvatorijalna Gvineja", "name:ca"=>"Guinea Equatorial", "name:co"=>"Guinea Equatoriale", "name:cs"=>"Rovníková Guinea", "name:cv"=>"Экваториаллă Гвиней", "name:cy"=>"Guinea Gyhydeddol", "name:da"=>"Ækvatorialguinea", "name:de"=>"Äquatorialguinea", "name:dv"=>"އިކުއެޓޯރިއަލް ގިނީ", "name:el"=>"Ισημερινή Γουινέα", "name:en"=>"Equatorial Guinea", "name:eo"=>"Ekvatora Gvineo", "name:es"=>"Guinea Ecuatorial", "name:et"=>"Ekvatoriaal-Guinea", "name:eu"=>"Ekuatore Ginea", "name:fa"=>"گینه استوایی", "name:fi"=>"Päiväntasaajan Guinea", "name:fo"=>"Ekvatorguinea", "name:fr"=>"Guinée équatoriale", "name:fy"=>"Ekwatoriaal Guinee", "name:ga"=>"An Ghuine Mheánchriosach", "name:gd"=>"Gini Mheadhan-Chriosach", "name:gl"=>"Guinea Ecuatorial", "name:gv"=>"Guinea Chryss ny Cruinney", "name:he"=>"גינאה המשוונית", "name:hi"=>"ईक्वीटोरियल गिनी", "name:hr"=>"Ekvatorska Gvineja", "name:ht"=>"Gine ekwateryal", "name:hu"=>"Egyenlítői-Guinea", "name:ia"=>"Guinea Equatorial", "name:id"=>"Guinea Khatulistiwa", "name:ie"=>"Equatorial Guinéa", "name:io"=>"Equatorala Guinea", "name:is"=>"Miðbaugs-Gínea", "name:it"=>"Guinea Equatoriale", "name:ja"=>"赤道ギニア", "name:jv"=>"Guinea Khatulistiwa", "name:ka"=>"ეკვატორული გვინეა", "name:kk"=>"Екуатор Гиния", "name:kn"=>"ವಿಷುವದ್ರೇಖೆಯ ಗಿನಿ", "name:ko"=>"적도 기니", "name:ku"=>"Gînêya Rojbendî", "name:kw"=>"Gyni Ekwadoriel", "name:la"=>"Guinea Aequatorensis", "name:lb"=>"Equatorialguinea", "name:li"=>"Equatoriaal Guinee", "name:ln"=>"Gine-Ekwatorial", "name:lt"=>"Pusiaujo Gvinėja", "name:lv"=>"Ekvatoriālā Gvineja", "name:mk"=>"Екваторијална Гвинеја", "name:ml"=>"ഇക്വറ്റോറിയല്‍ ഗിനി", "name:mn"=>"Экваторын Гвиней", "name:mr"=>"इक्वेटोरीयल गिनी", "name:ms"=>"Guinea Khatulistiwa", "name:nb"=>"Ekvatorial-Guinea", "name:nl"=>"Equatoriaal-Guinea", "name:nn"=>"Ekvatorial-Guinea", "name:no"=>"Ekvatorial-Guinea", "name:oc"=>"Guinèa Eqüatoriala", "name:os"=>"Экваториалон Гвиней", "name:pl"=>"Gwinea Równikowa", "name:ps"=>"اېکواټوريال ګوينا", "name:pt"=>"Guiné Equatorial", "name:qu"=>"Chawpipacha Khiniya", "name:ro"=>"Guineea Ecuatorială", "name:ru"=>"Экваториальная Гвинея", "name:sc"=>"Guinea Ecuadoriale", "name:se"=>"Beaivvedási Guinea", "name:sh"=>"Ekvatorijalna Gvineja", "name:sk"=>"Rovníková Guinea", "name:sl"=>"Ekvatorialna Gvineja", "name:sq"=>"Guineja Ekuatoriale", "name:sr"=>"Екваторијална Гвинеја", "name:sv"=>"Ekvatorialguinea", "name:sw"=>"Guinea ya Ikweta", "name:ta"=>"எக்குவடோரியல் கினி", "name:tg"=>"Гвинеяи Истивоӣ", "name:th"=>"ประเทศอิเควทอเรียลกินี", "name:tl"=>"Equatorial Guinea", "name:tr"=>"Ekvator Ginesi", "name:ts"=>"Equatorial Guinea", "name:ug"=>"Ékwator Gwinéyisi", "name:uk"=>"Екваторіальна Гвінея", "name:ur"=>"استوائی گنی", "name:uz"=>"Ekvatorli Gvineya", "name:vi"=>"Guinea Xích Đạo", "name:vo"=>"Kveatora-Gineyän", "name:wo"=>"Gineg yamoo", "name:zh"=>"赤道几内亚", "name:als"=>"Äquatorialguinea", "name:arz"=>"جينيا الاستوائيه", "name:ast"=>"Guinea Ecuatorial", "name:bcl"=>"Guineyang Ekwatoryal", "name:bpy"=>"একুয়াটরিয়াল গায়ানা", "name:ceb"=>"Guinea Ecuatorial", "name:crh"=>"Ekvatorial Gvineya", "name:diq"=>"Gineya Ekwatori", "name:frp"=>"Guinê èquatoriâla", "name:hif"=>"Equatorial Guinea", "name:lij"=>"Guinea Equatoriâ", "name:lmo"=>"Guinea Equaturiala", "name:nah"=>"Guinea Tlahcotlālticpac", "name:nds"=>"Äquatoriaal-Guinea", "name:nov"=>"Equatoral Gini", "name:pam"=>"Equatorial Guinea", "name:pms"=>"Guinea Equatorial", "name:pnb"=>"استوائی گنی", "name:sah"=>"Экуатор Гуинеята", "name:scn"=>"Guinia Ecuaturiali", "name:stq"=>"Äquatorioal Guinea", "name:vec"=>"Guinea Equatorial", "name:zea"=>"Equatoriaol Hunea", "name:zh_py"=>"Chidao Jineiya", "name:simple"=>"Equatorial Guinea", "name:zh_pyt"=>"Chìdào Jīnèiyà", "name:bat-smg"=>"Ekvatuorė Gvinėjė", "name:fiu-vro"=>"Ekvatoriaal-Ginea", "name:be-x-old"=>"Экватарыяльная Ґвінэя", "official_name"=>"República de Guinea Ecuatorial;République de Guinée équatoriale;República da Guiné Equatorial", "name:zh-min-nan"=>"Chhiah-tō Guinea", "official_name:el"=>"Δημοκρατία της Ισημερινής Γουινέας", "official_name:et"=>"Ekvatoriaal-Guinea Vabariik", "official_name:id"=>"Republik Guinea Khatulistiwa", "official_name:lt"=>"Pusiaujo Gvinėjos Respublika", "official_name:lv"=>"Ekvatoriālās Gvinejas Republika", "official_name:pt"=>"República da Guiné Equatorial", "official_name:sv"=>"Republiken Ekvatorialguinea", "official_name:vi"=>"Cộng hòa Guinea Xích Đạo"	\N	12
pk	"name"=>"پاکستان", "name:af"=>"Pakistan", "name:an"=>"Pakistán", "name:ar"=>"باكستان", "name:as"=>"পাকিস্তান", "name:az"=>"Pakistan", "name:ba"=>"Пакистан", "name:be"=>"Пакістан", "name:bg"=>"Пакистан", "name:bn"=>"পাকিস্তান", "name:bo"=>"པ་ཀི་སི་ཏན།", "name:br"=>"Pakistan", "name:bs"=>"Pakistan", "name:ca"=>"Pakistan", "name:cs"=>"Pákistán", "name:cv"=>"Пакистан", "name:cy"=>"Pakistan", "name:da"=>"Pakistan", "name:de"=>"Pakistan", "name:dv"=>"ޕާކިސްތާން", "name:el"=>"Πακιστάν", "name:en"=>"Pakistan", "name:eo"=>"Pakistano", "name:es"=>"Pakistán", "name:et"=>"Pakistan", "name:eu"=>"Pakistan", "name:fa"=>"پاکستان", "name:fi"=>"Pakistan", "name:fr"=>"Pakistan", "name:fy"=>"Pakistan", "name:ga"=>"An Phacastáin", "name:gd"=>"Pagastàn", "name:gl"=>"Paquistán", "name:gn"=>"Pakistán", "name:gu"=>"પાકિસ્તાન", "name:gv"=>"Yn Phakistaan", "name:ha"=>"Pakistan", "name:he"=>"פקיסטן", "name:hi"=>"पाकिस्तान", "name:hr"=>"Pakistan", "name:ht"=>"Pakistan", "name:hu"=>"Pakisztán", "name:hy"=>"Պակիստան", "name:id"=>"Pakistan", "name:ie"=>"Pakistan", "name:io"=>"Pakistan", "name:is"=>"Pakistan", "name:it"=>"Pakistan", "name:iu"=>"ᐸᑭᔅᑕᓐ/pakistan", "name:ja"=>"パキスタン", "name:jv"=>"Pakistan", "name:ka"=>"პაკისტანი", "name:kk"=>"Пәкістан", "name:kl"=>"Pakistan", "name:kn"=>"ಪಾಕಿಸ್ತಾನ", "name:ko"=>"파키스탄", "name:ks"=>"पाकिस्‍तान", "name:ku"=>"Pakistan", "name:kv"=>"Пакистан", "name:kw"=>"Pakistan", "name:ky"=>"Пакистан", "name:la"=>"Pakistania", "name:lb"=>"Pakistan", "name:li"=>"Pakistan", "name:ln"=>"Pakistáni", "name:lt"=>"Pakistanas", "name:lv"=>"Pakistāna", "name:mk"=>"Пакистан", "name:ml"=>"പാകിസ്താന്‍", "name:mn"=>"Пакистан", "name:mr"=>"पाकिस्तान", "name:ms"=>"Pakistan", "name:mt"=>"Pakistan", "name:nb"=>"Pakistan", "name:nl"=>"Pakistan", "name:nn"=>"Pakistan", "name:no"=>"Pakistan", "name:oc"=>"Paquistan", "name:or"=>"ପାକିସ୍ତାନ", "name:os"=>"Пакистан", "name:pa"=>"ਪਾਕਿਸਤਾਨ", "name:pl"=>"Pakistan", "name:ps"=>"پاکستان", "name:pt"=>"Paquistão", "name:qu"=>"Pakistan", "name:ro"=>"Pakistan", "name:ru"=>"Пакистан", "name:sa"=>"पाकिस्तान", "name:sd"=>"پاکستان", "name:se"=>"Pakistan", "name:sh"=>"Pakistan", "name:sk"=>"Pakistan", "name:sl"=>"Pakistan", "name:sq"=>"Pakistani", "name:sr"=>"Пакистан", "name:su"=>"Pakistan", "name:sv"=>"Pakistan", "name:sw"=>"Pakistan", "name:ta"=>"பாக்கித்தான்", "name:te"=>"పాకిస్తాన్", "name:tg"=>"Покистон", "name:th"=>"ประเทศปากีสถาน", "name:tk"=>"Päkistan", "name:tl"=>"Pakistan", "name:tr"=>"Pakistan", "name:ug"=>"پاكىستان", "name:uk"=>"Пакистан", "name:ur"=>"پاکستان", "name:uz"=>"Pokiston", "name:vi"=>"Pakistan", "name:vo"=>"Pakistän", "name:wa"=>"Pakistan", "name:wo"=>"Pakistaan", "name:yi"=>"פאקיסטאן", "name:yo"=>"Pakistan", "name:zh"=>"巴基斯坦", "name:ace"=>"Pakistan", "name:als"=>"Pakistan", "name:arc"=>"ܦܩܝܣܛܢ", "name:arz"=>"باكيستان", "name:ast"=>"Paquistán", "name:bcl"=>"Pakistan", "name:bpy"=>"পাকিস্তান", "name:ceb"=>"Pakistan", "name:crh"=>"Pakistan", "name:csb"=>"Pakistan", "name:diq"=>"Pakıstan", "name:dsb"=>"Pakistan", "name:frp"=>"Paquistan", "name:gan"=>"巴基斯坦", "name:hak"=>"Pâ-kî-sṳ̂-thán", "name:haw"=>"Pakitana", "name:hif"=>"Pakistan", "name:hsb"=>"Pakistan", "name:ilo"=>"Pakistan", "name:jbo"=>"kisygu'e", "name:kab"=>"Pakistan", "name:lij"=>"Pakistan", "name:lmo"=>"Pakistan", "name:mdf"=>"Пакистан", "name:mhr"=>"Пакистан", "name:nah"=>"Paquistan", "name:nds"=>"Pakistan", "name:nov"=>"Pakistan", "name:pam"=>"Pakistan", "name:pap"=>"Pakistan", "name:pms"=>"Pakistan", "name:pnb"=>"پاکستان", "name:rmy"=>"Pakistan", "name:sah"=>"Пакистан", "name:scn"=>"Pakistan", "name:sco"=>"Pakistan", "name:szl"=>"Pakistan", "name:udm"=>"Пакистан", "name:vec"=>"Pakistan", "name:war"=>"Pakistan", "name:wuu"=>"巴基斯坦", "name:zh_py"=>"Bajisitan", "name:simple"=>"Pakistan", "name:zh-yue"=>"巴基斯坦", "name:zh_pyt"=>"Bājīsītǎn", "name:bat-smg"=>"Pakėstans", "name:cbk-zam"=>"Pakistan", "name:be-x-old"=>"Пакістан", "official_name"=>"Islamic Republic of Pakistan", "name:zh-min-nan"=>"Pakistan", "official_name:af"=>"Islamistiese Republiek van Pakistan", "official_name:br"=>"Republik islamek Pakistan", "official_name:el"=>"Ισλαμική Δημοκρατία του Πακιστάν", "official_name:fr"=>"République islamique du Pakistan", "official_name:id"=>"Republik Islam Pakistan", "official_name:it"=>"Repubblica Islamica del Pakistan", "official_name:lb"=>"Islamische Republik Pakistan", "official_name:lt"=>"Pakistano Islamo Respublika", "official_name:lv"=>"Pakistānas Islāma Republika", "official_name:pl"=>"Islamska Republika Pakistanu", "official_name:sv"=>"Islamiska republiken Pakistan", "official_name:ur"=>"اسلامی جمہوریۂ پاکستان", "official_name:vi"=>"Cộng hoà Hồi giáo Pakistan", "name:zh-classical"=>"巴基斯坦"	\N	14
be	"name"=>"België - Belgique - Belgien", "name:af"=>"België", "name:am"=>"ቤልጅግ", "name:an"=>"Belchica", "name:ar"=>"بلجيكا", "name:az"=>"Belçika", "name:be"=>"Бельгія", "name:bg"=>"Белгия", "name:bn"=>"বেলজিয়াম", "name:bo"=>"པེར་ཅིན།", "name:br"=>"Belgia", "name:bs"=>"Belgija", "name:ca"=>"Bèlgica", "name:ce"=>"Бельге", "name:co"=>"Belgica", "name:cs"=>"Belgie", "name:cv"=>"Бельги", "name:cy"=>"Gwlad Belg", "name:da"=>"Belgien", "name:de"=>"Belgien", "name:dv"=>"ބެލްޖިއަމް", "name:dz"=>"བེལ་ཇིཡམ", "name:ee"=>"Belgium", "name:el"=>"Βέλγιο", "name:en"=>"Belgium", "name:eo"=>"Belgio", "name:es"=>"Bélgica", "name:et"=>"Belgia", "name:eu"=>"Belgika", "name:fa"=>"بلژیک", "name:fi"=>"Belgia", "name:fo"=>"Belgia", "name:fr"=>"Belgique", "name:fy"=>"Belgje", "name:ga"=>"An Bheilg", "name:gd"=>"A' Bheilg", "name:gl"=>"Bélxica", "name:gv"=>"Yn Velg", "name:he"=>"בלגיה", "name:hr"=>"Belgija", "name:ht"=>"Bèljik", "name:hu"=>"Belgium", "name:hy"=>"Բելգիա", "name:ia"=>"Belgica", "name:id"=>"Belgia", "name:ie"=>"Belgia", "name:io"=>"Belgia", "name:is"=>"Belgía", "name:it"=>"Belgio", "name:ja"=>"ベルギー", "name:jv"=>"Bèlgia", "name:ka"=>"ბელგია", "name:kk"=>"Белгия", "name:kl"=>"Belgia", "name:ko"=>"벨기에", "name:ku"=>"Belgiya", "name:kv"=>"Бельгия", "name:kw"=>"Pow Belg", "name:ky"=>"Бельгия", "name:la"=>"Belgia", "name:lb"=>"Belsch", "name:li"=>"Belsj", "name:ln"=>"Bɛ́ljika", "name:lt"=>"Belgija", "name:lv"=>"Beļģija", "name:mg"=>"Belzika", "name:mk"=>"Белгија", "name:ml"=>"ബെല്‍ജിയം", "name:mn"=>"Бельги", "name:mr"=>"बेल्जियम", "name:ms"=>"Belgium", "name:mt"=>"Belġju", "name:na"=>"Belgium", "name:nb"=>"Belgia", "name:ne"=>"बेल्जियम", "name:nl"=>"België", "name:nn"=>"Belgia", "name:no"=>"Belgia", "name:oc"=>"Belgica", "name:os"=>"Бельги", "name:pl"=>"Belgia", "name:pt"=>"Bélgica", "name:qu"=>"Bilhika", "name:rm"=>"Belgia", "name:ro"=>"Belgia", "name:ru"=>"Бельгия", "name:rw"=>"U Bubiligi", "name:sa"=>"बेल्जियम", "name:se"=>"Belgia", "name:sh"=>"Belgija", "name:sk"=>"Belgicko", "name:sl"=>"Belgija", "name:sq"=>"Belgjika", "name:sr"=>"Белгија", "name:su"=>"Bélgia", "name:sv"=>"Belgien", "name:sw"=>"Ubelgiji", "name:ta"=>"பெல்ஜியம்", "name:te"=>"బెల్జియం", "name:tg"=>"Белгия", "name:th"=>"ประเทศเบลเยียม", "name:tl"=>"Belhika", "name:tr"=>"Belçika", "name:tt"=>"Бельгия", "name:ug"=>"بېلگىيە", "name:uk"=>"Бельгія", "name:ur"=>"بلجئیم", "name:uz"=>"Belgiya", "name:vi"=>"Bỉ", "name:vo"=>"Belgän", "name:wa"=>"Beldjike", "name:wo"=>"Belsik", "name:yi"=>"בעלגיע", "name:yo"=>"Belgium", "name:zh"=>"比利时", "name:als"=>"Belgie", "name:ang"=>"Belgice", "name:arc"=>"ܒܠܓܝܟܐ", "name:arz"=>"بلجيكا", "name:ast"=>"Bélxica", "name:bar"=>"Belgien", "name:bcl"=>"Belhika", "name:bpy"=>"বেলজিয়াম", "name:ceb"=>"Belhika", "name:ckb"=>"به‌لجیكا", "name:crh"=>"Belçika", "name:csb"=>"Belgijskô", "name:diq"=>"Belçıka", "name:dsb"=>"Belgiska", "name:frp"=>"Bèlg·ique", "name:fur"=>"Belgjo", "name:hak"=>"Pí-li-sṳ", "name:haw"=>"Pelekiuma", "name:hif"=>"Belgium", "name:hsb"=>"Belgiska", "name:ilo"=>"Belgium", "name:jbo"=>"beldjym", "name:kab"=>"Biljik", "name:ksh"=>"Belljie", "name:lad"=>"Beljika", "name:lij"=>"Belgiò", "name:mdf"=>"Бельгия", "name:nah"=>"Belgica", "name:nap"=>"Belge", "name:nds"=>"Belgien", "name:nov"=>"Belgia", "name:nrm"=>"Belgique", "name:pam"=>"Belgium", "name:pap"=>"Bélgika", "name:pdc"=>"Belgien", "name:pih"=>"Beljum", "name:pms"=>"Belgi", "name:pnb"=>"بیلجیم", "name:pnt"=>"Βέλγιον", "name:rmy"=>"Beljiya", "name:sah"=>"Бельгия", "name:scn"=>"Belgiu", "name:sco"=>"Belgium", "name:srn"=>"Belgikondre", "name:stq"=>"Belgien", "name:szl"=>"Belgijo", "name:tet"=>"Béljika", "name:tpi"=>"Beljiam", "name:udm"=>"Бельгия", "name:vec"=>"Belgio", "name:vls"=>"België", "name:war"=>"Belhika", "name:wuu"=>"比利时", "name:zea"=>"Belhië", "name:zh_py"=>"Bilishi", "name:nds-nl"=>"België", "name:simple"=>"Belgium", "name:zh-yue"=>"比利時", "name:zh_pyt"=>"Bǐlìshí", "name:bat-smg"=>"Belgėjė", "name:fiu-vro"=>"Belgiä", "name:roa-rup"=>"Belghia", "name:be-x-old"=>"Бэльґія", "official_name"=>"Koninkrijk België;Royaume de Belgique;Königreich Belgien", "name:zh-min-nan"=>"Belgien", "official_name:be"=>"Каралеўства Бельгія", "official_name:da"=>"Koninkrijk België", "official_name:de"=>"Königreich Belgien", "official_name:el"=>"Βασίλειο του Βελγίου", "official_name:en"=>"Kingdom of Belgium", "official_name:es"=>"Reino de Bélgica", "official_name:fr"=>"Royaume de Belgique", "official_name:id"=>"Kerajaan Belgia", "official_name:ja"=>"ベルギー王国", "official_name:lt"=>"Belgijos Karalystė", "official_name:lv"=>"Beļģijas Karaliste", "official_name:nl"=>"Koninkrijk België", "official_name:pl"=>"Królestwo Belgii", "official_name:pt"=>"Reino da Bélgica", "official_name:sk"=>"Belgické kráľovstvo", "official_name:sv"=>"Konungariket Belgien", "official_name:vi"=>"Vương quốc Bỉ"	\N	15
ph	"name"=>"Philippines", "name:af"=>"Filippyne", "name:ar"=>"الفلبين", "name:be"=>"Філіпіны", "name:br"=>"Filipinez", "name:ca"=>"Filipines", "name:cy"=>"Pilipinas", "name:da"=>"Filippinerne", "name:de"=>"Philippinen", "name:el"=>"Φιλιππίνες", "name:eo"=>"Filipinoj", "name:es"=>"Filipinas", "name:fa"=>"فیلیپین", "name:fi"=>"Filippiinit", "name:fr"=>"Philippines", "name:fy"=>"de Filipinen", "name:ga"=>"Na hOileáin Fhilipíneacha", "name:gd"=>"Na h-Eileanan Filipineach", "name:he"=>"פיליפינים", "name:hr"=>"Filipini", "name:hu"=>"Fülöp-szigetek", "name:id"=>"Filipina", "name:is"=>"Filippseyjar", "name:it"=>"Filippine", "name:ja"=>"フィリピン", "name:la"=>"Philippinae", "name:lb"=>"Philippinen", "name:li"=>"De Filipiene", "name:lt"=>"Filipinai", "name:lv"=>"Filipīnas", "name:mn"=>"Филиппин", "name:nl"=>"Filipijnen", "name:pl"=>"Filipiny", "name:ru"=>"Филиппины", "name:sl"=>"Filipini", "name:sv"=>"Filippinerna", "name:th"=>"ประเทศฟิลิปปินส์", "name:tl"=>"Pilipinas", "name:tr"=>"Filipinler", "name:uk"=>"Філіппіни", "name:zh"=>"菲律宾", "name:haw"=>"ʻĀina Pilipino", "name:zh_py"=>"Feilübin", "name:zh_pyt"=>"Fēilǜbīn", "official_name"=>"Republic of the Philippines", "official_name:br"=>"Republik Filipinez", "official_name:el"=>"Δημοκρατία των Φιλιππίνων", "official_name:en"=>"Republic of the Philippines", "official_name:id"=>"Republik Filipina", "official_name:it"=>"Repubblica delle Filippine", "official_name:lb"=>"Republik vu de Philippinen", "official_name:lt"=>"Filipinų Respublika", "official_name:pl"=>"Republika Filipin", "official_name:sv"=>"Republiken Filippinerna", "official_name:tl"=>"Republika ng Pilipinas", "official_name:vi"=>"Cộng hoà Philippines"	\N	26
al	"name"=>"Shqipëria", "name:af"=>"Albanië", "name:am"=>"አልባኒያ", "name:an"=>"Albania", "name:ar"=>"ألبانيا", "name:az"=>"Albaniya", "name:be"=>"Албанія", "name:bg"=>"Албания", "name:bn"=>"আলবেনিয়া", "name:bo"=>"ཨར་པ་ཉི་ཡ།", "name:br"=>"Albania", "name:bs"=>"Albanija", "name:ca"=>"Albània", "name:ce"=>"Албани", "name:co"=>"Albania", "name:cs"=>"Albánie", "name:cv"=>"Албани", "name:cy"=>"Albania", "name:da"=>"Albanien", "name:de"=>"Albanien", "name:dz"=>"ཨལ་བཱ་ནི་ཡ།", "name:ee"=>"Albania", "name:el"=>"Αλβανία", "name:en"=>"Albania", "name:eo"=>"Albanio", "name:es"=>"Albania", "name:et"=>"Albaania", "name:eu"=>"Albania", "name:fa"=>"آلبانی", "name:fi"=>"Albania", "name:fo"=>"Albania", "name:fr"=>"Albanie", "name:fy"=>"Albaanje", "name:ga"=>"An Albáin", "name:gd"=>"Albàinia", "name:gl"=>"Albania", "name:gn"=>"Avaña", "name:gv"=>"Yn Albaan", "name:he"=>"אלבניה", "name:hi"=>"अल्बानिया", "name:hr"=>"Albanija", "name:ht"=>"Albani", "name:hu"=>"Albánia", "name:hy"=>"Ալբանիա", "name:id"=>"Albania", "name:ie"=>"Albania", "name:io"=>"Albania", "name:is"=>"Albanía", "name:it"=>"Albania", "name:ja"=>"アルバニア", "name:jv"=>"Albania", "name:ka"=>"ალბანეთი", "name:kg"=>"Albania", "name:kk"=>"Албания", "name:km"=>"អាល់បានី", "name:kn"=>"ಅಲ್ಬೇನಿಯ", "name:ko"=>"알바니아", "name:ku"=>"Albanya", "name:kv"=>"Албания", "name:ky"=>"Албания", "name:la"=>"Albania", "name:lb"=>"Albanien", "name:li"=>"Albanië", "name:ln"=>"Albania", "name:lt"=>"Albanija", "name:lv"=>"Albānija", "name:mg"=>"Albania", "name:mk"=>"Албанија", "name:ml"=>"അല്‍ബേനിയ", "name:mn"=>"Албани", "name:mr"=>"आल्बेनिया", "name:ms"=>"Albania", "name:mt"=>"Albanija", "name:na"=>"Albania", "name:ne"=>"अल्बानिया", "name:nl"=>"Albanië", "name:nn"=>"Albania", "name:no"=>"Albania", "name:oc"=>"Albania", "name:os"=>"Албани", "name:pl"=>"Albania", "name:ps"=>"البانيا", "name:pt"=>"Albânia", "name:qu"=>"Albanya", "name:rm"=>"Albania", "name:ro"=>"Albania", "name:ru"=>"Албания", "name:sa"=>"अल्बानिया", "name:sc"=>"Albania", "name:se"=>"Albánia", "name:sh"=>"Albanija", "name:sk"=>"Albánsko", "name:sl"=>"Albanija", "name:sq"=>"Shqipëria", "name:sr"=>"Албанија", "name:ss"=>"I-Alibheniya", "name:su"=>"Albania", "name:sv"=>"Albanien", "name:sw"=>"Albania", "name:ta"=>"அல்பேனியா", "name:te"=>"అల్బేనియా", "name:tg"=>"Албания", "name:th"=>"ประเทศแอลเบเนีย", "name:tl"=>"Albanya", "name:tr"=>"Arnavutluk", "name:tt"=>"Албания", "name:ug"=>"ئالبانىيە", "name:uk"=>"Албанія", "name:ur"=>"البانیا", "name:uz"=>"Albaniya", "name:vi"=>"Albania", "name:vo"=>"Lalbanän", "name:wo"=>"Albaani", "name:yi"=>"אלבאניע", "name:yo"=>"Albania", "name:zh"=>"阿尔巴尼亚", "name:ace"=>"Albania", "name:als"=>"Albanie", "name:ang"=>"Albania", "name:arc"=>"ܐܠܒܢܝܐ", "name:arz"=>"ألبانيا", "name:ast"=>"Albania", "name:bar"=>"Albanien", "name:bcl"=>"Albanya", "name:bpy"=>"আলবেনিয়া", "name:ceb"=>"Albanya", "name:chr"=>"ᎠᎸᏇᏂᏯ", "name:crh"=>"Arnavutlıq", "name:csb"=>"Albańskô", "name:diq"=>"Arnawutiye", "name:dsb"=>"Albańska", "name:eml"=>"Albanî", "name:ext"=>"Albánia", "name:frp"=>"Albanie", "name:fur"=>"Albanie", "name:haw"=>"‘Alepania", "name:hif"=>"Albania", "name:hsb"=>"Albanska", "name:ilo"=>"Albania", "name:lad"=>"אלבאניה", "name:lij"=>"Albania", "name:lmo"=>"Albania", "name:mzn"=>"آلباني", "name:nah"=>"Albania", "name:nds"=>"Albanien", "name:nov"=>"Albania", "name:pam"=>"Albania", "name:pdc"=>"Albaani", "name:pih"=>"Elbanya", "name:pms"=>"Albanìa", "name:pnb"=>"البانیا", "name:pnt"=>"Αλβανία", "name:rmy"=>"Shkiperiya", "name:sah"=>"Албания", "name:scn"=>"Albanìa", "name:sco"=>"Albanie", "name:srn"=>"Albanikondre", "name:stq"=>"Albanien", "name:szl"=>"Albańijo", "name:tet"=>"Albánia", "name:tpi"=>"Albenia", "name:udm"=>"Албания", "name:vec"=>"Albania", "name:war"=>"Albanya", "name:wuu"=>"阿尔巴尼亚", "name:xal"=>"Арнаутн Орн Нутг", "name:zea"=>"Albanië", "name:zh_py"=>"Aerbaniya", "name:simple"=>"Albania", "name:zh-yue"=>"阿爾巴尼亞", "name:zh_pyt"=>"Āěrbāníyà", "name:bat-smg"=>"Albanėjė", "name:fiu-vro"=>"Albaania", "name:roa-rup"=>"Arbinishia", "name:be-x-old"=>"Альбанія", "official_name"=>"Republika e Shqipërisë", "name:zh-min-nan"=>"Shqipëria", "official_name:be"=>"Рэспубліка Албанія", "official_name:el"=>"Δημοκρατία της Αλβανίας", "official_name:en"=>"Republic of Albania", "official_name:es"=>"República de Albania", "official_name:et"=>"Albaania Vabariik", "official_name:fr"=>"République d'Albanie", "official_name:ja"=>"アルバニア共和国", "official_name:lb"=>"Republik Albanien", "official_name:pl"=>"Republika Albanii", "official_name:pt"=>"República da Albânia", "official_name:sk"=>"Albánska republika", "official_name:sv"=>"Republiken Albanien", "official_name:vi"=>"Cộng hoà Albania"	sq	9
dz	"name"=>"الجزائر", "name:af"=>"Algerië", "name:am"=>"አልጄሪያ", "name:an"=>"Alcheria", "name:ar"=>"الجزائر", "name:az"=>"Əlcəzair", "name:be"=>"Алжыр", "name:bg"=>"Алжир", "name:bm"=>"Aljeri", "name:bn"=>"আলজেরিয়া", "name:bo"=>"ཨར་གེ་རི་ཡ", "name:br"=>"Aljeria", "name:bs"=>"Alžir", "name:ca"=>"Algeria", "name:cs"=>"Alžírsko", "name:cv"=>"Алжир", "name:cy"=>"Algeria", "name:da"=>"Algeriet", "name:de"=>"Algerien", "name:dv"=>"ޖަޒާއިރު", "name:dz"=>"ཨལ་ཇི་རི་ཡ།", "name:el"=>"Αλγερία", "name:en"=>"Algeria", "name:eo"=>"Alĝerio", "name:es"=>"Argelia", "name:et"=>"Alžiir", "name:eu"=>"Aljeria", "name:fa"=>"الجزایر", "name:fi"=>"Algeria", "name:fr"=>"Algérie", "name:fy"=>"Algerije", "name:ga"=>"An Ailgéir", "name:gd"=>"Aildiria", "name:gl"=>"Alxeria", "name:gv"=>"Yn Algear", "name:ha"=>"Aljeriya", "name:he"=>"אלג'יר", "name:hi"=>"अल्जीरिया", "name:hr"=>"Alžir", "name:ht"=>"Aljeri", "name:hu"=>"Algéria", "name:hy"=>"Ալժիր", "name:ia"=>"Algeria", "name:id"=>"Aljazair", "name:ie"=>"Algeria", "name:io"=>"Aljeria", "name:is"=>"Alsír", "name:it"=>"Algeria", "name:ja"=>"アルジェリア", "name:jv"=>"Aljazair", "name:ka"=>"ალჟირი", "name:kg"=>"Djazairia", "name:kn"=>"ಅಲ್ಜೀರಿಯ", "name:ko"=>"알제리", "name:ku"=>"Alcerya", "name:kw"=>"Aljeri", "name:ky"=>"Алжир", "name:la"=>"Algerium", "name:lb"=>"Algerien", "name:li"=>"Algerieë", "name:ln"=>"Aljeria", "name:lt"=>"Alžyras", "name:lv"=>"Alžīrija", "name:mg"=>"Aljeria", "name:mk"=>"Алжир", "name:ml"=>"അള്‍ജീറിയ", "name:mn"=>"Алжир", "name:mr"=>"अल्जीरिया", "name:ms"=>"Algeria", "name:mt"=>"Alġerija", "name:na"=>"Algeria", "name:nl"=>"Algerije", "name:nn"=>"Algerie", "name:no"=>"Algerie", "name:oc"=>"Argeria", "name:os"=>"Алжир", "name:pl"=>"Algieria", "name:ps"=>"الجېريا", "name:pt"=>"Argélia", "name:qu"=>"Alhirya", "name:rm"=>"Algeria", "name:ro"=>"Algeria", "name:ru"=>"Алжир", "name:sa"=>"अल्जीरिया", "name:sc"=>"Algerìa", "name:se"=>"Algeria", "name:sh"=>"Alžir", "name:sk"=>"Alžírsko", "name:sl"=>"Alžirija", "name:sm"=>"Algeria", "name:so"=>"Aljeeriya", "name:sq"=>"Algjeria", "name:sr"=>"Алжир", "name:sv"=>"Algeriet", "name:sw"=>"Algeria", "name:ta"=>"அல்சீரியா", "name:te"=>"అల్జీరియా", "name:tg"=>"Алҷазоир", "name:th"=>"ประเทศแอลจีเรีย", "name:tl"=>"Alherya", "name:tr"=>"Cezayir", "name:ts"=>"Algeria", "name:ug"=>"ئالجىرىيە", "name:uk"=>"Алжир", "name:ur"=>"الجزائر", "name:uz"=>"Jazoir", "name:vi"=>"Algiers", "name:vo"=>"Laljerän", "name:wa"=>"Aldjereye", "name:wo"=>"Alseeri", "name:yi"=>"אלזשעריע", "name:yo"=>"Algeria", "name:zh"=>"阿尔及利亚", "name:als"=>"Algerie", "name:ang"=>"Algeria", "name:arc"=>"ܓܙܐܝܪ", "name:arz"=>"الجزاير", "name:ast"=>"Arxelia", "name:bcl"=>"Algerya", "name:ber"=>"ⴷⵥⴰⵢⴻⵔ (Dzayer)", "name:bpy"=>"আলজেরিয়া", "name:ceb"=>"Algeria", "name:crh"=>"Cezair", "name:diq"=>"Cezayir", "name:dsb"=>"Algeriska", "name:ext"=>"Argélia", "name:frp"=>"Alg·èrie", "name:haw"=>"‘Alekelia", "name:hif"=>"Algeria", "name:hsb"=>"Algeriska", "name:jbo"=>"jexygu'e", "name:kab"=>"Dzayer", "name:ksh"=>"Alljeerije", "name:lad"=>"Arjelia", "name:lij"=>"Algeïa", "name:lmo"=>"Algeria", "name:mzn"=>"الجزایر", "name:nah"=>"Argelia", "name:nds"=>"Algerien", "name:nov"=>"Algeria", "name:pam"=>"Algeria", "name:pap"=>"Algeria", "name:pdc"=>"Altschieri", "name:pih"=>"Algeria", "name:pms"=>"Algerìa", "name:pnb"=>"الجزائر", "name:sah"=>"Алжир", "name:scn"=>"Algirìa", "name:stq"=>"Algerien", "name:szl"=>"Algeryjo", "name:vec"=>"Algeria", "name:war"=>"Alherya", "name:wuu"=>"阿尔及利亚", "name:zea"=>"Alherije", "name:zh_py"=>"Aerjiliya", "name:simple"=>"Algeria", "name:zh-yue"=>"阿爾及利亞", "name:zh_pyt"=>"Āěrjílìyà", "name:bat-smg"=>"Alžīrs", "name:fiu-vro"=>"Alžeeriä", "official_name"=>"アルジェリア民主人民共和国", "name:zh-min-nan"=>"Algeria", "official_name:en"=>"People's Democratic Republic of Algeria", "official_name:fr"=>"République algérienne démocratique et populaire", "official_name:lb"=>"Demokratesch Volleksrepublik Algerien", "official_name:pt"=>"República Popular Democrática da Argélia", "official_name:sl"=>"Ljudska demokratična republika Alžirija", "official_name:sv"=>"Demokratiska folkrepubliken Algeriet"	ar	19
eg	"name"=>"Egypt / مصر", "name:af"=>"Egipte", "name:am"=>"ግብፅ", "name:an"=>"Echipto", "name:ar"=>"مصر", "name:az"=>"Misir", "name:ba"=>"Мысыр", "name:be"=>"Егіпет", "name:bg"=>"Египет", "name:bm"=>"Misra", "name:bn"=>"মিশর", "name:bo"=>"ཨའི་ཅི", "name:br"=>"Egipt", "name:bs"=>"Egipat", "name:ca"=>"Egipte", "name:ce"=>"Миср", "name:cs"=>"Egypt", "name:cu"=>"Єгѷптъ", "name:cy"=>"Yr Aifft", "name:da"=>"Egypten", "name:de"=>"Ägypten", "name:dv"=>"މިޞްރު", "name:el"=>"Αίγυπτος", "name:en"=>"Egypt", "name:eo"=>"Egiptujo", "name:es"=>"Egipto", "name:et"=>"Egiptus", "name:eu"=>"Egipto", "name:fa"=>"مصر", "name:fi"=>"Egypti", "name:fj"=>"Ijipta", "name:fo"=>"Egyptaland", "name:fr"=>"Égypte", "name:fy"=>"Egypte", "name:ga"=>"An Éigipt", "name:gd"=>"An Èipheit", "name:gl"=>"Exipto - مصر", "name:gv"=>"Yn Egypt", "name:he"=>"מצריים", "name:hi"=>"मिस्र", "name:hr"=>"Egipat", "name:ht"=>"Ejip", "name:hu"=>"Egyiptom", "name:hy"=>"Եգիպտոս", "name:ia"=>"Egypto", "name:id"=>"Mesir", "name:ie"=>"Egypt", "name:io"=>"Egiptia", "name:is"=>"Egyptaland", "name:it"=>"Egitto", "name:ja"=>"エジプト", "name:jv"=>"Mesir", "name:ka"=>"ეგვიპტე", "name:kg"=>"Misiri", "name:kk"=>"Мысыр", "name:kn"=>"ಈಜಿಪ್ಟ್", "name:ko"=>"이집트", "name:ks"=>"مِسر", "name:ku"=>"Misir", "name:kv"=>"Египет", "name:kw"=>"Ejyp", "name:la"=>"Aegyptus", "name:lb"=>"Egypten", "name:li"=>"Egypte", "name:ln"=>"Ejipte", "name:lt"=>"Egiptas", "name:lv"=>"Ēģipte", "name:mg"=>"Ejipta", "name:mk"=>"Египет", "name:ml"=>"ഈജിപ്റ്റ്‌", "name:mn"=>"Египет", "name:mr"=>"इजिप्त", "name:ms"=>"Mesir", "name:na"=>"Egypt", "name:ne"=>"इजिप्ट", "name:nl"=>"Egypte", "name:nn"=>"Egypt", "name:no"=>"Egypt", "name:oc"=>"Egipte", "name:os"=>"Мысыр", "name:pa"=>"Egypt", "name:pl"=>"Egipt", "name:ps"=>"مصر", "name:pt"=>"Egito", "name:qu"=>"Ihiptu", "name:ro"=>"Egipt", "name:ru"=>"Египет", "name:sa"=>"ईजिप्ट", "name:se"=>"Egypta", "name:sh"=>"Egipat", "name:sk"=>"Egypt", "name:sl"=>"Egipt", "name:sm"=>"Aikupito", "name:sq"=>"Egjipti", "name:sr"=>"Египат", "name:ss"=>"IGibhithe", "name:sv"=>"Egypten", "name:sw"=>"Misri", "name:ta"=>"எகிப்து", "name:te"=>"ఈజిప్టు", "name:tg"=>"Миср", "name:th"=>"ประเทศอียิปต์", "name:tl"=>"Ehipto", "name:tr"=>"Mısır", "name:ts"=>"Egypt", "name:tt"=>"Мисыр", "name:ug"=>"مىسىر", "name:uk"=>"Єгипет", "name:ur"=>"مصر", "name:uz"=>"Misr", "name:vi"=>"Ai Cập", "name:vo"=>"Lägüptän", "name:wa"=>"Edjipe", "name:wo"=>"Isipt", "name:yi"=>"עגיפטן", "name:yo"=>"Egypt", "name:zh"=>"埃及", "name:ace"=>"Mesir", "name:als"=>"Ägypte", "name:ang"=>"Ǣgypt", "name:arc"=>"ܡܨܪܝܢ", "name:arz"=>"مصر", "name:ast"=>"Exipto", "name:bar"=>"Ägyptn", "name:bcl"=>"Ehipto", "name:bpy"=>"মিশর", "name:ceb"=>"Ehipto", "name:crh"=>"Mısır", "name:diq"=>"Mısır", "name:dsb"=>"Egyptojska", "name:frp"=>"Èg·ipte", "name:fur"=>"Egjit", "name:gan"=>"埃及", "name:hak"=>"Âi-khi̍p", "name:haw"=>"‘Aikupika", "name:hif"=>"Egypt", "name:hsb"=>"Egyptowska", "name:ilo"=>"Ehipto", "name:jbo"=>"misrygu'e", "name:kab"=>"Maṣer", "name:lij"=>"Egitto", "name:lmo"=>"Egit", "name:mdf"=>"Египет", "name:mzn"=>"مەسر", "name:nah"=>"Egipto", "name:nap"=>"Naggitto", "name:nds"=>"Ägypten", "name:new"=>"मिस्र", "name:nov"=>"Egiptia", "name:nrm"=>"Êgypte", "name:pam"=>"Ejiptu", "name:pms"=>"Egit", "name:pnb"=>"مصر", "name:pnt"=>"Αίγυπτος", "name:sah"=>"Эгипет", "name:scn"=>"Eggittu", "name:sco"=>"Egyp", "name:stq"=>"Ägypten", "name:szl"=>"Egipt", "name:tet"=>"Ejitu", "name:tpi"=>"Ijip", "name:vec"=>"Egito", "name:vls"=>"Egypte", "name:war"=>"Ehipto", "name:wuu"=>"埃及", "name:zh_py"=>"Aiji", "name:nds-nl"=>"Egypte", "name:simple"=>"Egypt", "name:zh-yue"=>"埃及", "name:zh_pyt"=>"Āijí", "name:bat-smg"=>"Egėpts", "name:be-x-old"=>"Эгіпет", "official_name"=>"جمهورية مصر العربية", "name:zh-min-nan"=>"Ai-ki̍p", "official_name:af"=>"Arabiese Republiek van Egipte", "official_name:br"=>"Republik arab Egipt", "official_name:ca"=>"República Àrab d'Egipte", "official_name:el"=>"Αραβική Δημοκρατία της Αιγύπτου", "official_name:en"=>"Arab Republic of Egypt", "official_name:et"=>"Egiptuse Araabia Vabariik", "official_name:id"=>"Republik Arab Mesir", "official_name:lb"=>"Arabesch Republik vun Egypten", "official_name:lt"=>"Egipto Arabų Respublika", "official_name:lv"=>"Ēģiptes Arābu Republika", "official_name:pt"=>"República Árabe do Egito", "official_name:sv"=>"Arabrepubliken Egypten", "official_name:vi"=>"Cộng hòa Ả Rập Ai Cập", "name:zh-classical"=>"埃及"	ar	16
fo	"name"=>"Føroyar/Færøerne", "name:af"=>"Faroëreilande", "name:am"=>"ፋሮ ደሴቶች", "name:ar"=>"جزر فارو", "name:az"=>"Farer adaları", "name:be"=>"Фарэрскія астравы", "name:bg"=>"Фарьорски острови", "name:br"=>"Inizi Faero", "name:bs"=>"Farska ostrva", "name:ca"=>"Illes Fèroe", "name:ce"=>"Фарерийн гІайренаш", "name:cs"=>"Faerské ostrovy", "name:cy"=>"Føroyar", "name:da"=>"Færøerne", "name:de"=>"Färöer", "name:dv"=>"ފަރޮއޭ ޖަޒީރާ", "name:el"=>"Νήσοι Φερόες", "name:en"=>"Faroe Islands", "name:eo"=>"Ferooj", "name:es"=>"Islas Feroe", "name:et"=>"Fääri saared", "name:eu"=>"Faroe Uharteak", "name:fa"=>"فارو", "name:fi"=>"Färsaaret", "name:fo"=>"Føroyar", "name:fr"=>"Îles Féroé", "name:fy"=>"Faeröer", "name:ga"=>"Oileáin Fharó", "name:gd"=>"Na h-Eileanan Fàro", "name:gl"=>"Illas Feroe", "name:gv"=>"Ellanyn ny Geyrragh", "name:he"=>"איי פארו", "name:hi"=>"फ़रो द्वीप", "name:hr"=>"Føroyar", "name:hu"=>"Feröer", "name:id"=>"Kepulauan Faroe", "name:io"=>"Faero", "name:is"=>"Færeyjar", "name:it"=>"Isole Fær Øer", "name:ja"=>"フェロー諸島", "name:jv"=>"Kapuloan Faroe", "name:ka"=>"ფარერის კუნძულები", "name:kk"=>"Фарер аралдары", "name:kl"=>"Savalimmiut", "name:ko"=>"페로 제도", "name:ku"=>"Giravên Faroe", "name:kw"=>"Ynysow Faroe", "name:la"=>"Insulae Faeroae", "name:li"=>"Faeröer", "name:lt"=>"Farerai", "name:lv"=>"Farēru (Fēru) salas", "name:mk"=>"Фарски Острови", "name:mn"=>"Фарерын Арлууд", "name:mr"=>"फेरो द्वीपसमूह", "name:ms"=>"Kepulauan Faroe", "name:nl"=>"Faeröer", "name:nn"=>"Færøyane", "name:no"=>"Færøyene", "name:oc"=>"Illas Feròe", "name:os"=>"Фарераг сакъадæхтæ", "name:pl"=>"Wyspy Owcze", "name:pt"=>"Ilhas Feroe", "name:qu"=>"Pharuy", "name:ro"=>"Insulele Feroe", "name:ru"=>"Фарерские острова", "name:se"=>"Fearsullot", "name:sh"=>"Farski Otoci", "name:sk"=>"Faerské ostrovy", "name:sl"=>"Ferski otoki", "name:sq"=>"Ishujt Faroe", "name:sr"=>"Фарска острва", "name:sv"=>"Färöarna", "name:sw"=>"Visiwa vya Faroe", "name:ta"=>"பரோயே தீவுகள்", "name:tg"=>"Ҷазираҳои Фаро", "name:th"=>"หมู่เกาะแฟโร", "name:tl"=>"Kapuluang Peroe", "name:tr"=>"Faroe Adaları", "name:uk"=>"Фарерські острови", "name:vi"=>"Quần đảo Faroe", "name:wo"=>"Duni Faarow", "name:zh"=>"法罗群岛", "alt_name"=>"Faeroe Islands;Faroes;Faeroes", "name:als"=>"Färöer", "name:ang"=>"Faroisca Īega", "name:ast"=>"Islles Feroe", "name:bar"=>"Färöer", "name:bpy"=>"ফারো দ্বীপমালা", "name:ext"=>"Islas Feroes", "name:frp"=>"Iles Fèroè", "name:gle"=>"Na Scigirí", "name:hsb"=>"Färöje", "name:lij"=>"Isoe Farœ", "name:lmo"=>"Faroe", "name:pam"=>"Faroe Islands", "name:pih"=>"Faaro Ailen", "name:pms"=>"Faròe", "name:rmy"=>"Dvipa Faroe", "name:scn"=>"Ìsuli Fær Øer", "name:sco"=>"Faroe Islands", "name:vec"=>"Ixołe Fær Øer", "name:war"=>"Feroe nga Islas", "name:wuu"=>"法罗群岛", "name:zh_py"=>"Faluoqundao", "name:nds-nl"=>"Faeröer", "name:simple"=>"Faroe Islands", "name:zh_pyt"=>"Fǎluóqúndǎo", "name:be-x-old"=>"Фарэрскія выспы", "name:zh-min-nan"=>"Mî-iûⁿ Kûn-tó", "official_name:lv"=>"Fēru salas"	fo	10
io	"name"=>"British Indian Ocean Territory", "name:af"=>"Britse Indiese Oseaan Gebied", "name:an"=>"Territorio Britanico de l'Ozián Indico", "name:ar"=>"إقليم المحيط الهندي البريطاني", "name:be"=>"Брытанскія Індыйска-акіянскія тэрыторыі", "name:bg"=>"Британска индоокеанска територия", "name:br"=>"Tiriadoù Breizhveuriat Mor Indez", "name:bs"=>"Britanski teritorij Indijskog okeana", "name:ca"=>"Territori Britànic de l'Oceà Índic", "name:cs"=>"Britské indickooceánské území", "name:da"=>"Britiske Indiske Ocean", "name:de"=>"Britisches Territorium im Indischen Ozean", "name:el"=>"Βρετανικό Έδαφος Ινδικού Ωκεανού", "name:en"=>"British Indian Ocean Territory", "name:eo"=>"Brita Hindoceana Teritorio", "name:es"=>"Territorio Británico del Océano Índico", "name:et"=>"Briti India ookeani ala", "name:fi"=>"Brittiläinen Intian valtameren alue", "name:fr"=>"Territoire britannique de l'océan Indien", "name:fy"=>"Britske Yndyske-Oseaanterritoarium", "name:ga"=>"Críoch Aigéan Indiach na Breataine", "name:gl"=>"Territorio Británico do Océano Índico", "name:he"=>"הטריטוריה הבריטית באוקיינוס ההודי", "name:hi"=>"ब्रिटिश हिंद महासागर क्षेत्र", "name:hr"=>"Britanski indijskooceanski teritoriji", "name:hu"=>"Brit Indiai-óceáni Terület", "name:id"=>"Teritorial Britania di Samudra Hindia", "name:is"=>"Breska Indlandshafseyjar", "name:it"=>"Territorio britannico dell'oceano Indiano", "name:ja"=>"イギリス領インド洋地域", "name:ka"=>"ბრიტანეთის ინდოეთის ოკეანის ტერიტორია", "name:ko"=>"영국령 인도양 지역", "name:lt"=>"Indijos vandenyno Britų sritis", "name:lv"=>"Indijas okeāna Britu teritorija", "name:mr"=>"ब्रिटीश हिंदी महासागर क्षेत्र", "name:ms"=>"Wilayah Lautan Hindi British", "name:nl"=>"Brits Territorium in de Indische Oceaan", "name:no"=>"Det britiske territoriet i Indiahavet", "name:pl"=>"Brytyjskie Terytorium Oceanu Indyjskiego", "name:pt"=>"Território Britânico do Oceano Índico", "name:ro"=>"Teritoriul Britanic din Oceanul Indian", "name:ru"=>"Британская территория в Индийском океане", "name:sh"=>"Britanski teritorij Indijskog oceana", "name:sk"=>"Britské indickooceánske územie", "name:sl"=>"Britanski teritorij v Indijskem oceanu", "name:sr"=>"Британска територија Индијског океана", "name:sv"=>"Brittiska territoriet i Indiska oceanen", "name:sw"=>"Eneo la Uingereza katika Bahari Hindi", "name:ta"=>"பிரித்தானிய இந்தியப் பெருங்கடல் மண்டலம்", "name:tr"=>"Britanya Hint Okyanusu Toprakları", "name:uk"=>"Британська територія в Індійському океані", "name:vi"=>"Lãnh thổ Ấn Độ Dương thuộc Anh", "name:zh"=>"英属印度洋领地", "loc_name"=>"Chagos Islands", "name:zh_py"=>"Yingshu Yinduyang Lingdu", "name:zh_pyt"=>"Yīngshǔ Yìndùyáng Lǐngdì", "name:be-x-old"=>"Брытанская тэрыторыя ў Індыйскім акіяне"	en	13
jo	"name"=>"Jordan / الأُرْدُن", "name:af"=>"Jordanië", "name:an"=>"Chordania", "name:ar"=>"الأردن", "name:az"=>"İordaniya", "name:be"=>"Іарданія", "name:bg"=>"Йордания", "name:bn"=>"জর্দান", "name:bo"=>"ཇོར་ཏའན", "name:br"=>"Jordania", "name:bs"=>"Jordan", "name:ca"=>"Jordània", "name:cs"=>"Jordánsko", "name:cv"=>"Иордани", "name:cy"=>"Gwlad Iorddonen", "name:de"=>"Jordanien", "name:dv"=>"އުރުދުން", "name:el"=>"Ιορδανία", "name:en"=>"Jordan", "name:eo"=>"Jordanio", "name:es"=>"Jordania", "name:et"=>"Jordaania", "name:eu"=>"Jordania", "name:fa"=>"اردن", "name:fi"=>"Jordania", "name:fr"=>"Jordanie", "name:fy"=>"Jordaanje", "name:ga"=>"An Iordáin", "name:gd"=>"Iòrdan", "name:gl"=>"Xordania", "name:gv"=>"Yn Jordaan", "name:he"=>"ירדן", "name:hi"=>"जार्डन", "name:hr"=>"Jordan", "name:ht"=>"Jòdani", "name:hu"=>"Jordánia", "name:hy"=>"Հորդանան", "name:ia"=>"Jordania", "name:id"=>"Yordania", "name:ie"=>"Jordania", "name:io"=>"Jordania", "name:is"=>"Jórdanía", "name:it"=>"Giordania", "name:ja"=>"ヨルダン", "name:jv"=>"Yordania", "name:ka"=>"იორდანია", "name:kk"=>"Иордан", "name:ko"=>"요르단", "name:ks"=>"जार्डन", "name:ku"=>"Urdun", "name:kv"=>"Иордания", "name:kw"=>"Jordan", "name:la"=>"Iordania", "name:lb"=>"Jordanien", "name:li"=>"Jordanië", "name:lt"=>"Jordanija", "name:lv"=>"Jordānija", "name:mk"=>"Јордан", "name:ml"=>"ജോര്‍ദാന്‍", "name:mn"=>"Йордан", "name:mr"=>"जॉर्डन", "name:ms"=>"Jordan", "name:na"=>"Jordan", "name:nl"=>"Jordanië", "name:nn"=>"Jordan", "name:no"=>"Jordan", "name:oc"=>"Jordania", "name:os"=>"Иордани", "name:pl"=>"Jordania", "name:ps"=>"اردن", "name:pt"=>"Jordânia", "name:qu"=>"Hurdanya", "name:ro"=>"Iordania", "name:ru"=>"Иордания", "name:sa"=>"जार्डन", "name:se"=>"Jordánia", "name:sh"=>"Jordan", "name:sk"=>"Jordánsko", "name:sl"=>"Jordanija", "name:sq"=>"Jordania", "name:sr"=>"Јордан", "name:sv"=>"Jordanien", "name:sw"=>"Yordani", "name:ta"=>"ஜோர்தான்", "name:te"=>"జోర్డాన్", "name:th"=>"ประเทศจอร์แดน", "name:tl"=>"Jordan", "name:tr"=>"Ürdün", "name:ug"=>"ئىئوردانىيە", "name:uk"=>"Йорданія", "name:ur"=>"اردن", "name:uz"=>"Iordan", "name:vi"=>"Jordan", "name:vo"=>"Yordän", "name:wo"=>"Jordaani", "name:yi"=>"יארדאניע", "name:zh"=>"约旦", "name:ace"=>"Yordania", "name:als"=>"Jordanien", "name:ang"=>"Jordan", "name:arc"=>"ܝܘܪܕܢܢ", "name:arz"=>"الاردن", "name:ast"=>"Xordania", "name:bcl"=>"Yordanya", "name:bpy"=>"জর্ডান", "name:ceb"=>"Jordan", "name:crh"=>"Urdun", "name:diq"=>"Urdun", "name:dsb"=>"Jordanska", "name:frp"=>"J·ordanie", "name:hak"=>"Yok-tan", "name:haw"=>"Ioredāne", "name:hif"=>"Jordan", "name:hsb"=>"Jordaniska", "name:ilo"=>"Jordan", "name:jbo"=>"jorgu'e", "name:kab"=>"Urdun", "name:lij"=>"Giordannia", "name:lmo"=>"Giurdania", "name:mzn"=>"اوردون", "name:nah"=>"Iordania", "name:nds"=>"Jordanien", "name:nov"=>"Jordan", "name:pam"=>"Jordan", "name:pms"=>"Giordania", "name:pnb"=>"اردن", "name:sah"=>"Иордания", "name:scn"=>"Giurdania", "name:szl"=>"Jordańijo", "name:udm"=>"Иордания", "name:war"=>"Hordanya", "name:wuu"=>"约旦", "name:zh_py"=>"Yuedan", "name:simple"=>"Jordan", "name:zh_pyt"=>"Yuēdàn", "name:bat-smg"=>"Juordanėjė", "name:fiu-vro"=>"Jordaania", "name:be-x-old"=>"Ярданія", "official_name"=>"المملكة الأردنية الهاشمية", "name:zh-min-nan"=>"Iok-tàn", "official_name:br"=>"Rouantelezh hachemit Jordania", "official_name:el"=>"Χασεμιτικό Βασίλειο της Ιορδανίας", "official_name:en"=>"Hashemite Kingdom of Jordan", "official_name:et"=>"Jordaania Hašimiidi Kuningriik", "official_name:gd"=>"Rioghachd Hashemach na Iòrdain", "official_name:id"=>"Kerajaan Hasyimiyah Yordania", "official_name:it"=>"Regno Hascemita di Giordania", "official_name:lb"=>"Haschimitescht Kinnekräich Jordanien", "official_name:lt"=>"Jordanijos Hašimitų Karalystė", "official_name:lv"=>"Jordānijas Hāšimītu Karaliste", "official_name:pl"=>"Jordańskie Królestwo Haszymidzkie", "official_name:sv"=>"Hashemitiska konungariket Jordanien"	ar	17
jp	"name"=>"日本 (Japan)", "name:af"=>"Japan", "name:am"=>"ጃፓን", "name:an"=>"Chapón", "name:ar"=>"اليابان", "name:as"=>"জাপান", "name:az"=>"Yaponiya", "name:ba"=>"Япония", "name:be"=>"Японія", "name:bg"=>"Япония", "name:bn"=>"জাপান", "name:bo"=>"རི་པིན།", "name:br"=>"Japan", "name:bs"=>"Japan", "name:ca"=>"Japó", "name:cs"=>"Japonsko", "name:cu"=>"Ꙗпѡні́ꙗ", "name:cv"=>"Япони", "name:cy"=>"Japan", "name:da"=>"Japan", "name:de"=>"Japan", "name:dv"=>"ޖަޕާނު", "name:dz"=>"ཇ་པཱན", "name:ee"=>"Japan", "name:el"=>"Ιαπωνία", "name:en"=>"Japan", "name:eo"=>"Japanio", "name:es"=>"Japón", "name:et"=>"Jaapan", "name:eu"=>"Japonia", "name:fa"=>"ژاپن", "name:fi"=>"Japani", "name:fo"=>"Japan", "name:fr"=>"Japon", "name:fy"=>"Japan", "name:ga"=>"An tSeapáin", "name:gd"=>"Iapan", "name:gl"=>"Xapón - 日本", "name:gu"=>"જાપાન", "name:gv"=>"Yn Çhapaan", "name:ha"=>"Japan", "name:he"=>"יפן", "name:hi"=>"जापान", "name:hr"=>"Japan", "name:ht"=>"Japon", "name:hu"=>"Japán", "name:hy"=>"Ճապոնիա", "name:ia"=>"Japon", "name:id"=>"Jepang", "name:ie"=>"Japan", "name:io"=>"Japonia", "name:is"=>"Japan", "name:it"=>"Giappone", "name:iu"=>"ᓃᑉᐊᓐ/niipan", "name:ja"=>"日本", "name:jv"=>"Jepang", "name:ka"=>"იაპონია", "name:kk"=>"Жапония", "name:km"=>"ជប៉ុន", "name:kn"=>"ಜಪಾನ್", "name:ko"=>"일본", "name:ks"=>"जापान", "name:ku"=>"Japan", "name:kv"=>"Япония", "name:kw"=>"Nihon", "name:ky"=>"Жапония", "name:la"=>"Iaponia", "name:lb"=>"Japan", "name:li"=>"Japan", "name:ln"=>"Zapɔ́", "name:lo"=>"ປະເທດຍີ່ປຸ່ນ", "name:lt"=>"Japonija", "name:lv"=>"Japāna", "name:mg"=>"Japana", "name:mi"=>"Nipono", "name:mk"=>"Јапонија", "name:ml"=>"ജപ്പാന്‍", "name:mn"=>"Япон", "name:mr"=>"जपान", "name:ms"=>"Jepun", "name:my"=>"ဂျပန်နိုင်ငံ", "name:na"=>"Djapan", "name:ne"=>"जापान", "name:nl"=>"Japan", "name:nn"=>"Japan", "name:no"=>"Japan", "name:nv"=>"Bina'adaałtzózí", "name:oc"=>"Japon", "name:or"=>"ଜାପାନ", "name:os"=>"Япон", "name:pl"=>"Japonia", "name:ps"=>"جاپان", "name:pt"=>"Japão", "name:qu"=>"Nihun", "name:ro"=>"Japonia", "name:ru"=>"Япония", "name:sa"=>"जापान", "name:sc"=>"Giappone", "name:sd"=>"جاپان", "name:se"=>"Japána", "name:si"=>"ජපානය", "name:sk"=>"Japonsko", "name:sl"=>"Japonska", "name:sm"=>"Iapani", "name:so"=>"Jabaan", "name:sq"=>"Japonia", "name:sr"=>"Јапан", "name:ss"=>"IJaphani", "name:su"=>"Jepang", "name:sv"=>"Japan", "name:sw"=>"Japani", "name:ta"=>"ஜப்பான்", "name:te"=>"జపాన్", "name:tg"=>"Ҷопон", "name:th"=>"ประเทศญี่ปุ่น", "name:ti"=>"ጃፓን", "name:tk"=>"Ýaponiýa", "name:tl"=>"Hapon", "name:tr"=>"Japonya", "name:ty"=>"Tāpōnē", "name:ug"=>"ياپونىيە", "name:uk"=>"Японія", "name:ur"=>"جاپان", "name:uz"=>"Yaponiya", "name:vi"=>"Nhật Bản", "name:vo"=>"Yapän", "name:wo"=>"Sapoŋ", "name:yi"=>"יאפאן", "name:yo"=>"Japan", "name:za"=>"Nditbonj", "name:zh"=>"日本", "name:zu"=>"iJapani", "name:als"=>"Japan", "name:ang"=>"Iapan", "name:arc"=>"ܝܦܢ", "name:arz"=>"اليابان", "name:ast"=>"Xapón", "name:bar"=>"Japan", "name:bcl"=>"Hapon", "name:bpy"=>"জাপান", "name:bug"=>"ᨍᨛᨄ", "name:bxr"=>"Жибэн", "name:cdo"=>"Nĭk-buōng", "name:ceb"=>"Hapon", "name:chr"=>"ᏣᏆᏂ", "name:crh"=>"Yaponiya", "name:csb"=>"Japòńskô", "name:diq"=>"Japonya", "name:dsb"=>"Japańska", "name:frp"=>"J·apon", "name:gan"=>"日本", "name:hak"=>"Ngi̍t-pún", "name:haw"=>"Iāpana", "name:hif"=>"Japan", "name:hsb"=>"Japanska", "name:ilo"=>"Japon", "name:jbo"=>"pongu'e", "name:lij"=>"Giappon", "name:lmo"=>"Giapun", "name:mdf"=>"Япунмастор", "name:mhr"=>"Японий", "name:mwl"=>"Japon", "name:nah"=>"Xapon", "name:nap"=>"Giappone", "name:nds"=>"Japan", "name:new"=>"जापान", "name:nov"=>"Japan", "name:nrm"=>"Japon", "name:pam"=>"Hapon", "name:pap"=>"Hapon", "name:pms"=>"Giapon", "name:pnb"=>"جاپان", "name:sah"=>"Дьоппуон", "name:scn"=>"Giappuni", "name:sco"=>"Japan", "name:szl"=>"Japůńijo", "name:tpi"=>"Siapan", "name:udm"=>"Япония", "name:vec"=>"Giapòn", "name:war"=>"Hapon", "name:wuu"=>"日本", "name:xal"=>"Японь", "name:ja_rm"=>"Nippon", "name:zh_py"=>"Riben", "name:nds-nl"=>"Japan", "name:simple"=>"Japan", "name:zh-yue"=>"日本", "name:zh_pyt"=>"Rìběn", "name:bat-smg"=>"Japuonėjė", "name:cbk-zam"=>"Japón", "name:be-x-old"=>"Японія", "name:zh-min-nan"=>"Ji̍t-pún", "official_name:ca"=>"Estat del Japó", "official_name:pt"=>"Império do Japão", "name:zh-classical"=>"日本"	ja	11
tn	"name"=>"تونس", "name:af"=>"Tunisië", "name:am"=>"ቱኒዚያ", "name:an"=>"Tunizia", "name:ar"=>"تونس", "name:az"=>"Tunis", "name:be"=>"Туніс", "name:bg"=>"Тунис", "name:bm"=>"Tunizi", "name:bn"=>"তিউনিসিয়া", "name:br"=>"Tunizia", "name:bs"=>"Tunis", "name:ca"=>"Tunísia", "name:cs"=>"Tunisko", "name:cv"=>"Тунис", "name:cy"=>"Tunisia", "name:da"=>"Tunesien", "name:de"=>"Tunesien", "name:el"=>"Τυνησία", "name:en"=>"Tunisia", "name:eo"=>"Tunizio", "name:es"=>"Túnez", "name:et"=>"Tuneesia", "name:eu"=>"Tunisia", "name:fa"=>"تونس", "name:fi"=>"Tunisia", "name:fo"=>"Tunesia", "name:fr"=>"Tunisie", "name:fy"=>"Tuneezje", "name:ga"=>"An Túinéis", "name:gd"=>"Tuinisia", "name:gl"=>"Tunisia", "name:gv"=>"Yn Tooneesh", "name:he"=>"טוניס", "name:hi"=>"टुनिशिया", "name:hr"=>"Tunis", "name:ht"=>"Tinizi", "name:hu"=>"Tunézia", "name:id"=>"Tunisia", "name:ie"=>"Tunisia", "name:io"=>"Tunizia", "name:is"=>"Túnis", "name:it"=>"Tunisia", "name:ja"=>"チュニジア", "name:jv"=>"Tunisia", "name:ka"=>"ტუნისი", "name:kg"=>"Tunisia", "name:kk"=>"Тунис", "name:kn"=>"ಟುನೀಶಿಯ", "name:ko"=>"튀니지", "name:ks"=>"टुनिशिया", "name:ku"=>"Tûnis", "name:kw"=>"Tunisi", "name:la"=>"Tunesia", "name:lb"=>"Tunesien", "name:li"=>"Tunesië", "name:ln"=>"Tunisia", "name:lt"=>"Tunisas", "name:lv"=>"Tunisija", "name:mg"=>"Tonizia", "name:mk"=>"Тунис", "name:ml"=>"ടുണീഷ്യ", "name:mn"=>"Тунис", "name:mr"=>"ट्युनिसिया", "name:ms"=>"Tunisia", "name:mt"=>"Tuneżija", "name:nl"=>"Tunesië", "name:nn"=>"Tunisia", "name:no"=>"Tunisia", "name:oc"=>"Tunisia", "name:pl"=>"Tunezja", "name:pt"=>"Tunísia", "name:qu"=>"Tunisya", "name:rm"=>"Tunesia", "name:ro"=>"Tunisia", "name:ru"=>"Тунис", "name:sa"=>"टुनिशिया", "name:sc"=>"Tunisia", "name:se"=>"Tunisia", "name:sh"=>"Tunis", "name:sk"=>"Tunisko", "name:sl"=>"Tunizija", "name:so"=>"Tunisie", "name:sq"=>"Tunizia", "name:sr"=>"Тунис", "name:sv"=>"Tunisien", "name:sw"=>"Tunisia", "name:ta"=>"துனீசியா", "name:te"=>"ట్యునీషియా", "name:tg"=>"Тунис", "name:th"=>"ประเทศตูนิเซีย", "name:ti"=>"ቱኒዢያ", "name:tl"=>"Tunisia", "name:tr"=>"Tunus", "name:ts"=>"Tunisia", "name:ug"=>"تۇنىس", "name:uk"=>"Туніс", "name:ur"=>"تیونس", "name:uz"=>"Tunis", "name:vi"=>"Tunisia", "name:vo"=>"Tunisän", "name:wa"=>"Tunizeye", "name:wo"=>"Tiniisi", "name:yo"=>"Tunisia", "name:zh"=>"突尼西亚", "name:ace"=>"Tunisia", "name:als"=>"Tunesien", "name:ang"=>"Tunisia", "name:arc"=>"ܬܘܢܣ", "name:arz"=>"تونس", "name:ast"=>"Túnez", "name:bcl"=>"Tunisya", "name:bpy"=>"তিউনিসিয়া", "name:ceb"=>"Tunisia", "name:crh"=>"Tunis", "name:diq"=>"Tunıs", "name:frp"=>"Tunisie", "name:haw"=>"Tunisia", "name:hif"=>"Tunisia", "name:hsb"=>"Tuneziska", "name:ilo"=>"Tunisia", "name:kab"=>"Tunes", "name:lad"=>"Tunesia", "name:lij"=>"Tunixia", "name:lmo"=>"Tünisia", "name:mzn"=>"تونس", "name:nah"=>"Tunez", "name:nds"=>"Tunesien", "name:nov"=>"Tunisia", "name:pam"=>"Tunisia", "name:pap"=>"Tunesia", "name:pms"=>"Tunisìa", "name:pnb"=>"ٹیونس", "name:sah"=>"Тунис", "name:scn"=>"Tunisìa", "name:szl"=>"Tůnezyjo", "name:vec"=>"Tunixia", "name:war"=>"Tunisia", "name:wuu"=>"突尼斯", "name:zh_py"=>"Tunixiya", "name:simple"=>"Tunisia", "name:zh_pyt"=>"Tūníxīyà", "name:be-x-old"=>"Туніс", "official_name"=>"الجمهورية التونسية", "name:zh-min-nan"=>"Tunisia", "official_name:br"=>"Republik Tunizian", "official_name:el"=>"Δημοκρατία της Τυνησίας", "official_name:en"=>"Tunisian Republic", "official_name:et"=>"Tuneesia Vabariik", "official_name:id"=>"Republik Tunisia", "official_name:ja"=>"チュニジア共和国", "official_name:lb"=>"Tunesesch Republik", "official_name:lt"=>"Tuniso Respublika", "official_name:pt"=>"República da Tunísia", "official_name:sv"=>"Republiken Tunisien", "official_name:vi"=>"Cộng hòa Tunisia"	ar	18
tw	"name"=>"Taiwan", "name:ar"=>"تايوان", "name:be"=>"Тайвань", "name:br"=>"Taiwan", "name:da"=>"Taiwan", "name:en"=>"Taiwan", "name:eo"=>"Tajvano", "name:fa"=>"تایوان", "name:fi"=>"Taiwan", "name:fr"=>"Taïwan", "name:ga"=>"An Téaváin", "name:gd"=>"Tai-Bhàn", "name:he"=>"טייואן", "name:hr"=>"Tajvan", "name:hu"=>"Tajvan", "name:is"=>"Lýðveldið Kína", "name:it"=>"Taiwan", "name:ja"=>"台湾", "name:la"=>"Taivania", "name:lt"=>"Taivanas", "name:mn"=>"Тайвань", "name:pl"=>"Tajwan", "name:pt"=>"Taiwan; Formosa", "name:ru"=>"Тайвань", "name:sl"=>"Tajvan", "name:sv"=>"Taiwan", "name:th"=>"ไต้หวัน", "name:tr"=>"Tayvan", "name:uk"=>"Тайвань", "name:vi"=>"Đài Loan", "name:zh"=>"台湾", "name:zh_py"=>"Taiwan", "name:zh_pyt"=>"Táiwān", "name:zh-Hans"=>"台湾", "name:zh-Hant"=>"台灣", "official_name:et"=>"Hiina Vabariik", "official_name:gd"=>"Poblachd na Sìne", "official_name:id"=>"Republik Cina", "official_name:it"=>"Repubblica di Cina", "official_name:la"=>"Res publica Sinarum", "official_name:lb"=>"Republik China", "official_name:lt"=>"Taivanas (Kinijos provincija)", "official_name:pl"=>"Republika Chińska", "official_name:pt"=>"República da China", "official_name:vi"=>"Trung Hoa Dân Quốc"	zh	25
nz	"name"=>"New Zealand", "name:af"=>"Nieu-Seeland", "name:ar"=>"نيوزيلندا", "name:be"=>"Новая Зеландыя", "name:br"=>"Zeland Nevez", "name:ca"=>"Nova Zelanda", "name:cy"=>"Seland Newydd", "name:de"=>"Neuseeland", "name:el"=>"Νέα Ζηλανδία", "name:en"=>"New Zealand", "name:eo"=>"Nov-Zelando", "name:es"=>"Nueva Zelanda", "name:et"=>"Uus-Meremaa", "name:fa"=>"نیوزیلند", "name:fi"=>"Uusi-Seelanti", "name:fr"=>"Nouvelle-Zélande", "name:fy"=>"Nij-Seelân", "name:ga"=>"An Nua-Shéalainn", "name:gd"=>"Sealainn Nuadh", "name:he"=>"ניו זילנד", "name:hr"=>"Novi Zeland", "name:hu"=>"Új-Zéland", "name:hy"=>"Նոր Զելանդիա", "name:id"=>"Selandia Baru", "name:is"=>"Nýja-Sjáland", "name:it"=>"Nuova Zelanda", "name:ja"=>"ニュージーランド", "name:la"=>"Nova Zelandia", "name:lb"=>"Neiséiland", "name:li"=>"Nui-Zieland", "name:lt"=>"Naujoji Zelandija", "name:lv"=>"Jaunzēlande", "name:mi"=>"Aotearoa", "name:mn"=>"Шинэ Зеланд", "name:nl"=>"Nieuw-Zeeland", "name:pl"=>"Nowa Zelandia", "name:ru"=>"Новая Зеландия", "name:sl"=>"Nova Zelandija", "name:sv"=>"Nya Zeeland", "name:th"=>"ประเทศนิวซีแลนด์", "name:tr"=>"Yeni Zelanda", "name:uk"=>"Нова Зеландія", "name:vi"=>"Tân Tây Lan", "name:zh"=>"新西兰"	\N	27
ht	"name"=>"Haiti", "name:af"=>"Haïti", "name:ar"=>"هايتي", "name:be"=>"Гаіці", "name:br"=>"Haiti", "name:ca"=>"Haití", "name:da"=>"Haiti", "name:el"=>"Αϊτή", "name:eo"=>"Haitio", "name:es"=>"Haití", "name:fa"=>"هائیتی", "name:fi"=>"Haiti", "name:fr"=>"Haïti", "name:fy"=>"Haïty", "name:ga"=>"Háití", "name:he"=>"האיטי", "name:hu"=>"Haiti", "name:is"=>"Haítí", "name:it"=>"Haiti", "name:ja"=>"ハイチ", "name:la"=>"Haitia", "name:li"=>"Haïti", "name:lt"=>"Haitis", "name:lv"=>"Haiti", "name:mn"=>"Гайти", "name:nl"=>"Haïti", "name:pl"=>"Haiti", "name:ru"=>"Гаити", "name:sv"=>"Haiti", "name:th"=>"ประเทศเฮติ", "name:uk"=>"Гаїті", "name:zh"=>"海地", "official_name"=>"Repiblik Ayiti", "official_name:be"=>"Рэспубліка Гаіці", "official_name:br"=>"Republik Haiti", "official_name:el"=>"Δημοκρατία της Αϊτής", "official_name:en"=>"Republic of Haiti", "official_name:fr"=>"République d'Haïti", "official_name:id"=>"Republik Haiti", "official_name:it"=>"Repubblica di Haiti", "official_name:ja"=>"ハイチ共和国", "official_name:lt"=>"Haičio Respublika", "official_name:lv"=>"Haiti Republika", "official_name:pl"=>"Republika Haiti", "official_name:sv"=>"Republiken Haiti"	\N	29
af	"name"=>"Afghanistan", "name:ar"=>"أفغانستان", "name:az"=>"Əfqanıstan", "name:be"=>"Аўганістан", "name:bg"=>"Афганистан", "name:br"=>"Afghanistan", "name:ca"=>"Afganistan", "name:cs"=>"Afghánistán", "name:da"=>"Afghanistan", "name:el"=>"Αφγανιστάν", "name:en"=>"Afghanistan", "name:eo"=>"Afganio", "name:es"=>"Afganistán", "name:et"=>"Afganistan", "name:fa"=>"افغانستان", "name:fi"=>"Afganistan", "name:fr"=>"Afghanistan", "name:fy"=>"Afganistan", "name:ga"=>"An Afganastáin", "name:gd"=>"Afganastan", "name:he"=>"אפגניסטן", "name:hr"=>"Afganistan", "name:hu"=>"Afganisztán", "name:hy"=>"Աֆղանստան", "name:id"=>"Afganistan", "name:is"=>"Afganistan", "name:it"=>"Afghanistan", "name:ja"=>"アフガニスタン", "name:ka"=>"ავღანეთი", "name:ko"=>"아프가니스탄", "name:la"=>"Afgania", "name:li"=>"Afganistan", "name:lt"=>"Afganistanas", "name:lv"=>"Afganistāna", "name:mn"=>"Афганистан", "name:pl"=>"Afganistan", "name:pt"=>"Afeganistão", "name:ru"=>"Афганистан", "name:sl"=>"Afganistan", "name:sv"=>"Afghanistan", "name:th"=>"ประเทศอัฟกานิสถาน", "name:tr"=>"Afganistan", "name:uk"=>"Афганістан", "name:zh"=>"阿富汗", "name:haw"=>"‘Apekanikana", "name:zh_py"=>"Afuhan", "name:zh_pyt"=>"Āfùhàn", "name:cs_ascii"=>"Afganistan", "official_name:el"=>"Ισλαμική Δημοκρατία του Αφγανιστάν", "official_name:et"=>"Afganistani Islamivabariik", "official_name:fi"=>"Afganistanin islamilainen tasavalta", "official_name:fr"=>"République islamique d'Afghanistan", "official_name:id"=>"Republik Islam Afganistan", "official_name:it"=>"Repubblica Islamica dell'Afghanistan", "official_name:ja"=>"アフガニスタン・イスラム共和国", "official_name:lt"=>"Afganistano Islamo Respublika", "official_name:pl"=>"Islamska Republika Afganistanu", "official_name:pt"=>"República Islâmica do Afeganistão", "official_name:sv"=>"Islamska republiken Afghanistan", "official_name:vi"=>"Cộng hòa Hồi giáo Afghanistan"	\N	30
es	"name"=>"España", "name:af"=>"Spanje", "name:ar"=>"إسبانيا", "name:be"=>"Іспанія", "name:br"=>"Spagn", "name:ca"=>"Espanya", "name:cy"=>"Sbaen", "name:da"=>"Spanien", "name:de"=>"Spanien", "name:el"=>"Ισπανία", "name:en"=>"Spain", "name:eo"=>"Hispanio", "name:es"=>"España", "name:et"=>"Hispaania", "name:eu"=>"Espainia", "name:fa"=>"اسپانیا", "name:fi"=>"Espanja", "name:fr"=>"Espagne", "name:fy"=>"Spanje", "name:ga"=>"An Spáinn", "name:gd"=>"An Spàinn", "name:he"=>"ספרד", "name:hr"=>"Španjolska", "name:hu"=>"Spanyolország", "name:hy"=>"Իսպանիա", "name:id"=>"Spanyol", "name:is"=>"Spánn", "name:it"=>"Spagna", "name:ja"=>"スペイン", "name:la"=>"Hispania", "name:lb"=>"Spuenien", "name:lt"=>"Ispanija", "name:lv"=>"Spānija", "name:mn"=>"Испани", "name:nb"=>"Spania", "name:nl"=>"Spanje", "name:nn"=>"Spania", "name:no"=>"Spania", "name:pl"=>"Hiszpania", "name:pt"=>"Espanha", "name:ru"=>"Испания", "name:sk"=>"Španielsko", "name:sl"=>"Španija", "name:sv"=>"Spanien", "name:th"=>"ประเทศสเปน", "name:tl"=>"Espanya", "name:tr"=>"İspanya", "name:uk"=>"Іспанія", "name:vi"=>"Tây Ban Nha", "name:zh"=>"西班牙", "name:haw"=>"Sepania", "name:zh_py"=>"Xibanya", "name:zh_pyt"=>"Xībānyá", "official_name"=>"Reino de España", "official_name:be"=>"Каралеўства Іспанія", "official_name:el"=>"Βασίλειο της Ισπανίας", "official_name:en"=>"Kingdom of Spain", "official_name:fr"=>"Royaume d’Espagne", "official_name:gd"=>"Rìoghachd na Spàinne", "official_name:id"=>"Kerajaan Spanyol", "official_name:lb"=>"Kinneksräich Spuenien", "official_name:lt"=>"Ispanijos Karalystė", "official_name:pl"=>"Królestwo Hiszpanii", "official_name:pt"=>"Reino de Espanha", "official_name:sk"=>"Španielske kráľovstvo", "official_name:sv"=>"Konungariket Spanien", "official_name:vi"=>"Vương quốc Tây Ban Nha"	\N	31
th	"name"=>"ประเทศไทย", "name:af"=>"Thailand", "name:an"=>"Tailandia", "name:ar"=>"تايلاند", "name:as"=>"থাইলেণ্ড", "name:az"=>"Tayland Krallığı", "name:be"=>"Тайланд", "name:bg"=>"Тайланд", "name:bn"=>"থাইল্যান্ড", "name:bo"=>"ཐའེ་གོ", "name:br"=>"Thailand", "name:bs"=>"Tajland", "name:ca"=>"Tailàndia", "name:cs"=>"Thajsko", "name:cv"=>"Таиланд", "name:cy"=>"Gwlad Thai", "name:da"=>"Thailand", "name:de"=>"Thailand", "name:dv"=>"ސިޔާމު", "name:dz"=>"ཐཱའི་ལེནཌ", "name:el"=>"Ταϊλάνδη", "name:en"=>"Thailand", "name:eo"=>"Tajlando", "name:es"=>"Tailandia", "name:et"=>"Tai", "name:eu"=>"Tailandia", "name:fa"=>"تایلند", "name:fi"=>"Thaimaa", "name:fr"=>"Thaïlande", "name:fy"=>"Tailân", "name:ga"=>"An Téalainn", "name:gd"=>"Tài-lann", "name:gl"=>"Tailandia", "name:gu"=>"થાઇલેન્ડ", "name:gv"=>"Yn Çheer Thai", "name:he"=>"תאילנד", "name:hi"=>"थाईलैंड", "name:hr"=>"Tajland", "name:ht"=>"Tayilann", "name:hu"=>"Thaiföld", "name:ia"=>"Thailanda", "name:id"=>"Thailand", "name:ie"=>"Thailand", "name:io"=>"Tailando", "name:is"=>"Taíland", "name:it"=>"Thailandia", "name:ja"=>"タイ王国", "name:jv"=>"Thailand", "name:ka"=>"ტაილანდი", "name:kk"=>"Таиланд", "name:km"=>"ថៃ", "name:kn"=>"ಥೈಲ್ಯಾಂಡ್", "name:ko"=>"타이", "name:ks"=>"थाइलैंड", "name:ku"=>"Tayland", "name:kv"=>"Таиланд", "name:kw"=>"Pow Tay", "name:la"=>"Thailandia", "name:lb"=>"Thailand", "name:li"=>"Thailand", "name:lo"=>"ປະເທດໄທ", "name:lt"=>"Tailandas", "name:lv"=>"Taizeme", "name:mg"=>"Thaïlande", "name:mk"=>"Тајланд", "name:ml"=>"തായ്‌ലാന്റ്", "name:mn"=>"Тайланд", "name:mr"=>"थायलंड", "name:ms"=>"Thailand", "name:my"=>"ထိုင်းနိုင်ငံ", "name:ne"=>"थाइलेडं", "name:nl"=>"Thailand", "name:nn"=>"Thailand", "name:no"=>"Thailand", "name:oc"=>"Tailàndia", "name:os"=>"Таиланд", "name:pl"=>"Tajlandia", "name:ps"=>"تايلېنډ", "name:pt"=>"Tailândia", "name:qu"=>"Thaysuyu", "name:ro"=>"Thailanda", "name:ru"=>"Таиланд", "name:sa"=>"थाइलैंड", "name:se"=>"Thaieana", "name:sh"=>"Tajland", "name:sk"=>"Thajsko", "name:sl"=>"Tajska", "name:sq"=>"Tailanda", "name:sr"=>"Тајланд", "name:su"=>"Thailand", "name:sv"=>"Thailand", "name:sw"=>"Uthai", "name:ta"=>"தாய்லாந்து", "name:te"=>"థాయిలాండ్", "name:tg"=>"Таиланд", "name:th"=>"ประเทศไทย", "name:tk"=>"Taýland", "name:tl"=>"Taylandiya", "name:tr"=>"Tayland", "name:ug"=>"تايلاند", "name:uk"=>"Таїланд", "name:ur"=>"تھائی لینڈ", "name:vi"=>"Thái Lan", "name:vo"=>"Tayän", "name:wo"=>"Taaylaand", "name:wu"=>"泰国", "name:yo"=>"Thailandi", "name:za"=>"Daigoz", "name:zh"=>"泰国", "name:ace"=>"Muangthai", "name:als"=>"Thailand", "name:arz"=>"تايلاندا", "name:ast"=>"Tailandia", "name:bcl"=>"Tailandya", "name:bpy"=>"টাইলান্ডিয়া", "name:ceb"=>"Thailand", "name:crh"=>"Tayland", "name:diq"=>"Tayland", "name:frp"=>"Tayilande", "name:gan"=>"泰國", "name:hak"=>"Thai-koet", "name:haw"=>"Tailani", "name:hif"=>"Thailand", "name:hsb"=>"Thailand", "name:ilo"=>"Thailand", "name:lij"=>"Thailandia", "name:lmo"=>"Thailandia", "name:mhr"=>"Таиланд", "name:nah"=>"Taitlālpan", "name:nds"=>"Thailand", "name:nov"=>"Tailande", "name:pam"=>"Thailand", "name:pap"=>"Thailand", "name:pih"=>"Thailand", "name:pms"=>"Thailandia", "name:pnb"=>"تھائی لینڈ", "name:sah"=>"Тайлаан", "name:scn"=>"Thailandia", "name:stq"=>"Thailound", "name:szl"=>"Tajlandyjo", "name:udm"=>"Таиланд", "name:vec"=>"Thailandia", "name:war"=>"Thailand", "name:zea"=>"Thailand", "name:nds-nl"=>"Thailaand", "name:zh-yue"=>"泰國", "name:bat-smg"=>"Tailands", "name:fiu-vro"=>"Tai", "name:map-bms"=>"Thailand", "name:be-x-old"=>"Тайлянд", "name:zh-min-nan"=>"Thài-kok", "official_name:af"=>"Koninkryk van Thailand", "official_name:el"=>"Βασίλειο της Ταϊλάνδης", "official_name:et"=>"Tai Kuningriik", "official_name:id"=>"Kerajaan Thailand", "official_name:it"=>"Regno di Thailandia", "official_name:lb"=>"Kinnekräich Thailand", "official_name:lt"=>"Tailando Karalystė", "official_name:pl"=>"Królestwo Tajlandii", "official_name:pt"=>"Reino da Tailândia", "official_name:sv"=>"Konungariket Thailand", "official_name:th"=>"ราชอาณาจักรไทย", "name:zh-classical"=>"泰國"	\N	32
cu	"name"=>"Cuba", "name:af"=>"Kuba", "name:ar"=>"كوبا", "name:be"=>"Куба", "name:br"=>"Kuba", "name:de"=>"Kuba", "name:el"=>"Κούβα", "name:en"=>"Cuba", "name:eo"=>"Kubo", "name:et"=>"Kuuba", "name:eu"=>"Kuba", "name:fa"=>"کوبا", "name:fi"=>"Kuuba", "name:fr"=>"Cuba", "name:fy"=>"Kuba", "name:ga"=>"Cúba", "name:gd"=>"Cùba", "name:he"=>"קובה", "name:hr"=>"Kuba", "name:hu"=>"Kuba", "name:hy"=>"Կուբա", "name:id"=>"Kuba", "name:is"=>"Kúba", "name:it"=>"Cuba", "name:ja"=>"キューバ", "name:lb"=>"Kuba", "name:lt"=>"Kuba", "name:lv"=>"Kuba", "name:mn"=>"Куба", "name:pl"=>"Kuba", "name:ru"=>"Куба", "name:sl"=>"Kuba", "name:sv"=>"Kuba", "name:th"=>"ประเทศคิวบา", "name:tr"=>"Küba", "name:uk"=>"Куба", "name:zh"=>"古巴", "official_name"=>"República de Cuba", "official_name:be"=>"Рэспубліка Куба", "official_name:el"=>"Δημοκρατία της Κούβας", "official_name:en"=>"Republic of Cuba", "official_name:et"=>"Kuuba Vabariik", "official_name:gd"=>"Poblachd Chùba", "official_name:id"=>"Republik Kuba", "official_name:it"=>"Repubblica di Cuba", "official_name:lb"=>"Republik Kuba", "official_name:lt"=>"Kubos Respublika", "official_name:lv"=>"Kubas Republika", "official_name:pl"=>"Republika Kuby", "official_name:sv"=>"Republiken Kuba", "official_name:vi"=>"Cộng hòa Cuba"	es	42
hn	"name"=>"Honduras", "name:ar"=>"هندوراس", "name:be"=>"Гандурас", "name:br"=>"Honduras", "name:ca"=>"Hondures", "name:da"=>"Honduras", "name:el"=>"Ονδούρα", "name:en"=>"Honduras", "name:eo"=>"Honduro", "name:fa"=>"هندوراس", "name:fi"=>"Honduras", "name:fr"=>"Honduras", "name:fy"=>"Hondueras", "name:ga"=>"Hondúras", "name:gd"=>"Hondùras", "name:he"=>"הונדורס", "name:hu"=>"Honduras", "name:is"=>"Hondúras", "name:it"=>"Honduras", "name:ja"=>"ホンジュラス", "name:la"=>"Honduria", "name:lt"=>"Hondūras", "name:lv"=>"Hondurasa", "name:mn"=>"Гондурас", "name:pl"=>"Honduras", "name:ru"=>"Гондурас", "name:sv"=>"Honduras", "name:th"=>"ประเทศฮอนดูรัส", "name:uk"=>"Гондурас", "name:zh"=>"洪都拉斯", "official_name"=>"República de Honduras", "official_name:be"=>"Рэспубліка Гандурас", "official_name:el"=>"Δημοκρατία της Ονδούρας", "official_name:id"=>"Republik Honduras", "official_name:lt"=>"Hondūro Respublika", "official_name:lv"=>"Hondurasas Republika", "official_name:pl"=>"Republika Hondurasu", "official_name:sv"=>"Republiken Honduras", "official_name:vi"=>"Cộng hoà Honduras"	es	56
pt	"name"=>"Portugal", "name:ar"=>"البرتغال", "name:be"=>"Партугалія", "name:br"=>"Portugal", "name:cy"=>"Portiwgal", "name:el"=>"Πορτογαλία", "name:en"=>"Portugal", "name:eo"=>"Portugalio", "name:fa"=>"پرتغال", "name:fi"=>"Portugali", "name:fr"=>"Portugal", "name:fy"=>"Portegal", "name:ga"=>"An Phortaingéil", "name:gd"=>"A' Phortagail", "name:he"=>"פורטוגל", "name:hu"=>"Portugália", "name:hy"=>"Պորտուգալիա", "name:is"=>"Portúgal", "name:it"=>"Portogallo", "name:ja"=>"ポルトガル", "name:la"=>"Lusitania", "name:lt"=>"Portugalija", "name:lv"=>"Portugāle", "name:mn"=>"Португал", "name:pl"=>"Portugalia", "name:ru"=>"Португалия", "name:sk"=>"Portugalsko", "name:sl"=>"Portugalska", "name:sv"=>"Portugal", "name:th"=>"ประเทศโปรตุเกส", "name:tr"=>"Portekiz", "name:uk"=>"Португалія", "name:vi"=>"Bồ Đào Nha", "name:zh"=>"葡萄牙", "name:haw"=>"Potugala", "name:zh_py"=>"Putaoya", "name:zh_pyt"=>"Pútáoyá", "official_name"=>"República Portuguesa", "official_name:be"=>"Рэспубліка Партугалія", "official_name:br"=>"Republik Portugal", "official_name:el"=>"Πορτογαλική Δημοκρατία", "official_name:en"=>"Portuguese Republic", "official_name:es"=>"República Portuguesa", "official_name:fr"=>"République portugaise", "official_name:id"=>"Republik Portugal", "official_name:lb"=>"Portugiesesch Republik", "official_name:lt"=>"Portugalijos Respublika", "official_name:pl"=>"Republika Portugalska", "official_name:pt"=>"República Portuguesa", "official_name:sk"=>"Portugalská republika", "official_name:sv"=>"Republiken Portugal", "official_name:vi"=>"Cộng hòa Bồ Đào Nha", "official_name:mwl"=>"República Pertuesa"	pt	34
si	"name"=>"Slovenija", "name:af"=>"Slowenië", "name:ar"=>"سلوفينيا", "name:be"=>"Славенія", "name:br"=>"Slovenia", "name:ca"=>"Eslovènia", "name:cs"=>"Slovinsko", "name:cy"=>"Slofenia", "name:da"=>"Slovenien", "name:de"=>"Slowenien", "name:ee"=>"Sloveenia", "name:el"=>"Σλοβενία", "name:en"=>"Slovenia", "name:eo"=>"Slovenio", "name:es"=>"Eslovenia", "name:et"=>"Sloveenia", "name:fa"=>"اسلوونی", "name:fi"=>"Slovenia", "name:fr"=>"Slovénie", "name:fy"=>"Sloveenje", "name:ga"=>"An tSlóivéin", "name:gd"=>"Sloibhìnia", "name:he"=>"סלובניה", "name:hu"=>"Szlovénia", "name:id"=>"Slovenia", "name:is"=>"Slóvenía", "name:it"=>"Slovenia", "name:la"=>"Slovenia", "name:lb"=>"Slowenien", "name:li"=>"Slovenië", "name:lt"=>"Slovėnija", "name:mn"=>"Словени", "name:ne"=>"स्लोभेनिया", "name:nl"=>"Slovenië", "name:pl"=>"Słowenia", "name:ps"=>"سلووېنيا", "name:pt"=>"Eslovênia", "name:ru"=>"Словения", "name:sk"=>"Slovinsko", "name:sl"=>"Slovenija", "name:sv"=>"Slovenien", "name:th"=>"ประเทศสโลวีเนีย", "name:tr"=>"Slovenya", "name:uk"=>"Словенія", "name:vi"=>"Slovenia", "name:zh"=>"斯洛文尼亚", "name:haw"=>"Solowenia", "name:zh_py"=>"Siluowenniya", "name:zh_pyt"=>"Sīluòwénníyà", "official_name:el"=>"Σλοβενική Δημοκρατία", "official_name:et"=>"Sloveenia Vabariik", "official_name:id"=>"Republik Slovenia", "official_name:lb"=>"Republik Slowenien", "official_name:lt"=>"Slovėnijos Respublika", "official_name:pt"=>"República da Eslovênia", "official_name:sk"=>"Slovinská republika", "official_name:sv"=>"Republiken Slovenien", "official_name:vi"=>"Cộng hòa Slovenia"	sl	36
dj	"name"=>"جيبوتي;Djibouti", "name:af"=>"Djiboeti", "name:ar"=>"جيبوتي", "name:be"=>"Джыбуці", "name:br"=>"Djibouti", "name:ca"=>"Djibouti", "name:da"=>"Djibouti", "name:de"=>"Dschibuti", "name:el"=>"Τζιμπουτί", "name:en"=>"Djibouti", "name:eo"=>"Ĝibutio", "name:es"=>"Yibuti", "name:et"=>"Djibouti", "name:fa"=>"جیبوتی", "name:fi"=>"Djibouti", "name:fr"=>"Djibouti", "name:fy"=>"Dzjibûty", "name:ga"=>"Diobúití", "name:gd"=>"Diobutaidh", "name:he"=>"ג'יבוטי", "name:hr"=>"Džibuti", "name:hu"=>"Dzsibuti", "name:id"=>"Djibouti", "name:is"=>"Djíbútí", "name:it"=>"Gibuti", "name:ja"=>"ジブチ", "name:la"=>"Dzibutum", "name:lb"=>"Dschibuti", "name:li"=>"Djiboeti", "name:lt"=>"Džibutis", "name:lv"=>"Džibutija", "name:mn"=>"Джибути", "name:nl"=>"Djibouti", "name:pl"=>"Dżibuti", "name:pt"=>"Djibuti", "name:ru"=>"Джибути", "name:sl"=>"Džibuti", "name:sv"=>"Djibouti", "name:th"=>"ประเทศจิบูตี", "name:tr"=>"Cibuti", "name:uk"=>"Джибуті", "name:vi"=>"Djibouti", "name:zh"=>"吉布提", "name:haw"=>"Dibuti", "name:zh_py"=>"Jibuti", "name:zh_pyt"=>"Jíbùtí", "official_name"=>"جمهورية جيبوتي;République de Djibouti", "official_name:af"=>"Republiek van Djiboeti", "official_name:br"=>"Republik Djibouti", "official_name:el"=>"Δημοκρατία του Τζιμπουτί", "official_name:en"=>"Republic of Djibouti", "official_name:et"=>"Djibouti Vabariik", "official_name:lv"=>"Džibutijas Republika", "official_name:pt"=>"República do Djibuti", "official_name:sv"=>"Republiken Djibouti", "official_name:vi"=>"Cộng hòa Djibouti"	\N	43
gg	"name"=>"Guernsey", "name:ar"=>"غويرنسي", "name:be"=>"Гернсі", "name:br"=>"Gwernenez", "name:cy"=>"Ynys y Garn", "name:el"=>"Γκέρνσεϊ", "name:en"=>"Guernsey", "name:eo"=>"Guernsey", "name:fi"=>"Guernsey", "name:fr"=>"Guernesey", "name:ga"=>"Geansaí", "name:he"=>"גרנזי", "name:hu"=>"Guernsey", "name:is"=>"Guernsey", "name:la"=>"Lisia", "name:lt"=>"Gernsis", "name:lv"=>"Gērnsija", "name:mn"=>"Гернси", "name:pl"=>"Guernsey", "name:ru"=>"Гернси", "name:sk"=>"Guernsey", "name:sv"=>"Guernsey", "name:th"=>"เกิร์นซีย์", "name:uk"=>"Гернсі", "name:zh"=>"格恩西岛", "name:zh_py"=>"Geenxi Dao", "name:zh_pyt"=>"Géēnxī Dǎo", "official_name:vi"=>"Địa hạt Guernsey"	en	77
ky	"name"=>"Cayman Islands", "name:af"=>"Kaaimanseilande", "name:ar"=>"جزر الكايمان", "name:be"=>"Кайманавы астравы", "name:br"=>"Inizi Cayman", "name:ca"=>"Illes Caiman", "name:cy"=>"Ynysoedd Cayman", "name:da"=>"Caymanøerne", "name:de"=>"Kaimaninseln", "name:en"=>"Cayman Islands", "name:eo"=>"Kajmaninsuloj", "name:es"=>"Islas Caimán", "name:et"=>"Kaimanisaared", "name:fa"=>"جزایر کایمان", "name:fi"=>"Caymansaaret", "name:fr"=>"Îles Caïmans", "name:fy"=>"de Kaaimaneilannen", "name:ga"=>"Oileáin Cayman", "name:he"=>"איי קיימן", "name:hr"=>"Kajmanski otoci", "name:hu"=>"Kajmán-szigetek", "name:id"=>"Kepulauan Cayman", "name:is"=>"Caymaneyjar", "name:it"=>"Isole Cayman", "name:lb"=>"Kaimaninselen", "name:lt"=>"Kaimanų salos", "name:lv"=>"Kaimanu salas", "name:mn"=>"Кайманы Арлууд", "name:nl"=>"Kaaimaneilanden", "name:pl"=>"Kajmany", "name:pt"=>"Ilhas Cayman", "name:ru"=>"Каймановы острова", "name:sl"=>"Kajmanski otoki", "name:sv"=>"Caymanöarna", "name:th"=>"หมู่เกาะเคย์แมน", "name:tr"=>"Kayman Adaları", "name:uk"=>"Кайманові острови", "name:vi"=>"Quần đảo Cayman", "name:zh"=>"开曼群岛"	en	38
ie	"name"=>"Ireland", "name:af"=>"Ierland", "name:ar"=>"أيرلندا", "name:be"=>"Ірландыя", "name:br"=>"Iwerzhon", "name:ca"=>"Irlanda", "name:cy"=>"Iwerddon", "name:da"=>"Irland", "name:de"=>"Irland", "name:el"=>"Ιρλανδία", "name:en"=>"Ireland", "name:eo"=>"Irlando", "name:es"=>"Irlanda", "name:et"=>"Iirimaa", "name:fa"=>"ایرلند", "name:fi"=>"Irlanti", "name:fr"=>"Irlande", "name:fy"=>"Ierlân", "name:ga"=>"Éire", "name:gd"=>"Poblachd na h-Èireann", "name:gv"=>"Nerin", "name:he"=>"אירלנד", "name:hr"=>"Irska", "name:hu"=>"Írország", "name:id"=>"Irlandia", "name:is"=>"Írland", "name:it"=>"Irlanda", "name:ja"=>"アイルランド", "name:la"=>"Hibernia", "name:lb"=>"Irland", "name:li"=>"Ierland", "name:lt"=>"Airija", "name:lv"=>"Īrija", "name:mn"=>"Ирланд", "name:nl"=>"Ierland", "name:pl"=>"Irlandia", "name:ru"=>"Ирландия", "name:sk"=>"Írsko", "name:sl"=>"Irska", "name:sv"=>"Irland", "name:th"=>"สาธารณรัฐไอร์แลนด์", "name:tr"=>"İrlanda", "name:uk"=>"Ірландія", "name:zh"=>"爱尔兰", "name:haw"=>"‘Ilelani", "name:zh_py"=>"Aierlan", "name:zh_pyt"=>"Àiěrlán", "official_name"=>"Republic of Ireland", "official_name:af"=>"Republiek van Ierland", "official_name:be"=>"Рэспубліка Ірландыя", "official_name:el"=>"Δημοκρατία της Ιρλανδίας", "official_name:es"=>"República de Irlanda", "official_name:id"=>"Republik Irlandia", "official_name:it"=>"Repubblica d'Irlanda", "official_name:ja"=>"アイルランド共和国", "official_name:la"=>"Hibernia (res publica)", "official_name:pl"=>"Republika Irlandii", "official_name:vi"=>"Cộng hòa Ireland"	\N	46
km	"name"=>"Comores;ﺍﻟﻘﻤﺮي;Komori", "name:af"=>"Komore", "name:ar"=>"جزر القمر", "name:br"=>"Komorez", "name:ca"=>"Comores", "name:cy"=>"Comoros", "name:da"=>"Comorerne", "name:de"=>"Komoren", "name:el"=>"Κομόρες", "name:en"=>"Comoros", "name:eo"=>"Komoroj", "name:es"=>"Comoras", "name:et"=>"Komoorid", "name:eu"=>"Komoreak", "name:fa"=>"مجمع‌الجزایر قمر", "name:fi"=>"Komorit", "name:fr"=>"Comores", "name:fy"=>"de Komoaren", "name:ga"=>"Oileáin Chomóra", "name:gd"=>"Comòras", "name:he"=>"קומורו", "name:hr"=>"Komori", "name:hu"=>"Comore-szigetek", "name:id"=>"Komoro", "name:is"=>"Kómoreyjar", "name:it"=>"Comore", "name:ja"=>"コモロ", "name:la"=>"Insulae Comorianae", "name:lb"=>"Komoren", "name:lt"=>"Komorai", "name:lv"=>"Komoru salas", "name:mn"=>"Коморын арлууд", "name:nl"=>"Comoren", "name:pl"=>"Komory", "name:pt"=>"Comores", "name:ru"=>"Коморы", "name:sl"=>"Komori", "name:sv"=>"Komorerna", "name:th"=>"ประเทศคอโมโรส", "name:tr"=>"Komorlar", "name:uk"=>"Коморські Острови", "name:vi"=>"Comoros", "name:zh"=>"科摩洛", "name:haw"=>"Komorosa", "name:zh_py"=>"Kemoluo", "name:zh_pyt"=>"Kēmóluò", "official_name"=>"Union des Comores;الاتحاد ﺍﻟﻘﻤﺮي;Udzima wa Komori", "official_name:ar"=>"الاتّحاد القمريّ", "official_name:el"=>"Ένωση των Κομορών", "official_name:en"=>"Union of the Comoros", "official_name:es"=>"Unión de las Comoras", "official_name:id"=>"Perserikatan Komoro", "official_name:lt"=>"Komorų Sąjunga", "official_name:lv"=>"Komoru Islāma Federatīvā Republika", "official_name:pl"=>"Związek Komorów", "official_name:pt"=>"União das Comores", "official_name:sv"=>"Unionen Komorerna", "official_name:vi"=>"Liên bang Comoros"	\N	47
st	"name"=>"São Tomé e Príncipe", "name:af"=>"São Tomé en Principe", "name:ar"=>"سان تومي وبرينسيبي", "name:br"=>"São Tomé ha Príncipe", "name:ca"=>"São Tomé i Príncipe", "name:cy"=>"São Tomé a Príncipe", "name:da"=>"São Tomé og Príncipe", "name:de"=>"São Tomé und Príncipe", "name:el"=>"Σάο Τομέ και Πρίνσιπε", "name:en"=>"São Tomé and Príncipe", "name:eo"=>"Sao-Tomeo kaj Principeo", "name:es"=>"Santo Tomé y Príncipe", "name:et"=>"São Tomé ja Príncipe", "name:fa"=>"سائوتومه و پرینسیپ", "name:fi"=>"São Tomé ja Príncipe", "name:fr"=>"Sao Tomé-et-Principe", "name:fy"=>"Sao Tomee en Prinsyp", "name:ga"=>"São Tomé agus Príncipe", "name:gd"=>"São Tomé agus Príncipe", "name:he"=>"סאו טומה ופרינסיפה", "name:hr"=>"Sveti Toma i Princip", "name:hu"=>"São Tomé és Príncipe", "name:id"=>"Sao Tome dan Principe", "name:is"=>"Saó Tóme og Prinsípe", "name:la"=>"Insulae Sancti Thomae et Principis", "name:lb"=>"São Tomé a Príncipe", "name:li"=>"São Tomé en Príncipe", "name:lt"=>"Sao Tomė ir Prinsipė", "name:mn"=>"Сан-Томе ба Принсипи", "name:nl"=>"Sao Tomé en Principe", "name:pl"=>"Wyspy Świętego Tomasza i Książęca", "name:pt"=>"São Tomé e Príncipe", "name:ru"=>"Сан-Томе и Принсипи", "name:sl"=>"Sao Tome in Principe", "name:sv"=>"São Tomé och Príncipe", "name:th"=>"ประเทศเซาตูเมและปรินซิปี", "name:tr"=>"São Tomé ve Príncipe", "name:uk"=>"Сан-Томе і Принсіпі", "name:vi"=>"São Tomé và Príncipe", "name:zh"=>"圣多美和普林西比", "name:zh_py"=>"Shengduomei he Pulinxibi", "name:zh_pyt"=>"Shèngduōměi hé Pǔlínxībǐ", "official_name:fr"=>"République démocratique de Sao Tomé-et-Principe", "official_name:id"=>"Republik Demokratik Sao Tome dan Principe", "official_name:lb"=>"Demokratesch Republik São Tomé a Príncipe", "official_name:pt"=>"República Democrática de São Tomé e Príncipe", "official_name:sv"=>"Demokratiska republiken São Tomé och Príncipe", "official_name:vi"=>"Cộng hòa Dân chủ São Tomé và Príncipe"	pt	53
no	"name"=>"Norge", "name:af"=>"Noorweë", "name:ar"=>"النرويج", "name:be"=>"Нарвегія", "name:br"=>"Norvegia", "name:ca"=>"Noruega", "name:cy"=>"Norwy", "name:de"=>"Norwegen", "name:el"=>"Νορβηγία", "name:en"=>"Norway", "name:eo"=>"Norvegio", "name:es"=>"Noruega", "name:et"=>"Norra", "name:fa"=>"نروژ", "name:fi"=>"Norja", "name:fr"=>"Norvège", "name:fy"=>"Noarwegen", "name:ga"=>"An Iorua", "name:gd"=>"Nirribhidh", "name:he"=>"נורווגיה", "name:hr"=>"Norveška", "name:hu"=>"Norvégia", "name:hy"=>"Նորվեգիա", "name:id"=>"Norwegia", "name:is"=>"Noregur", "name:it"=>"Norvegia", "name:ja"=>"ノルウェー", "name:la"=>"Norvegia", "name:lb"=>"Norwegen", "name:li"=>"Noorwege", "name:lt"=>"Norvegija", "name:lv"=>"Norvēģija", "name:mn"=>"Норвеги", "name:nl"=>"Noorwegen", "name:no"=>"Norge", "name:pl"=>"Norwegia", "name:ru"=>"Норвегия", "name:sk"=>"Nórsko", "name:sl"=>"Norveška", "name:sv"=>"Norge", "name:th"=>"ประเทศนอร์เวย์", "name:tr"=>"Norveç", "name:uk"=>"Норвегія", "name:vi"=>"Na Uy", "name:zh"=>"挪威", "name:haw"=>"Nolewai", "name:zh_py"=>"Nuowei", "name:zh_pyt"=>"Nuówēi", "official_name"=>"Kongeriket Norge", "official_name:be"=>"Каралеўства Нарвегія", "official_name:el"=>"Βασίλειο της Νορβηγίας", "official_name:en"=>"Kingdom of Norway", "official_name:id"=>"Kerajaan Norwegia", "official_name:it"=>"Regno di Norvegia", "official_name:ja"=>"ノルウェー王国", "official_name:lb"=>"Kinneksräich Norwegen", "official_name:lt"=>"Norvegijos Karalystė", "official_name:sk"=>"Nórske kráľovstvo", "official_name:sv"=>"Konungariket Norge", "official_name:vi"=>"Vương quốc Na Uy"	\N	60
kn	"name"=>"Saint Kitts and Nevis", "name:af"=>"Sint Kitts en Nevis", "name:ar"=>"سانت كيتس ونيفس", "name:be"=>"Святы Кітс і Невіс", "name:br"=>"Saint Kitts ha Nevis", "name:ca"=>"Saint Kitts i Nevis", "name:cy"=>"Saint Kitts a Nevis", "name:da"=>"Saint Kitts og Nevis", "name:de"=>"St. Kitts und Nevis", "name:eo"=>"Sankta-Kito kaj Neviso", "name:es"=>"San Cristóbal y Nieves", "name:et"=>"Saint Kitts ja Nevis", "name:fa"=>"سنت کیتس و نویس", "name:fi"=>"Saint Kitts ja Nevis", "name:fr"=>"Saint-Christophe-et-Niévès", "name:fy"=>"Sint Kitts en Nevis", "name:ga"=>"San Críostóir-Nimheas", "name:gd"=>"Naomh Crìstean agus Nibheis", "name:he"=>"סנט קיטס ונוויס", "name:hr"=>"Sveti Kristofor i Nevis", "name:hu"=>"Saint Christopher és Nevis", "name:id"=>"Saint Kitts dan Nevis", "name:is"=>"Sankti Kristófer og Nevis", "name:it"=>"Saint Kitts e Nevis", "name:lb"=>"Saint Kitts a Nevis", "name:li"=>"Saint-Kitts", "name:lt"=>"Sen Kristoferis ir Nevis", "name:mn"=>"Сент-Киттс ба Невис", "name:nl"=>"Saint Kitts en Nevis", "name:pl"=>"Saint Kitts i Nevis", "name:pt"=>"São Cristóvão e Nevis", "name:ru"=>"Сент-Китс и Невис", "name:sl"=>"Saint Kitts in Nevis", "name:sv"=>"Saint Kitts och Nevis", "name:th"=>"ประเทศเซนต์คิตส์และเนวิส", "name:tr"=>"Saint Kitts ve Nevis", "name:uk"=>"Сент-Кіттс і Невіс", "name:vi"=>"Saint Kitts và Nevis", "name:zh"=>"圣基茨和尼维斯", "alt_name"=>"Federation of Saint Christopher and Nevis", "official_name"=>"Federation of Saint Kitts and Nevis", "official_name:es"=>"Federación de San Cristóbal y Nieves", "official_name:fr"=>"Fédération de Saint-Christophe-et-Niévès", "official_name:id"=>"Federasi Saint Kitts dan Nevis", "official_name:it"=>"Federazione di Saint Kitts e Nevis", "official_name:pl"=>"Federacja Saint Kitts i Nevis", "official_name:pt"=>"Federação de São Cristóvão e Nevis", "official_name:vi"=>"Liên bang Saint Kitts và Nevis"	en	84
rs	"name"=>"Србија (Serbia)", "name:af"=>"Serwië", "name:ar"=>"صربيا", "name:be"=>"Сербія", "name:br"=>"Serbia", "name:ca"=>"Sèrbia", "name:cy"=>"Serbia", "name:da"=>"Serbien", "name:de"=>"Serbien", "name:el"=>"Σερβία", "name:en"=>"Serbia", "name:eo"=>"Serbio", "name:es"=>"Serbia", "name:et"=>"Serbia", "name:fa"=>"صربستان", "name:fi"=>"Serbia", "name:fr"=>"Serbie", "name:fy"=>"Servje", "name:ga"=>"An tSeirbia", "name:gd"=>"An t-Sèarb", "name:he"=>"סרביה", "name:hr"=>"Srbija", "name:hu"=>"Szerbia", "name:id"=>"Serbia", "name:is"=>"Serbía", "name:it"=>"Serbia", "name:ja"=>"セルビア", "name:la"=>"Serbia", "name:lb"=>"Serbien", "name:li"=>"Servië", "name:lt"=>"Serbija", "name:mn"=>"Серби", "name:nb"=>"Serbia", "name:nl"=>"Servië", "name:nn"=>"Serbia", "name:no"=>"Serbia", "name:pl"=>"Serbia", "name:pt"=>"Sérvia", "name:ru"=>"Сербия", "name:sk"=>"Srbsko", "name:sl"=>"Srbija", "name:sr"=>"Србија", "name:sv"=>"Serbien", "name:th"=>"ประเทศเซอร์เบีย", "name:tr"=>"Sırbistan", "name:uk"=>"Сербія", "name:vi"=>"Serbia", "name:zh"=>"塞尔维亚", "name:haw"=>"Seripia", "name:zh_py"=>"Saierweiya", "name:zh_pyt"=>"Sāiěrwéiyà", "official_name:br"=>"Republik Serbia", "official_name:el"=>"Δημοκρατία της Σερβίας", "official_name:et"=>"Serbia Vabariik", "official_name:fr"=>"République de Serbie", "official_name:id"=>"Republik Serbia", "official_name:ja"=>"セルビア共和国", "official_name:lt"=>"Serbijos Respublika", "official_name:pt"=>"República da Sérvia", "official_name:sk"=>"Srbská republika", "official_name:sv"=>"Republiken Serbien"	sr	59
lb	"name"=>"لبنان  Lebanon", "name:af"=>"Libanon", "name:ar"=>"لبنان", "name:be"=>"Ліван", "name:br"=>"Liban", "name:ca"=>"Líban", "name:cy"=>"Libanus", "name:da"=>"Libanon", "name:de"=>"Libanon", "name:el"=>"Λίβανος", "name:en"=>"Lebanon", "name:eo"=>"Libano", "name:es"=>"Líbano", "name:et"=>"Liibanon", "name:fa"=>"لبنان", "name:fi"=>"Libanon", "name:fr"=>"Liban", "name:fy"=>"Libanon", "name:ga"=>"An Liobáin", "name:gd"=>"Leabanon", "name:he"=>"לבנון", "name:hr"=>"Libanon", "name:hu"=>"Libanon", "name:id"=>"Lebanon", "name:is"=>"Líbanon", "name:it"=>"Libano", "name:ja"=>"レバノン", "name:la"=>"Libanus", "name:lb"=>"Libanon", "name:li"=>"Libanon", "name:lt"=>"Libanas", "name:lv"=>"Libāna", "name:mn"=>"Ливан", "name:nb"=>"Libanon", "name:nl"=>"Libanon", "name:nn"=>"Libanon", "name:no"=>"Libanon", "name:pl"=>"Liban", "name:pt"=>"Líbano", "name:ru"=>"Ливан", "name:sl"=>"Libanon", "name:sv"=>"Libanon", "name:th"=>"ประเทศเลบานอน", "name:tr"=>"Lübnan", "name:uk"=>"Ліван", "name:vi"=>"Liban", "name:zh"=>"黎巴嫩", "name:haw"=>"Lepanona", "name:zh_py"=>"Libanen", "name:zh_pyt"=>"Líbānèn", "official_name"=>"Republic of Lebanon", "official_name:br"=>"Republik Liban", "official_name:en"=>"Republic of Lebanon", "official_name:et"=>"Liibanoni Vabariik", "official_name:id"=>"Republik Lebanon", "official_name:it"=>"Repubblica Libanese", "official_name:ja"=>"レバノン共和国", "official_name:lb"=>"Republik Libanon", "official_name:lv"=>"Libānas Republika", "official_name:pl"=>"Republika Libańska", "official_name:pt"=>"República do Líbano", "official_name:sv"=>"Republiken Libanon", "official_name:vi"=>"Cộng hòa Liban"	\N	66
bt	"name"=>"Bhutan", "name:af"=>"Bhoetan", "name:ar"=>"بوتان", "name:be"=>"Бутан", "name:br"=>"Bhoutan", "name:dz"=>"འབྲུག་ཡུལ་", "name:el"=>"Μπουτάν", "name:en"=>"Bhutan", "name:eo"=>"Butano", "name:es"=>"Bután", "name:fa"=>"بوتان", "name:fi"=>"Bhutan", "name:fr"=>"Bhoutan", "name:fy"=>"Bûtan", "name:ga"=>"An Bhútain", "name:gd"=>"Butàn", "name:he"=>"בהוטן", "name:hr"=>"Butan", "name:hu"=>"Bhután", "name:is"=>"Bútan", "name:it"=>"Bhutan", "name:ja"=>"ブータン", "name:la"=>"Butania", "name:li"=>"Bhoetaan", "name:lt"=>"Butanas", "name:lv"=>"Butāna", "name:mn"=>"Бутан", "name:pl"=>"Bhutan", "name:pt"=>"Butão", "name:ru"=>"Бутан", "name:sl"=>"Butan", "name:sv"=>"Bhutan", "name:th"=>"ประเทศภูฏาน", "name:uk"=>"Бутан", "name:zh"=>"不丹", "name:haw"=>"Butana", "name:zh_py"=>"Budan", "name:zh_pyt"=>"Bùdān", "official_name:el"=>"Βασίλειο του Μπουτάν", "official_name:en"=>"Kingdom of Bhutan", "official_name:fi"=>"Bhutanin kuningaskunta", "official_name:it"=>"Regno del Bhutan", "official_name:lt"=>"Butano Karalystė", "official_name:lv"=>"Butānas Karaliste", "official_name:pt"=>"Reino do Butão", "official_name:sv"=>"Konungariket Bhutan", "official_name:vi"=>"Vương quốc Bhutan"	dz	87
mk	"name"=>"Македонија", "name:af"=>"Masedonië", "name:ar"=>"مقدونيا", "name:be"=>"Македонія", "name:br"=>"Makedonia", "name:ca"=>"Macedònia", "name:cy"=>"Gweriniaeth Macedonia", "name:da"=>"Makedonien", "name:de"=>"Mazedonien", "name:en"=>"Macedonia", "name:eo"=>"Makedonio", "name:es"=>"Macedonia", "name:et"=>"Makedoonia", "name:fa"=>"مقدونیه", "name:fi"=>"Makedonia", "name:fr"=>"Macédoine", "name:fy"=>"Massedoanje", "name:ga"=>"An Mhacadóin", "name:gd"=>"Masadoinia", "name:he"=>"מקדוניה", "name:hr"=>"Makedonija", "name:hu"=>"Macedónia", "name:id"=>"Republik Makedonia", "name:is"=>"Makedónía", "name:it"=>"Macedonia", "name:ja"=>"マケドニア", "name:la"=>"Respublica Macedonica", "name:lb"=>"Makedonien", "name:li"=>"Macedonië", "name:lt"=>"Makedonija", "name:lv"=>"Maķedonija", "name:mn"=>"Македон", "name:nl"=>"Macedonië", "name:pl"=>"Macedonia", "name:pt"=>"Macedônia", "name:ru"=>"Македония", "name:sk"=>"Macedónsko", "name:sl"=>"Makedonija", "name:sv"=>"Makedonien", "name:th"=>"ประเทศมาซิโดเนีย", "name:tr"=>"Makedonya", "name:uk"=>"Македонія", "name:vi"=>"Macedonia", "name:zh"=>"马其顿", "name:haw"=>"Repupalika ‘o Makekonia", "name:zh_py"=>"Maqidun", "name:zh_pyt"=>"Mǎqídùn", "official_name"=>"Република Македонија", "official_name:af"=>"Republiek van Masedonië", "official_name:be"=>"Рэспубліка Македонія ", "official_name:br"=>"Republik Makedonia", "official_name:ca"=>"Exrepública Iugoslava de Macedònia", "official_name:en"=>"Republic of Macedonia", "official_name:es"=>"República de Macedonia", "official_name:et"=>"Makedoonia Vabariik", "official_name:fr"=>"République de Macédoine", "official_name:it"=>"Repubblica di Macedonia", "official_name:ja"=>"マケドニア旧ユーゴスラビア共和国", "official_name:lv"=>"Maķedonijas Republika", "official_name:pl"=>"Republika Macedonii", "official_name:pt"=>"República da Macedônia", "official_name:sk"=>"Macedónska republika", "official_name:sl"=>"Republika Makedonija", "official_name:sv"=>"Republiken Makedonien", "official_name:vi"=>"Cộng hòa Macedonia"	mk	69
pg	"name"=>"Papua New Guinea", "name:af"=>"Papoea-Nieu-Guinee", "name:ar"=>"بابوا نيوغينيا", "name:be"=>"Папуа-Новая Гвінея ", "name:br"=>"Papoua Ginea Nevez", "name:ca"=>"Papua Nova Guinea", "name:cy"=>"Papua Guinea Newydd", "name:da"=>"Papua Ny Guinea", "name:de"=>"Papua-Neuguinea", "name:en"=>"Papua New Guinea", "name:eo"=>"Papuo-Nov-Gvineo", "name:es"=>"Papúa Nueva Guinea", "name:et"=>"Paapua Uus-Guinea", "name:fa"=>"پاپوآ گینه نو", "name:fi"=>"Papua-Uusi-Guinea", "name:fr"=>"Papouasie-Nouvelle-Guinée", "name:fy"=>"Papoea Nij-Guinea", "name:ga"=>"Nua-Ghuine Phapua", "name:gd"=>"Papua Gini-Nuadh", "name:he"=>"פפואה גינאה החדשה", "name:hr"=>"Papua Nova Gvineja", "name:hu"=>"Pápua Új-Guinea", "name:id"=>"Papua Nugini", "name:is"=>"Papúa Nýja-Gínea", "name:it"=>"Papua Nuova Guinea", "name:la"=>"Papua Nova Guinea", "name:lb"=>"Papua-Neiguinea", "name:li"=>"Papoea-Nui-Guinea", "name:lt"=>"Papua ir Naujoji Gvinėja", "name:lv"=>"Papua-Jaungvineja", "name:mn"=>"Папуа-Шинэ Гвиней", "name:nl"=>"Papoea-Nieuw-Guinea", "name:pl"=>"Papua-Nowa Gwinea", "name:ru"=>"Папуа-Новая Гвинея", "name:sl"=>"Papua Nova Gvineja", "name:sv"=>"Papua Nya Guinea", "name:th"=>"ประเทศปาปัวนิวกินี", "name:tr"=>"Papua -Yeni Gine", "name:uk"=>"Папуа-Нова Гвінея", "name:zh"=>"巴布亚新几内亚", "official_name"=>"Independent State of Papua New Guinea;Independen Stet bilong Papua Niugini", "official_name:es"=>"Estado Independiente de Papúa Nueva Guínea", "official_name:et"=>"Paapua Uus-Guinea Iseseisvusriik", "official_name:lv"=>"Papua-Jaungvinejas Neatkarīgā Valsts", "official_name:pl"=>"Niezależne Państwo Papui-Nowej Gwinei", "official_name:vi"=>"Quốc gia Độc lập Papua New Guinea"	\N	71
sd	"name"=>"السودان ‎al-Sūdān", "name:af"=>"Soedan", "name:ar"=>"السودان", "name:be"=>"Судан", "name:br"=>"Soudan", "name:ca"=>"Sudan ", "name:cy"=>"Sudan", "name:da"=>"Sudan", "name:de"=>"Sudan", "name:el"=>"Σουδάν", "name:en"=>"Sudan", "name:eo"=>"Sudano", "name:es"=>"Sudán", "name:et"=>"Sudaan", "name:fa"=>"سودان", "name:fi"=>"Sudan", "name:fr"=>"Soudan", "name:fy"=>"Sûdan", "name:ga"=>"An tSúdáin", "name:gd"=>"Sudan", "name:he"=>"סודן", "name:hr"=>"Sudan", "name:hu"=>"Szudán", "name:id"=>"Sudan", "name:is"=>"Súdan", "name:it"=>"Sudan", "name:ja"=>"スーダン", "name:la"=>"Sudania", "name:lb"=>"Sudan", "name:li"=>"Soedaan", "name:lt"=>"Sudanas", "name:lv"=>"Sudāna", "name:mn"=>"Судан", "name:nl"=>"Soedan", "name:pl"=>"Sudan", "name:pt"=>"Sudão", "name:ru"=>"Судан", "name:sl"=>"Sudan", "name:sv"=>"Sudan", "name:th"=>"ประเทศซูดาน", "name:tr"=>"Sudan", "name:uk"=>"Судан", "name:vi"=>"Sudan", "name:zh"=>"苏丹", "name:haw"=>"Sudana", "name:zh_py"=>"Sudan", "name:zh_pyt"=>"Sūdān", "official_name"=>"جمهورية السودان", "official_name:br"=>"Republik Soudan", "official_name:el"=>"Δημοκρατία του Σουδάν", "official_name:en"=>"Republic of Sudan", "official_name:et"=>"Sudaani Vabariik", "official_name:fr"=>"République du Soudan", "official_name:id"=>"Republik Sudan", "official_name:ja"=>"スーダン共和国", "official_name:lb"=>"Republik Sudan", "official_name:pt"=>"República do Sudão", "official_name:sv"=>"Republiken Sudan", "official_name:vi"=>"Cộng hòa Sudan"	\N	72
za	"name"=>"South Africa", "name:af"=>"Suid-Afrika", "name:ar"=>"جنوب أفريقيا", "name:be"=>"Паўднёва-Афрыканская Рэспубліка", "name:br"=>"Suafrika", "name:ca"=>"Sud-àfrica", "name:cy"=>"De Affrica", "name:da"=>"Sydafrika", "name:de"=>"Südafrika", "name:el"=>"Νότια Αφρική", "name:en"=>"South Africa", "name:eo"=>"Sudafriko", "name:es"=>"Sudáfrica", "name:et"=>"Lõuna-Aafrika Vabariik", "name:fa"=>"آفریقای جنوبی", "name:fi"=>"Etelä-Afrikka", "name:fr"=>"Afrique du Sud", "name:fy"=>"Súd-Afrika", "name:ga"=>"An Afraic Theas", "name:gd"=>"Afraga a Deas", "name:he"=>"דרום אפריקה", "name:hr"=>"Južnoafrička Republika", "name:hu"=>"Dél-Afrikai Köztársaság", "name:id"=>"Afrika Selatan", "name:is"=>"Suður-Afríka", "name:it"=>"Sudafrica", "name:ja"=>"南アフリカ", "name:la"=>"Africa Australis", "name:lb"=>"Südafrika", "name:li"=>"Zuud-Afrika", "name:lt"=>"Pietų Afrikos Respublika", "name:mn"=>"Өмнөд Африк", "name:nl"=>"Zuid-Afrika", "name:pl"=>"Republika Południowej Afryki", "name:pt"=>"África do Sul", "name:ru"=>"Южная Африка", "name:sl"=>"Južna Afrika", "name:ss"=>"INingizimu Afrika", "name:st"=>"Afrika Borwa", "name:sv"=>"Sydafrika", "name:th"=>"ประเทศแอฟริกาใต้", "name:tn"=>"Aferika Borwa", "name:tr"=>"Güney Afrika", "name:ts"=>"Afrika-Dzonga", "name:uk"=>"Південно-Африканська Республіка", "name:ve"=>"Afurika Tshipembe", "name:vi"=>"Nam Phi", "name:xh"=>"uMzantsi Afrika", "name:zh"=>"南非", "name:zu"=>"Ningizimu Afrika", "name:haw"=>"ʻApelika Hema", "name:zh_py"=>"Nan Fei", "name:zh_pyt"=>"Nán Fēi", "official_name"=>"Republic of South Africa", "official_name:br"=>"Republik Suafrika", "official_name:en"=>"Republic of South Africa", "official_name:fr"=>"République d'Afrique du Sud", "official_name:gd"=>"Poblachd Afraga a Deas", "official_name:id"=>"Republik Afrika Selatan", "official_name:ja"=>"南アフリカ共和国", "official_name:lb"=>"Republik Südafrika", "official_name:pt"=>"República da África do Sul", "official_name:ru"=>"Южно-Африканская Республика", "official_name:sl"=>"Republika Južna Afrika", "official_name:sv"=>"Republiken Sydafrika", "official_name:ts"=>"Riphabliki ra Afrika Dzonga", "official_name:ve"=>"Riphabuḽiki ya Afurika Tshipembe", "official_name:vi"=>"Cộng hòa Nam Phi"	\N	76
sc	"name"=>"Seychelles", "name:af"=>"Seychelle", "name:ar"=>"سيشيل", "name:be"=>"Сейшэлы", "name:br"=>"Sechelez", "name:da"=>"Seychellerne", "name:de"=>"Seychellen", "name:el"=>"Σεϋχέλλες", "name:en"=>"Seychelles", "name:eo"=>"Sejŝeloj", "name:es"=>"Seychelles", "name:et"=>"Seišellid", "name:fa"=>"سیشل", "name:fi"=>"Seychellit", "name:fr"=>"Seychelles", "name:fy"=>"de Seysjellen", "name:ga"=>"Na Séiséil", "name:gd"=>"Na h-Eileanan Sheiseall", "name:he"=>"סיישל", "name:hr"=>"Sejšeli", "name:hu"=>"Seychelle-szigetek", "name:is"=>"Seychelles-eyjar", "name:la"=>"Insulae Seisellenses", "name:lb"=>"Seychellen", "name:li"=>"Seisjelle", "name:lt"=>"Seišeliai", "name:mn"=>"Сейшелийн арлууд", "name:nl"=>"Seychellen", "name:pl"=>"Seszele", "name:ru"=>"Сейшелы", "name:sl"=>"Sejšeli", "name:sv"=>"Seychellerna", "name:th"=>"ประเทศเซเชลส์", "name:tr"=>"Seyşeller", "name:uk"=>"Сейшельські Острови", "name:zh"=>"塞舌尔群岛", "name:haw"=>"Sekele", "name:zh_py"=>"Saisheerqundao", "name:zh_pyt"=>"Sàishéěr Qúndǎo", "official_name"=>"Repiblik Sesel", "official_name:el"=>"Δημοκρατία των Σεϋχελλών", "official_name:en"=>"Republic of Seychelles", "official_name:es"=>"República de las Seychelles", "official_name:et"=>"Seišelli Vabariik", "official_name:fr"=>"République des Seychelles", "official_name:gd"=>"Poblachd na h-Eileanan Sheiseall", "official_name:id"=>"Republik Seychelles", "official_name:lt"=>"Seišelių Respublika", "official_name:pl"=>"Republika Seszeli", "official_name:sv"=>"Republiken Seychellerna", "official_name:vi"=>"Cộng hòa Seychelles"	\N	79
sz	"name"=>"Swaziland", "name:ar"=>"سوازيلند", "name:be"=>"Свазіленд", "name:br"=>"Swaziland", "name:ca"=>"Swazilàndia", "name:cy"=>"Gwlad Swazi", "name:de"=>"Swasiland", "name:el"=>"Σουαζιλάνδη", "name:eo"=>"Svazilando", "name:es"=>"Suazilandia", "name:et"=>"Svaasimaa", "name:fa"=>"سوازیلند", "name:fi"=>"Swazimaa", "name:fr"=>"Swaziland", "name:fy"=>"Swazilân", "name:ga"=>"An tSuasalainn", "name:gd"=>"Suasalainn", "name:he"=>"סווזילנד", "name:hr"=>"Svazi", "name:hu"=>"Szváziföld", "name:is"=>"Svasíland", "name:it"=>"Swaziland", "name:ja"=>"スワジランド", "name:la"=>"Suazia", "name:lb"=>"Swasiland", "name:lt"=>"Svazilendas", "name:mn"=>"Свазиланд", "name:pl"=>"Suazi", "name:pt"=>"Suazilândia", "name:ru"=>"Свазиленд", "name:sl"=>"Svazi", "name:sv"=>"Swaziland", "name:th"=>"ประเทศสวาซิแลนด์", "name:tr"=>"Svaziland", "name:uk"=>"Свазіленд", "name:zh"=>"斯威士兰", "name:haw"=>"Suazilana", "name:zh_py"=>"Siweishilan", "name:zh_pyt"=>"Sīwēishìlán", "official_name"=>"Kingdom of Swaziland;Umbuso weSwatini", "official_name:ca"=>"Regne de Swazilàndia", "official_name:el"=>"Βασίλειο της Σουαζιλάνδης", "official_name:et"=>"Svaasimaa Kuningriik", "official_name:gd"=>"Dùthaich nan Suasaidh", "official_name:id"=>"Kerajaan Swaziland", "official_name:ja"=>"スワジランド王国", "official_name:lb"=>"Kinneksräich Swasiland", "official_name:pt"=>"Reino da Suazilândia", "official_name:sl"=>"Kraljevina Svazi", "official_name:sv"=>"Konungariket Swaziland", "official_name:vi"=>"Vương quốc Swaziland"	\N	82
ae	"name"=>"United Arab Emirates", "name:af"=>"Verenigde Arabiese Emirate", "name:ar"=>"الإمارات العربية المتحدة", "name:br"=>"Emirelezhioù Arab Unanet", "name:ca"=>"Emirats Àrabs Units", "name:cy"=>"Yr Emiradau Arabaidd Unedig", "name:da"=>"Forenede Arabiske Emirater", "name:de"=>"Vereinigte Arabische Emirate", "name:el"=>"Ηνωμένα Αραβικά Εμιράτα", "name:en"=>"United Arab Emirates", "name:eo"=>"Unuiĝintaj Arabaj Emirlandoj", "name:es"=>"Emiratos Árabes Unidos", "name:et"=>"Araabia Ühendemiraadid", "name:fa"=>"امارات متحده عربی", "name:fi"=>"Yhdistyneet arabiemiirikunnat", "name:fr"=>"Emirats Arabes Unis", "name:fy"=>"de Feriene Arabyske Emiraten", "name:ga"=>"Aontas na nÉimíríochtaí Arabacha", "name:gd"=>"Na h-Iomaratan Arabach Aonaichte", "name:he"=>"איחוד האמירויות הערביות", "name:hr"=>"Ujedinjeni Arapski Emirati", "name:hu"=>"Egyesült Arab Emírségek", "name:id"=>"Uni Emirat Arab", "name:is"=>"Sameinuðu arabísku furstadæmin", "name:it"=>"Emirati Arabi Uniti", "name:ja"=>"アラブ首長国連邦", "name:la"=>"Phylarchiarum Arabicarum Confoederatio", "name:lb"=>"Vereenegt Arabesch Emirater", "name:li"=>"Vereinegde Arabische Emirate", "name:lt"=>"Jungtiniai Arabų Emyratai", "name:mn"=>"Арабын Нэгдсэн Эмирт Улс", "name:nl"=>"Verenigde Arabische Emiraten", "name:pl"=>"Zjednoczone Emiraty Arabskie", "name:pt"=>"Emirados Árabes Unidos", "name:ru"=>"Объединённые Арабские Эмираты", "name:sl"=>"Združeni arabski emirati", "name:sv"=>"Förenade Arabemiraten", "name:th"=>"สหรัฐอาหรับเอมิเรตส์", "name:tr"=>"Birleşik Arap Emirlikleri", "name:uk"=>"Об'єднані Арабські Емірати", "name:vi"=>"Các Tiểu vương quốc Ả Rập Thống nhất", "name:zh"=>"阿拉伯联合酋长国", "name:zh_py"=>"Alabo Lianhe Qiuchangguo", "name:zh_pyt"=>"Ālābó Liánhé Qiúchángguó"	ar	83
tr	"name"=>"Türkiye", "name:af"=>"Turkye", "name:ar"=>"تركيا", "name:az"=>"Türkiyə", "name:be"=>"Турцыя", "name:br"=>"Turkia", "name:ca"=>"Turquia", "name:cy"=>"Twrci", "name:da"=>"Tyrkiet", "name:de"=>"Türkei", "name:el"=>"Τουρκία", "name:en"=>"Turkey", "name:eo"=>"Turkio", "name:es"=>"Turquía", "name:et"=>"Türgi", "name:fa"=>"ترکیه", "name:fi"=>"Turkki", "name:fr"=>"Turquie", "name:fy"=>"Turkije", "name:ga"=>"An Tuirc", "name:gd"=>"An Tuirc", "name:he"=>"טורקיה", "name:hr"=>"Turska", "name:hu"=>"Törökország", "name:hy"=>"Թուրքիա", "name:id"=>"Turki", "name:is"=>"Tyrkland", "name:it"=>"Turchia", "name:ja"=>"トルコ", "name:la"=>"Turcia", "name:lb"=>"Tierkei", "name:li"=>"Törkieë", "name:lt"=>"Turkija", "name:lv"=>"Turcija", "name:nl"=>"Turkije", "name:no"=>"Tyrkia", "name:pl"=>"Turcja", "name:pt"=>"Turquia", "name:ru"=>"Турция", "name:sk"=>"Turecko", "name:sl"=>"Turčija", "name:sv"=>"Turkiet", "name:th"=>"ประเทศตุรกี", "name:tr"=>"Türkiye", "name:uk"=>"Турція", "name:vi"=>"Thổ Nhĩ Kỳ", "name:zh"=>"土耳其", "name:haw"=>"Tureke", "name:zh_py"=>"Tuerqi", "name:zh_pyt"=>"Tǔěrqí", "official_name"=>"Türkiye Cumhuriyeti", "official_name:br"=>"Republik Turkia", "official_name:es"=>"República de Turquía", "official_name:et"=>"Türgi Vabariik", "official_name:id"=>"Republik Turki", "official_name:it"=>"Repubblica di Turchia", "official_name:lb"=>"Republik Tierkei", "official_name:lv"=>"Turcijas Republika", "official_name:pl"=>"Republika Turcji", "official_name:pt"=>"República da Turquia", "official_name:sk"=>"Turecká republika", "official_name:sv"=>"Republiken Turkiet", "official_name:vi"=>"Cộng hoà Thổ Nhĩ Kỳ"	tr	81
et	"name"=>"Ethiopia", "name:af"=>"Ethiopië", "name:am"=>"ኢትዮጵያ", "name:ar"=>"إثيوبيا", "name:be"=>"Эфіопія", "name:br"=>"Etiopia", "name:ca"=>"Etiòpia", "name:da"=>"Etiopien", "name:de"=>"Äthiopien", "name:el"=>"Αιθιοπία", "name:en"=>"Ethiopia", "name:eo"=>"Etiopio", "name:es"=>"Etiopía", "name:et"=>"Etioopia", "name:eu"=>"Etiopia", "name:fa"=>"اتیوپی", "name:fi"=>"Etiopia", "name:fr"=>"Éthiopie", "name:fy"=>"Etioopje", "name:ga"=>"An Aetóip", "name:gd"=>"An Aetiòp", "name:he"=>"אתיופיה", "name:hr"=>"Etiopija", "name:hu"=>"Etiópia", "name:is"=>"Eþíópía", "name:it"=>"Etiopia", "name:ja"=>"エチオピア", "name:la"=>"Aethiopia", "name:lb"=>"Ethiopien", "name:li"=>"Ethiopië", "name:lt"=>"Etiopija", "name:lv"=>"Etiopija", "name:mn"=>"Этиоп", "name:nl"=>"Ethiopië", "name:pl"=>"Etiopia", "name:pt"=>"Etiópia", "name:ru"=>"Эфиопия", "name:sl"=>"Etiopija", "name:sv"=>"Etiopien", "name:th"=>"ประเทศเอธิโอเปีย", "name:tr"=>"Etiyopya", "name:uk"=>"Ефіопія", "name:zh"=>"埃塞俄比亚", "old_name"=>"Abyssinia", "name:zh_py"=>"Aisaiebiya", "name:zh_pyt"=>"Āisàiébǐyà", "official_name"=>"Federal Democratic Republic of Ethiopia", "official_name:af"=>"Federale Demokratiese Republiek Ethiopië", "official_name:be"=>"Федэратыўная Дэмакратычная Рэспубліка Эфіопія", "official_name:el"=>"Ομοσπονδιακή Δημοκρατία της Αιθιοπίας", "official_name:en"=>"Federal Democratic Republic of Ethiopia", "official_name:id"=>"Republik Demokratik Federal Ethiopia", "official_name:lb"=>"Bundesrepublik Ethiopien", "official_name:lt"=>"Etiopijos Federacinė Demokratinė Respublika", "official_name:lv"=>"Etiopijas Federatīvā Demokrātiskā Republika", "official_name:pt"=>"República Democrática Federal da Etiópia", "official_name:sv"=>"Demokratiska förbundsrepubliken Etiopien", "official_name:vi"=>"Cộng hòa Dân chủ Liên bang Ethiopia"	\N	90
cl	"name"=>"Chile", "name:af"=>"Chili", "name:ar"=>"شيلي", "name:be"=>"Чылі", "name:br"=>"Chile", "name:ca"=>"Xile", "name:el"=>"Χιλή", "name:en"=>"Chile", "name:eo"=>"Ĉilio", "name:et"=>"Tšiili", "name:eu"=>"Txile", "name:fa"=>"شیلی", "name:fi"=>"Chile", "name:fr"=>"Chili", "name:fy"=>"Sily", "name:ga"=>"An tSile", "name:gd"=>"An t-Sile", "name:he"=>"צילה", "name:hr"=>"Čile", "name:hu"=>"Chile", "name:id"=>"Chili", "name:is"=>"Chile", "name:it"=>"Cile", "name:ja"=>"チリ", "name:la"=>"Chilia", "name:li"=>"Chili", "name:lt"=>"Čilė", "name:lv"=>"Čīle", "name:mn"=>"Чили", "name:nl"=>"Chili", "name:pl"=>"Chile", "name:pt"=>"Chile", "name:ru"=>"Чили", "name:sl"=>"Čile", "name:sv"=>"Chile", "name:th"=>"ประเทศชิลี", "name:tr"=>"Şili", "name:uk"=>"Чілі", "name:zh"=>"智利", "official_name"=>"República de Chile", "official_name:el"=>"Δημοκρατία της Χιλής", "official_name:en"=>"Republic of Chile", "official_name:gd"=>"Poblachd na Sile", "official_name:it"=>"Repubblica del Cile", "official_name:ja"=>"チリ共和国", "official_name:lb"=>"Republik Chile", "official_name:lt"=>"Čilės Respublika", "official_name:lv"=>"Čīles Republika", "official_name:pl"=>"Republika Chile", "official_name:pt"=>"República do Chile", "official_name:sv"=>"Republiken Chile", "official_name:vi"=>"Cộng hoà Chile"	es	88
mz	"name"=>"Mozambique", "name:af"=>"Mosambiek", "name:ar"=>"موزمبيق", "name:be"=>"Мазамбік", "name:br"=>"Mozambik", "name:cy"=>"Mosambic", "name:de"=>"Mosambik", "name:el"=>"Μοζαμβίκη", "name:en"=>"Mozambique", "name:eo"=>"Mozambiko", "name:es"=>"Mozambique", "name:et"=>"Mosambiik", "name:fa"=>"موزامبیک", "name:fi"=>"Mosambik", "name:fr"=>"Mozambique", "name:fy"=>"Mozambyk", "name:ga"=>"Mósaimbíc", "name:gd"=>"Mòsaimbic", "name:he"=>"מוזמביק", "name:hr"=>"Mozambik", "name:hu"=>"Mozambik", "name:id"=>"Mozambik", "name:is"=>"Mósambík", "name:it"=>"Mozambico", "name:la"=>"Mozambicum", "name:lb"=>"Mosambik", "name:li"=>"Mozambiek", "name:lt"=>"Mozambikas", "name:lv"=>"Mozambika", "name:mn"=>"Мозамбик", "name:pl"=>"Mozambik", "name:pt"=>"Moçambique", "name:ru"=>"Мозамбик", "name:sl"=>"Mozambik", "name:sv"=>"Moçambique", "name:th"=>"ประเทศโมซัมบิก", "name:tr"=>"Mozambik", "name:uk"=>"Мозамбік", "name:zh"=>"莫桑比克", "name:haw"=>"Mozamabika", "name:zh_py"=>"Mosangbike", "name:zh_pyt"=>"Mòsāngbǐkè", "official_name"=>"República de Moçambique;République du Mozambique", "official_name:el"=>"Δημοκρατία της Μοζαμβίκης", "official_name:gd"=>"Poblachd Mhòsaimbic", "official_name:id"=>"Republik Mozambik", "official_name:lt"=>"Mozambiko Respublika", "official_name:lv"=>"Mozambikas Republika", "official_name:sv"=>"Republiken Moçambique", "official_name:vi"=>"Cộng hòa Mozambique"	pt	98
py	"name"=>"Paraguay", "name:ar"=>"باراغواي", "name:be"=>"Парагвай", "name:br"=>"Paraguay", "name:ca"=>"Paraguai", "name:da"=>"Paraguay", "name:el"=>"Παραγουάη", "name:en"=>"Paraguay", "name:eo"=>"Paragvajo", "name:fa"=>"پاراگوئه", "name:fi"=>"Paraguay", "name:fr"=>"Paraguay", "name:ga"=>"Paragua", "name:gd"=>"Paraguaidh", "name:he"=>"פראגואי", "name:hr"=>"Paragvaj", "name:hu"=>"Paraguay", "name:is"=>"Paragvæ", "name:ja"=>"パラグアイ", "name:la"=>"Paraguaia", "name:lt"=>"Paragvajus", "name:lv"=>"Paragvaja", "name:mn"=>"Парагвай", "name:pl"=>"Paragwaj", "name:ru"=>"Парагвай", "name:sl"=>"Paragvaj", "name:sv"=>"Paraguay", "name:th"=>"ประเทศปารากวัย", "name:uk"=>"Парагвай", "name:zh"=>"巴拉圭", "official_name"=>"República del Paraguay", "official_name:el"=>"Δημοκρατία της Παραγουάης", "official_name:gd"=>"Poblachd Pharaguaidh", "official_name:id"=>"Republik Paraguay", "official_name:lt"=>"Paragvajaus Respublika", "official_name:lv"=>"Paragvajas Republika", "official_name:pl"=>"Republika Paragwaju", "official_name:sv"=>"Republiken Paraguay"	\N	101
lk	"name"=>"Sri Lanka", "name:ar"=>"سري لنكا", "name:be"=>"Шры-Ланка", "name:br"=>"Sri Lanka", "name:da"=>"Sri Lanka", "name:el"=>"Σρι Λάνκα", "name:en"=>"Sri Lanka", "name:eo"=>"Sri-Lanko", "name:fa"=>"سری‌لانکا", "name:fi"=>"Sri Lanka", "name:fr"=>"Sri Lanka", "name:fy"=>"Sry Lanka", "name:ga"=>"Srí Lanca", "name:gd"=>"Sri Lanca", "name:he"=>"סרי לנקה", "name:hu"=>"Srí Lanka", "name:is"=>"Srí Lanka", "name:it"=>"Sri Lanka", "name:ja"=>"スリランカ", "name:la"=>"Taprobane", "name:lt"=>"Šri Lanka", "name:lv"=>"Šrilanka", "name:mn"=>"Шри-Ланка", "name:pl"=>"Sri Lanka", "name:pt"=>"Sri Lanka", "name:ru"=>"Шри-Ланка", "name:sl"=>"Šrilanka", "name:sv"=>"Sri Lanka", "name:th"=>"ประเทศศรีลังกา", "name:tr"=>"Sri Lanka", "name:uk"=>"Шрі-Ланка", "name:zh"=>"斯里兰卡", "name:haw"=>"Sililanaka", "name:zh_py"=>"Sililanka", "name:zh_pyt"=>"Sīlǐlánkǎ", "official_name:br"=>"Republik Demokratel ha Sokialour Sri Lanka", "official_name:el"=>"Λαϊκή Σοσιαλιστική Δημοκρατία της Σρι Λάνκα", "official_name:gd"=>"Poblachd shòisealach dheomacrasach Sri Lanca", "official_name:id"=>"Republik Sosialis Demokratik Sri Lanka", "official_name:it"=>"Repubblica Democratica Socialista dello Sri Lanka", "official_name:lb"=>"Demokratesch Sozialistesch Republik Sri Lanka", "official_name:lv"=>"Šrilankas Demokrātiskā Sociālistiskā Republika", "official_name:pl"=>"Demokratyczno-Socjalistyczna Republika Sri Lanki", "official_name:pt"=>"República DemocráticaSocial do Sri Lanka", "official_name:sv"=>"Demokratiska socialistiska republiken Sri Lanka", "official_name:vi"=>"Cộng hòa Dân chủ Xã hội chủ nghĩa Sri Lanka"	\N	95
mw	"name"=>"Malawi", "name:ar"=>"ملاوي", "name:be"=>"Малаві", "name:br"=>"Malawi", "name:el"=>"Μαλάουι", "name:en"=>"Malawi", "name:eo"=>"Malavio", "name:es"=>"Malaui", "name:fa"=>"مالاوی", "name:fi"=>"Malawi", "name:fr"=>"Malawi", "name:fy"=>"Malawy", "name:ga"=>"An Mhaláiv", "name:gd"=>"Malabhaidh", "name:he"=>"מלאווי", "name:hr"=>"Malavi", "name:hu"=>"Malawi", "name:is"=>"Malaví", "name:it"=>"Malawi", "name:ja"=>"マラウイ", "name:la"=>"Malavium", "name:lt"=>"Malavis", "name:lv"=>"Malāvija", "name:mn"=>"Малави", "name:pl"=>"Malawi", "name:ru"=>"Малави", "name:sl"=>"Malavi", "name:sv"=>"Malawi", "name:th"=>"ประเทศมาลาวี", "name:tr"=>"Malavi", "name:uk"=>"Малаві", "name:zh"=>"马拉维", "name:haw"=>"Malaui", "name:zh_py"=>"Malawei", "name:zh_pyt"=>"Mǎlāwéi", "official_name"=>"Republic of Malaŵi;Dziko la Malaŵi", "official_name:id"=>"Republik Malawi", "official_name:lb"=>"Republik Malawi", "official_name:lt"=>"Malavio Respublika", "official_name:lv"=>"Malāvijas Republika", "official_name:sv"=>"Republiken Malawi", "official_name:vi"=>"Cộng hòa Malawi"	\N	97
mv	"name"=>"Maldives", "name:af"=>"Maldive", "name:ar"=>"ملديف", "name:be"=>"Мальдзівы", "name:br"=>"Maldivez", "name:da"=>"Maldiverne", "name:de"=>"Malediven", "name:el"=>"Μαλδίβες", "name:en"=>"Maldives", "name:eo"=>"Maldivoj", "name:es"=>"Maldivas", "name:et"=>"Maldiivid", "name:fa"=>"مالدیو", "name:fi"=>"Malediivit", "name:fr"=>"Maldives", "name:fy"=>"de Maldiven", "name:ga"=>"Oileáin Mhaildíve", "name:gd"=>"Na h-Eileanan Mhaladaibh", "name:he"=>"האיים המלדיביים", "name:hr"=>"Maldivi", "name:hu"=>"Maldív-szigetek", "name:id"=>"Maladewa", "name:is"=>"Maldíveyjar", "name:it"=>"Maldive", "name:la"=>"Insulae Maldivae", "name:lb"=>"Malediven", "name:lt"=>"Maldyvai", "name:lv"=>"Maldīvija", "name:mn"=>"Мальдив", "name:nl"=>"Malediven", "name:pl"=>"Malediwy", "name:ru"=>"Мальдивы", "name:sl"=>"Maldivi", "name:sv"=>"Maldiverna", "name:th"=>"ประเทศมัลดีฟส์", "name:tr"=>"Maldivler", "name:uk"=>"Мальдіви", "name:zh"=>"马尔代夫", "name:haw"=>"Maladiwa", "name:zh_py"=>"Maerdaifu", "name:zh_pyt"=>"Mǎěrdàifū", "official_name:et"=>"Maldiivi Vabariik", "official_name:id"=>"Republik Maladewa", "official_name:it"=>"Repubblica delle Maledive", "official_name:lb"=>"Republik Malediven", "official_name:lt"=>"Maldyvų Respublika", "official_name:lv"=>"Maldīvijas Republika", "official_name:pl"=>"Republika Malediwów", "official_name:sv"=>"Republiken Maldiverna"	dv	96
na	"name"=>"Namibia", "name:af"=>"Namibië", "name:ar"=>"ناميبيا", "name:be"=>"Намібія", "name:br"=>"Namibia", "name:ca"=>"Namíbia", "name:el"=>"Ναμίμπια", "name:en"=>"Namibia", "name:eo"=>"Namibio", "name:es"=>"Namibia", "name:et"=>"Namiibia", "name:fa"=>"نامیبیا", "name:fi"=>"Namibia", "name:fr"=>"Namibie", "name:fy"=>"Namybje", "name:ga"=>"An Namaib", "name:gd"=>"Naimibia", "name:he"=>"נמיביה", "name:hu"=>"Namíbia", "name:is"=>"Namibía", "name:it"=>"Namibia", "name:lb"=>"Namibien", "name:li"=>"Namibië", "name:lt"=>"Namibija", "name:lv"=>"Namībija", "name:mn"=>"Намиби", "name:nl"=>"Namibië", "name:pl"=>"Namibia", "name:ru"=>"Намибия", "name:sl"=>"Namibija", "name:sv"=>"Namibia", "name:th"=>"ประเทศนามิเบีย", "name:tr"=>"Namibya", "name:uk"=>"Намібія", "name:zh"=>"纳米比亚", "name:zh_py"=>"Namibiya", "name:zh_pyt"=>"Nàmǐbǐyà", "official_name"=>"Republic of Namibia;Republiek van Namibia;Republik Namibia", "official_name:el"=>"Δημοκρατία της Ναμίμπιας", "official_name:gd"=>"Poblachd Namibia", "official_name:id"=>"Republik Namibia", "official_name:lb"=>"Republik Namibien", "official_name:lt"=>"Namibijos Respublika", "official_name:lv"=>"Namībijas Republika", "official_name:sl"=>"Republika Namibija", "official_name:sv"=>"Republiken Namibia", "official_name:vi"=>"Cộng hòa Namibia"	\N	99
rw	"name"=>"Rwanda", "name:ar"=>"رواندا", "name:be"=>"Руанда", "name:br"=>"Rwanda", "name:de"=>"Ruanda", "name:el"=>"Ρουάντα", "name:en"=>"Rwanda", "name:eo"=>"Ruando", "name:es"=>"Ruanda", "name:fa"=>"رواندا", "name:fi"=>"Ruanda", "name:fr"=>"Rwanda", "name:fy"=>"Rûanda", "name:ga"=>"Ruanda", "name:gd"=>"Ruanda", "name:he"=>"רואנדה", "name:hr"=>"Ruanda", "name:hu"=>"Ruanda", "name:is"=>"Rúanda", "name:it"=>"Ruanda", "name:ja"=>"ルワンダ", "name:la"=>"Ruanda", "name:lb"=>"Ruanda", "name:li"=>"Roeanda", "name:lt"=>"Ruanda", "name:lv"=>"Ruanda", "name:mn"=>"Руанда", "name:pl"=>"Rwanda", "name:ru"=>"Руанда", "name:sl"=>"Ruanda", "name:sv"=>"Rwanda", "name:th"=>"ประเทศรวันดา", "name:tr"=>"Ruanda", "name:uk"=>"Руанда", "name:zh"=>"卢旺达", "name:haw"=>"Ruanada", "name:zh_py"=>"Luwangda", "name:zh_pyt"=>"Lúwàngdá", "official_name"=>"Republic of Rwanda;Repubulika y'u Rwanda;République du Rwanda", "official_name:el"=>"Δημοκρατία της Ρουάντα", "official_name:gd"=>"Poblachd Ruanda", "official_name:id"=>"Republik Rwanda", "official_name:lb"=>"Republik Ruanda", "official_name:lt"=>"Ruandos Respublika", "official_name:lv"=>"Ruandas Republika", "official_name:sv"=>"Republiken Rwanda", "official_name:vi"=>"Cộng hòa Rwanda"	\N	102
mh	"name"=>"Marshall Islands", "name:af"=>"Marshalleilande", "name:ar"=>"جزر مارشال", "name:be"=>"Маршалавы астравы", "name:br"=>"Inizi Marshall", "name:ca"=>"Illes Marshall", "name:cy"=>"Ynysoedd Marshall", "name:da"=>"Marshalløerne", "name:de"=>"Marshallinseln", "name:en"=>"Marshall Islands", "name:eo"=>"Marŝala Insularo", "name:es"=>"Islas Marshall", "name:et"=>"Marshalli Saared", "name:fa"=>"جزایر مارشال", "name:fi"=>"Marshallinsaaret", "name:fr"=>"Îles Marshall", "name:fy"=>"de Marshalleilannen", "name:ga"=>"Oileáin Marshall", "name:gd"=>"Na h-Eileanan Mharshall", "name:he"=>"איי מרשל", "name:hr"=>"Maršalovi Otoci", "name:hu"=>"Marshall-szigetek", "name:id"=>"Kepulauan Marshall", "name:is"=>"Marshalleyjar", "name:it"=>"Isole Marshall", "name:la"=>"Insulae Marsalienses", "name:lb"=>"Marshallinselen", "name:li"=>"Marshall-eilen", "name:lt"=>"Maršalo salos", "name:lv"=>"Māršala salas", "name:mn"=>"Маршаллын арлууд", "name:nl"=>"Marshalleilanden", "name:pl"=>"Wyspy Marshalla", "name:pt"=>"Ilhas Marshall", "name:ru"=>"Маршалловы Острова", "name:sl"=>"Marshallovi otoki", "name:sv"=>"Marshallöarna", "name:th"=>"สาธารณรัฐหมู่เกาะมาร์แชลล์", "name:tr"=>"Marshall Adaları", "name:uk"=>"Маршаллові Острови", "name:vi"=>"Quần đảo Marshall", "name:zh"=>"马绍尔群岛", "official_name"=>"Aolepān Aorōkin M̧ajeļ;Republic of the Marshall Islands", "official_name:be"=>"Маршалавы астравы", "official_name:es"=>"República de las Islas Marshall", "official_name:id"=>"Republik Kepulauan Marshall", "official_name:lb"=>"Republik Marshallinselen", "official_name:lt"=>"Maršalo Salų Respublika", "official_name:lv"=>"Māršala Salu Republika", "official_name:pl"=>"Republika Wysp Marshalla", "official_name:pt"=>"República das Ilhas Marshall", "official_name:sl"=>"Republika Marshallovi otoki", "official_name:sv"=>"Republiken Marshallöarna", "official_name:vi"=>"Cộng hoà Quần đảo Marshal"	\N	105
va	"name"=>"Città del Vaticano", "name:af"=>"Vatikaanstad", "name:ar"=>"الفاتيكان", "name:be"=>"Ватыкан", "name:br"=>"Vatikan", "name:ca"=>"Ciutat del Vaticà", "name:cy"=>"Dinas y Fatican", "name:da"=>"Vatikanstaten", "name:de"=>"Vatikanstadt", "name:el"=>"Βατικανό", "name:en"=>"Vatican City", "name:eo"=>"Vatikanurbo", "name:es"=>"Ciudad del Vaticano", "name:et"=>"Vatikan", "name:eu"=>"Vatikano Hiria", "name:fa"=>"واتیکان", "name:fi"=>"Vatikaanivaltio", "name:fr"=>"Vatican", "name:fy"=>"Fatikaanstêd", "name:ga"=>"Cathair na Vatacáine", "name:gd"=>"Cathair na Bhatacain", "name:he"=>"ותיקן", "name:hr"=>"Vatikan", "name:hu"=>"Vatikán", "name:id"=>"Vatikan", "name:is"=>"Vatíkanið", "name:it"=>"Città del Vaticano", "name:la"=>"Civitas Vaticana", "name:lb"=>"Vatikanstad", "name:li"=>"Vaticaanstad", "name:lt"=>"Vatikano Miesto Valstybė", "name:lv"=>"Vatikāns (Svētais Krēsls)", "name:mn"=>"Ватикан Хот Улс", "name:nl"=>"Vaticaanstad", "name:pl"=>"Watykan", "name:pt"=>"Cidade do Vaticano", "name:ru"=>"Ватикан", "name:sk"=>"Vatikán", "name:sl"=>"Vatikan", "name:sv"=>"Vatikanstaten", "name:th"=>"นครรัฐวาติกัน", "name:tr"=>"Vatikan", "name:uk"=>"Ватикан", "name:vi"=>"Thành Vatican", "name:zh"=>"梵蒂冈", "name:haw"=>"Ka Watikano", "name:zh_py"=>"Fandigang", "name:zh_pyt"=>"Fàndìgāng", "official_name"=>"Stato della Città del Vaticano", "official_name:el"=>"Κράτος της πόλης του Βατικανού", "official_name:fr"=>"État de la Cité du Vatican", "official_name:la"=>"Status Civitatis Vaticanae", "official_name:lb"=>"Stat Vatikanstad", "official_name:pl"=>"Państwo Watykańskie", "official_name:sk"=>"Vatikánsky mestský štát", "official_name:vi"=>"Thành Quốc Vatican"	it	107
pn	"name"=>"Pitcairn", "name:ar"=>"بتكايرن", "name:be"=>"Піткерн", "name:br"=>"Inizi Pitcairn", "name:ca"=>"Illes Pitcairn", "name:cy"=>"Ynysoedd Pitcairn", "name:da"=>"Pitcairn", "name:el"=>"Νήσοι Πίτκαιρν", "name:en"=>"Pitcairn", "name:eo"=>"Pitkarna Insulo", "name:es"=>"Islas Pitcairn", "name:fa"=>"پیت‌کرن", "name:fi"=>"Pitcairn", "name:fr"=>"Îles Pitcairn", "name:fy"=>"de Pitcairneilannen", "name:ga"=>"Oileán Pitcairn", "name:gd"=>"Eilean Pitcairn", "name:he"=>"פיטקרן", "name:hu"=>"Pitcairn-szigetek", "name:id"=>"Kepulauan Pitcairn", "name:is"=>"Pitcairn", "name:it"=>"Isole Pitcairn", "name:la"=>"Pitcairn Insulae", "name:lt"=>"Pitkernas", "name:lv"=>"Pitkērna", "name:mn"=>"Питкэрн Арлууд", "name:pl"=>"Wyspy Pitcairn", "name:ru"=>"Питкерн", "name:sv"=>"Pitcairnöarna", "name:th"=>"หมู่เกาะพิตแคร์น", "name:tr"=>"Pitcairn Adaları", "name:uk"=>"Піткерн", "name:vi"=>"Quần đảo Pitcairn", "name:zh"=>"皮特凯恩群岛", "official_name"=>"Pitcairn, Henderson, Ducie, and Oeno Islands;Pitkern Ailen", "official_name:lv"=>"Pitkērnas salas"	\N	113
se	"name"=>"Sverige", "name:af"=>"Swede", "name:ar"=>"السويد", "name:be"=>"Швецыя", "name:br"=>"Sveden", "name:ca"=>"Suècia", "name:cy"=>"Sweden", "name:de"=>"Schweden", "name:el"=>"Σουηδία", "name:en"=>"Sweden", "name:eo"=>"Svedio", "name:es"=>"Suecia", "name:et"=>"Rootsi", "name:fa"=>"سوئد", "name:fi"=>"Ruotsi", "name:fr"=>"Suède", "name:fy"=>"Sweden", "name:ga"=>"An tSualainn", "name:gd"=>"An t-Suain", "name:he"=>"שוודיה", "name:hr"=>"Švedska", "name:hu"=>"Svédország", "name:hy"=>"Շվեդիա", "name:id"=>"Swedia", "name:is"=>"Svíþjóð", "name:it"=>"Svezia", "name:ja"=>"スウェーデン", "name:la"=>"Suecia", "name:lb"=>"Schweden", "name:li"=>"Zwaede", "name:lt"=>"Švedija", "name:lv"=>"Zviedrija", "name:mn"=>"Швед", "name:nl"=>"Zweden", "name:pl"=>"Szwecja", "name:pt"=>"Suécia", "name:ru"=>"Швеция", "name:sk"=>"Švédsko", "name:sl"=>"Švedska", "name:sv"=>"Sverige", "name:th"=>"ประเทศสวีเดน", "name:tr"=>"İsveç", "name:uk"=>"Швеція", "name:vi"=>"Thụy Điển", "name:zh"=>"瑞典", "name:haw"=>"Kuekene", "name:zh_py"=>"Ruidian", "name:zh_pyt"=>"Ruìdiǎn", "official_name"=>"Konungariket Sverige", "official_name:af"=>"Koninkryk Swede", "official_name:be"=>"Каралеўства Швецыя", "official_name:el"=>"Βασίλειο της Σουηδίας", "official_name:et"=>"Rootsi Kuningriik", "official_name:fr"=>"Royaume de Suède", "official_name:id"=>"Kerajaan Swedia", "official_name:ja"=>"スウェーデン王国", "official_name:lb"=>"Kinneksräich Schweden", "official_name:lt"=>"Švedijos Karalystė", "official_name:pt"=>"Reino da Suécia", "official_name:sk"=>"Švédske kráľovstvo", "official_name:sv"=>"Konungariket Sverige", "official_name:vi"=>"Vương quốc Thụy Điển"	sv	112
ve	"name"=>"Venezuela", "name:ar"=>"فنزويلا", "name:be"=>"Венесуэла", "name:br"=>"Venezuela", "name:ca"=>"Veneçuela", "name:da"=>"Venezuela", "name:el"=>"Βενεζουέλα", "name:en"=>"Venezuela", "name:eo"=>"Venezuelo", "name:fa"=>"ونزوئلا", "name:fi"=>"Venezuela", "name:fr"=>"Venezuela", "name:fy"=>"Fenezuëla", "name:ga"=>"Veiniséala", "name:gd"=>"A' Bheiniseala", "name:he"=>"ונצואלה", "name:hu"=>"Venezuela", "name:is"=>"Venusúela", "name:ja"=>"ベネズエラ", "name:la"=>"Venetiola", "name:lt"=>"Venesuela", "name:lv"=>"Venecuēla", "name:mn"=>"Венесуэл", "name:pl"=>"Wenezuela", "name:pt"=>"Venezuela", "name:ru"=>"Венесуэла", "name:sv"=>"Venezuela", "name:th"=>"ประเทศเวเนซุเอลา", "name:uk"=>"Венесуела", "name:zh"=>"委内瑞拉", "official_name"=>"República Bolivariana de Venezuela", "official_name:be"=>"Баліварыянская Рэспубліка Венесуэла", "official_name:en"=>"Bolivarian Republic of Venezuela", "official_name:id"=>"Republik Bolivar Venezuela", "official_name:lt"=>"Venesuelos Bolivaro Respublika", "official_name:pl"=>"Boliwariańska Republika Wenezueli", "official_name:pt"=>"República Bolivariana da Venezuela", "official_name:sv"=>"Bolivarianska republiken Venezuela", "official_name:vi"=>"Cộng hòa Bolivar Venezuela"	es	108
vg	"name"=>"British Virgin Islands", "name:af"=>"Brits-Maagde-eilande", "name:ar"=>"جزر فيرجن البريطانية", "name:be"=>"Брытанскія Вірджынскія астравы", "name:br"=>"Inizi Gwerc’h Breizhveuriat", "name:ca"=>"Illes Verges Britàniques", "name:da"=>"Britiske Jomfruøer", "name:de"=>"Britische Jungferninseln", "name:en"=>"British Virgin Islands", "name:eo"=>"Britaj Virgulininsuloj", "name:es"=>"Islas Vírgenes Británicas", "name:et"=>"Briti Neitsisaared", "name:eu"=>"Birjina uharte britainiarrak", "name:fa"=>"جزایر ویرجین بریتانیا", "name:fi"=>"Brittiläiset Neitsytsaaret", "name:fr"=>"Îles Vierges britanniques", "name:ga"=>"Oileáin Bhriotanacha na Maighdean", "name:he"=>"איי הבתולה הבריטיים", "name:hr"=>"Britanski Djevičanski otoci", "name:hu"=>"Brit Virgin-szigetek", "name:id"=>"Kepulauan Virgin Britania Raya", "name:is"=>"Bresku Jómfrúaeyjar", "name:it"=>"Isole Vergini Britanniche", "name:ja"=>"イギリス領ヴァージン諸島", "name:la"=>"Britannicae Virginis Insulae", "name:lb"=>"Britesch Joffereninselen", "name:lt"=>"Mergelės salos (Britų)", "name:lv"=>"Britu Virdžīnu salas", "name:mn"=>"Виржиний Арлууд, Британийн", "name:nl"=>"Britse Maagdeneilanden", "name:pl"=>"Brytyjskie Wyspy Dziewicze", "name:ru"=>"Британские Виргинские острова", "name:sl"=>"Britanski Deviški otoki", "name:sv"=>"Brittiska Jungfruöarna", "name:th"=>"หมู่เกาะบริติชเวอร์จิน", "name:tr"=>"Birleşik Krallık Virgin Adaları", "name:uk"=>"Британські Віргінські острови", "name:vi"=>"Quần đảo Virgin thuộc Anh", "name:zh"=>"英属维尔京群岛"	en	109
cy	"name"=>"Κύπρος", "name:af"=>"Siprus", "name:ar"=>"قبرص", "name:be"=>"Кіпр", "name:br"=>"Kiprenez", "name:ca"=>"Xipre", "name:cy"=>"Cyprus", "name:da"=>"Cypern", "name:de"=>"Zypern", "name:el"=>"Κύπρος", "name:en"=>"Cyprus", "name:eo"=>"Kipro", "name:es"=>"Chipre", "name:et"=>"Küpros", "name:fa"=>"قبرس", "name:fi"=>"Kypros", "name:fr"=>"Chypre", "name:fy"=>"Syprus", "name:ga"=>"An Chipir", "name:gd"=>"Cìopras", "name:he"=>"קפריסין", "name:hr"=>"Cipar", "name:hu"=>"Ciprus", "name:id"=>"Siprus", "name:is"=>"Kýpur", "name:it"=>"Cipro", "name:ja"=>"キプロス", "name:la"=>"Cyprus", "name:lb"=>"Zypern", "name:li"=>"Cyprus", "name:lt"=>"Kipras", "name:lv"=>"Kipra", "name:mn"=>"Кипр", "name:nl"=>"Cyprus", "name:pl"=>"Cypr", "name:pt"=>"Chipre", "name:ru"=>"Кипр", "name:sl"=>"Ciper", "name:sv"=>"Cypern", "name:th"=>"ประเทศไซปรัส", "name:tr"=>"Kıbrıs", "name:uk"=>"Кіпр", "name:vi"=>"Síp", "name:zh"=>"塞浦路斯", "name:haw"=>"Kupelo", "name:zh_py"=>"Saipulusi", "name:zh_pyt"=>"Sàipǔlùsī", "official_name"=>"Κυπριακή Δημοκρατία", "official_name:br"=>"Republik Kiprenez", "official_name:el"=>"Κυπριακή Δημοκρατία", "official_name:es"=>"República de Chipre", "official_name:et"=>"Küprose Vabariik", "official_name:id"=>"Republik Siprus", "official_name:ja"=>"キプロス共和国", "official_name:lb"=>"Republik Zypern", "official_name:lt"=>"Kipro Respublika", "official_name:lv"=>"Kipras Republika", "official_name:pl"=>"Republika Cypryjska", "official_name:pt"=>"República de Chipre", "official_name:sv"=>"Republiken Cypern", "official_name:tr"=>"Kıbrıs Cumhuriyeti", "official_name:vi"=>"Cộng hòa Síp"	\N	114
sg	"name"=>"Singapore", "name:af"=>"Singapoer", "name:ar"=>"سنغافورة", "name:be"=>"Сінгапур", "name:br"=>"Singapour", "name:ca"=>"Singapur", "name:de"=>"Singapur", "name:el"=>"Σιγκαπούρη", "name:eo"=>"Singapuro", "name:es"=>"Singapur", "name:et"=>"Singapur", "name:fa"=>"سنگاپور", "name:fi"=>"Singapore", "name:fr"=>"Singapour", "name:ga"=>"Singeapór", "name:gd"=>"Siongapòr", "name:he"=>"סינגפור", "name:hr"=>"Singapur", "name:hu"=>"Szingapúr", "name:id"=>"Singapura", "name:is"=>"Singapúr", "name:it"=>"Singapore", "name:la"=>"Singapura", "name:lb"=>"Singapur", "name:lt"=>"Singapūras", "name:mn"=>"Сингапур", "name:ms"=>"Singapura", "name:pl"=>"Singapur", "name:ru"=>"Сингапур", "name:sl"=>"Singapur", "name:sv"=>"Singapore", "name:th"=>"ประเทศสิงคโปร์", "name:tl"=>"Singgapur", "name:tr"=>"Singapur", "name:uk"=>"Сінгапур", "name:zh"=>"新加坡", "name:haw"=>"Sinapoa", "name:zh_py"=>"Xinjiapo", "name:zh_pyt"=>"Xīnjiāpō", "official_name"=>"Republic of Singapore", "official_name:br"=>"Republik Singapour", "official_name:el"=>"Δημοκρατία της Σιγκαπούρης", "official_name:et"=>"Singapuri Vabariik", "official_name:id"=>"Republik Singapura", "official_name:it"=>"Repubblica di Singapore", "official_name:lb"=>"Republik Singapur", "official_name:lt"=>"Singapūro Respublika", "official_name:pl"=>"Republika Singapuru", "official_name:sv"=>"Republiken Singapore", "official_name:tl"=>"Republika ng Singgapur", "official_name:vi"=>"Cộng hòa Singapore"	\N	115
vu	"name"=>"Vanuatu", "name:ar"=>"فانواتو", "name:be"=>"Вануату", "name:br"=>"Vanuatu", "name:da"=>"Vanuatu", "name:el"=>"Βανουάτου", "name:eo"=>"Vanuatuo", "name:fa"=>"وانواتو", "name:fi"=>"Vanuatu", "name:fr"=>"Vanuatu", "name:fy"=>"Fanuatû", "name:ga"=>"Vanuatú", "name:gd"=>"Bhanuatu", "name:he"=>"ונואטו", "name:hu"=>"Vanuatu", "name:is"=>"Vanúatú", "name:ja"=>"バヌアツ", "name:mn"=>"Вануату", "name:pl"=>"Vanuatu", "name:pt"=>"Vanuatu", "name:ru"=>"Вануату", "name:sv"=>"Vanuatu", "name:th"=>"ประเทศวานูอาตู", "name:uk"=>"Вануату", "name:zh"=>"瓦努阿图", "official_name"=>"Ripablik blong Vanuatu", "official_name:el"=>"Δημοκρατία του Βανουάτου", "official_name:en"=>"Republic of Vanuatu", "official_name:es"=>"República de Vanuatu", "official_name:fr"=>"République de Vanuatu", "official_name:id"=>"Republik Vanuatu", "official_name:ja"=>"バヌアツ共和国", "official_name:lb"=>"Republik Vanuatu", "official_name:lt"=>"Vanuatu Respublika", "official_name:pl"=>"Republika Vanuatu", "official_name:pt"=>"República do Vanuatu", "official_name:sv"=>"Republiken Vanuatu", "official_name:vi"=>"Cộng hòa Vanuatu"	\N	116
bo	"name"=>"Bolivia", "name:ar"=>"بوليفيا", "name:be"=>"Балівія", "name:br"=>"Bolivia", "name:ca"=>"Bolívia", "name:cy"=>"Bolifia", "name:da"=>"Bolivia", "name:de"=>"Bolivien", "name:el"=>"Βολιβία", "name:en"=>"Bolivia", "name:eo"=>"Bolivio", "name:et"=>"Boliivia", "name:fa"=>"بولیوی", "name:fi"=>"Bolivia", "name:fr"=>"Bolivie", "name:ga"=>"An Bholaiv", "name:gd"=>"Boilibhia", "name:he"=>"בוליוויה", "name:hu"=>"Bolívia", "name:is"=>"Bólivía", "name:it"=>"Bolivia", "name:lb"=>"Bolivien", "name:lt"=>"Bolivija", "name:lv"=>"Bolīvija", "name:mn"=>"Болив", "name:pl"=>"Boliwia", "name:pt"=>"Bolívia", "name:ru"=>"Боливия", "name:sl"=>"Bolivija", "name:sv"=>"Bolivia", "name:th"=>"ประเทศโบลิเวีย", "name:tr"=>"Bolivya", "name:uk"=>"Болівія", "name:zh"=>"玻利维亚", "official_name"=>"Estado Plurinacional de Bolivia", "official_name:ay"=>"Wuliwya Suyu", "official_name:be"=>"Рэспубліка Балівія", "official_name:el"=>"Πολυεθνοτικό Κράτος της Βολιβίας", "official_name:en"=>"Plurinational State of Bolivia", "official_name:fi"=>"Bolivian monikansallinen valtio", "official_name:fr"=>"État plurinational de Bolivie", "official_name:gn"=>"Tetã Volívia", "official_name:id"=>"Republik Bolivia", "official_name:lt"=>"Bolivijos Respublika", "official_name:lv"=>"Bolīvijas Republika", "official_name:pl"=>"Wielonarodowe Państwo Boliwii", "official_name:pt"=>"Estado Plurinacional da Bolívia", "official_name:qu"=>"Bulibiya Mama llaqta", "official_name:sv"=>"Republiken Bolivia", "official_name:vi"=>"Cộng hoà Bolivia"	\N	120
bw	"name"=>"Botswana", "name:ar"=>"بوتسوانا", "name:be"=>"Батсвана", "name:br"=>"Botswana", "name:de"=>"Botsuana", "name:el"=>"Μποτσουάνα", "name:en"=>"Botswana", "name:eo"=>"Bocvano", "name:es"=>"Botsuana", "name:fa"=>"بوتسوانا", "name:fi"=>"Botswana", "name:fr"=>"Botswana", "name:ga"=>"An Bhotsuáin", "name:gd"=>"Botsuana", "name:he"=>"בוטסוונה", "name:hr"=>"Bocvana", "name:hu"=>"Botswana", "name:is"=>"Botsvana", "name:it"=>"Botswana", "name:ja"=>"ボツワナ", "name:la"=>"Botsuana", "name:lt"=>"Botsvana", "name:lv"=>"Botsvāna", "name:mn"=>"Ботсван", "name:pl"=>"Botswana", "name:pt"=>"Botswana", "name:ru"=>"Ботсвана", "name:sl"=>"Bocvana", "name:sv"=>"Botswana", "name:th"=>"ประเทศบอตสวานา", "name:tn"=>"Lefatshe la Botswana", "name:tr"=>"Botsvana", "name:uk"=>"Ботсвана", "name:zh"=>"博茨瓦纳", "name:haw"=>"Botuana", "name:zh_py"=>"Bociwana", "name:zh_pyt"=>"Bócíwǎnà", "official_name"=>"Republic of Botswana;Lefatse la Botswana", "official_name:el"=>"Δημοκρατία της Μποτσουάνας", "official_name:fi"=>"Botswanan tasavalta", "official_name:id"=>"Republik Botswana", "official_name:ja"=>"ボツワナ共和国", "official_name:lb"=>"Republik vu Botswana", "official_name:lt"=>"Botsvanos Respublika", "official_name:lv"=>"Botsvānas Republika", "official_name:pt"=>"República do Botswana", "official_name:sv"=>"Republiken Botswana", "official_name:vi"=>"Cộng hoà Botswana"	\N	122
cc	"name"=>"Cocos (Keeling) Islands", "name:af"=>"Cocos (Keeling) Eilande", "name:ar"=>"جزر كوكوس (كيلينغ)", "name:be"=>"Какосавыя (Кілінг) астравы", "name:br"=>"Inizi Kokoz", "name:ca"=>"Illes Cocos", "name:da"=>"Cocosøerne", "name:de"=>"Kokosinseln", "name:el"=>"Νησιά Κόκος", "name:en"=>"Cocos (Keeling) Islands", "name:eo"=>"Kokosinsuloj", "name:es"=>"Islas Cocos (Keeling)", "name:et"=>"Kookossaared", "name:eu"=>"Cocos (Keeling) uharteak", "name:fa"=>"جزایر کوکوس", "name:fi"=>"Kookossaaret", "name:fr"=>"Îles Cocos", "name:fy"=>"de Kokoseilannen", "name:he"=>"איי קוקוס (קילינג)", "name:hr"=>"Kokosovi otoci", "name:hu"=>"Kókusz (Keeling)-szigetek", "name:id"=>"Kepulauan Cocos (Keeling)", "name:is"=>"Kókoseyjar", "name:it"=>"Isole Cocos e Keeling", "name:lt"=>"Kokoso (Keelingo) salos", "name:lv"=>"Kokosu (Kīlinga) salas", "name:mn"=>"Кокосын (Кийлингийн) Арлууд", "name:nl"=>"Cocoseilanden", "name:pl"=>"Wyspy Kokosowe", "name:ru"=>"Кокосовые острова", "name:sl"=>"Kokosovi otoki", "name:sv"=>"Kokosöarna", "name:tr"=>"Cocos (Keeling) Adaları", "name:uk"=>"Кокосові острови", "name:vi"=>"Quần đảo Cocos (Keeling)", "name:zh"=>"科科斯（基林）群島", "official_name"=>"Territory of the Cocos (Keeling) Islands", "official_name:es"=>"Territorio de las Islas Cocos (Keeling)", "official_name:lv"=>"Kokosu (Kīlinga) salu teritorija", "official_name:pl"=>"Terytorium Wysp Kokosowych (Keelinga)"	en	118
la	"name"=>"Laos", "name:af"=>"Laos", "name:ar"=>"لاوس", "name:be"=>"Лаос", "name:br"=>"Laos", "name:da"=>"Laos", "name:el"=>"Λάος", "name:en"=>"Laos", "name:eo"=>"Laoso", "name:fa"=>"لائوس", "name:fi"=>"Laos", "name:fr"=>"Laos", "name:ga"=>"Laos", "name:gd"=>"Làthos", "name:he"=>"לאוס", "name:hu"=>"Laosz", "name:is"=>"Lagos", "name:it"=>"Laos", "name:ja"=>"ラオス", "name:la"=>"Laotia", "name:lt"=>"Laosas", "name:lv"=>"Laosa", "name:mn"=>"Лаос", "name:pl"=>"Laos", "name:ru"=>"Лаос", "name:sv"=>"Laos", "name:th"=>"ประเทศลาว", "name:uk"=>"Лаос", "name:vi"=>"Lào", "name:zh"=>"老挝", "name:haw"=>"Laosa", "name:zh_py"=>"Laowo", "name:zh_pyt"=>"Lǎowō", "official_name:br"=>"Republik Demokratel ar Bobl Lao", "official_name:el"=>"Λαϊκή Δημοκρατία του Λάος", "official_name:id"=>"Republik Demokratik Rakyat Laos", "official_name:it"=>"Repubblica Popolare Democratica del Laos", "official_name:lb"=>"Demokratesch Volleksrepublik Laos", "official_name:lt"=>"Laoso Liaudies Demokratinė Respublika", "official_name:lv"=>"Laosas Tautas Demokrātiskā Republika", "official_name:pl"=>"Laotańska Republika Ludowo-Demokratyczna", "official_name:ru"=>"Лаосская Народно-Демократическая Республика", "official_name:sv"=>"Demokratiska folkrepubliken Laos", "official_name:vi"=>"Cộng hòa Dân chủ Nhân dân Lào"	lo	145
ke	"name"=>"Kenya", "name:af"=>"Kenia", "name:ar"=>"كينيا", "name:be"=>"Кенія", "name:br"=>"Kenya", "name:de"=>"Kenia", "name:el"=>"Κένυα", "name:en"=>"Kenya", "name:eo"=>"Kenjo", "name:es"=>"Kenia", "name:fa"=>"کنیا", "name:fi"=>"Kenia", "name:fr"=>"Kenya", "name:ga"=>"An Chéinia", "name:gd"=>"A' Cheinia", "name:he"=>"קניה", "name:hr"=>"Kenija", "name:hu"=>"Kenya", "name:is"=>"Kenýa", "name:it"=>"Kenya", "name:ja"=>"ケニア", "name:la"=>"Kenia", "name:li"=>"Kenia", "name:lt"=>"Kenija", "name:lv"=>"Kenija", "name:mn"=>"Кени", "name:nl"=>"Kenia", "name:pl"=>"Kenia", "name:ru"=>"Кения", "name:sl"=>"Kenija", "name:sv"=>"Kenya", "name:th"=>"ประเทศเคนยา", "name:uk"=>"Кенія", "name:zh"=>"肯尼亚", "name:haw"=>"Kenia", "name:zh_py"=>"Kenniya", "name:zh_pyt"=>"Kěnníyà", "official_name"=>"Republic of Kenya;Jamhuri ya Kenya", "official_name:el"=>"Δημοκρατία της Κένυας", "official_name:id"=>"Republik Kenya", "official_name:ja"=>"ケニア共和国", "official_name:lb"=>"Republik Kenia", "official_name:lt"=>"Kenijos Respublika", "official_name:lv"=>"Kenijas Republika", "official_name:sv"=>"Republiken Kenya", "official_name:vi"=>"Cộng hòa Kenya"	\N	126
tj	"name"=>"Tajikistan", "name:af"=>"Tadjikistan", "name:ar"=>"طاجيكستان", "name:az"=>"Tacikistan", "name:be"=>"Таджыкістан", "name:br"=>"Tadjikistan", "name:ca"=>"Tadjikistan", "name:da"=>"Tadsjikistan", "name:de"=>"Tadschikistan", "name:el"=>"Τατζικιστάν", "name:en"=>"Tajikistan", "name:eo"=>"Taĝikio", "name:es"=>"Tayikistán", "name:et"=>"Tadžikistan", "name:fa"=>"تاجیکستان", "name:fi"=>"Tadžikistan", "name:fr"=>"Tadjikistan", "name:fy"=>"Tadzjikistan", "name:ga"=>"An Táidsíceastáin", "name:gd"=>"Taidigeastàn", "name:he"=>"טג'יקיסטן", "name:hr"=>"Tadžikistan", "name:hu"=>"Tádzsikisztán", "name:is"=>"Tadsjikistan", "name:it"=>"Tagikistan", "name:la"=>"Tadzikistania", "name:lb"=>"Tadschikistan", "name:li"=>"Tadzjikistan", "name:lt"=>"Tadžikistanas", "name:lv"=>"Tadžikistāna", "name:mn"=>"Тажикистан", "name:nl"=>"Tadzjikistan", "name:pl"=>"Tadżykistan", "name:pt"=>"Tadjiquistão", "name:ru"=>"Таджикистан", "name:sl"=>"Tadžikistan", "name:sv"=>"Tadzjikistan", "name:tg"=>"Тоҷикистон", "name:th"=>"ประเทศทาจิกิสถาน", "name:tr"=>"Tacikistan", "name:uk"=>"Таджикистан", "name:zh"=>"塔吉克斯坦", "name:zh_py"=>"Tajikesitan", "name:zh_pyt"=>"Tǎjíkèsītǎn", "official_name:el"=>"Δημοκρατία του Τατζικιστάν", "official_name:et"=>"Tadžikistani Vabariik", "official_name:gd"=>"Poblachd Thaidigeastàn", "official_name:id"=>"Republik Tajikistan", "official_name:it"=>"Repubblica del Tagikistan", "official_name:lt"=>"Tadžikistano Respublika", "official_name:pl"=>"Republika Tadżykistanu", "official_name:pt"=>"República do Tadjiquistão", "official_name:sv"=>"Republiken Tadzjikistan", "official_name:vi"=>"Cộng hòa Tajikistan"	\N	129
tz	"name"=>"Tanzania", "name:af"=>"Tanzanië", "name:ar"=>"تنـزاني", "name:be"=>"Танзанія", "name:br"=>"Tanzania", "name:ca"=>"Tanzània", "name:de"=>"Tansania", "name:el"=>"Τανζανία", "name:en"=>"Tanzania", "name:eo"=>"Tanzanio", "name:es"=>"Tanzania", "name:et"=>"Tansaania", "name:fa"=>"تانزانیا", "name:fi"=>"Tansania", "name:fr"=>"Tanzanie", "name:ga"=>"An Tansáin", "name:gd"=>"Tansainìa", "name:he"=>"טנזניה", "name:hr"=>"Tanzanija", "name:hu"=>"Tanzánia", "name:is"=>"Tansanía", "name:it"=>"Tanzania", "name:ja"=>"タンザニア", "name:lb"=>"Tansania", "name:lt"=>"Tanzanija", "name:lv"=>"Tanzānija", "name:mn"=>"Танзани", "name:pl"=>"Tanzania", "name:pt"=>"Tanzânia", "name:ru"=>"Танзания", "name:sl"=>"Tanzanija", "name:sv"=>"Tanzania", "name:th"=>"ประเทศแทนซาเนีย", "name:tr"=>"Tanzanya", "name:uk"=>"Танзанія", "name:zh"=>"坦桑尼亚", "name:haw"=>"Tanazania", "name:zh_py"=>"Tansangniya", "name:zh_pyt"=>"Tǎnsāngníyà", "official_name"=>"United Republic of Tanzania;Jamhuri Ya Muungano Wa Tanzania", "official_name:et"=>"Tansaania Ühendvabariik", "official_name:id"=>"Persatuan Republik Tanzania", "official_name:lb"=>"Vereenegt Republik Tansania", "official_name:lt"=>"Tanzanijos Jungtinė Respublika", "official_name:pt"=>"República Unida da Tanzânia", "official_name:sv"=>"Förenade republiken Tanzania", "official_name:vi"=>"Cộng hòa Thống nhất Tanzania"	\N	130
ws	"name"=>"Samoa", "name:ar"=>"ساموا", "name:be"=>"Самоа", "name:br"=>"Samoa", "name:da"=>"Samoa", "name:el"=>"Σαμόα", "name:en"=>"Samoa", "name:eo"=>"Samoo", "name:fa"=>"ساموآ", "name:fi"=>"Samoa", "name:fr"=>"Samoa", "name:ga"=>"Samó", "name:he"=>"סמואה", "name:hu"=>"Szamoa", "name:is"=>"Samóa", "name:mn"=>"Самоа", "name:pl"=>"Samoa", "name:ru"=>"Самоа", "name:sv"=>"Samoa", "name:th"=>"ประเทศซามัว", "name:uk"=>"Самоа", "name:zh"=>"萨摩亚", "official_name"=>"Malo Sa'oloto Tuto'atasi o Samoa", "official_name:en"=>"Independent State of Samoa", "official_name:es"=>"Estado Independiente de Samoa", "official_name:lb"=>"Unabhängiger Stat Samoa", "official_name:lt"=>"Samoa Nepriklausomoji Valstybė", "official_name:pl"=>"Niezależne Państwo Samoa", "official_name:ru"=>"Независимое Государство Самоа", "official_name:sv"=>"Självständiga staten Samoa", "official_name:vi"=>"Nhà nước Độc lập Samoa"	\N	131
ls	"name"=>"Lesotho", "name:ar"=>"ليسوتو", "name:be"=>"Лесота", "name:br"=>"Lesotho", "name:el"=>"Λεσότο", "name:eo"=>"Lesoto", "name:es"=>"Lesoto", "name:fa"=>"لسوتو", "name:fi"=>"Lesotho", "name:fr"=>"Lesotho", "name:fy"=>"Lesoto", "name:ga"=>"Leosóta", "name:gd"=>"Leasoto", "name:he"=>"לסוטו", "name:hr"=>"Lesoto", "name:hu"=>"Lesotho", "name:is"=>"Lesótó", "name:it"=>"Lesotho", "name:ja"=>"レソト", "name:la"=>"Lesothum", "name:lt"=>"Lesotas", "name:lv"=>"Lesoto", "name:mn"=>"Лесото", "name:pl"=>"Lesotho", "name:ru"=>"Лесото", "name:sl"=>"Lesoto", "name:sv"=>"Lesotho", "name:th"=>"ประเทศเลโซโท", "name:tr"=>"Lesoto", "name:uk"=>"Лесото", "name:zh"=>"莱索托", "name:haw"=>"Lesoto", "name:zh_py"=>"Laisuotuo", "name:zh_pyt"=>"Láisuǒtuō", "official_name"=>"Kingdom of Lesotho;Muso oa Lesotho", "official_name:id"=>"Kerajaan Lesotho", "official_name:lb"=>"Kinnekräich Lesotho", "official_name:lt"=>"Lesoto Karalystė", "official_name:lv"=>"Lesoto Karaliste", "official_name:sl"=>"Kraljevina Lesoto", "official_name:sv"=>"Konungariket Lesotho", "official_name:vi"=>"Vương quốc Lesotho"	\N	136
lc	"name"=>"Saint Lucia", "name:af"=>"Sint Lucia", "name:ar"=>"سانت لوسيا", "name:be"=>"Святая Лусія", "name:br"=>"Saint Lucia", "name:da"=>"Saint Lucia", "name:de"=>"St. Lucia", "name:en"=>"Saint Lucia", "name:eo"=>"Sankta Lucio", "name:es"=>"Santa Lucía", "name:fa"=>"سنت لوسیا", "name:fi"=>"Saint Lucia", "name:fr"=>"Sainte-Lucie", "name:fy"=>"Sint Lusia", "name:ga"=>"San Lucia", "name:gd"=>"Naomh Lùisia", "name:he"=>"סנט לוסיה", "name:hr"=>"Sveta Lucija", "name:hu"=>"Saint Lucia", "name:is"=>"Sankti Lúsía", "name:it"=>"Santa Lucia", "name:ja"=>"セントルシア", "name:la"=>"Sancta Lucia", "name:li"=>"Santa Lucia", "name:lt"=>"Sent Lusija", "name:lv"=>"Sentlūsija", "name:mn"=>"Сент Люсиа", "name:pl"=>"Saint Lucia", "name:pt"=>"Santa Lúcia", "name:ru"=>"Сент-Люсия", "name:sv"=>"Saint Lucia", "name:th"=>"ประเทศเซนต์ลูเซีย", "name:uk"=>"Сент-Люсія", "name:zh"=>"圣卢西亚岛"	lc	146
om	"name"=>"سلطنة عُمان Oman", "name:af"=>"Oman", "name:ar"=>"عمان", "name:be"=>"Аман", "name:br"=>"Oman", "name:ca"=>"Oman", "name:cy"=>"Oman", "name:da"=>"Oman", "name:de"=>"Oman", "name:el"=>"Ομάν", "name:en"=>"Oman", "name:eo"=>"Omano", "name:es"=>"Omán", "name:et"=>"Omaan", "name:fa"=>"عمان", "name:fi"=>"Oman", "name:fr"=>"Oman", "name:fy"=>"Oman", "name:ga"=>"Óman", "name:gd"=>"Omàn", "name:he"=>"עומן", "name:hr"=>"Oman", "name:hu"=>"Omán", "name:id"=>"Oman", "name:is"=>"Óman", "name:it"=>"Oman", "name:ja"=>"オマーン", "name:la"=>"Omania", "name:lb"=>"Oman", "name:li"=>"Omaan", "name:lt"=>"Omanas", "name:mn"=>"Оман", "name:nl"=>"Oman", "name:pl"=>"Oman", "name:pt"=>"Omã", "name:ru"=>"Оман", "name:sl"=>"Oman", "name:sv"=>"Oman", "name:th"=>"ประเทศโอมาน", "name:tr"=>"Umman", "name:uk"=>"Оман", "name:vi"=>"Oman", "name:zh"=>"阿曼", "name:haw"=>"ʻOmana", "name:zh_py"=>"Aman", "name:zh_pyt"=>"Āmàn", "official_name"=>"سلطنة عُمان", "official_name:br"=>"Sultanad Oman", "official_name:ca"=>"Sultanat d'Oman ", "official_name:el"=>"Σουλτανάτο του Ομάν", "official_name:en"=>"Sultanate of Oman", "official_name:et"=>"Omaani Sultaniriik", "official_name:fr"=>"Sultanat d'Oman", "official_name:id"=>"Kesultanan Oman", "official_name:it"=>"Sultanato dell'Oman", "official_name:ja"=>"オマーン国", "official_name:lb"=>"Saltanat Uman", "official_name:lt"=>"Omano Sultonatas", "official_name:pl"=>"Sułtanat Omanu", "official_name:pt"=>"Sultanato do Omã", "official_name:sv"=>"Sultanatet Oman"	ar	137
ru	"name"=>"Россия", "name:af"=>"Rusland", "name:ar"=>"روسيا الاتحادية", "name:az"=>"Rusiya Federasiyası", "name:be"=>"Расія", "name:br"=>"Rusia", "name:by"=>"Расія", "name:ca"=>"Rússia", "name:cy"=>"Ffederasiwn Rwsia", "name:da"=>"Rusland", "name:de"=>"Russland", "name:el"=>"Ρωσία", "name:en"=>"Russia", "name:eo"=>"Rusio", "name:es"=>"Rusia", "name:et"=>"Venemaa", "name:fa"=>"روسیه", "name:fi"=>"Venäjä", "name:fr"=>"Russie", "name:fy"=>"Ruslân", "name:ga"=>"An Rúis", "name:gd"=>"An Ruis", "name:he"=>"רוסיה", "name:hr"=>"Rusija", "name:hu"=>"Oroszország", "name:hy"=>"Ռուսաստան", "name:id"=>"Rusia", "name:is"=>"Rússland", "name:ja"=>"ロシア", "name:la"=>"Russia", "name:lb"=>"Russland", "name:li"=>"Rösland", "name:lt"=>"Rusija", "name:lv"=>"Krievija", "name:mn"=>"Орос", "name:nl"=>"Rusland", "name:pl"=>"Rosja", "name:pt"=>"Rússia", "name:ro"=>"Rusia", "name:ru"=>"Россия", "name:sl"=>"Rusija", "name:sv"=>"Ryssland", "name:th"=>"ประเทศรัสเซีย", "name:tr"=>"Rusya", "name:ua"=>"Росія", "name:uk"=>"Росія", "name:vi"=>"Nga", "name:zh"=>"俄罗斯", "alt_name"=>"Russia;Россия", "name:haw"=>"Rūsia", "name:zh_py"=>"Eluosi", "name:zh_pyt"=>"Éluósī", "official_name"=>"Российская Федерация", "official_name:af"=>"Russiese Federasie", "official_name:be"=>"Расійская Федэрацыя", "official_name:br"=>"Kevread Rusia", "official_name:ca"=>"Federació Russa", "official_name:el"=>"Ρωσική Ομοσπονδία", "official_name:en"=>"Russian Federation", "official_name:es"=>"Federación Rusa", "official_name:et"=>"Venemaa Föderatsioon", "official_name:id"=>"Federasi Rusia", "official_name:lb"=>"Russesch Federatioun", "official_name:lt"=>"Rusijos Federacija", "official_name:pl"=>"Federacja Rosyjska", "official_name:pt"=>"Federação Russa", "official_name:sl"=>"Ruska federacija", "official_name:sv"=>"Ryska federationen", "official_name:vi"=>"Liên Bang Nga"	ru	135
cm	"name"=>"Cameroon;Cameroun", "name:af"=>"Kameroen", "name:ar"=>"الكاميرون", "name:be"=>"Камерун", "name:br"=>"Kameroun", "name:ca"=>"Camerun", "name:cy"=>"Camerŵn", "name:da"=>"Cameroun", "name:de"=>"Kamerun", "name:el"=>"Καμερούν", "name:en"=>"Cameroon", "name:eo"=>"Kameruno", "name:es"=>"Camerún", "name:et"=>"Kamerun", "name:eu"=>"Kamerun", "name:fa"=>"کامرون", "name:fi"=>"Kamerun", "name:fr"=>"Cameroun", "name:fy"=>"Kameroen", "name:ga"=>"Camarún", "name:gd"=>"Camarun", "name:he"=>"קמרון", "name:hr"=>"Kamerun", "name:hu"=>"Kamerun", "name:id"=>"Kamerun", "name:is"=>"Kamerún", "name:it"=>"Camerun", "name:ja"=>"カメルーン", "name:la"=>"Cameronia", "name:lb"=>"Kamerun", "name:li"=>"Kameroen", "name:lt"=>"Kamerūnas", "name:lv"=>"Kamerūna", "name:mn"=>"Камерун", "name:nl"=>"Kameroen", "name:pl"=>"Kamerun", "name:pt"=>"Camarões", "name:ru"=>"Камерун", "name:sl"=>"Kamerun", "name:sv"=>"Kamerun", "name:th"=>"ประเทศแคเมอรูน", "name:tr"=>"Kamerun", "name:uk"=>"Камерун", "name:vi"=>"Cameroon", "name:zh"=>"喀麦隆", "name:zh_py"=>"Kamailong", "name:zh_pyt"=>"Kāmàilóng", "official_name"=>"Republic of Cameroon;République du Cameroun", "official_name:el"=>"Δημοκρατία του Καμερούν", "official_name:gd"=>"Poblachd Chamarun", "official_name:id"=>"Republik Kamerun", "official_name:ja"=>"カメルーン共和国", "official_name:lt"=>"Kamerūno Respublika", "official_name:lv"=>"Kamerūnas Republika", "official_name:pt"=>"República dos Camarões", "official_name:sv"=>"Republiken Kamerun", "official_name:vi"=>"Cộng hòa Cameroon"	\N	141
iq	"name"=>"Iraq", "name:af"=>"Irak", "name:ar"=>"العراق", "name:be"=>"Ірак", "name:br"=>"Irak", "name:cy"=>"Irac", "name:da"=>"Irak", "name:de"=>"Irak", "name:el"=>"Ιράκ", "name:en"=>"Iraq", "name:eo"=>"Irako", "name:et"=>"Iraak", "name:fa"=>"عراق", "name:fi"=>"Irak", "name:fr"=>"Irak", "name:fy"=>"Irak", "name:ga"=>"An Iaráic", "name:gd"=>"Ioràc", "name:he"=>"עירק", "name:hr"=>"Irak", "name:hu"=>"Irak", "name:hy"=>"Իրաք", "name:id"=>"Irak", "name:is"=>"Írak", "name:it"=>"Iraq", "name:ja"=>"イラク", "name:la"=>"Iraquia", "name:lb"=>"Irak", "name:li"=>"Irak", "name:lt"=>"Irakas", "name:lv"=>"Irāka", "name:mn"=>"Ирак", "name:nb"=>"Irak", "name:nl"=>"Irak", "name:nn"=>"Irak", "name:no"=>"Irak", "name:pl"=>"Irak", "name:ru"=>"Ирак", "name:sl"=>"Irak", "name:sv"=>"Irak", "name:th"=>"ประเทศอิรัก", "name:tr"=>"Irak", "name:uk"=>"Ірак", "name:zh"=>"伊拉克", "name:haw"=>"‘Ilaka", "name:zh_py"=>"Yilake", "name:zh_pyt"=>"Yīlākè", "official_name"=>"جمهورية العراق", "official_name:el"=>"Δημοκρατία του Ιράκ", "official_name:en"=>"Republic of Iraq", "official_name:et"=>"Iraagi Vabariik", "official_name:gd"=>"Poblachd Ioràic", "official_name:id"=>"Republik Irak", "official_name:lb"=>"Republik Irak", "official_name:lt"=>"Irako Respublika", "official_name:lv"=>"Irākas Republika", "official_name:pl"=>"Republika Federalna Iraku", "official_name:sv"=>"Republiken Irak", "official_name:vi"=>"Cộng hoà Iraq"	\N	144
bg	"name"=>"България", "name:af"=>"Bulgarye", "name:ar"=>"بلغاريا", "name:be"=>"Балгарыя", "name:bg"=>"България", "name:br"=>"Bulgaria", "name:ca"=>"Bulgària", "name:cy"=>"Bwlgaria", "name:da"=>"Bulgarien", "name:de"=>"Bulgarien", "name:el"=>"Βουλγαρία", "name:en"=>"Bulgaria", "name:eo"=>"Bulgario", "name:es"=>"Bulgaria", "name:et"=>"Bulgaaria", "name:fa"=>"بلغارستان", "name:fi"=>"Bulgaria", "name:fr"=>"Bulgarie", "name:fy"=>"Bulgarije", "name:ga"=>"An Bhulgáir", "name:gd"=>"Bulgàiria", "name:he"=>"בולגריה", "name:hr"=>"Bugarska", "name:hu"=>"Bulgária", "name:id"=>"Bulgaria", "name:is"=>"Búlgaría", "name:it"=>"Bulgaria", "name:ja"=>"ブルガリア", "name:la"=>"Bulgaria", "name:lb"=>"Bulgarien", "name:li"=>"Bölgarieë", "name:lt"=>"Bulgarija", "name:lv"=>"Bulgārija", "name:mn"=>"Болгар", "name:nl"=>"Bulgarije", "name:pl"=>"Bułgaria", "name:pt"=>"Bulgária", "name:ru"=>"Болгария", "name:sk"=>"Bulharsko", "name:sl"=>"Bolgarija", "name:sv"=>"Bulgarien", "name:th"=>"ประเทศบัลแกเรีย", "name:tr"=>"Bulgaristan", "name:uk"=>"Болгарія", "name:vi"=>"Bulgaria", "name:zh"=>"保加利亚", "name:haw"=>"Pulukalia", "name:zh_py"=>"Baojialiya", "name:zh_pyt"=>"Bǎojiālìyà", "official_name"=>"Република България", "official_name:br"=>"Republik Bulgaria", "official_name:el"=>"Δημοκρατία της Βουλγαρίας", "official_name:en"=>"Republic of Bulgaria", "official_name:es"=>"República de Bulgaria", "official_name:et"=>"Bulgaaria Vabariik", "official_name:it"=>"Repubblica di Bulgaria", "official_name:ja"=>"ブルガリア共和国", "official_name:lb"=>"Republik Bulgarien", "official_name:lt"=>"Bulgarijos Respublika", "official_name:lv"=>"Bulgārijas Republika", "official_name:pl"=>"Republika Bułgarii", "official_name:pt"=>"República da Bulgária", "official_name:sk"=>"Bulharská republika", "official_name:sv"=>"Republiken Bulgarien", "official_name:vi"=>"Cộng hòa Bulgaria"	bg	140
gd	"name"=>"Grenada", "name:ar"=>"غرينادا", "name:be"=>"Грэнада", "name:br"=>"Grenada", "name:da"=>"Grenada", "name:el"=>"Γρενάδα", "name:en"=>"Grenada", "name:eo"=>"Grenado", "name:es"=>"Granada", "name:fa"=>"گرنادا", "name:fi"=>"Grenada", "name:fr"=>"Grenade", "name:ga"=>"Greanáda", "name:gd"=>"Greanada", "name:he"=>"גרנדה", "name:hu"=>"Grenada", "name:is"=>"Grenada", "name:it"=>"Grenada", "name:ja"=>"グレナダ", "name:la"=>"Granata", "name:lb"=>"Granada", "name:lv"=>"Grenāda", "name:mn"=>"Гренада", "name:pl"=>"Granada", "name:ru"=>"Гренада", "name:sv"=>"Grenada", "name:th"=>"ประเทศเกรเนดา", "name:uk"=>"Гренада", "name:zh"=>"格林纳达"	en	143
mu	"name"=>"Mauritius", "name:af"=>"Mauritius", "name:ar"=>"موريشيوس", "name:be"=>"Маўрыкій", "name:br"=>"Moris", "name:ca"=>"Maurici", "name:da"=>"Mauritius", "name:el"=>"Μαυρίκιος", "name:en"=>"Mauritius", "name:eo"=>"Maŭricio", "name:es"=>"Mauricio", "name:fa"=>"موریس", "name:fi"=>"Mauritius", "name:fr"=>"Maurice", "name:fy"=>"Mauritsius", "name:ga"=>"Oileán Mhuirís", "name:gd"=>"Na h-Eileanan Mhoiriseas", "name:he"=>"מאוריציוס", "name:hr"=>"Mauricius", "name:hu"=>"Mauritius", "name:is"=>"Máritíus", "name:lt"=>"Mauricijus", "name:lv"=>"Maurīcija", "name:mn"=>"Маврикий", "name:pl"=>"Mauritius", "name:ru"=>"Маврикий", "name:sv"=>"Mauritius", "name:th"=>"ประเทศมอริเชียส", "name:uk"=>"Маврикій", "name:zh"=>"毛里求斯", "name:haw"=>"Mauritiusa", "name:zh_py"=>"Maoliquisi", "name:zh_pyt"=>"Máolǐqiúsī", "official_name"=>"Republic of Mauritius", "official_name:el"=>"Δημοκρατία του Μαυρίκιου", "official_name:es"=>"República de Mauricio", "official_name:fr"=>"République de Maurice", "official_name:id"=>"Republik Mauritius", "official_name:lb"=>"Republik Mauritius", "official_name:lt"=>"Mauricijaus Respublika", "official_name:lv"=>"Maurīcijas Republika", "official_name:pl"=>"Republika Mauritiusa;Republika Mauritiusu", "official_name:sv"=>"Republiken Mauritius", "official_name:vi"=>"Cộng hòa Mauritius"	\N	150
ni	"name"=>"Nicaragua", "name:ar"=>"نيكاراغوا", "name:be"=>"Нікарагуа", "name:br"=>"Nicaragua", "name:da"=>"Nicaragua", "name:el"=>"Νικαράγουα", "name:en"=>"Nicaragua", "name:eo"=>"Nikaragvo", "name:fa"=>"نیکاراگوآ", "name:fi"=>"Nicaragua", "name:fr"=>"Nicaragua", "name:fy"=>"Nikaragua", "name:ga"=>"Nicearagua", "name:gd"=>"Niocaragua", "name:he"=>"ניקרגואה", "name:hr"=>"Nikaragva", "name:hu"=>"Nicaragua", "name:id"=>"Nikaragua", "name:is"=>"Níkaragva", "name:it"=>"Nicaragua", "name:ja"=>"ニカラグア", "name:lt"=>"Nikaragva", "name:lv"=>"Nikaragva", "name:mn"=>"Никарагуа", "name:pl"=>"Nikaragua", "name:ru"=>"Никарагуа", "name:sl"=>"Nikaragva", "name:sv"=>"Nicaragua", "name:th"=>"ประเทศนิการากัว", "name:tr"=>"Nikaragua", "name:uk"=>"Нікарагуа", "name:zh"=>"尼加拉瓜", "official_name"=>"República de Nicaragua", "official_name:be"=>"Рэспубліка Нікарагуа", "official_name:id"=>"Republik Nikaragua", "official_name:it"=>"Repubblica del Nicaragua", "official_name:ja"=>"ニカラグア共和国", "official_name:lt"=>"Nikaragvos Respublika", "official_name:lv"=>"Nikaragvas Republika", "official_name:pl"=>"Republika Nikaragui", "official_name:sv"=>"Republiken Nicaragua"	es	151
pa	"name"=>"Panama", "name:ar"=>"بنما", "name:be"=>"Панама", "name:br"=>"Panama", "name:ca"=>"Panamà", "name:da"=>"Panama", "name:en"=>"Panama", "name:eo"=>"Panamo", "name:es"=>"Panamá", "name:fa"=>"پاناما", "name:fi"=>"Panama", "name:fr"=>"Panama", "name:ga"=>"Panama", "name:he"=>"פנמה", "name:hu"=>"Panama", "name:is"=>"Panama", "name:it"=>"Panamá", "name:ja"=>"パナマ", "name:li"=>"Pánama", "name:lv"=>"Panama", "name:mn"=>"Панама", "name:pl"=>"Panama", "name:ru"=>"Панама", "name:sv"=>"Panama", "name:th"=>"ประเทศปานามา", "name:uk"=>"Панама", "name:zh"=>"巴拿马", "official_name"=>"República de Panamá", "official_name:be"=>"Рэспубліка Панама", "official_name:en"=>"Republic of Panama", "official_name:gd"=>"Poblachd Phanama", "official_name:id"=>"Republik Panama", "official_name:it"=>"Repubblica di Panamá", "official_name:ja"=>"パナマ共和国", "official_name:lt"=>"Panamos Respublika", "official_name:lv"=>"Panamas Republika", "official_name:pl"=>"Republika Panamy", "official_name:sv"=>"Republiken Panama", "official_name:vi"=>"Cộng hoà Panama"	es	152
sm	"name"=>"San Marino", "name:ar"=>"سان مارينو", "name:be"=>"Сан-Марына", "name:br"=>"San Marino", "name:da"=>"San Marino", "name:el"=>"Άγιος Μαρίνος", "name:en"=>"San Marino", "name:eo"=>"San-Marino", "name:fa"=>"سان مارینو", "name:fi"=>"San Marino", "name:fr"=>"Saint-Marin", "name:ga"=>"San Mairíne", "name:he"=>"סן מרינו", "name:hu"=>"San Marino", "name:is"=>"San Marínó", "name:la"=>"Sancti Marini", "name:lt"=>"San Marinas", "name:mn"=>"Сан-Марино", "name:pl"=>"San Marino", "name:pt"=>"San Marino", "name:ru"=>"Сан-Марино", "name:sk"=>"San Maríno", "name:sv"=>"San Marino", "name:th"=>"ประเทศซานมารีโน", "name:uk"=>"Сан-Марино", "name:zh"=>"圣马力诺", "name:haw"=>"Sana Marino", "name:zh_py"=>"Shengmalinuo", "name:zh_pyt"=>"Shèngmǎlìnuò", "official_name:id"=>"Republik San Marino", "official_name:lb"=>"Republik San Marino", "official_name:lt"=>"San Marino Respublika", "official_name:pt"=>"Sereníssima República de San Marino", "official_name:sk"=>"Sanmarínska republika", "official_name:sv"=>"Republiken San Marino", "official_name:vi"=>"Cộng hòa Đại bình yên San Marino"	it	153
so	"name"=>"Somalia / الصومال", "name:af"=>"Somalië", "name:ar"=>"الصومال", "name:be"=>"Самалі", "name:br"=>"Somalia", "name:ca"=>"Somàlia", "name:cy"=>"Somalia", "name:da"=>"Somalia", "name:de"=>"Somalia", "name:el"=>"Σομαλία", "name:en"=>"Somalia", "name:eo"=>"Somalio", "name:es"=>"Somalia", "name:et"=>"Somaalia", "name:fa"=>"سومالی", "name:fi"=>"Somalia", "name:fr"=>"Somalie", "name:fy"=>"Somaalje", "name:ga"=>"An tSomáil", "name:gd"=>"Somàilia", "name:he"=>"סומליה", "name:hr"=>"Somalija", "name:hu"=>"Szomália", "name:id"=>"Somalia", "name:is"=>"Sómalía", "name:it"=>"Somalia", "name:ja"=>"ソマリア", "name:la"=>"Somalia", "name:lb"=>"Somalia", "name:li"=>"Somalië", "name:lt"=>"Somalis", "name:lv"=>"Somālija", "name:mn"=>"Сомали", "name:nl"=>"Somalië", "name:pl"=>"Somalia", "name:pt"=>"Somália", "name:ru"=>"Сомали", "name:sl"=>"Somalija", "name:so"=>"Soomaaliya", "name:sv"=>"Somalia", "name:th"=>"ประเทศโซมาเลีย", "name:tr"=>"Somali", "name:uk"=>"Сомалі", "name:vi"=>"Somalia", "name:zh"=>"索马里", "name:haw"=>"Somalia", "name:zh_py"=>"Suomali", "name:zh_pyt"=>"Suǒmǎlǐ", "official_name"=>"Somali Republic", "official_name:ar"=>"جمهورية الصومال‎", "official_name:br"=>"Republik Somalia", "official_name:el"=>"Δημοκρατία της Σομαλίας", "official_name:en"=>"Somali Republic", "official_name:et"=>"Somaalia Vabariik", "official_name:fr"=>"République de Somalie", "official_name:lb"=>"Republik Somalia", "official_name:lt"=>"Somalio Respublika", "official_name:pt"=>"República Somali", "official_name:so"=>"Jamhuuriyadda Soomaaliya", "official_name:sv"=>"Republiken Somalia", "official_name:vi"=>"Cộng hòa Somalia"	\N	154
ug	"name"=>"Uganda", "name:ar"=>"أوغندا", "name:be"=>"Уганда", "name:br"=>"Ouganda", "name:el"=>"Ουγκάντα", "name:en"=>"Uganda", "name:eo"=>"Ugando", "name:es"=>"Uganda", "name:fa"=>"اوگاندا", "name:fi"=>"Uganda", "name:fr"=>"Ouganda", "name:ga"=>"Uganda", "name:he"=>"אוגנדה", "name:hu"=>"Uganda", "name:is"=>"Úganda", "name:it"=>"Uganda", "name:ja"=>"ウガンダ", "name:li"=>"Oeganda", "name:lv"=>"Uganda", "name:mn"=>"Уганда", "name:nl"=>"Oeganda", "name:pl"=>"Uganda", "name:ru"=>"Уганда", "name:sv"=>"Uganda", "name:th"=>"ประเทศยูกันดา", "name:uk"=>"Уганда", "name:zh"=>"乌干达", "name:zh_py"=>"Wuganda", "name:zh_pyt"=>"Wūgāndá", "official_name"=>"Republic of Uganda;Jamhuri ya Uganda", "official_name:br"=>"Republik Ouganda", "official_name:gd"=>"Poblachd Uganda", "official_name:id"=>"Republik Uganda", "official_name:lt"=>"Ugandos Respublika", "official_name:sv"=>"Republiken Uganda"	\N	155
tl	"name"=>"Timor-Leste; Timor Lorosa'e", "name:af"=>"Oos-Timor", "name:ar"=>"جمهورية تيمور", "name:br"=>"Timor ar Reter", "name:ca"=>"Timor Oriental", "name:cy"=>"Dwyrain Timor", "name:da"=>"Østtimor", "name:de"=>"Osttimor", "name:en"=>"East Timor", "name:eo"=>"Orienta Timoro", "name:et"=>"Ida-Timor", "name:fa"=>"تیمور شرقی", "name:fi"=>"Itä-Timor", "name:fr"=>"Timor Oriental", "name:fy"=>"East-Timor", "name:ga"=>"An Tíomór Thoir", "name:gd"=>"Tiomor an Ear", "name:he"=>"מזרח טימור", "name:hr"=>"Istočni Timor", "name:hu"=>"Kelet-Timor", "name:id"=>"Timor Leste", "name:is"=>"Austur-Tímor", "name:it"=>"Timor Est", "name:la"=>"Timoria Orientalis", "name:li"=>"Oos-Timor", "name:lt"=>"Rytų Timoras", "name:mn"=>"Зүүн Тимор", "name:nl"=>"Oost-Timor", "name:pl"=>"Timor Wschodni", "name:pt"=>"Timor-Leste", "name:ru"=>"Тимор-Лесте", "name:sl"=>"Vzhodni Timor", "name:sv"=>"Östtimor", "name:th"=>"ประเทศติมอร์ตะวันออก", "name:tl"=>"Silangan Timor", "name:tr"=>"Doğu Timor", "name:uk"=>"Східний Тимор", "name:vi"=>"Đông Timor", "name:zh"=>"东帝汶", "alt_name"=>"East Timor", "name:tet"=>"Timor Lorosa'e", "official_name"=>"Repúblika Demokrátika Timor Lorosa'e; República Democrática de Timor-Leste", "official_name:en"=>"Democratic Republic of Timor-Leste", "official_name:et"=>"Timor-Leste Demokraatlik Vabariik", "official_name:gd"=>"Poblachd deomocrasach Timor-Leste", "official_name:id"=>"Republik Demokratik Timor Leste", "official_name:lb"=>"Demokratesch Republik Timor-Leste", "official_name:lt"=>"Rytų Timoro Demokratinė Respublika", "official_name:pl"=>"Demokratyczna Republika Timoru Wschodniego", "official_name:pt"=>"República Democrática de Timor-Leste", "official_name:ru"=>"Демократическая Республика Тимор-Лесте", "official_name:sv"=>"Demokratiska republiken Östtimor", "official_name:tl"=>"Demokratikong Republika ng Silangan Timor", "official_name:vi"=>"Cộng hòa Dân chủ Đông Timor", "official_name:tet"=>"Repúblika Demokrátika Timor Lorosa'e"	\N	161
kh	"name"=>"Cambodia", "name:af"=>"Kambodja", "name:ar"=>"كمبوديا", "name:be"=>"Камбоджа", "name:br"=>"Kambodja", "name:ca"=>"Cambodja", "name:da"=>"Cambodja", "name:de"=>"Kambodscha", "name:el"=>"Καμπότζη", "name:en"=>"Cambodia", "name:eo"=>"Kamboĝo", "name:et"=>"Kambodža", "name:eu"=>"Kanputxea", "name:fa"=>"کامبوج", "name:fi"=>"Kambodža", "name:fr"=>"Cambodge", "name:fy"=>"Kambodja", "name:ga"=>"An Chambóid", "name:gd"=>"Cambuidea", "name:he"=>"קמבודיה", "name:hr"=>"Kambodža", "name:hu"=>"Kambodzsa", "name:id"=>"Kamboja", "name:is"=>"Kambódía", "name:it"=>"Cambogia", "name:ja"=>"カンボジア", "name:la"=>"Cambosia", "name:lb"=>"Kambodscha", "name:li"=>"Cambodja", "name:lt"=>"Kambodža", "name:lv"=>"Kambodža", "name:mn"=>"Камбож", "name:nl"=>"Cambodja", "name:pl"=>"Kambodża", "name:pt"=>"Camboja", "name:ru"=>"Камбоджа", "name:sl"=>"Kambodža", "name:sv"=>"Kambodja", "name:th"=>"ประเทศ กัมพูชา", "name:tr"=>"Kamboçya", "name:uk"=>"Камбоджа", "name:vi"=>"Campuchia", "name:zh"=>"高棉", "name:haw"=>"Kamabodia", "name:zh_py"=>"Gaomian", "name:zh_pyt"=>"Gāomián", "official_name:af"=>"Koninkryk van Kambodja", "official_name:el"=>"Βασίλειο της Καμπότζης", "official_name:id"=>"Kerajaan Kamboja", "official_name:it"=>"Regno di Cambogia", "official_name:ja"=>"カンボジア王国", "official_name:lt"=>"Kambodžos Karalystė", "official_name:lv"=>"Kambodžas Karaliste", "official_name:pl"=>"Królestwo Kambodży", "official_name:pt"=>"Reino do Camboja", "official_name:sv"=>"Konungariket Kambodja", "official_name:vi"=>"Vương quốc Campuchia"	km	159
mg	"name"=>"Madagascar", "name:af"=>"Madagaskar", "name:ar"=>"مدغشقر", "name:be"=>"Мадагаскар", "name:br"=>"Madagaskar", "name:da"=>"Madagaskar", "name:de"=>"Madagaskar", "name:el"=>"Μαδαγασκάρη", "name:en"=>"Madagascar", "name:eo"=>"Madagaskaro", "name:es"=>"Madagascar", "name:et"=>"Madagaskar", "name:fa"=>"ماداگاسکار", "name:fi"=>"Madagaskar", "name:fr"=>"Madagascar", "name:fy"=>"Madagaskar", "name:ga"=>"Madagascar", "name:he"=>"מדגסקר", "name:hr"=>"Madagaskar", "name:hu"=>"Madagaszkár", "name:id"=>"Madagaskar", "name:is"=>"Madagaskar", "name:it"=>"Madagascar", "name:ja"=>"マダガスカル", "name:la"=>"Madagascaria", "name:lb"=>"Madagaskar", "name:li"=>"Madagaskar", "name:lt"=>"Madagaskaras", "name:lv"=>"Madagaskara", "name:mn"=>"Мадагаскар", "name:nl"=>"Madagaskar", "name:pl"=>"Madagaskar", "name:ru"=>"Мадагаскар", "name:sl"=>"Madagaskar", "name:sv"=>"Madagaskar", "name:th"=>"ประเทศมาดากัสการ์", "name:tr"=>"Madagaskar", "name:uk"=>"Мадагаскар", "name:zh"=>"马达加斯加", "name:haw"=>"Madagaseka", "name:zh_py"=>"Madajiasijia", "name:zh_pyt"=>"Mǎdájiāsījiā", "official_name"=>"Repoblikan'i Madagasikara", "official_name:el"=>"Δημοκρατία της Μαδαγασκάρης", "official_name:en"=>"Republic of Madagascar", "official_name:es"=>"República de Madagascar", "official_name:fr"=>"République de Madagascar", "official_name:id"=>"Republik Madagaskar", "official_name:lt"=>"Madagaskaro Respublika", "official_name:lv"=>"Madagaskaras Republika", "official_name:pl"=>"Republika Madagaskaru", "official_name:sv"=>"Republiken Madagaskar", "official_name:vi"=>"Cộng hòa Madagascar"	\N	164
mt	"name"=>"Malta", "name:ar"=>"مالطا", "name:be"=>"Мальта", "name:br"=>"Malta", "name:ca"=>"República de Malta", "name:el"=>"Μάλτα", "name:en"=>"Malta", "name:eo"=>"Malto", "name:fa"=>"مالت", "name:fi"=>"Malta", "name:fr"=>"Malte", "name:ga"=>"Málta", "name:he"=>"מלטה", "name:hu"=>"Málta", "name:is"=>"Malta", "name:ja"=>"マルタ", "name:la"=>"Melita", "name:lv"=>"Malta", "name:mn"=>"Мальта", "name:pl"=>"Malta", "name:ru"=>"Мальта", "name:sk"=>"Malta", "name:sv"=>"Malta", "name:th"=>"ประเทศมอลตา", "name:uk"=>"Мальта", "name:zh"=>"马尔他", "name:haw"=>"Malata", "name:zh_py"=>"Maerta", "name:zh_pyt"=>"Mǎěrtā", "official_name:el"=>"Δημοκρατία της Μάλτας", "official_name:id"=>"Republik Malta", "official_name:ja"=>"マルタ共和国", "official_name:lb"=>"Republik Malta", "official_name:lt"=>"Maltos Respublika", "official_name:lv"=>"Maltas Republika", "official_name:sk"=>"Maltská republika", "official_name:sv"=>"Republiken Malta", "official_name:vi"=>"Cộng hòa Malta"	\N	165
mn	"name"=>"Монгол Улс", "name:af"=>"Mongolië", "name:ar"=>"منغوليا", "name:az"=>"Monqolustan", "name:be"=>"Манголія", "name:br"=>"Mongolia", "name:ca"=>"Mongòlia", "name:cy"=>"Mongolia", "name:da"=>"Mongoliet", "name:de"=>"Mongolei", "name:el"=>"Μογγολία", "name:en"=>"Mongolia", "name:eo"=>"Mongolio", "name:es"=>"Mongolia", "name:et"=>"Mongoolia", "name:fa"=>"مغولستان", "name:fi"=>"Mongolia", "name:fr"=>"Mongolie", "name:fy"=>"Mongoalje", "name:ga"=>"An Mhongóil", "name:gd"=>"Mongòilia", "name:he"=>"מונגוליה", "name:hr"=>"Mongolija", "name:hu"=>"Mongólia", "name:id"=>"Mongolia", "name:is"=>"Mongólía", "name:it"=>"Mongolia", "name:ja"=>"モンゴル", "name:la"=>"Mogolia", "name:lb"=>"Mongolei", "name:li"=>"Mongolië", "name:lt"=>"Mongolija", "name:lv"=>"Mongolija", "name:mn"=>"Монгол Улс", "name:nl"=>"Mongolië", "name:pl"=>"Mongolia", "name:pt"=>"Mongólia", "name:ru"=>"Монголия", "name:sl"=>"Mongolija", "name:sv"=>"Mongoliet", "name:th"=>"ประเทศมองโกเลีย", "name:tr"=>"Moğolistan", "name:uk"=>"Монголія", "name:vi"=>"Mông Cổ", "name:zh"=>"蒙古国", "name:haw"=>"Monokolia", "official_name:pl"=>"Republika Mongolska"	mn	167
bm	"name"=>"Bermuda", "name:ar"=>"برمودا", "name:be"=>"Бярмуды", "name:br"=>"Bermuda", "name:ca"=>"Bermudes", "name:da"=>"Bermuda", "name:el"=>"Βερμούδες", "name:en"=>"Bermuda", "name:eo"=>"Bermudo", "name:fa"=>"برمودا", "name:fi"=>"Bermuda", "name:fr"=>"Bermudes", "name:ga"=>"Beirmiúda", "name:he"=>"ברמודה", "name:hu"=>"Bermuda", "name:is"=>"Bermúda", "name:lv"=>"Bermudu salas", "name:mn"=>"Бермудын Арал", "name:pl"=>"Bermudy", "name:pt"=>"Bermuda", "name:ru"=>"Бермуды", "name:sl"=>"Bermudi", "name:sv"=>"Bermuda", "name:th"=>"เบอร์มิวดา", "name:uk"=>"Бермудські острови", "name:zh"=>"百慕大"	en	176
ua	"name"=>"Україна", "name:af"=>"Oekraïne", "name:ar"=>"أوكرانيا", "name:be"=>"Украіна", "name:br"=>"Ukraina", "name:ca"=>"Ucraïna", "name:cy"=>"Wcráin", "name:da"=>"Ukraine", "name:de"=>"Ukraine", "name:el"=>"Ουκρανία", "name:en"=>"Ukraine", "name:eo"=>"Ukrainio", "name:es"=>"Ucrania", "name:et"=>"Ukraina", "name:fa"=>"اوکراین", "name:fi"=>"Ukraina", "name:fr"=>"Ukraine", "name:fy"=>"de Oekraïne", "name:ga"=>"An Úcráin", "name:gd"=>"An Ùcrain", "name:he"=>"אוקראינה", "name:hr"=>"Ukrajina", "name:hu"=>"Ukrajna", "name:id"=>"Ukraina", "name:is"=>"Úkraína", "name:it"=>"Ucraina", "name:ja"=>"ウクライナ", "name:la"=>"Ucraina", "name:lb"=>"Ukraine", "name:li"=>"De Oekraïne", "name:lt"=>"Ukraina", "name:lv"=>"Ukraina", "name:mn"=>"Украйн", "name:nl"=>"Oekraïne", "name:pl"=>"Ukraina", "name:pt"=>"Ucrânia", "name:ru"=>"Украина", "name:sk"=>"Ukrajina", "name:sl"=>"Ukrajina", "name:sv"=>"Ukraina", "name:th"=>"ประเทศยูเครน", "name:tr"=>"Ukrayna", "name:uk"=>"Україна", "name:vi"=>"Ukraina", "name:zh"=>"乌克兰", "name:haw"=>"‘Ukelena", "name:zh_py"=>"Wukelan", "name:zh_pyt"=>"Wūkèlán"	uk	173
uy	"name"=>"Uruguay", "name:ar"=>"أوروغواي", "name:be"=>"Уругвай", "name:br"=>"Uruguay", "name:ca"=>"Uruguai", "name:da"=>"Uruguay", "name:el"=>"Ουρουγουάη", "name:en"=>"Uruguay", "name:eo"=>"Urugvajo", "name:fa"=>"اروگوئه", "name:fi"=>"Uruguay", "name:fr"=>"Uruguay", "name:fy"=>"Urûguay", "name:ga"=>"Uragua", "name:gd"=>"Uruguaidh", "name:he"=>"אורוגואי", "name:hr"=>"Urugvaj", "name:hu"=>"Uruguay", "name:is"=>"Úrúgvæ", "name:ja"=>"ウルグアイ", "name:la"=>"Uruguaia", "name:li"=>"Urugay", "name:lt"=>"Urugvajus", "name:lv"=>"Urugvaja", "name:mn"=>"Уругвай", "name:pl"=>"Urugwaj", "name:pt"=>"Uruguai", "name:ru"=>"Уругвай", "name:sl"=>"Urugvaj", "name:sv"=>"Uruguay", "name:th"=>"ประเทศอุรุกวัย", "name:uk"=>"Уругвай", "name:zh"=>"乌拉圭", "official_name"=>"Oriental Republic of Uruguay", "official_name:br"=>"Republik-Reter Uruguay", "official_name:es"=>"República Oriental del Uruguay", "official_name:fr"=>"République orientale de l'Uruguay", "official_name:id"=>"Republik Timur Uruguay", "official_name:lb"=>"Republik östlich vum Uruguay", "official_name:lt"=>"Urugvajaus Rytų Respublika", "official_name:pl"=>"Wschodnia Republika Urugwaju", "official_name:pt"=>"República Oriental do Uruguai", "official_name:sv"=>"Republiken Uruguay"	es	174
vc	"name"=>"Saint Vincent and the Grenadines", "name:af"=>"Sint Vincent en die Grenadines", "name:ar"=>"سانت فنسنت وجزر غرينادين", "name:be"=>"Святы Вінцэнт і Грэнадзіны", "name:br"=>"Saint Vincent ha Grenadines", "name:ca"=>"Saint Vincent i les Grenadines", "name:cy"=>"Saint Vincent a'r Grenadines", "name:da"=>"Saint Vincent og Grenadinerne", "name:de"=>"Saint Vincent und die Grenadinen", "name:en"=>"Saint Vincent and the Grenadines", "name:eo"=>"Sankta Vincento kaj Grenadinoj", "name:es"=>"San Vicente y las Granadinas", "name:fa"=>"سنت وینسنت و گرنادین", "name:fi"=>"Saint Vincent ja Grenadiinit", "name:fr"=>"Saint-Vincent-et-les Grenadines", "name:fy"=>"Sint Finsint en de Grenadinen", "name:ga"=>"San Uinseann agus na Greanáidíní", "name:gd"=>"Naomh Bhionsant agus Eileanan Greanadach", "name:he"=>"סנט וינסנט והגרנדינים", "name:hr"=>"Sveti Vincent i Grenadini", "name:hu"=>"Saint Vincent és a Grenadine-szigetek", "name:id"=>"Saint Vincent dan Grenadines", "name:is"=>"Sankti Vinsent og Grenadíneyjar", "name:it"=>"Saint Vincent e Grenadine", "name:ja"=>"セントビンセント及びグレナディーン諸島", "name:lb"=>"Saint Vincent an d’Grenadinen", "name:li"=>"Saint-Vincent", "name:lt"=>"Sent Vinsentas ir Grenadinai", "name:mn"=>"Сент-Винсент ба Гренадин", "name:nl"=>"Saint Vincent en de Grenadines", "name:pl"=>"Saint Vincent i Grenadyny", "name:pt"=>"São Vicente e Granadinas", "name:ru"=>"Сент-Винсент и Гренадины", "name:sv"=>"Saint Vincent och Grenadinerna", "name:th"=>"ประเทศเซนต์วินเซนต์และเกรนาดีนส์", "name:tr"=>"Saint Vincent ve Grenadinler", "name:uk"=>"Сент-Вінсент і Гренадини", "name:vi"=>"Saint Vincent và Grenadines", "name:zh"=>"圣文森特和格林纳丁斯"	en	171
ag	"name"=>"Antigua and Barbuda", "name:af"=>"Antigua en Barbuda", "name:ar"=>"أنتيغوا وبربودا", "name:az"=>"Antiqua və Barbuda", "name:be"=>"Антыгуа і Барбуда", "name:br"=>"Antigua ha Barbuda", "name:ca"=>"Antigua i Barbuda", "name:cy"=>"Antigua a Barbuda", "name:da"=>"Antigua og Barbuda", "name:de"=>"Antigua und Barbuda", "name:el"=>"Αντίγκουα και Μπαρμπούντα", "name:en"=>"Antigua and Barbuda", "name:eo"=>"Antigvo-Barbudo", "name:es"=>"Antigua y Barbuda", "name:et"=>"Antigua ja Barbuda", "name:eu"=>"Antigua eta Barbuda", "name:fa"=>"آنتیگوا و باربودا", "name:fi"=>"Antigua ja Barbuda", "name:fr"=>"Antigua-et-Barbuda", "name:fy"=>"Antigua en Barbûda", "name:ga"=>"Antigua agus Barbúda", "name:gd"=>"Antigua agus Barbuda", "name:he"=>"אנטיגואה וברבודה", "name:hr"=>"Antigva i Barbuda", "name:hu"=>"Antigua és Barbuda", "name:id"=>"Antigua dan Barbuda", "name:is"=>"Antígva og Barbúda", "name:it"=>"Antigua e Barbuda", "name:la"=>"Antiqua et Barbuda", "name:lb"=>"Antigua a Barbuda", "name:li"=>"Antigua en Barbuda", "name:lt"=>"Antigva ir Barbuda", "name:lv"=>"Antigva un Barbuda", "name:mn"=>"Антигуа ба Барбуда", "name:nb"=>"Antigua og Barbuda", "name:nl"=>"Antigua en Barbuda", "name:nn"=>"Antigua og Barbuda", "name:no"=>"Antigua og Barbuda", "name:pl"=>"Antigua i Barbuda", "name:pt"=>"Antígua e Barbuda", "name:ru"=>"Антигуа и Барбуда", "name:sl"=>"Antigva in Barbuda", "name:sv"=>"Antigua och Barbuda", "name:th"=>"ประเทศแอนติกาและบาร์บูดา", "name:tr"=>"Antigua ve Barbuda", "name:uk"=>"Антигуа і Барбуда", "name:vi"=>"Antigua và Barbuda", "name:zh"=>"安提瓜和巴布达"	en	205
bb	"name"=>"Barbados", "name:ar"=>"بربادوس", "name:be"=>"Барбадас", "name:br"=>"Barbados", "name:da"=>"Barbados", "name:el"=>"Μπαρμπάντος", "name:en"=>"Barbados", "name:eo"=>"Barbado", "name:es"=>"Barbados", "name:fa"=>"باربادوس", "name:fi"=>"Barbados", "name:fr"=>"Barbade", "name:ga"=>"Barbadós", "name:he"=>"ברבדוס", "name:hu"=>"Barbados", "name:is"=>"Barbados", "name:it"=>"Barbados", "name:ja"=>"バルバドス", "name:la"=>"Barbata", "name:lt"=>"Barbadosas", "name:lv"=>"Barbadosa", "name:mn"=>"Барбадос", "name:pl"=>"Barbados", "name:pt"=>"Barbados", "name:ru"=>"Барбадос", "name:sv"=>"Barbados", "name:th"=>"ประเทศบาร์เบโดส", "name:uk"=>"Барбадос", "name:zh"=>"巴巴多斯"	en	206
bs	"name"=>"Bahamas", "name:ar"=>"جزر البهاما", "name:az"=>"Baham adaları", "name:be"=>"Багамы", "name:br"=>"Bahamas", "name:ca"=>"Bahames", "name:cy"=>"Y Bahamas", "name:el"=>"Μπαχάμες", "name:en"=>"Bahamas", "name:eo"=>"Bahamoj", "name:et"=>"Bahama", "name:eu"=>"Bahamak", "name:fa"=>"باهاما", "name:fi"=>"Bahama", "name:fr"=>"Bahamas", "name:fy"=>"de Bahama's", "name:ga"=>"Na Bahámaí", "name:gd"=>"Na h-Eileanan Bhathama", "name:he"=>"בהמה", "name:hr"=>"Bahami", "name:hu"=>"Bahama-szigetek", "name:id"=>"Bahama", "name:is"=>"Bahamaeyjar", "name:it"=>"Bahamas", "name:la"=>"Insulae Bahamenses", "name:li"=>"Bahama-eilen", "name:lt"=>"Bahamos", "name:lv"=>"Bahamu salas", "name:mn"=>"Багамын арлууд", "name:nl"=>"Bahama's", "name:pl"=>"Bahamy", "name:pt"=>"Bahamas", "name:ru"=>"Багамы", "name:sl"=>"Bahami", "name:sv"=>"Bahamas", "name:th"=>"ประเทศบาฮามาส", "name:tr"=>"Bahamalar", "name:uk"=>"Багамські Острови", "name:zh"=>"巴哈马", "official_name"=>"Commonwealth of The Bahamas", "official_name:be"=>"Садружнасць Багамскіх астравоў", "official_name:el"=>"Κοινοπολιτεία των Μπαχαμών", "official_name:fi"=>"Bahaman kansainyhteisö", "official_name:id"=>"Persemakmuran Bahama", "official_name:it"=>"Commonwealth delle Bahamas", "official_name:lt"=>"Bahamų Sandrauga", "official_name:lv"=>"Bahamu Salu Sadraudzība", "official_name:pl"=>"Wspólnota Bahamów", "official_name:pt"=>"Comunidade das Bahamas", "official_name:sv"=>"Samväldet Bahamas"	en	207
bz	"name"=>"Belize", "name:ar"=>"بليز", "name:be"=>"Беліз", "name:br"=>"Belize", "name:el"=>"Μπελίζε", "name:en"=>"Belize", "name:eo"=>"Belizo", "name:es"=>"Belice", "name:fa"=>"بلیز", "name:fi"=>"Belize", "name:fr"=>"Belize", "name:ga"=>"An Bheilís", "name:gd"=>"Beilise", "name:hu"=>"Belize", "name:is"=>"Belís", "name:it"=>"Belize", "name:ja"=>"ベリーズ", "name:la"=>"Beliza", "name:lt"=>"Belizas", "name:lv"=>"Beliza", "name:mn"=>"Белиз", "name:pl"=>"Belize", "name:pt"=>"Belize", "name:ru"=>"Белиз", "name:sv"=>"Belize", "name:th"=>"ประเทศเบลีซ", "name:uk"=>"Беліз", "name:zh"=>"伯利兹"	en	208
dm	"name"=>"Dominica", "name:af"=>"Dominika", "name:ar"=>"دومينيكا", "name:be"=>"Дамініка", "name:br"=>"Dominica", "name:el"=>"Ντομίνικα", "name:en"=>"Dominica", "name:eo"=>"Dominiko", "name:es"=>"Dominica", "name:eu"=>"Dominika", "name:fa"=>"دومینیکا", "name:fi"=>"Dominica", "name:fr"=>"Dominique", "name:fy"=>"Dominika", "name:ga"=>"Doiminice", "name:gd"=>"Doiminicia", "name:he"=>"דומיניקה", "name:hr"=>"Dominika", "name:hu"=>"Dominikai Közösség", "name:id"=>"Dominika", "name:is"=>"Dóminíka", "name:it"=>"Dominìca", "name:ja"=>"ドミニカ", "name:lt"=>"Dominika", "name:lv"=>"Dominika", "name:mn"=>"Доминика", "name:pl"=>"Dominika", "name:pt"=>"Dominica", "name:ru"=>"Доминика", "name:sl"=>"Dominika", "name:sv"=>"Dominica", "name:th"=>"ประเทศโดมินิกา", "name:tr"=>"Dominika", "name:uk"=>"Домініка", "name:zh"=>"多明尼加", "official_name"=>"Commonwealth of Dominica", "official_name:be"=>"Садружнасць Дамінікі", "official_name:el"=>"Κοινοπολιτεία της Ντομίνικα", "official_name:fr"=>"Commonwealth de Dominique", "official_name:id"=>"Persemakmuran Dominika", "official_name:ja"=>"ドミニカ共和国", "official_name:lt"=>"Dominikos Sandrauga", "official_name:lv"=>"Dominikas Sadraudzība", "official_name:pl"=>"Wspólnota Dominiki", "official_name:pt"=>"Comunidade da Dominica", "official_name:sv"=>"Samväldet Dominica", "official_name:vi"=>"Khối thịnh vượng chung Dominica"	en	209
zm	"name"=>"Zambia", "name:af"=>"Zambië", "name:ar"=>"زامبيا", "name:be"=>"Замбія", "name:br"=>"Zambia", "name:ca"=>"Zàmbia", "name:de"=>"Sambia", "name:el"=>"Ζάμπια", "name:en"=>"Zambia", "name:eo"=>"Zambio", "name:es"=>"Zambia", "name:et"=>"Sambia", "name:fa"=>"زامبیا", "name:fi"=>"Sambia", "name:fr"=>"Zambie", "name:fy"=>"Sambia", "name:ga"=>"An tSaimbia", "name:gd"=>"Saimbia", "name:he"=>"זמביה", "name:hu"=>"Zambia", "name:is"=>"Sambía", "name:it"=>"Zambia", "name:ja"=>"ザンビア", "name:lb"=>"Sambia", "name:lt"=>"Zambija", "name:lv"=>"Zambija", "name:mn"=>"Замби", "name:pl"=>"Zambia", "name:pt"=>"Zâmbia", "name:ru"=>"Замбия", "name:sl"=>"Zambija", "name:sv"=>"Zambia", "name:th"=>"ประเทศแซมเบีย", "name:tr"=>"Zambiya", "name:uk"=>"Замбія", "name:zh"=>"赞比亚", "name:haw"=>"Zamibia", "name:zh_py"=>"Zanbiya", "name:zh_pyt"=>"Zànbǐyà", "official_name"=>"Republic of Zambia", "official_name:el"=>"Δημοκρατία της Ζάμπιας", "official_name:et"=>"Sambia Vabariik", "official_name:gd"=>"Poblachd Shaimbia", "official_name:id"=>"Republik Zambia", "official_name:ja"=>"ザンビア共和国", "official_name:lb"=>"Republik Sambia", "official_name:lt"=>"Zambijos Respublika", "official_name:pt"=>"República da Zâmbia", "official_name:sv"=>"Republiken Zambia"	en	222
fj	"name"=>"Fiji", "name:af"=>"Fidji", "name:ar"=>"فيجي", "name:be"=>"Фіджы", "name:br"=>"Fidji", "name:de"=>"Fidschi", "name:el"=>"Φίτζι", "name:en"=>"Fiji", "name:eo"=>"Fiĝioj", "name:es"=>"Fiyi", "name:et"=>"Fidži", "name:fa"=>"فیجی", "name:fi"=>"Fidži", "name:fr"=>"Fidji", "name:fy"=>"Fidzjy", "name:ga"=>"Fidsí", "name:gd"=>"Fìdi", "name:he"=>"פיג'י", "name:hr"=>"Fidži", "name:hu"=>"Fidzsi-szigetek", "name:is"=>"Fídjieyjar", "name:it"=>"Figi", "name:ja"=>"フィジー", "name:la"=>"Viti", "name:lb"=>"Fidschi", "name:li"=>"Fidzji-eilen", "name:lt"=>"Fidžis", "name:lv"=>"Fidži", "name:mn"=>"Фижи", "name:pl"=>"Fidżi", "name:pt"=>"Fiji", "name:ru"=>"Фиджи", "name:sl"=>"Fidži", "name:sq"=>"Fixhi", "name:sv"=>"Fiji", "name:th"=>"ประเทศฟิจิ", "name:uk"=>"Фіджі", "name:zh"=>"斐济岛", "official_name"=>"Matanitu Tu-Vaka-i-koya ko Viti", "official_name:be"=>"Фіджы", "official_name:en"=>"Republic of the Fiji Islands", "official_name:es"=>"República de las Islas Fiyi", "official_name:fr"=>"République des îles Fidji", "official_name:id"=>"Republik Kepulauan Fiji", "official_name:ja"=>"フィジー諸島共和国", "official_name:lt"=>"Fidžio Salų Respublika", "official_name:lv"=>"Fidži Republika", "official_name:pl"=>"Republika Wysp Fidżi", "official_name:pt"=>"República das Ilhas Fiji", "official_name:ru"=>"Республика Островов Фиджи", "official_name:sv"=>"Republiken Fijiöarna", "official_name:vi"=>"Cộng hòa Quần đảo Fiji"	en	210
gm	"name"=>"The Gambia", "name:af"=>"Gambië", "name:ar"=>"غامبيا", "name:be"=>"Гамбія", "name:br"=>"Gambia", "name:ca"=>"Gàmbia", "name:cy"=>"Y Gambia", "name:da"=>"Gambia", "name:de"=>"Gambia", "name:el"=>"Γκάμπια", "name:eo"=>"Gambio", "name:es"=>"Gambia", "name:et"=>"Gambia", "name:fa"=>"گامبیا", "name:fi"=>"Gambia", "name:fr"=>"Gambie", "name:fy"=>"Gambia", "name:ga"=>"An Ghaimbia", "name:gd"=>"A' Ghaimbia", "name:he"=>"גמביה", "name:hr"=>"Gambija", "name:hu"=>"Gambia", "name:id"=>"Gambia", "name:is"=>"Gambía", "name:it"=>"Gambia", "name:ja"=>"ガンビア", "name:la"=>"Gambia", "name:lb"=>"Gambia", "name:li"=>"Gambia", "name:lt"=>"Gambija", "name:lv"=>"Gambija", "name:mn"=>"Гамби", "name:nb"=>"Gambia", "name:nl"=>"Gambia", "name:nn"=>"Gambia", "name:no"=>"Gambia", "name:pl"=>"Gambia", "name:pt"=>"Gâmbia", "name:ru"=>"Гамбия", "name:sl"=>"Gambija", "name:sv"=>"Gambia", "name:th"=>"ประเทศแกมเบีย", "name:tr"=>"Gambiya", "name:uk"=>"Гамбія", "name:vi"=>"Gambia", "name:zh"=>"冈比亚", "name:zh_py"=>"Gangbiya", "name:zh_pyt"=>"Gāngbǐyà", "official_name"=>"Republic of The Gambia", "official_name:be"=>"Рэспубліка Гамбія", "official_name:el"=>"Δημοκρατία της Γκάμπια", "official_name:et"=>"Gambia Vabariik", "official_name:gd"=>"Poblachd na Gaimbia", "official_name:id"=>"Republik Gambia", "official_name:ja"=>"ガンビア共和国", "official_name:lv"=>"Gambijas Republika", "official_name:pt"=>"República da Gâmbia", "official_name:sv"=>"Republiken Gambia", "official_name:vi"=>"Cộng hòa Gambia"	en	212
gy	"name"=>"Guyana", "name:ar"=>"غيانا", "name:be"=>"Гаяна", "name:br"=>"Guyana", "name:da"=>"Guyana", "name:el"=>"Γουιάνα", "name:en"=>"Guyana", "name:eo"=>"Gujano", "name:fa"=>"گویان", "name:fi"=>"Guyana", "name:fr"=>"Guyana", "name:ga"=>"An Ghuáin", "name:gd"=>"Guiana", "name:he"=>"גיאנה", "name:hr"=>"Gvajana", "name:hu"=>"Guyana", "name:is"=>"Gvæjana", "name:ja"=>"ガイアナ", "name:la"=>"Guiana", "name:lt"=>"Gajana", "name:lv"=>"Gajāna", "name:mn"=>"Гайана", "name:pl"=>"Gujana", "name:pt"=>"Guiana", "name:ru"=>"Гайана", "name:sl"=>"Gvajana", "name:sv"=>"Guyana", "name:th"=>"ประเทศกายอานา", "name:uk"=>"Гаяна", "name:zh"=>"圭亚那", "official_name"=>"Co-operative Republic of Guyana", "official_name:be"=>"Кааператыўная Рэспубліка Гаяна", "official_name:el"=>"Συνεργατική Δημοκρατία της Γουιάνας", "official_name:es"=>"República Cooperativa de Guyana", "official_name:id"=>"Republik Kooperatif Guyana", "official_name:ja"=>"ガイアナ共和国", "official_name:lt"=>"Gajanos Respublika", "official_name:lv"=>"Gajānas Kooperatīvā Republika", "official_name:pl"=>"Kooperacyjna Republika Gujany", "official_name:pt"=>"República Cooperativa da Guiana", "official_name:sv"=>"Republiken Guyana"	en	213
jm	"name:af"=>"Jamaika", "name:ar"=>"جامايكا", "name:be"=>"Ямайка", "name:br"=>"Jamaika", "name:de"=>"Jamaika", "name:el"=>"Τζαμάικα", "name:eo"=>"Jamajko", "name:fa"=>"جامائیکا", "name:fi"=>"Jamaika", "name:fr"=>"Jamaïque", "name:fy"=>"Jamaika", "name:ga"=>"Iamáice", "name:gd"=>"Iaimeuca", "name:he"=>"ג'מייקה", "name:hr"=>"Jamajka", "name:hu"=>"Jamaica", "name:id"=>"Jamaika", "name:is"=>"Jamaíka", "name:it"=>"Giamaica", "name:ja"=>"ジャマイカ", "name:la"=>"Iamaica", "name:lb"=>"Jamaika", "name:lt"=>"Jamaika", "name:lv"=>"Jamaika", "name:mn"=>"Ямайка", "name:pl"=>"Jamajka", "name:ru"=>"Ямайка", "name:sl"=>"Jamajka", "name:sv"=>"Jamaica", "name:th"=>"ประเทศจาเมกา", "name:tr"=>"Jamaika", "name:uk"=>"Ямайка", "name:zh"=>"牙买加"	en	214
ki	"name"=>"Kiribati", "name:ar"=>"كيريباس", "name:be"=>"Кірыбаці", "name:br"=>"Kiribati", "name:da"=>"Kiribati", "name:el"=>"Κιριμπάτι", "name:en"=>"Kiribati", "name:eo"=>"Kiribato", "name:fa"=>"کیریباتی", "name:fi"=>"Kiribati", "name:fr"=>"Kiribati", "name:fy"=>"Kiribaty", "name:ga"=>"Cireabaití", "name:he"=>"קיריבטי", "name:hu"=>"Kiribati", "name:is"=>"Kíribatí", "name:li"=>"Kiribati-eilen", "name:lt"=>"Kiribatis", "name:lv"=>"Kiribati", "name:mn"=>"Кирибати", "name:pl"=>"Kiribati", "name:ru"=>"Кирибати", "name:sv"=>"Kiribati", "name:th"=>"ประเทศคิริบาส", "name:uk"=>"Кірибаті", "name:zh"=>"基里巴斯", "official_name"=>"Republic of Kiribati", "official_name:el"=>"Δημοκρατία του Κιριμπάτι", "official_name:es"=>"República de Kiribati", "official_name:id"=>"Republik Kiribati", "official_name:lt"=>"Kiribačio Respublika", "official_name:lv"=>"Kiribati Republika", "official_name:pl"=>"Republika Kiribati", "official_name:sv"=>"Republiken Kiribati", "official_name:gil"=>"Ribaberikin Kiribati"	en	215
lr	"name"=>"Liberia", "name:af"=>"Liberië", "name:ar"=>"ليبريا", "name:be"=>"Ліберыя", "name:br"=>"Liberia", "name:ca"=>"Libèria", "name:da"=>"Liberia", "name:el"=>"Λιβερία", "name:en"=>"Liberia", "name:eo"=>"Liberio", "name:es"=>"Liberia", "name:et"=>"Libeeria", "name:fa"=>"لیبریا", "name:fi"=>"Liberia", "name:fr"=>"Liberia", "name:fy"=>"Libearia", "name:ga"=>"An Libéir", "name:gd"=>"Libèiria", "name:he"=>"ליבריה", "name:hu"=>"Libéria", "name:is"=>"Líbería", "name:it"=>"Liberia", "name:lt"=>"Liberija", "name:lv"=>"Libērija", "name:mn"=>"Либери", "name:pl"=>"Liberia", "name:ru"=>"Либерия", "name:sl"=>"Liberija", "name:sv"=>"Liberia", "name:th"=>"ประเทศไลบีเรีย", "name:tr"=>"Liberya", "name:uk"=>"Ліберія", "name:zh"=>"利比里亚", "name:zh_py"=>"Libiliya", "name:zh_pyt"=>"Lìbǐlǐyà", "official_name"=>"Republic of Liberia", "official_name:be"=>"Рэспубліка Ліберыя", "official_name:et"=>"Libeeria Vabariik", "official_name:id"=>"Republik Liberia", "official_name:lt"=>"Liberijos Respublika", "official_name:lv"=>"Libērijas Republika", "official_name:sv"=>"Republiken Liberia", "official_name:vi"=>"Cộng hòa Liberia"	en	216
fm	"name"=>"Micronesia", "name:af"=>"Mikronesië", "name:ar"=>"ميكرونيزيا", "name:be"=>"Мікранэзія", "name:br"=>"Mikronezia", "name:ca"=>"Micronèsia", "name:da"=>"Mikronesien", "name:de"=>"Mikronesien", "name:en"=>"Micronesia", "name:eo"=>"Mikronezio", "name:et"=>"Mikroneesia", "name:fa"=>"میکرونزی", "name:fi"=>"Mikronesia", "name:fr"=>"Micronésie", "name:fy"=>"Mikroneezje", "name:ga"=>"An Mhicrinéis", "name:gd"=>"Na Meanbh Eileanan", "name:he"=>"מיקרונזיה", "name:hr"=>"Mikronezija", "name:hu"=>"Mikronézia", "name:id"=>"Mikronesia", "name:is"=>"Míkrónesía", "name:lb"=>"Mikronesien", "name:li"=>"Micronesië", "name:lt"=>"Mikronezija", "name:lv"=>"Mikronēzija", "name:mn"=>"Микронези", "name:no"=>"Mikronesia", "name:pl"=>"Mikronezja", "name:ru"=>"Микронезия", "name:sl"=>"Mikronezija", "name:sv"=>"Mikronesien", "name:th"=>"ประเทศไมโครนีเซีย", "name:tr"=>"Mikronezya", "name:uk"=>"Мікронезія", "name:zh"=>"密克罗尼西亚", "official_name"=>"Federated States of Micronesia", "official_name:be"=>"Федэратыўныя штаты Мікранэзіі", "official_name:es"=>"Estados Federados de Micronesia", "official_name:et"=>"Mikroneesia Liiduriigid", "official_name:lb"=>"Federéiert Staten vu Mikronesien", "official_name:lt"=>"Mikronezijos Federacinės Valstijos", "official_name:lv"=>"Mikronēzijas Federatīvās Valstis", "official_name:pl"=>"Sfederowane Stany Mikronezji", "official_name:sl"=>"Federativne države Mikronezije", "official_name:sv"=>"Mikronesiska federationen", "official_name:vi"=>"Liên bang Micronesia"	en	217
ng	"name"=>"Nigeria", "name:af"=>"Nigerië", "name:ar"=>"نيجيريا", "name:az"=>"Nigeriya", "name:be"=>"Нігерыя", "name:br"=>"Nigeria", "name:ca"=>"Nigèria", "name:da"=>"Nigeria", "name:el"=>"Νιγηρία", "name:en"=>"Nigeria", "name:eo"=>"Niĝerio", "name:es"=>"Nigeria", "name:et"=>"Nigeeria", "name:fa"=>"نیجریه", "name:fi"=>"Nigeria", "name:fr"=>"Nigeria", "name:fy"=>"Nigearia", "name:ga"=>"An Nigéir", "name:gd"=>"Nìgeiria", "name:he"=>"ניגריה", "name:hu"=>"Nigéria", "name:is"=>"Nígería", "name:it"=>"Nigeria", "name:ja"=>"ナイジェリア", "name:lt"=>"Nigerija", "name:lv"=>"Nigērija", "name:mn"=>"Нигери", "name:pl"=>"Nigeria", "name:ru"=>"Нигерия", "name:sl"=>"Nigerija", "name:sv"=>"Nigeria", "name:th"=>"ประเทศไนจีเรีย", "name:tr"=>"Nijerya", "name:uk"=>"Нігерія", "name:zh"=>"尼日利亚", "name:haw"=>"Naigeria", "name:zh_py"=>"Niriliya", "name:zh_pyt"=>"Nírìlìyà", "official_name"=>"Federal Republic of Nigeria", "official_name:be"=>"Федэратыўная Рэспубліка Нігерыя", "official_name:el"=>"Ομοσπονδιακή Δημοκρατία της Νιγηρίας", "official_name:et"=>"Nigeeria Liitvabariik", "official_name:gd"=>"Poblachd Caidreachail Nìgeiria", "official_name:lb"=>"Bundesrepublik Nigeria", "official_name:lt"=>"Nigerijos Federacinė Respublika", "official_name:lv"=>"Nigērijas Federatīvā Republika", "official_name:sv"=>"Förbundsrepubliken Nigeria", "official_name:vi"=>"Cộng hòa Liên bang Nigeria"	en	218
sl	"name"=>"Sierra Leone", "name:ar"=>"سيراليون", "name:be"=>"С’ера-Леоне ", "name:br"=>"Sierra Leone", "name:da"=>"Sierra Leone", "name:el"=>"Σιέρα Λεόνε", "name:en"=>"Sierra Leone", "name:eo"=>"Siera-Leono", "name:es"=>"Sierra Leona", "name:fa"=>"سیرالئون", "name:fi"=>"Sierra Leone", "name:fr"=>"Sierra Leone", "name:fy"=>"Sierra Leöane", "name:ga"=>"Siarra Leon", "name:gd"=>"Siarra Leòmhann", "name:he"=>"סיארה ליאון", "name:hu"=>"Sierra Leone", "name:is"=>"Síerra Leóne", "name:it"=>"Sierra Leone", "name:la"=>"Mons Leoninus", "name:lt"=>"Siera Leonė", "name:mn"=>"Сьерра-Леоне", "name:pl"=>"Sierra Leone", "name:pt"=>"Serra Leoa", "name:ru"=>"Сьерра-Леоне", "name:sv"=>"Sierra Leone", "name:th"=>"ประเทศเซียร์ราลีโอน", "name:uk"=>"Сьєрра-Леоне", "name:zh"=>"塞拉利昂", "name:zh_py"=>"Sailali'ang", "name:zh_pyt"=>"Sàilālì'áng", "official_name"=>"Republic of Sierra Leone", "official_name:be"=>"Рэспубліка С’ера-Леоне ", "official_name:el"=>"Δημοκρατία της Σιέρα Λεόνε", "official_name:gd"=>"Poblachd Shiarra Leòmhann", "official_name:id"=>"Republik Sierra Leone", "official_name:lt"=>"Siera Leonės Respublika", "official_name:pt"=>"República da Serra Leoa", "official_name:sv"=>"Republiken Sierra Leone", "official_name:vi"=>"Cộng hòa Sierra Leone"	en	219
to	"name"=>"Tonga", "name:ar"=>"تونغا", "name:be"=>"Тонга", "name:br"=>"Tonga", "name:da"=>"Tonga", "name:el"=>"Τόνγκα", "name:en"=>"Tonga", "name:eo"=>"Tongo", "name:fa"=>"تونگا", "name:fi"=>"Tonga", "name:fr"=>"Tonga", "name:ga"=>"Tonga", "name:he"=>"טונגה", "name:hu"=>"Tonga", "name:mn"=>"Тонга", "name:pl"=>"Tonga", "name:pt"=>"Tonga", "name:ru"=>"Тонга", "name:sv"=>"Tonga", "name:th"=>"ประเทศตองกา", "name:uk"=>"Тонга", "name:zh"=>"汤加群岛", "official_name"=>"Pule'anga Fakatu'i 'o Tonga", "official_name:br"=>"Rouantelezh Tonga", "official_name:en"=>"Kingdom of Tonga", "official_name:es"=>"Reino de Tonga", "official_name:id"=>"Kerajaan Tonga", "official_name:lb"=>"Kinneksräich Tonga", "official_name:lt"=>"Tongos Karalystė", "official_name:pl"=>"Królestwo Tonga", "official_name:pt"=>"Reino de Tonga", "official_name:ru"=>"Королевство Тонга", "official_name:sv"=>"Konungariket Tonga", "official_name:vi"=>"Vương quốc Tonga"	en	220
tt	"name"=>"Trinidad and Tobago", "name:af"=>"Trinidad en Tobago", "name:ar"=>"ترينيداد وتوباغو", "name:be"=>"Трынідад і Табага", "name:br"=>"Trinidad ha Tobago", "name:ca"=>"Trinitat i Tobago", "name:cy"=>"Trinidad a Tobago", "name:da"=>"Trinidad og Tobago", "name:de"=>"Trinidad und Tobago", "name:en"=>"Trinidad and Tobago", "name:eo"=>"Trinidado kaj Tobago", "name:es"=>"Trinidad y Tobago", "name:et"=>"Trinidad ja Tobago", "name:fa"=>"ترینیداد و توباگو", "name:fi"=>"Trinidad ja Tobago", "name:fr"=>"Trinité-et-Tobago", "name:fy"=>"Trinidad en Tobago", "name:ga"=>"Oileán na Tríonóide agus Tobága", "name:gd"=>"Trianaid agus Tobago", "name:he"=>"טרינידד וטובגו", "name:hr"=>"Trinidad i Tobago", "name:hu"=>"Trinidad és Tobago", "name:id"=>"Trinidad dan Tobago", "name:is"=>"Trínidad og Tóbagó", "name:it"=>"Trinidad e Tobago", "name:ja"=>"トリニダード・トバゴ", "name:la"=>"Trinitas et Tabacum", "name:lt"=>"Trinidadas ir Tobagas", "name:mn"=>"Тринидад ба Тобаго", "name:nl"=>"Trinidad en Tobago", "name:pl"=>"Trynidad i Tobago", "name:pt"=>"Trinidad e Tobago", "name:ru"=>"Тринидад и Тобаго", "name:sl"=>"Trinidad in Tobago", "name:sv"=>"Trinidad och Tobago", "name:th"=>"ประเทศตรินิแดดและโตเบโก", "name:tr"=>"Trinidad ve Tobago", "name:uk"=>"Трінідад та Тобаго", "name:vi"=>"Trinidad và Tobago", "name:zh"=>"特立尼达和多巴哥", "official_name"=>"Republic of Trinidad and Tobago", "official_name:be"=>"Рэспубліка Трынідад і Табага", "official_name:br"=>"Republik Trinidad ha Tobago", "official_name:es"=>"República de Trinidad y Tobago", "official_name:et"=>"Trinidadi ja Tobago Vabariik", "official_name:fr"=>"République de Trinité-et-Tobago", "official_name:id"=>"Republik Trinidad dan Tobago", "official_name:ja"=>"トリニダード・トバゴ共和国", "official_name:lt"=>"Trinidado ir Tobago Respublika", "official_name:pt"=>"República de Trinidad e Tobago", "official_name:sv"=>"Republiken Trinidad och Tobago", "official_name:vi"=>"Cộng hoà Trinidad và Tobago"	en	221
mq	"name"=>"Martinique", "name:ar"=>"مارتينيك", "name:be"=>"Марцініка", "name:br"=>"Martinik", "name:ca"=>"Martinica", "name:da"=>"Martinique", "name:el"=>"Μαρτινίκα", "name:en"=>"Martinique", "name:eo"=>"Martiniko", "name:es"=>"Martinica", "name:fa"=>"مارتینیک", "name:fi"=>"Martinique", "name:fr"=>"Martinique", "name:fy"=>"Martinyk", "name:he"=>"מרטיניק", "name:hr"=>"Martinik", "name:hu"=>"Martinique", "name:id"=>"Martinik", "name:is"=>"Martinique", "name:it"=>"Martinica", "name:la"=>"Martinica", "name:lt"=>"Martinika", "name:lv"=>"Martinika", "name:mn"=>"Мартиник", "name:pl"=>"Martynika", "name:ru"=>"Мартиника", "name:sv"=>"Martinique", "name:uk"=>"Мартиніка", "name:zh"=>"馬提尼克", "official_name:lv"=>"Francijas Martinikas departaments"	fr	233
zw	"name"=>"Zimbabwe", "name:ar"=>"زمبابوي", "name:be"=>"Зімбабве", "name:br"=>"Zimbabwe", "name:da"=>"Zimbabwe", "name:de"=>"Simbabwe", "name:el"=>"Ζιμπάμπουε", "name:en"=>"Zimbabwe", "name:eo"=>"Zimbabvo", "name:es"=>"Zimbabue", "name:fa"=>"زیمبابوه", "name:fi"=>"Zimbabwe", "name:fr"=>"Zimbabwe", "name:fy"=>"Simbabwe", "name:ga"=>"An tSiombáib", "name:gd"=>"Siombabue", "name:he"=>"זימבבווה", "name:hr"=>"Zimbabve", "name:hu"=>"Zimbabwe", "name:is"=>"Simbabve", "name:it"=>"Zimbabwe", "name:ja"=>"ジンバブエ", "name:la"=>"Zimbabua", "name:lb"=>"Simbabwe", "name:lt"=>"Zimbabvė", "name:mn"=>"Зимбабве", "name:pl"=>"Zimbabwe", "name:pt"=>"Zimbábue", "name:ru"=>"Зимбабве", "name:sl"=>"Zimbabve", "name:sv"=>"Zimbabwe", "name:th"=>"ประเทศซิมบับเว", "name:tr"=>"Zimbabve", "name:uk"=>"Зімбабве", "name:vi"=>"Zimbabwe", "name:zh"=>"津巴布韦", "name:haw"=>"Zimababue", "name:zh_py"=>"Jinbabuwei", "name:zh_pyt"=>"Jīnbābùwéi", "official_name"=>"Republic of Zimbabwe;República de Zimbabue", "official_name:el"=>"Δημοκρατία της Ζιμπάμπουε", "official_name:gd"=>"Poblachd Shiombabue", "official_name:id"=>"Republik Zimbabwe", "official_name:ja"=>"ジンバブエ共和国", "official_name:lb"=>"Republik Simbabwe", "official_name:lt"=>"Zimbabvės Respublika", "official_name:pt"=>"República do Zimbábue", "official_name:sv"=>"Republiken Zimbabwe", "official_name:vi"=>"Cộng hòa Zimbabwe"	en	223
bj	"name"=>"Bénin", "name:af"=>"Benin", "name:ar"=>"بنن", "name:be"=>"Бенін", "name:br"=>"Benin", "name:ca"=>"Benín", "name:cy"=>"Benin", "name:da"=>"Benin", "name:de"=>"Benin", "name:el"=>"Μπενίν", "name:en"=>"Benin", "name:eo"=>"Benino", "name:es"=>"Benín", "name:et"=>"Benin", "name:eu"=>"Benin", "name:fa"=>"بنین", "name:fi"=>"Benin", "name:fr"=>"Bénin", "name:fy"=>"Benyn", "name:ga"=>"Beinin", "name:gd"=>"Beinin", "name:he"=>"בנין", "name:hu"=>"Benin", "name:id"=>"Benin", "name:is"=>"Benín", "name:it"=>"Benin", "name:ja"=>"ベナン", "name:la"=>"Beninum", "name:lb"=>"Benin", "name:li"=>"Benin", "name:lt"=>"Beninas", "name:lv"=>"Benina", "name:mn"=>"Бенин", "name:nl"=>"Benin", "name:pl"=>"Benin", "name:pt"=>"Benin", "name:ru"=>"Бенин", "name:sl"=>"Benin", "name:sv"=>"Benin", "name:th"=>"ประเทศเบนิน", "name:tr"=>"Benin", "name:uk"=>"Бенін", "name:zh"=>"贝宁", "name:zh_py"=>"Beining", "name:zh_pyt"=>"Bèiníng", "official_name"=>"République du Bénin", "official_name:fi"=>"Beninin tasavalta", "official_name:id"=>"Republik Benin", "official_name:lt"=>"Benino Respublika", "official_name:lv"=>"Beninas Republika", "official_name:pt"=>"República do Benin", "official_name:sv"=>"Republiken Benin", "official_name:vi"=>"Cộng hoà Bénin"	fr	224
bf	"name"=>"Burkina Faso", "name:af"=>"Burkina Faso", "name:ar"=>"بوركينا فاصو", "name:be"=>"Буркіна-Фасо", "name:br"=>"Burkina Faso", "name:da"=>"Burkina Faso", "name:el"=>"Μπουρκίνα Φάσο", "name:en"=>"Burkina Faso", "name:eo"=>"Burkino", "name:es"=>"Burkina Faso", "name:fa"=>"بورکینافاسو", "name:fi"=>"Burkina Faso", "name:fr"=>"Burkina Faso", "name:fy"=>"Bûrkina Faso", "name:ga"=>"Buircíne Fasó", "name:gd"=>"Buirciona Faso", "name:he"=>"בורקינה פאסו", "name:hu"=>"Burkina Faso", "name:is"=>"Búrkína Fasó", "name:it"=>"Burkina Faso", "name:ja"=>"ブルキナファソ", "name:la"=>"Burkina", "name:lt"=>"Burkina Fasas", "name:lv"=>"Burkinafaso", "name:mn"=>"Буркина Фасо", "name:pl"=>"Burkina Faso", "name:pt"=>"Burkina Faso", "name:ru"=>"Буркина-Фасо", "name:sv"=>"Burkina Faso", "name:th"=>"ประเทศบูร์กินาฟาโซ", "name:uk"=>"Буркіна-Фасо", "name:zh"=>"布基纳法索", "name:haw"=>"Burakina Faso", "name:zh_py"=>"Bujinafasuo", "name:zh_pyt"=>"Bùjīnàfǎsuǒ"	fr	225
ne	"name"=>"Niger", "name:ar"=>"النيجر", "name:be"=>"Нігер", "name:br"=>"Niger", "name:ca"=>"Níger", "name:da"=>"Niger", "name:el"=>"Νίγηρας", "name:en"=>"Niger", "name:eo"=>"Niĝero", "name:es"=>"Níger", "name:fa"=>"نیجر", "name:fi"=>"Niger", "name:fr"=>"Niger", "name:ga"=>"An Nígir", "name:gd"=>"Nìgeir", "name:he"=>"ניז'ר", "name:hu"=>"Niger", "name:is"=>"Níger", "name:it"=>"Niger", "name:ja"=>"ニジェール", "name:lt"=>"Nigeris", "name:lv"=>"Nigēra", "name:mn"=>"Нигер", "name:pl"=>"Niger", "name:ru"=>"Нигер", "name:sv"=>"Niger", "name:th"=>"ประเทศไนเจอร์", "name:tr"=>"Nijer", "name:uk"=>"Нігер", "name:zh"=>"尼日尔", "name:haw"=>"Naigera", "name:zh_py"=>"Nirier", "name:zh_pyt"=>"Nírìěr", "official_name"=>"République du Niger", "official_name:el"=>"Δημοκρατία του Νίγηρα", "official_name:en"=>"Republic of Niger", "official_name:gd"=>"Poblachd Nìgeir", "official_name:id"=>"Republik Niger", "official_name:lt"=>"Nigerio Respublika", "official_name:lv"=>"Nigēras Republika", "official_name:sv"=>"Republiken Niger", "official_name:vi"=>"Cộng hoà Niger"	fr	226
cf	"name"=>"Centrafrique", "name:af"=>"Sentraal-Afrikaanse Republiek", "name:ar"=>"جمهورية أفريقيا الوسطى", "name:be"=>"Цэнтральна-Афрыканская Рэспубліка", "name:br"=>"Kreizafrika", "name:ca"=>"República Centreafricana", "name:cy"=>"Gweriniaeth Canolbarth Affrica", "name:da"=>"Centralafrikanske Republik", "name:de"=>"Zentralafrikanische Republik", "name:el"=>"Κεντροαφρικανική Δημοκρατία", "name:en"=>"Central African Republic", "name:eo"=>"Centr-Afrika Respubliko", "name:es"=>"República Centroafricana", "name:et"=>"Kesk-Aafrika Vabariik", "name:eu"=>"Afrika Erdiko Errepublika", "name:fa"=>"جمهوری آفریقای مرکزی", "name:fi"=>"Keski-Afrikan tasavalta", "name:fr"=>"Centrafrique", "name:fy"=>"de Sintraal-Afrikaanske Republyk", "name:ga"=>"Poblacht na hAfraice Láir", "name:gd"=>"Poblachd Meadhan Afraga", "name:he"=>"הרפובליקה המרכז-אפריקאית", "name:hr"=>"Centralna Afrička Republika", "name:hu"=>"Közép-Afrikai Köztarsaság", "name:id"=>"Republik Afrika Tengah", "name:is"=>"Mið-Afríkulýðveldið", "name:it"=>"Repubblica Centrafricana", "name:la"=>"Respublica Africae Mediae", "name:lb"=>"Zentralafrikanesch Republik", "name:li"=>"Centraal Afrika", "name:lt"=>"Centrinės Afrikos Respublika", "name:lv"=>"Centrālāfrikas Republika", "name:mn"=>"Төв Африкийн Бүгд Найрамдах Улс", "name:nl"=>"Centraal-Afrikaanse Republiek", "name:pl"=>"Republika Środkowoafrykańska", "name:pt"=>"República Centro-Africana", "name:ru"=>"Центрально-Африканская Республика", "name:sl"=>"Srednjeafriška republika", "name:sv"=>"Centralafrikanska republiken", "name:th"=>"สาธารณรัฐแอฟริกากลาง", "name:tr"=>"Orta Afrika Cumhuriyeti", "name:uk"=>"Центрально-Африканська Республіка", "name:vi"=>"Cộng hòa Trung Phi", "name:zh"=>"中非", "name:zh_py"=>"Zhong Fei", "name:zh_pyt"=>"Zhōng Fēi", "official_name:fr"=>"République centrafricaine", "official_name:pt"=>"República Centro-Africana"	fr	227
ga	"name"=>"Gabon", "name:af"=>"Gaboen", "name:ar"=>"غابون", "name:be"=>"Габон", "name:br"=>"Gabon", "name:de"=>"Gabun", "name:el"=>"Γκαμπόν", "name:en"=>"Gabon", "name:eo"=>"Gabono", "name:es"=>"Gabón", "name:fa"=>"گابن", "name:fi"=>"Gabon", "name:fr"=>"Gabon", "name:ga"=>"An Ghabúin", "name:he"=>"גבון", "name:hu"=>"Gabon", "name:is"=>"Gabon", "name:it"=>"Gabon", "name:ja"=>"ガボン", "name:la"=>"Gabonia", "name:lb"=>"Gabun", "name:lt"=>"Gabonas", "name:lv"=>"Gabona", "name:mn"=>"Габон", "name:pl"=>"Gabon", "name:pt"=>"Gabão", "name:ru"=>"Габон", "name:sv"=>"Gabon", "name:th"=>"ประเทศกาบอง", "name:uk"=>"Габон", "name:zh"=>"加蓬", "name:zh_py"=>"Jiapeng", "name:zh_pyt"=>"Jiāpéng", "official_name"=>"République Gabonaise", "official_name:el"=>"Δημοκρατία της Γκαμπόν", "official_name:en"=>"Gabonese Republic", "official_name:gd"=>"Poblachd Ghabon", "official_name:id"=>"Republik Gabon", "official_name:lt"=>"Gabono Respublika", "official_name:lv"=>"Gabonas Republika", "official_name:pt"=>"República Gabonesa", "official_name:sv"=>"Republiken Gabon", "official_name:vi"=>"Cộng hòa Gabon"	fr	239
ci	"name"=>"Côte d'Ivoire", "name:af"=>"Ivoorkus", "name:ar"=>"كوت ديفوار", "name:be"=>"Кот д’Івуар", "name:br"=>"Aod an Olifant", "name:ca"=>"Costa d'Ivori", "name:da"=>"Elfenbenskysten", "name:de"=>"Elfenbeinküste", "name:el"=>"Ακτή Ελεφαντοστού", "name:en"=>"Côte d'Ivoire", "name:eo"=>"Ebur-Bordo", "name:es"=>"Costa de Marfil", "name:et"=>"Elevandiluurannik", "name:eu"=>"Boli Kosta", "name:fa"=>"ساحل عاج", "name:fi"=>"Norsunluurannikko", "name:fr"=>"Côte d'Ivoire", "name:fy"=>"Ivoarkust", "name:ga"=>"An Cósta Eabhair", "name:gd"=>"Costa Ìbhri", "name:he"=>"חוף השנהב", "name:hr"=>"Obala Bjelokosti", "name:hu"=>"Elefántcsontpart", "name:id"=>"Pantai Gading", "name:is"=>"Fílabeinsströndin", "name:it"=>"Costa d'Avorio", "name:ja"=>"コートジボワール", "name:la"=>"Litus Eburneum", "name:lb"=>"Elfebeeküst", "name:li"=>"Ivoorkös", "name:lt"=>"Dramblio kaulo krantas", "name:lv"=>"Kotdivuāra", "name:mn"=>"Зааны Ясан Эрэг", "name:nl"=>"Ivoorkust", "name:pl"=>"Wybrzeże Kości Słoniowej", "name:pt"=>"Costa do Marfim", "name:ru"=>"Кот д'Ивуар", "name:sl"=>"Slonokoščena obala", "name:sv"=>"Elfenbenskusten", "name:th"=>"ประเทศโกตดิวัวร์", "name:tr"=>"Fildişi Sahili", "name:uk"=>"Кот-д'Івуар", "name:zh"=>"科特迪瓦", "name:zh_py"=>"Ketediwa", "name:zh_pyt"=>"Kētèdíwǎ", "official_name"=>"République de Côte d’Ivoire", "official_name:be"=>"Рэспубліка Кот д’Івуар", "official_name:el"=>"Δημοκρατία της Ακτής Ελεφαντοστού", "official_name:en"=>"Republic of Côte d'Ivoire", "official_name:lt"=>"Dramblio Kaulo Kranto Respublika", "official_name:lv"=>"Kotdivuāras Republika", "official_name:pt"=>"República da Costa do Marfim", "official_name:sv"=>"Republiken Elfenbenskusten", "official_name:vi"=>"Cộng hòa Côte d'Ivoire"	fr	228
cd	"name"=>"République Démocratique du Congo", "name:af"=>"Demokratiese Republiek van die Kongo", "name:ar"=>"الكونغو", "name:br"=>"Republik Demokratel Kongo", "name:ca"=>"República Democràtica del Congo", "name:cy"=>"Gweriniaeth Ddemocrataidd Congo", "name:da"=>"Demokratiske Republik Congo", "name:de"=>"Demokratische Republik Kongo", "name:el"=>"Λαϊκή Δημοκρατία του Κονγκό", "name:en"=>"Democratic Republic of the Congo", "name:eo"=>"Demokratia Respubliko Kongo", "name:es"=>"República Democrática del Congo", "name:et"=>"Kongo Demokraatlik Vabariik", "name:fa"=>"جمهوری دموکراتیک کنگو", "name:fi"=>"Kongon demokraattinen tasavalta", "name:fr"=>"République démocratique du Congo", "name:fy"=>"Demokratyske Republyk de Kongo", "name:ga"=>"Poblacht Dhaonlathach an Chongó", "name:gd"=>"Poblachd Dheamocrach na Congo", "name:he"=>"הרפובליקה הדמוקרטית של קונגו", "name:hr"=>"Demokratska Republika Kongo", "name:hu"=>"Kongói Demokratikus Köztársaság", "name:id"=>"Republik Demokratik Kongo", "name:is"=>"Vestur-Kongó", "name:it"=>"Repubblica Democratica del Congo", "name:kg"=>"Repubilika ya Kongo Demokratiki", "name:la"=>"Respublica Popularis Congensis", "name:lb"=>"Demokratesch Republik Kongo", "name:li"=>"Democratische Rippebliek vaan de Kongo", "name:ln"=>"Republiki ya Kongó Demokratiki", "name:lt"=>"Kongo Demokratinė Respublika", "name:lv"=>"Kongo Demokrātiskā Republika", "name:mn"=>"Бүгд Найрамдах Ардчилсан Конго", "name:nl"=>"Democratische Republiek Congo", "name:pl"=>"Demokratyczna Republika Konga", "name:ru"=>"Демократическая Республика Конго", "name:sl"=>"Demokratična republika Kongo", "name:sv"=>"Demokratiska republiken Kongo", "name:sw"=>"Jamhuri ya Kidemokrasia ya Kongo", "name:th"=>"สาธารณรัฐประชาธิปไตยคองโก", "name:tr"=>"Demokratik Kongo Cumhuriyeti", "name:uk"=>"Демократична Республіка Конго", "name:vi"=>"Cộng hòa Dân chủ Congo", "name:zh"=>"刚果民主共和国", "alt_name"=>"Congo-Kinshasa;Congo (Kinshasa);Congo;RD Congo;RDC", "name:lua"=>"Ditunga dia Kongu wa Mungalaata", "old_name"=>"Congo Free State;Belgian Congo;Congo-Léopoldville;Congo-Kinshasa;Zaire", "official_name:fr"=>"République démocratique du Congo"	fr	229
cg	"name"=>"République du Congo", "name:af"=>"Republiek van die Kongo", "name:ar"=>"جمهورية الكونغو الديمقراطية", "name:br"=>"Republik Kongo", "name:ca"=>"República del Congo", "name:cy"=>"Gweriniaeth y Congo", "name:da"=>"Republikken Congo", "name:de"=>"Republik Kongo", "name:el"=>"Δημοκρατία του Κονγκό", "name:en"=>"Republic of the Congo", "name:eo"=>"Respubliko Kongo", "name:es"=>"República del Congo", "name:et"=>"Kongo Vabariik", "name:fa"=>"جمهوری کنگو", "name:fi"=>"Kongon tasavalta", "name:fr"=>"République du Congo", "name:fy"=>"Republyk de Kongo", "name:ga"=>"Poblacht an Chongó", "name:gd"=>"A' Chongo", "name:he"=>"קונגו", "name:hr"=>"Republika Kongo", "name:hu"=>"Kongó", "name:id"=>"Republik Kongo", "name:is"=>"Vestur-Kongó", "name:it"=>"Repubblica del Congo", "name:kg"=>"Repubilika ya Kongo", "name:la"=>"Respublica Congensis", "name:lb"=>"Republik Kongo", "name:li"=>"Rippebliek vaan de Kongo", "name:ln"=>"Republiki ya Kongó", "name:lt"=>"Kongo Respublika", "name:lv"=>"Kongo", "name:mn"=>"Бүгд Найрамдах Конго", "name:nl"=>"Republiek Congo", "name:pl"=>"Kongo", "name:ru"=>"Республика Конго", "name:sl"=>"Kongo", "name:sv"=>"Kongo", "name:th"=>"สาธารณรัฐคองโก", "name:tr"=>"Kongo Cumhuriyeti", "name:uk"=>"Республіка Конго", "name:vi"=>"Cộng hòa Congo", "name:zh"=>"刚果共和国", "alt_name"=>"Congo-Brazzaville;Congo (Brazzaville);Congo", "official_name:fr"=>"République du Congo", "official_name:gd"=>"Poblachd na Congo", "official_name:lv"=>"Kongo Republika", "official_name:sl"=>"Republika Kongo", "official_name:sv"=>"Republiken Kongo"	fr	230
gf	"name"=>"Guyane Française", "name:af"=>"Frans-Guyana", "name:ar"=>"غيانا", "name:br"=>"Gwiana c’hall", "name:ca"=>"Guaiana Francesa", "name:cy"=>"Guyane", "name:da"=>"Fransk Guyana", "name:de"=>"Französisch-Guayana", "name:el"=>"Γαλλική Γουιάνα", "name:en"=>"French Guiana", "name:eo"=>"Gujano", "name:es"=>"Guayana Francesa", "name:et"=>"Prantsuse Guajaana", "name:fa"=>"گویان فرانسه", "name:fi"=>"Ranskan Guayana", "name:fr"=>"Guyane française", "name:fy"=>"Frânsk Guyana", "name:ga"=>"Guáin na Fraince", "name:gd"=>"Guiana Fhrangach", "name:he"=>"גיאנה הצרפתית", "name:hr"=>"Francuska Gvajana", "name:hu"=>"Francia Guyana", "name:id"=>"Guyana Perancis", "name:is"=>"Franska Gvæjana", "name:it"=>"Guyana francese", "name:la"=>"Guiana Francica", "name:li"=>"Frans Guyana", "name:lt"=>"Prancūzijos Gviana", "name:lv"=>"Franču Gviāna", "name:mn"=>"Франц Гвиана", "name:nl"=>"Frans-Guyana", "name:pl"=>"Gujana Francuska", "name:ru"=>"Французская Гвиана", "name:sl"=>"Francoska Gvajana", "name:sv"=>"Franska Guyana", "name:th"=>"เฟรนช์เกียนา", "name:tr"=>"Fransız Guyanası", "name:uk"=>"Французька Гвіана", "name:vi"=>"Guyane thuộc Pháp", "name:zh"=>"法属圭亚那"	fr	231
gp	"name"=>"Guadeloupe", "name:ar"=>"غوادلوب", "name:be"=>"Гвадэлупа", "name:br"=>"Gwadeloup", "name:ca"=>"Illa de Guadalupe", "name:da"=>"Guadeloupe", "name:el"=>"Γουαδελούπη", "name:en"=>"Guadeloupe", "name:eo"=>"Gvadelupo", "name:es"=>"Guadalupe", "name:fa"=>"گوادلوپ", "name:fi"=>"Guadeloupe", "name:fr"=>"Guadeloupe", "name:fy"=>"Guadelûp", "name:ga"=>"Guadalúip", "name:he"=>"גוואדלופ", "name:hr"=>"Gvadalupa", "name:hu"=>"Guadeloupe", "name:is"=>"Gvadelúpeyjar", "name:it"=>"Guadalupa", "name:la"=>"Guadalupa", "name:lt"=>"Gvadelupa", "name:lv"=>"Gvadelupa", "name:mn"=>"Гуаделупе", "name:pl"=>"Gwadelupa", "name:ru"=>"Гваделупа", "name:sv"=>"Guadeloupe", "name:th"=>"กวาเดอลูป", "name:uk"=>"Гваделупа", "name:zh"=>"瓜德罗普", "official_name:lv"=>"Francijas Gvadelupas departaments"	fr	232
nc	"name"=>"Nouvelle-Calédonie", "name:af"=>"Nieu-Caledonia", "name:ar"=>"كاليدونيا الجديدة", "name:be"=>"Новая Каледонія", "name:br"=>"Kaledonia Nevez", "name:ca"=>"Nova Caledònia", "name:cy"=>"Caledonia Newydd", "name:da"=>"Ny Kaledonien", "name:de"=>"Neukaledonien", "name:el"=>"Νέα Καληδονία", "name:en"=>"New Caledonia", "name:eo"=>"Nov-Kaledonio", "name:es"=>"Nueva Caledonia", "name:fa"=>"کالدونیای جدید", "name:fi"=>"Uusi-Kaledonia", "name:fr"=>"Nouvelle-Calédonie", "name:ga"=>"An Nua-Chaladóin", "name:he"=>"קלדוניה החדשה", "name:hr"=>"Nova Kaledonija", "name:hu"=>"Új-Kaledónia", "name:id"=>"Kaledonia Baru", "name:is"=>"Nýja-Kaledónía", "name:it"=>"Nuova Caledonia", "name:la"=>"Nova Caledonia", "name:lt"=>"Naujoji Kaledonija", "name:lv"=>"Jaunkaledonija", "name:mn"=>"Шинэ Каледони", "name:nl"=>"Nieuw-Caledonië", "name:pl"=>"Nowa Kaledonia", "name:ru"=>"Новая Каледония", "name:sl"=>"Nova Kaledonija", "name:sv"=>"Nya Kaledonien", "name:th"=>"นิวแคลิโดเนีย", "name:tr"=>"Yeni Kaledonya", "name:uk"=>"Нова Каледонія", "name:zh"=>"新喀里多尼亚", "official_name:es"=>"Colectividad de Ultramar francesa de Nueva Caledonia", "official_name:lv"=>"Jaunkaledonija un piederīgās teritorijas"	fr	234
re	"name"=>"Réunion", "name:af"=>"Réunion", "name:ar"=>"ريونيون", "name:be"=>"Руньён", "name:br"=>"Ar Reunion", "name:ca"=>"Illa de la Reunió", "name:da"=>"Reunion", "name:el"=>"Ρεϊνιόν", "name:eo"=>"Reunio", "name:es"=>"La Reunión", "name:fa"=>"رئونیون", "name:fi"=>"Réunion", "name:fr"=>"La Réunion", "name:he"=>"ראוניון", "name:hu"=>"Réunion", "name:is"=>"Réunion", "name:it"=>"Riunione", "name:la"=>"Reunio", "name:lt"=>"Reunionas", "name:lv"=>"Reinjona", "name:mn"=>"Реюньон", "name:pl"=>"Reunion", "name:ru"=>"Реюньон", "name:sl"=>"Reunion", "name:sv"=>"Réunion", "name:th"=>"เรอูนียง", "name:uk"=>"Реюньйон", "name:zh"=>"留尼汪", "name:zh_py"=>"Liuniwang", "name:zh_pyt"=>"Liúníwāng", "official_name"=>"Région de La Réunion", "official_name:lv"=>"Francijas Reinjonas departaments"	fr	235
pm	"name"=>"Saint-Pierre-et-Miquelon", "name:af"=>"Saint-Pierre et Miquelon", "name:be"=>"Святы П’ер і Міквелон", "name:da"=>"Saint Pierre og Miquelon", "name:de"=>"Saint-Pierre und Miquelon", "name:en"=>"Saint Pierre and Miquelon", "name:eo"=>"Sankta-Piero kaj Mikelono", "name:es"=>"San Pedro y Miguelón", "name:fi"=>"Saint-Pierre ja Miquelon", "name:fr"=>"Saint-Pierre-et-Miquelon", "name:hr"=>"Sveti Petar i Mikelon", "name:hu"=>"Saint-Pierre és Miquelon", "name:lt"=>"Sen Pjeras ir Mikelonas", "name:lv"=>"Senpjēra un Mikelona", "name:mn"=>"Сент Пьер ба Микелон", "name:sv"=>"Saint-Pierre och Miquelon", "name:tr"=>"Saint-Pierre ve Miquelon", "name:uk"=>"Сен-П'єр і Мікелон", "official_name"=>"Saint-Pierre-et-Miquelon", "official_name:fr"=>"Saint-Pierre-et-Miquelon", "official_name:lv"=>"Senpjēras un Mikelonas teritoriālā vienība"	fr	236
sn	"name"=>"Sénégal", "name:af"=>"Senegal", "name:ar"=>"السنغال", "name:be"=>"Сенегал", "name:br"=>"Senegal", "name:ca"=>"Senegal", "name:cy"=>"Sénégal", "name:da"=>"Senegal", "name:de"=>"Senegal", "name:el"=>"Σενεγάλη", "name:en"=>"Senegal", "name:eo"=>"Senegaleo", "name:es"=>"Senegal", "name:et"=>"Senegal", "name:fa"=>"سنگال", "name:fi"=>"Senegal", "name:fr"=>"Sénégal", "name:fy"=>"Senegal", "name:ga"=>"An tSeineagáil", "name:gd"=>"Seanagal", "name:he"=>"סנגל", "name:hr"=>"Senegal", "name:hu"=>"Szenegál", "name:id"=>"Senegal", "name:is"=>"Senegal", "name:it"=>"Senegal", "name:ja"=>"セネガル", "name:la"=>"Senegalia", "name:lb"=>"Senegal", "name:li"=>"Senegal", "name:lt"=>"Senegalas", "name:lv"=>"Senegāla", "name:mn"=>"Сенегал", "name:nl"=>"Senegal", "name:pl"=>"Senegal", "name:pt"=>"Senegal", "name:ru"=>"Сенегал", "name:sl"=>"Senegal", "name:sv"=>"Senegal", "name:th"=>"ประเทศเซเนกัล", "name:tr"=>"Senegal", "name:uk"=>"Сенегал", "name:zh"=>"塞内加尔", "name:haw"=>"Senekala", "name:zh_py"=>"Saineijiaer", "name:zh_pyt"=>"Sàinèijiāěr", "official_name"=>"République du Sénégal", "official_name:be"=>"Рэспубліка Сенегал", "official_name:ca"=>"República del Senegal", "official_name:el"=>"Δημοκρατία της Σενεγάλης", "official_name:et"=>"Senegali Vabariik", "official_name:gd"=>"Poblachd Sheanagail", "official_name:id"=>"Republik Senegal", "official_name:ja"=>"セネガル共和国", "official_name:lt"=>"Senegalo Respublika", "official_name:pt"=>"República do Senegal", "official_name:sv"=>"Republiken Senegal", "official_name:vi"=>"Cộng hoà Sénégal"	fr	237
wf	"name"=>"Wallis-et-Futuna", "name:af"=>"Wallis-en-Futuna", "name:an"=>"Wallis e Futuna", "name:ar"=>"جزر واليس وفوتونا", "name:be"=>"Уоліс і Футуна", "name:bg"=>"Уолис и Футуна", "name:br"=>"Wallis ha Futuna", "name:ca"=>"Wallis i Futuna", "name:cs"=>"Wallis a Futuna", "name:cy"=>"Wallis a Futuna", "name:da"=>"Wallis og Futuna", "name:de"=>"Wallis und Futuna", "name:dv"=>"ވާލީ އަދި ފުތޫނާ", "name:el"=>"Ουώλλις και Φουτούνα", "name:en"=>"Wallis and Futuna Islands", "name:eo"=>"Valiso kaj Futuno", "name:es"=>"Wallis y Futuna", "name:et"=>"Wallis ja Futuna", "name:eu"=>"Wallis eta Futuna", "name:fa"=>"والیس و فوتونا", "name:fi"=>"Wallis- ja Futunasaaret", "name:fr"=>"Wallis-et-Futuna", "name:fy"=>"Wallis en Fûtûna", "name:ga"=>"Vailís agus Futúna", "name:gl"=>"Wallis e Futuna", "name:he"=>"ואליס ופוטונה", "name:hr"=>"Wallis i Futuna", "name:hu"=>"Wallis és Futuna", "name:id"=>"Wallis dan Futuna", "name:io"=>"Wallis e Futuna Insuli", "name:is"=>"Wallis- og Fútúnaeyjar", "name:it"=>"Wallis e Futuna", "name:ja"=>"ウォリス・フツナ", "name:jv"=>"Wallis lan Futuna", "name:ko"=>"왈리스 퓌튀나", "name:kw"=>"Wallis ha Futuna", "name:la"=>"Vallis et Futuna", "name:lb"=>"Wallis a Futuna", "name:lt"=>"Walliso ir Futuna salos", "name:lv"=>"Volisa un Futuna", "name:mn"=>"Уоллис ба Футуна", "name:mr"=>"वालिस व फुतुना", "name:ms"=>"Wallis dan Futuna", "name:nl"=>"Wallis en Futuna", "name:nn"=>"Wallis- og Futunaøyane", "name:no"=>"Wallis- og Futunaøyene", "name:oc"=>"Wallis e Futuna", "name:pl"=>"Wallis i Futuna", "name:pt"=>"Wallis e Futuna", "name:ro"=>"Wallis şi Futuna", "name:ru"=>"Уоллис и Футуна", "name:se"=>"Wallis ja Futuna", "name:sh"=>"Wallis i Futuna", "name:sk"=>"Wallis a Futuna", "name:sl"=>"Wallis in Futuna", "name:sm"=>"Wallis and Futuna", "name:sr"=>"Валис и Футуна", "name:sv"=>"Wallis- och Futunaöarna", "name:sw"=>"Wallis na Futuna", "name:ta"=>"வலிசும் புட்டூனாவும்", "name:th"=>"หมู่เกาะวาลลิสและหมู่เกาะฟุตูนา", "name:tr"=>"Wallis ve Futuna Adaları", "name:ug"=>"Wallis we Futuna Taqim Aralliri", "name:uk"=>"Волліс і Футуна", "name:vi"=>"Wallis và Futuna", "name:wo"=>"Wallis ak Futuna", "name:zh"=>"瓦利斯和富图纳群岛", "name:ast"=>"Wallis y Futuna", "name:bpy"=>"ৱাল্লিস বারো ফুটুনা", "name:frp"=>"Valis-et-Futuna", "name:lij"=>"Wallis e Fortuna", "name:simple"=>"Wallis and Futuna", "name:be-x-old"=>"Выспы Ўоліс і Футуна", "official_name"=>"Territoire des Îles Wallis et Futuna", "name:zh-min-nan"=>"Wallis kap Futuna", "official_name:en"=>"Territory of Wallis and Futuna Islands", "official_name:es"=>"Territorio de las Islas Wallis y Futuna", "official_name:et"=>"Wallise ja Futuna ühisala", "official_name:vi"=>"Lãnh thổ các đảo Wallis và Futuna"	fr	238
gn	"name"=>"Guinée", "name:af"=>"Guinee", "name:ar"=>"غينيا", "name:be"=>"Гвінея", "name:br"=>"Ginea", "name:ca"=>"República de Guinea", "name:cy"=>"Guinée", "name:da"=>"Guinea", "name:de"=>"Guinea", "name:el"=>"Γουινέα", "name:en"=>"Guinea", "name:eo"=>"Gvineo", "name:es"=>"Guinea", "name:et"=>"Guinea", "name:fa"=>"گینه", "name:fi"=>"Guinea", "name:fr"=>"Guinée", "name:fy"=>"Guinee", "name:ga"=>"An Ghuine", "name:gd"=>"Gini", "name:he"=>"גינאה", "name:hr"=>"Gvineja", "name:hu"=>"Guinea", "name:id"=>"Guinea", "name:is"=>"Gínea", "name:it"=>"Guinea", "name:la"=>"Guinea", "name:lb"=>"Guinea", "name:lt"=>"Gvinėja", "name:lv"=>"Gvineja", "name:mn"=>"Гвиней", "name:nl"=>"Guinee", "name:pl"=>"Gwinea", "name:pt"=>"Guiné", "name:ru"=>"Гвинея", "name:sl"=>"Gvineja", "name:sv"=>"Guinea", "name:th"=>"ประเทศกินี", "name:tr"=>"Gine", "name:uk"=>"Ґвінея", "name:zh"=>"几内亚", "name:zh_py"=>"Jineiya", "name:zh_pyt"=>"Jīnèiyà", "official_name:el"=>"Δημοκρατία της Γουινέας", "official_name:et"=>"Guinea Vabariik", "official_name:gd"=>"Poblachd Ghini", "official_name:id"=>"Republik Guinea", "official_name:lt"=>"Gvinėjos Respublika", "official_name:lv"=>"Gvinejas Republika", "official_name:pt"=>"República da Guiné", "official_name:sv"=>"Republiken Guinea", "official_name:vi"=>"Cộng hòa nhân dân cách mạng Guinée"	fr	240
ml	"name"=>"Mali", "name:ar"=>"مالي", "name:be"=>"Малі", "name:br"=>"Mali", "name:da"=>"Mali", "name:el"=>"Μάλι", "name:en"=>"Mali", "name:eo"=>"Malio", "name:es"=>"Malí", "name:fa"=>"مالی", "name:fi"=>"Mali", "name:fr"=>"Mali", "name:fy"=>"Maly", "name:ga"=>"Mailí", "name:gd"=>"Màili", "name:he"=>"מאלי", "name:hu"=>"Mali", "name:is"=>"Malí", "name:it"=>"Mali", "name:ja"=>"マリ", "name:la"=>"Malium", "name:lt"=>"Malis", "name:lv"=>"Mali", "name:mn"=>"Мали", "name:pl"=>"Mali", "name:ru"=>"Мали", "name:sv"=>"Mali", "name:th"=>"ประเทศมาลี", "name:uk"=>"Малі", "name:zh"=>"马里", "name:haw"=>"Māli", "official_name"=>"République du Mali", "official_name:be"=>"Рэспубліка Малі", "official_name:el"=>"Δημοκρατία του Μάλι", "official_name:en"=>"Republic of Mali", "official_name:id"=>"Republik Mali", "official_name:ja"=>"マリ共和国", "official_name:lt"=>"Malio Respublika", "official_name:lv"=>"Mali Republika", "official_name:sv"=>"Republiken Mali", "official_name:vi"=>"Cộng hòa Mali"	fr	241
mc	"name"=>"Monaco", "name:ar"=>"موناكو", "name:be"=>"Манака", "name:br"=>"Monako", "name:el"=>"Μονακό", "name:en"=>"Monaco", "name:eo"=>"Monako", "name:es"=>"Mónaco", "name:fa"=>"موناکو", "name:fi"=>"Monaco", "name:fr"=>"Monaco", "name:fy"=>"Monako", "name:ga"=>"Monacó", "name:he"=>"מונקו", "name:hu"=>"Monaco", "name:id"=>"Monako", "name:is"=>"Mónakó", "name:ja"=>"モナコ", "name:la"=>"Monoecus", "name:lt"=>"Monakas", "name:lv"=>"Monako", "name:mn"=>"Монако", "name:pl"=>"Monako", "name:ru"=>"Монако", "name:sk"=>"Monako", "name:sl"=>"Monako", "name:sv"=>"Monaco", "name:th"=>"ประเทศโมนาโก", "name:tr"=>"Monako", "name:uk"=>"Монако", "name:zh"=>"摩纳哥", "name:haw"=>"Monako", "name:zh_py"=>"Monage", "name:zh_pyt"=>"Mónàgē", "official_name"=>"Principatu de Múnegu", "official_name:br"=>"Priñselezh Monako", "official_name:el"=>"Πριγκηπάτο του Μονακό", "official_name:en"=>"Principality of Monaco", "official_name:es"=>"Principado de Mónaco", "official_name:fr"=>"Principauté de Monaco", "official_name:id"=>"Kepangeranan Monako", "official_name:it"=>"Principato di Monaco", "official_name:ja"=>"モナコ公国", "official_name:lb"=>"Fürstentum Monaco", "official_name:lt"=>"Monako Kunigaikštystė", "official_name:lv"=>"Monako Firstiste", "official_name:mn"=>"Principatu de Múnegu", "official_name:pl"=>"Księstwo Monako", "official_name:sk"=>"Monacké kniežatstvo", "official_name:sl"=>"Kneževína Monáko", "official_name:sv"=>"Furstendömet Monaco"	fr	242
tg	"name"=>"Togo", "name:ar"=>"توغو", "name:be"=>"Тога", "name:br"=>"Togo", "name:da"=>"Togo", "name:el"=>"Τόγκο", "name:en"=>"Togo", "name:eo"=>"Togo", "name:es"=>"Togo", "name:fa"=>"توگو", "name:fi"=>"Togo", "name:fr"=>"Togo", "name:ga"=>"Tóga", "name:gd"=>"Tògo", "name:he"=>"טוגו", "name:hu"=>"Togo", "name:is"=>"Tógó", "name:it"=>"Togo", "name:la"=>"Togum", "name:lt"=>"Togas", "name:mn"=>"Того", "name:pl"=>"Togo", "name:pt"=>"Togo", "name:ru"=>"Того", "name:sv"=>"Togo", "name:th"=>"ประเทศโตโก", "name:uk"=>"Того", "name:zh"=>"多哥", "name:haw"=>"Tōkō", "name:zh_py"=>"Duoge", "name:zh_pyt"=>"Duōgē", "official_name"=>"République Togolaise", "official_name:br"=>"Republik Togo", "official_name:el"=>"Δημοκρατία του Τόγκο", "official_name:gd"=>"Poblachd Thògo", "official_name:id"=>"Republik Togo", "official_name:lb"=>"Republik Togo", "official_name:lt"=>"Togo Respublika", "official_name:pt"=>"República Togolesa", "official_name:sv"=>"Republiken Togo", "official_name:vi"=>"Cộng hòa Togo"	fr	243
ca	"name"=>"Canada", "name:af"=>"Kanada", "name:ar"=>"كندا", "name:be"=>"Канада", "name:br"=>"Kanada", "name:ca"=>"Canadà", "name:de"=>"Kanada", "name:el"=>"Καναδάς", "name:en"=>"Canada", "name:eo"=>"Kanado", "name:es"=>"Canadá", "name:eu"=>"Kanada", "name:fa"=>"کانادا", "name:fi"=>"Kanada", "name:fr"=>"Canada", "name:fy"=>"Kanada", "name:ga"=>"Ceanada", "name:he"=>"קנדה", "name:hr"=>"Kanada", "name:hu"=>"Kanada", "name:hy"=>"Կանադա", "name:id"=>"Kanada", "name:is"=>"Kanada", "name:it"=>"Canada", "name:ja"=>"カナダ", "name:lb"=>"Kanada", "name:lt"=>"Kanada", "name:lv"=>"Kanāda", "name:mn"=>"Канад", "name:pl"=>"Kanada", "name:pt"=>"Canadá", "name:ru"=>"Канада", "name:sl"=>"Kanada", "name:sv"=>"Kanada", "name:th"=>"ประเทศแคนาดา", "name:tr"=>"Kanada", "name:uk"=>"Канада", "name:zh"=>"加拿大", "name:zh_py"=>"Jianada", "name:zh_pyt"=>"Jiānádà"	\N	244
at	"name"=>"Österreich", "name:af"=>"Oostenryk", "name:ar"=>"النمسا", "name:be"=>"Аўстрыя", "name:bg"=>"Австрия", "name:br"=>"Aostria", "name:ca"=>"Àustria", "name:cs"=>"Rakousko", "name:cy"=>"Awstria", "name:da"=>"Østrig", "name:el"=>"Αυστρία", "name:en"=>"Austria", "name:eo"=>"Aŭstrio", "name:es"=>"Austria", "name:et"=>"Austria", "name:fa"=>"اتریش", "name:fi"=>"Itävalta", "name:fr"=>"Autriche", "name:fy"=>"Eastenryk", "name:ga"=>"An Ostair", "name:gd"=>"An Ostair", "name:he"=>"אוסטריה", "name:hr"=>"Austrija", "name:hu"=>"Ausztria", "name:hy"=>"Ավստրիա", "name:id"=>"Austria", "name:is"=>"Austurríki", "name:it"=>"Austria", "name:ja"=>"オーストリア", "name:la"=>"Austria", "name:lb"=>"Éisträich", "name:li"=>"Oosteriek", "name:lt"=>"Austrija", "name:lv"=>"Austrija", "name:mn"=>"Австри", "name:nl"=>"Oostenrijk", "name:pl"=>"Austria", "name:ro"=>"Austria", "name:ru"=>"Австрия", "name:sk"=>"Rakúsko", "name:sl"=>"Avstrija", "name:sv"=>"Österrike", "name:th"=>"ประเทศออสเตรีย", "name:tr"=>"Avusturya", "name:uk"=>"Австрія", "name:vi"=>"Áo", "name:zh"=>"奥地利", "name:haw"=>"‘Aukekulia", "name:zh_py"=>"Audili", "name:zh_pyt"=>"Àodìlì", "official_name:el"=>"Δημοκρατία της Αυστρίας", "official_name:fr"=>"République d'Autriche", "official_name:id"=>"Republik Austria", "official_name:it"=>"Repubblica d'Austria", "official_name:ja"=>"オーストリア共和国", "official_name:lb"=>"Republik Éisträich", "official_name:lt"=>"Austrijos Respublika", "official_name:lv"=>"Austrijas Republika", "official_name:sk"=>"Rakúska republika", "official_name:sv"=>"Republiken Österrike", "official_name:vi"=>"Cộng hòa Áo"	de	245
li	"name"=>"Liechtenstein", "name:ar"=>"ليختنشتاين", "name:be"=>"Ліхтэнштэйн", "name:br"=>"Liechtenstein", "name:el"=>"Λιχτενστάιν", "name:eo"=>"Liĥtenŝtejno", "name:fa"=>"لیختن‌اشتاین", "name:fi"=>"Liechtenstein", "name:fr"=>"Liechtenstein", "name:fy"=>"Lychtenstein", "name:ga"=>"Lichtinstéin", "name:he"=>"ליכטנשטיין", "name:hr"=>"Lihtenštajn", "name:hu"=>"Liechtenstein", "name:is"=>"Liechtenstein", "name:ja"=>"リヒテンシュタイン", "name:la"=>"Lichtenstenum", "name:lt"=>"Lichtenšteinas", "name:lv"=>"Lihtenšteina", "name:mn"=>"Лихтенштейн", "name:pl"=>"Liechtenstein", "name:ru"=>"Лихтенштейн", "name:sk"=>"Lichtenštajnsko", "name:sl"=>"Lihtenštajn", "name:sv"=>"Liechtenstein", "name:th"=>"ประเทศลิกเตนสไตน์", "name:tr"=>"Lihtenştayn", "name:uk"=>"Ліхтенштейн", "name:zh"=>"列支敦士登", "name:haw"=>"Likenekaina", "name:zh_py"=>"Liezhidunshideng", "name:zh_pyt"=>"Lièzhīdūnshìdēng", "official_name"=>"Fürstentum Liechtenstein", "official_name:be"=>"Княства Ліхтэнштэйн", "official_name:br"=>"Priñselezh Liechtenstein", "official_name:de"=>"Fürstentum Liechtenstein", "official_name:el"=>"Πριγκηπάτο του Λιχτενστάιν", "official_name:en"=>"Principality of Liechtenstein", "official_name:es"=>"Principado de Liechtenstein", "official_name:id"=>"Kepangeranan Liechtenstein", "official_name:it"=>"Principato del Liechtenstein", "official_name:ja"=>"リヒテンシュタイン公国", "official_name:lb"=>"Fürstentum Liechtenstein", "official_name:lt"=>"Lichtenšteino Kunigaikštystė", "official_name:lv"=>"Lihtenšteinas Firstiste", "official_name:pl"=>"Księstwo Liechtenstein", "official_name:ru"=>"Кня́жество Лихтенште́йн", "official_name:sk"=>"Lichtenštajnské kniežatstvo", "official_name:sl"=>"Kneževina Líhtenštajn", "official_name:sv"=>"Furstendömet Liechtenstein", "official_name:vi"=>"Công quốc Liechtenstein"	de	246
cw	"name"=>"Curaçao", "name:en"=>"Curaçao", "name:es"=>"Curazao", "name:fr"=>"Curaçao", "name:ru"=>"Кюрасао", "name:sv"=>"Curaçao", "name:pap"=>"Kòrsou"	\N	248
sx	"name"=>"Sint Maarten"	\N	249
ad	"name"=>"Andorra", "name:ar"=>"أندورا", "name:be"=>"Андора", "name:bg"=>"Андора", "name:br"=>"Andorra", "name:ca"=>"Andorra", "name:el"=>"Ανδόρρα", "name:eo"=>"Andoro", "name:fa"=>"آندورا", "name:fi"=>"Andorra", "name:fr"=>"Andorre", "name:ga"=>"Andóra", "name:he"=>"אנדורה", "name:hr"=>"Andora", "name:hu"=>"Andorra", "name:hy"=>"Անդորրա", "name:is"=>"Andorra", "name:it"=>"Andorra", "name:ja"=>"アンドラ", "name:ka"=>"ანდორა", "name:ko"=>"안도라", "name:lt"=>"Andora", "name:lv"=>"Andora", "name:mn"=>"Андорра", "name:oc"=>"Andòrra", "name:pl"=>"Andora", "name:pt"=>"Andorra", "name:ru"=>"Андорра", "name:sk"=>"Andorra", "name:sl"=>"Andora", "name:sv"=>"Andorra", "name:th"=>"ประเทศอันดอร์รา", "name:uk"=>"Андора", "name:zh"=>"安道尔", "name:haw"=>"‘Anakola", "name:sco"=>"Andorrae", "name:zh_py"=>"Andaoer", "name:zh_pyt"=>"Āndàoěr", "official_name:el"=>"Πριγκηπάτο της Ανδόρρας", "official_name:fi"=>"Andorran ruhtinaskunta", "official_name:fr"=>"Principauté d'Andorre", "official_name:id"=>"Kepangeranan Andorra", "official_name:ja"=>"アンドラ公国", "official_name:la"=>"Principatus Andorrae", "official_name:lt"=>"Andoros Kunigaikštystė", "official_name:lv"=>"Andoras Firstiste", "official_name:pt"=>"Principado de Andorra", "official_name:sk"=>"Andorrské kniežatstvo", "official_name:sv"=>"Furstendömet Andorra", "official_name:vi"=>"Công quốc Andorra"	ca	35
ai	"name"=>"Anguilla", "name:ar"=>"أنجويلا", "name:az"=>"Angilya", "name:br"=>"Anguilla", "name:el"=>"Ανγκουίλα", "name:en"=>"Anguilla", "name:eo"=>"Angvilo", "name:es"=>"Anguila", "name:eu"=>"Angila", "name:fa"=>"آنگویلا", "name:fi"=>"Anguilla", "name:fr"=>"Anguilla", "name:ga"=>"Angaíle", "name:he"=>"אנגווילה", "name:hr"=>"Angvila", "name:hu"=>"Anguilla", "name:is"=>"Angvilla", "name:lt"=>"Angilija", "name:lv"=>"Angilja", "name:mn"=>"Ангилья", "name:pl"=>"Anguilla", "name:ru"=>"Ангилья", "name:sl"=>"Angvila", "name:sv"=>"Anguilla", "name:th"=>"แองกวิลลา", "name:uk"=>"Ангілья", "name:zh"=>"安圭拉"	en	175
am	"name"=>"Armenia", "name:af"=>"Armenië", "name:ar"=>"أرمينيا", "name:az"=>"Ermənistan", "name:be"=>"Арменія", "name:br"=>"Armenia", "name:ca"=>"Armènia", "name:da"=>"Armenien", "name:de"=>"Armenien", "name:el"=>"Αρμενία", "name:en"=>"Armenia", "name:eo"=>"Armenio", "name:fa"=>"ارمنستان", "name:fi"=>"Armenia", "name:fr"=>"Arménie", "name:fy"=>"Armeenje", "name:ga"=>"An Airméin", "name:gd"=>"Airmeinia", "name:he"=>"ארמניה", "name:hu"=>"Örményország", "name:hy"=>"Հայաստան", "name:is"=>"Armenía", "name:it"=>"Armenia", "name:ja"=>"アルメニア", "name:lb"=>"Armenien", "name:li"=>"Armenië", "name:lt"=>"Armėnija", "name:lv"=>"Armēnija", "name:mn"=>"Армен", "name:nl"=>"Armenië", "name:pl"=>"Armenia", "name:pt"=>"Armênia", "name:ru"=>"Армения", "name:sl"=>"Armenija", "name:sv"=>"Armenien", "name:th"=>"ประเทศอาร์เมเนีย", "name:tr"=>"Ermenistan", "name:uk"=>"Вірменія", "name:zh"=>"亚美尼亚", "name:haw"=>"‘Āmēnia", "name:zh_py"=>"Yameiniya", "name:zh_pyt"=>"Yàměiníyà", "official_name"=>"Republic of Armenia", "official_name:el"=>"Δημοκρατία της Αρμενίας", "official_name:fi"=>"Armenian tasavalta", "official_name:fr"=>"République d'Arménie", "official_name:id"=>"Republik Armenia", "official_name:it"=>"Repubblica di Armenia", "official_name:lt"=>"Armėnijos Respublika", "official_name:lv"=>"Armēnijas Republika", "official_name:pl"=>"Republika Armenii", "official_name:sv"=>"Republiken Armenien", "official_name:vi"=>"Cộng hoà Armenia"	hy	33
ao	"name"=>"Angola", "name:ar"=>"أنغولا", "name:az"=>"Anqola", "name:be"=>"Ангола", "name:br"=>"Angola", "name:ca"=>"Angola", "name:co"=>"Angola", "name:el"=>"Αγκόλα", "name:en"=>"Angola", "name:eo"=>"Angolo", "name:es"=>"Angola", "name:fa"=>"آنگولا", "name:fi"=>"Angola", "name:fr"=>"Angola", "name:fy"=>"Angoala", "name:ga"=>"Angóla", "name:he"=>"אנגולה", "name:hu"=>"Angola", "name:is"=>"Angóla", "name:it"=>"Angola", "name:ja"=>"アンゴラ", "name:la"=>"Angolia", "name:lv"=>"Angola", "name:mn"=>"Ангол", "name:pl"=>"Angola", "name:pt"=>"Angola", "name:ru"=>"Ангола", "name:sv"=>"Angola", "name:th"=>"ประเทศแองโกลา", "name:uk"=>"Ангола", "name:zh"=>"安哥拉", "name:zh_py"=>"Angela", "name:zh_pyt"=>"Āngēlā", "official_name"=>"República de Angola", "official_name:el"=>"Δημοκρατία της Αγκόλας", "official_name:en"=>"Republic of Angola", "official_name:fi"=>"Angolan tasavalta", "official_name:fr"=>"République d'Angola", "official_name:gd"=>"Poblachd Angola", "official_name:id"=>"Republik Angola", "official_name:lb"=>"Republik Angola", "official_name:lt"=>"Angolos Respublika", "official_name:lv"=>"Angolas Republika", "official_name:pt"=>"República de Angola", "official_name:sv"=>"Republiken Angola"	pt	85
bq	\N	nl	250
ar	"name"=>"Argentina", "name:af"=>"Argentinië", "name:ar"=>"الأرجنتين", "name:be"=>"Аргенціна", "name:br"=>"Arc’hantina", "name:cy"=>"Yr Ariannin", "name:de"=>"Argentinien", "name:el"=>"Αργεντινή", "name:en"=>"Argentina", "name:eo"=>"Argentino", "name:fa"=>"آرژانتین", "name:fi"=>"Argentiina", "name:fr"=>"Argentine", "name:fy"=>"Argentynje", "name:ga"=>"An Airgintín", "name:gd"=>"An Argantain", "name:he"=>"ארגנטינה", "name:hu"=>"Argentína", "name:hy"=>"Արգենտինա", "name:is"=>"Argentína", "name:it"=>"Argentina", "name:ja"=>"アルゼンチン", "name:lb"=>"Argentinien", "name:li"=>"Argentinië", "name:lv"=>"Argentīna", "name:mn"=>"Аргентин", "name:nl"=>"Argentinië", "name:pl"=>"Argentyna", "name:pt"=>"Argentina", "name:ru"=>"Аргентина", "name:sl"=>"Argentina", "name:sv"=>"Argentina", "name:th"=>"ประเทศอาร์เจนตินา", "name:tr"=>"Arjantin", "name:uk"=>" Аргентина", "name:zh"=>"阿根廷", "name:haw"=>"‘Alekina", "official_name"=>"República Argentina", "official_name:el"=>"Δημοκρατία της Αργεντινής", "official_name:en"=>"Argentine Republic", "official_name:fi"=>"Argentiinan tasavalta", "official_name:fr"=>"République argentine", "official_name:id"=>"Republik Argentina", "official_name:lb"=>"Republik Argentinien", "official_name:lt"=>"Argentinos Respublika", "official_name:lv"=>"Argentīnas Republika", "official_name:pl"=>"Republika Argentyńska", "official_name:pt"=>"República Argentina", "official_name:sv"=>"Republiken Argentina", "official_name:vi"=>"Cộng hòa Argentina"	es	39
au	"name"=>"Australia", "name:af"=>"Australië", "name:ar"=>"أستراليا", "name:az"=>"Avstraliya", "name:be"=>"Аўстралія", "name:br"=>"Aostralia", "name:ca"=>"Austràlia", "name:cy"=>"Awstralia", "name:da"=>"Australien", "name:de"=>"Australien", "name:el"=>"Αυστραλία", "name:en"=>"Australia", "name:eo"=>"Aŭstralio", "name:et"=>"Austraalia", "name:fa"=>"استرالیا", "name:fi"=>"Australia", "name:fr"=>"Australie", "name:fy"=>"Austraalje", "name:ga"=>"An Astráil", "name:gd"=>"Astràilia", "name:he"=>"אוסטרליה", "name:hu"=>"Ausztrália", "name:hy"=>"Ավստրալիա", "name:is"=>"Ástralía", "name:it"=>"Australia", "name:ja"=>"オーストラリア", "name:lb"=>"Australien", "name:li"=>"Australië", "name:lt"=>"Australija", "name:lv"=>"Austrālija", "name:mn"=>"Австрали", "name:nl"=>"Australië", "name:pl"=>"Australia", "name:pt"=>"Austrália", "name:ru"=>"Австралия", "name:sl"=>"Avstralija", "name:sv"=>"Australien", "name:th"=>"ประเทศออสเตรเลีย", "name:tr"=>"Avustralya", "name:uk"=>"Австралія", "name:vi"=>"Úc", "name:zh"=>"澳大利亚", "official_name"=>"Commonwealth of Australia", "official_name:be"=>"Аўстралійскі саюз", "official_name:el"=>"Κοινοπολιτεία της Αυστραλίας", "official_name:es"=>"Mancomunidad de Australia", "official_name:fi"=>"Australian liittovaltio", "official_name:fr"=>"Commonwealth d’Australie", "official_name:id"=>"Negara Persemakmuran Australia", "official_name:lv"=>"Austrālijas Savienība", "official_name:pl"=>"Związek Australijski", "official_name:pt"=>"Comunidade da Austrália", "official_name:sv"=>"Australiska statsförbundet", "official_name:vi"=>"Liên bang Úc"	en	139
az	"name"=>"Azerbaijan", "name:af"=>"Azerbeidjan", "name:ar"=>"أذربيجان", "name:az"=>"Azərbaycan", "name:be"=>"Азербайджан", "name:br"=>"Azerbaidjan", "name:ca"=>"Azerbaidjan", "name:da"=>"Aserbajdsjan", "name:de"=>"Aserbaidschan", "name:el"=>"Αζερμπαϊτζάν", "name:en"=>"Azerbaijan", "name:eo"=>"Azerbajĝano", "name:es"=>"Azerbaiyán", "name:et"=>"Aserbaidžaan", "name:fa"=>"آذربایجان", "name:fi"=>"Azerbaidžan", "name:fr"=>"Azerbaïdjan", "name:fy"=>"Azerbeidzjan", "name:ga"=>"An Asarbaiseáin", "name:gd"=>"Asarbaidean", "name:he"=>"אזרבייג'ן", "name:hr"=>"Azerbejdžan", "name:hu"=>"Azerbajdzsán", "name:hy"=>"Ադրբեջան", "name:is"=>"Aserbaídsjan", "name:it"=>"Azerbaigian", "name:ja"=>"アゼルバイジャン", "name:la"=>"Adrabigania", "name:lb"=>"Aserbaidschan", "name:li"=>"Azerbaidzjan", "name:lt"=>"Azerbaidžanas", "name:lv"=>"Azerbaidžāna", "name:mn"=>"Азербайжан", "name:nb"=>"Aserbajdsjan", "name:nl"=>"Azerbeidzjan", "name:nn"=>"Aserbajdsjan", "name:no"=>"Aserbajdsjan", "name:pl"=>"Azerbejdżan", "name:pt"=>"Azerbaijão", "name:ru"=>"Азербайджан", "name:sl"=>"Azerbajdžan", "name:sv"=>"Azerbajdzjan", "name:th"=>"ประเทศอาเซอร์ไบจาน", "name:tr"=>"Azerbaycan", "name:uk"=>"Азербаджайн", "name:zh"=>"阿塞拜疆", "name:haw"=>"‘Akepaikana", "name:zh_py"=>"Asaibaijiang", "name:zh_pyt"=>"Āsàibàijiāng", "official_name"=>"Republic of Azerbaijan", "official_name:az"=>"Azərbaycan Respublikası", "official_name:el"=>"Δημοκρατία του Αζερμπαϊτζάν", "official_name:fa"=>"جمهوری آذربایجان", "official_name:fi"=>"Azerbaidžanin tasavalta", "official_name:id"=>"Republik Azerbaijan", "official_name:it"=>"Repubblica dell'Azerbaigian", "official_name:lt"=>"Azerbaidžano Respublika", "official_name:lv"=>"Azerbaidžānas Republika", "official_name:pl"=>"Republika Azerbejdżanu", "official_name:pt"=>"República do Azerbaijão", "official_name:sv"=>"Republiken Azerbajdzjan", "official_name:vi"=>"Cộng hoà Azerbaijan"	az	119
bd	"name"=>"Bangladesh", "name:af"=>"Bangladesj", "name:ar"=>"بنغلاديش", "name:az"=>"Banqladeş", "name:be"=>"Бангладэш", "name:br"=>"Bangladesh", "name:ca"=>"Bangla Desh", "name:da"=>"Bangladesh", "name:de"=>"Bangladesch", "name:el"=>"Μπανγκλαντές", "name:en"=>"Bangladesh", "name:eo"=>"Bangladeŝo", "name:fa"=>"بنگلادش", "name:fi"=>"Bangladesh", "name:fr"=>"Bangladesh", "name:fy"=>"Banglades", "name:ga"=>"An Bhangladéis", "name:gd"=>"Bangladais", "name:he"=>"בנגלדש", "name:hr"=>"Bangladeš", "name:hu"=>"Banglades", "name:is"=>"Bangladess", "name:it"=>"Bangladesh", "name:ja"=>"バングラデシュ", "name:la"=>"Bangladesha", "name:lb"=>"Bangladesch", "name:li"=>"Bangladesj", "name:lt"=>"Bangladešas", "name:lv"=>"Bangladeša", "name:mn"=>"Бангладеш", "name:pl"=>"Bangladesz", "name:pt"=>"Bangladesh", "name:ru"=>"Бангладеш", "name:sl"=>"Bangladeš", "name:sv"=>"Bangladesh", "name:th"=>"ประเทศบังกลาเทศ", "name:tr"=>"Bangladeş", "name:uk"=>"Бангладеш", "name:zh"=>"孟加拉国", "name:haw"=>"Banagaladesa", "name:zh_py"=>"Mengjialaguo", "name:zh_pyt"=>"Mèngjiālāguó", "official_name:el"=>"Λαϊκή Δημοκρατία του Μπανγκλαντές", "official_name:fi"=>"Belgian kuningaskunta", "official_name:id"=>"Republik Rakyat Bangladesh", "official_name:it"=>"Repubblica Popolare del Bangladesh", "official_name:la"=>"Res Publica Popularis Bangladeshae", "official_name:lt"=>"Bangladešo Liaudies Respublika", "official_name:lv"=>"Bangladešas Tautas Republika", "official_name:pl"=>"Ludowa Republika Bangladeszu", "official_name:pt"=>"República Popular do Bangladesh", "official_name:sv"=>"Folkrepubliken Bangladesh", "official_name:vi"=>"Cộng hoà Nhân dân Bangladesh"	bn	158
my	"name"=>"Malaysia", "name:af"=>"Maleisië", "name:ar"=>"ماليزي", "name:az"=>"Malayziya", "name:be"=>"Малайзія", "name:br"=>"Malaysia", "name:ca"=>"Malàisia", "name:el"=>"Μαλαισία", "name:en"=>"Malaysia", "name:eo"=>"Malajzio", "name:es"=>"Malasia", "name:et"=>"Malaisia", "name:fa"=>"مالزی", "name:fi"=>"Malesia", "name:fr"=>"Malaisie", "name:fy"=>"Maleizje", "name:ga"=>"An Mhalaeisia", "name:gd"=>"Malaidhsia", "name:he"=>"מלזיה", "name:hr"=>"Malezija", "name:hu"=>"Malajzia", "name:is"=>"Malasía", "name:it"=>"Malesia", "name:ja"=>"マレーシア", "name:la"=>"Malaesia", "name:lt"=>"Malaizija", "name:lv"=>"Malaizija", "name:mn"=>"Малайз", "name:nl"=>"Maleisië", "name:pl"=>"Malezja", "name:ru"=>"Малайзия", "name:sl"=>"Malezija", "name:sv"=>"Malaysia", "name:th"=>"ประเทศมาเลเซีย", "name:tr"=>"Malezya", "name:uk"=>"Малайзія", "name:zh"=>"马来西亚", "name:haw"=>"Malaisia", "name:zh_py"=>"Malaixiya", "name:zh_pyt"=>"Mǎláixīyà", "official_name:lv"=>"Malaizijas Federācija", "official_name:pl"=>"Federacja Malezji"	ms	7
bh	"name"=>"البحرين", "name:af"=>"Bahrein", "name:ar"=>"البحرين", "name:be"=>"Бахрэйн", "name:br"=>"Bahrein", "name:ca"=>"Bahrain", "name:cy"=>"Bahrain", "name:da"=>"Bahrain", "name:de"=>"Bahrain", "name:el"=>"Μπαχρέιν", "name:en"=>"Bahrain", "name:eo"=>"Barejno", "name:es"=>"Bahréin", "name:et"=>"Bahrein", "name:fa"=>"بحرين", "name:fi"=>"Bahrain", "name:fr"=>"Bahreïn", "name:fy"=>"De Barein", "name:ga"=>"Bairéin", "name:gd"=>"Bachrain", "name:he"=>"בחריין", "name:hr"=>"Bahrein", "name:hu"=>"Bahrein", "name:id"=>"Bahrain", "name:is"=>"Barein", "name:it"=>"Bahrain", "name:ja"=>"バーレーン", "name:la"=>"Baharina", "name:lb"=>"Bahrain", "name:li"=>"Bahrein", "name:lt"=>"Bahreinas", "name:lv"=>"Bahreina", "name:mn"=>"Бахрейн", "name:nl"=>"Bahrein", "name:pl"=>"Bahrajn", "name:pt"=>"Bahrein", "name:ru"=>"Бахрейн", "name:sl"=>"Bahrajn", "name:sv"=>"Bahrain", "name:th"=>"ประเทศบาห์เรน", "name:tr"=>"Bahreyn", "name:uk"=>"Бахрейн", "name:vi"=>"Bahrain", "name:zh"=>"巴林", "name:haw"=>"Baharaina", "name:zh_py"=>"Balin", "name:zh_pyt"=>"Bālín", "official_name"=>"‎مملكة البحرين  (Mamlakat al-Baḥrayn)", "official_name:br"=>"Rouantelezh Bahrein", "official_name:el"=>"Βασίλειο του Μπαχρέιν", "official_name:en"=>"Kingdom of Bahrain", "official_name:et"=>"Bahreini Kuningriik", "official_name:id"=>"Kerajaan Bahrain", "official_name:it"=>"Regno del Bahrain", "official_name:ja"=>"バーレーン王国", "official_name:lt"=>"Bahreino Karalystė", "official_name:lv"=>"Bahreinas Karaliste", "official_name:pl"=>"Królestwo Bahrajnu", "official_name:pt"=>"Reino do Bahrein", "official_name:sv"=>"Konungariket Bahrain", "official_name:vi"=>"Vương quốc Bahrain"	ar	62
bi	"name"=>"Burundi", "name:af"=>"Burundi", "name:ar"=>"بوروندي", "name:be"=>"Бурундзі", "name:br"=>"Burundi", "name:cy"=>"Bwrwndi", "name:da"=>"Burundi", "name:el"=>"Μπουρούντι", "name:en"=>"Burundi", "name:eo"=>"Burundo", "name:es"=>"Burundi", "name:fa"=>"بوروندی", "name:fi"=>"Burundi", "name:fr"=>"Burundi", "name:fy"=>"Bûrûndy", "name:ga"=>"An Bhurúin", "name:gd"=>"Burundaidh", "name:he"=>"בורונדי", "name:hu"=>"Burundi", "name:is"=>"Búrúndí", "name:it"=>"Burundi", "name:ja"=>"ブルンジ", "name:la"=>"Burundia", "name:li"=>"Boeroendi", "name:lt"=>"Burundis", "name:lv"=>"Burundija", "name:mn"=>"Бурунди", "name:pl"=>"Burundi", "name:ru"=>"Бурунди", "name:sv"=>"Burundi", "name:th"=>"ประเทศบุรุนดี", "name:uk"=>"Бурунді", "name:zh"=>"布隆迪", "name:haw"=>"Buruni", "name:zh_py"=>"Bulongdi", "name:zh_pyt"=>"Bùlóngdí", "official_name"=>"Republika y'u Burundi;Republique du Burundi", "official_name:el"=>"Δημοκρατία του Μπουρούντι", "official_name:fi"=>"Burundin tasavalta", "official_name:lb"=>"Republik Burundi", "official_name:lt"=>"Burundžio Respublika", "official_name:lv"=>"Burundijas Republika", "official_name:sv"=>"Republiken Burundi", "official_name:vi"=>"Cộng hòa Burundi"	fr	61
bn	"name"=>"Brunei Darussalam", "name:af"=>"Broenei", "name:ar"=>"بروني دار السلام", "name:be"=>"Бруней", "name:br"=>"Brunei", "name:cy"=>"Brunei", "name:da"=>"Brunei", "name:el"=>"Μπρουνέι", "name:en"=>"Brunei Darussalam", "name:eo"=>"Brunejo", "name:es"=>"Brunéi", "name:et"=>"Brunei", "name:eu"=>"Brunei", "name:fa"=>"برونئی", "name:fi"=>"Brunei", "name:fr"=>"Brunei", "name:fy"=>"Brûnei", "name:ga"=>"Brúiné", "name:gd"=>"Brùnaidh", "name:he"=>"ברוניי", "name:hr"=>"Burneji", "name:hu"=>"Brunei", "name:id"=>"Brunei", "name:is"=>"Brúnei", "name:it"=>"Brunei", "name:la"=>"Bruneium", "name:lb"=>"Brunei", "name:li"=>"Broenai", "name:lt"=>"Brunėjaus Darusalamas", "name:lv"=>"Bruneja", "name:mn"=>"Бруней", "name:nl"=>"Brunei", "name:pl"=>"Brunei", "name:pt"=>"Brunei", "name:ru"=>"Бруней-Даруссалам", "name:sl"=>"Brunej", "name:sv"=>"Brunei", "name:th"=>"ประเทศบรูไนดารุสซาลาม", "name:tr"=>"Bruney", "name:uk"=>"Бруней", "name:vi"=>"Brunei", "name:zh"=>"文莱", "name:haw"=>"Brunei", "name:zh_py"=>"Wenlai", "name:zh_pyt"=>"Wénlái", "official_name:fi"=>"Brunei Darussalamin valtio", "official_name:lv"=>"Brunejas Darusalamas Valsts", "official_name:pl"=>"Państwo Brunei Darussalam", "official_name:pt"=>"Estado do Brunei Darussalam", "official_name:sv"=>"Brunei Darussalam", "official_name:vi"=>"Vương quốc Hồi giáo Brunei"	ms	86
br	"name"=>"Brasil", "name:af"=>"Brasilië", "name:ar"=>"البرازيل", "name:be"=>"Бразілія", "name:br"=>"Brazil", "name:da"=>"Brasilien", "name:de"=>"Brasilien", "name:el"=>"Βραζιλία", "name:en"=>"Brazil", "name:eo"=>"Brzilo", "name:et"=>"Brasiilia", "name:fa"=>"برزیل", "name:fi"=>"Brasilia", "name:fr"=>"Brésil", "name:fy"=>"Brazylje", "name:ga"=>"An Bhrasaíl", "name:gd"=>"Braisil", "name:he"=>"ברזיל", "name:hr"=>"Brazil", "name:hu"=>"Brazília", "name:hy"=>"Բրազիլիա", "name:is"=>"Brasilía", "name:it"=>"Brasile", "name:ja"=>"ブラジル", "name:la"=>"Brasilia", "name:lb"=>"Brasilien", "name:li"=>"'t Braziel", "name:lt"=>"Brazilija", "name:lv"=>"Brazīlija", "name:mn"=>"Бразил", "name:nl"=>"Brazilië", "name:pl"=>"Brazylia", "name:ru"=>"Бразилия", "name:sl"=>"Brazilija", "name:sv"=>"Brasilien", "name:th"=>"ประเทศบราซิล", "name:tr"=>"Brezilya", "name:uk"=>"Бразилія", "name:zh"=>"巴西", "official_name"=>"República Federativa do Brasil", "official_name:el"=>"Ομοσπονδιακή Δημοκρατία της Βραζιλίας", "official_name:en"=>"Federative Republic of Brazil", "official_name:es"=>"República Federativa del Brasil", "official_name:fi"=>"Brasilian liittotasavalta", "official_name:fr"=>"République fédérative du Brésil", "official_name:id"=>"Republik Federal Brasil", "official_name:ja"=>"ブラジル連邦共和国", "official_name:lt"=>"Brazilijos Federacinė Respublika", "official_name:lv"=>"Brazīlijas Federatīvā Republika", "official_name:pl"=>"Federacyjna Republika Brazylii", "official_name:sv"=>"Förbundsrepubliken Brasilien", "official_name:vi"=>"Cộng hòa Liên bang Brasil"	pt	121
fk	"name"=>"Falkland Islands", "name:af"=>"Falklandeilande", "name:ar"=>"جزر الفولكلاند", "name:be"=>"Фалклендскія астравы", "name:br"=>"Inizi Maloù", "name:ca"=>"Illes Malvines", "name:cy"=>"Ynysoedd y Falklands", "name:da"=>"Falklandsøerne", "name:de"=>"Falklandinseln", "name:en"=>"Falkland Islands", "name:eo"=>"Falklandoj", "name:es"=>"Islas Malvinas", "name:et"=>"Falklandi saared", "name:fa"=>"جزایر فالکلند", "name:fi"=>"Falklandinsaaret", "name:fr"=>"Îles Malouines", "name:fy"=>"Falklâneilannen", "name:ga"=>"Oileáin Fháclainne", "name:gd"=>"Na h-Eileanan Fàclainn", "name:he"=>"איי פוקלנד", "name:hr"=>"Falklandski Otoci", "name:hu"=>"Falkland-szigetek", "name:id"=>"Kepulauan Falkland", "name:is"=>"Falklandseyjar", "name:la"=>"Insulae Malvinae", "name:lt"=>"Malvinų salos", "name:lv"=>"Folklenda salas", "name:mn"=>"Фолклендийн Арлууд", "name:nl"=>"Falklandeilanden", "name:pl"=>"Falklandy", "name:ru"=>"Фолклендские Oстрова", "name:sl"=>"Falklandi", "name:sv"=>"Falklandsöarna", "name:th"=>"หมู่เกาะฟอล์กแลนด์", "name:tr"=>"Falkland Adaları", "name:uk"=>"Фолклендські острови", "name:vi"=>"Quần đảo Falkland", "name:zh"=>"福克兰群岛", "official_name:lv"=>"Folklenda (Malvinu) salas"	en	91
cn	"name"=>"China 中国", "name:af"=>"Sjina", "name:ar"=>"الصين", "name:be"=>"Кітай", "name:br"=>"Sina", "name:ca"=>"Xina", "name:cy"=>"Tsieina", "name:da"=>"Kina", "name:de"=>"China", "name:el"=>"Κίνα", "name:en"=>"China", "name:eo"=>"Ĉinio", "name:es"=>"China", "name:et"=>"Hiina", "name:eu"=>"Txina", "name:fa"=>"چین", "name:fi"=>"Kiina", "name:fr"=>"Chine", "name:fy"=>"Sina", "name:ga"=>"An tSín", "name:gd"=>"Sìona", "name:he"=>"סין", "name:hr"=>"Kina", "name:hu"=>"Kína", "name:hy"=>"Չինաստան", "name:id"=>"Cina", "name:is"=>"Alþýðulýðveldið Kína", "name:it"=>"Cina", "name:ja"=>"中国", "name:la"=>"Sinae", "name:lb"=>"Volleksrepublik China", "name:li"=>"Sjina", "name:lt"=>"Kinija", "name:lv"=>"Ķīna", "name:mn"=>"Хятад", "name:nb"=>"Kina", "name:nl"=>"China", "name:nn"=>"Kina", "name:no"=>"Kina", "name:pl"=>"Chiny", "name:pt"=>"China", "name:ru"=>"Китай", "name:sl"=>"Kitajska", "name:sv"=>"Kina", "name:th"=>"ประเทศจีน", "name:tl"=>"Tsina", "name:tr"=>"Çin Halk Cumhuriyeti", "name:uk"=>"Китай", "name:vi"=>"Trung Hoa", "name:zh"=>"中国", "name:haw"=>"Kina", "name:zh_py"=>"Zhongguo", "name:zh_pyt"=>"Zhōngguó", "official_name"=>"中华人民共和国", "official_name:af"=>"Volksrepubliek van Sjina", "official_name:br"=>"Republik Pobl Sina", "official_name:el"=>"Λαϊκή Δημοκρατία της Κίνας", "official_name:en"=>"People's Republic of China", "official_name:eu"=>"Txinako Herri Errepublika", "official_name:gd"=>"Sluagh-Phoblachd na Sìne", "official_name:hy"=>"Չինաստանի Ժողովրդական Հանրապետություն", "official_name:id"=>"Republik Rakyat Cina", "official_name:it"=>"Repubblica Popolare Cinese", "official_name:ja"=>"中華人民共和国", "official_name:la"=>"Res Publica Popularis Sinarum", "official_name:lb"=>"Volleksrepublik China", "official_name:lt"=>"Kinijos Liaudies Respublika", "official_name:lv"=>"Ķīnas Tautas Republika", "official_name:pl"=>"Chińska Republika Ludowa", "official_name:pt"=>"República Popular da China", "official_name:sl"=>"Ljudska republika Kitajska", "official_name:sv"=>"Folkrepubliken Kina", "official_name:vi"=>"Cộng hòa Nhân dân Trung Hoa", "official_name:zh_py"=>"Zhonghua Renmin Gongheguo", "official_name:zh_pyt"=>"Zhōnghuá Rénmín Gònghéguó"	zh	117
co	"name"=>"Colombia", "name:ar"=>"كولومبيا", "name:be"=>"Калумбія", "name:br"=>"Kolombia", "name:ca"=>"Colòmbia", "name:da"=>"Colombia", "name:de"=>"Kolumbien", "name:el"=>"Κολομβία", "name:en"=>"Colombia", "name:eo"=>"Kolombio", "name:eu"=>"Kolonbia", "name:fa"=>"کلمبیا", "name:fi"=>"Kolumbia", "name:fr"=>"Colombie", "name:fy"=>"Kolombia", "name:ga"=>"An Cholóim", "name:he"=>"קולומביה", "name:hr"=>"Kolumbija", "name:id"=>"Kolombia", "name:is"=>"Kólumbía", "name:it"=>"Colombia", "name:ja"=>"コロンビア", "name:la"=>"Columbia", "name:lb"=>"Kolumbien", "name:lt"=>"Kolumbija", "name:lv"=>"Kolumbija", "name:mn"=>"Колумб", "name:pl"=>"Kolumbia", "name:pt"=>"Colômbia", "name:ru"=>"Колумбия", "name:sl"=>"Kolumbija", "name:sv"=>"Colombia", "name:th"=>"ประเทศโคลอมเบีย", "name:tr"=>"Kolombiya", "name:uk"=>"Колумбія", "name:zh"=>"哥伦比亚", "official_name"=>"República de Colombia", "official_name:be"=>"Рэспубліка Калумбія", "official_name:el"=>"Δημοκρατία της Κολομβίας", "official_name:en"=>"Republic of Colombia", "official_name:fr"=>"République de Colombie", "official_name:id"=>"Republik Kolombia", "official_name:lt"=>"Kolumbijos Respublika", "official_name:pl"=>"Republika Kolumbii", "official_name:sv"=>"Republiken Colombia", "official_name:vi"=>"Cộng hoà Colombia"	es	133
cr	"name"=>"Costa Rica", "name:ar"=>"كوستاريكا", "name:be"=>"Коста Рыка", "name:br"=>"Costa Rica", "name:da"=>"Costa Rica", "name:el"=>"Κόστα Ρίκα", "name:en"=>"Costa Rica", "name:eo"=>"Kostariko", "name:fa"=>"کاستاریکا", "name:fi"=>"Costa Rica", "name:fr"=>"Costa Rica", "name:fy"=>"Kosta Rika", "name:ga"=>"Cósta Ríce", "name:he"=>"קוסטה ריקה", "name:hr"=>"Kostarika", "name:hu"=>"Costa Rica", "name:id"=>"Kosta Rika", "name:is"=>"Kosta Ríka", "name:it"=>"Costa Rica", "name:ja"=>"コスタリカ", "name:la"=>"Ora Opulenta", "name:lt"=>"Kosta Rika", "name:lv"=>"Kostarika", "name:mn"=>"Коста-Рика", "name:pl"=>"Kostaryka", "name:ru"=>"Коста-Рика", "name:sl"=>"Kostarika", "name:sv"=>"Costa Rica", "name:th"=>"ประเทศคอสตาริกา", "name:tr"=>"Kosta Rika", "name:uk"=>"Коста-Ріка", "name:zh"=>"哥斯大黎加", "official_name"=>"República de Costa Rica", "official_name:be"=>"Рэспубліка Коста-Рыка", "official_name:el"=>"Δημοκρατία της Κόστα Ρίκα", "official_name:en"=>"Republic of Costa Rica", "official_name:gd"=>"Poblachd Chosta Rica", "official_name:it"=>"Repubblica di Costa Rica", "official_name:lt"=>"Kosta Rikos Respublika", "official_name:lv"=>"Kostarikas Republika", "official_name:pl"=>"Republika Kostaryki", "official_name:sv"=>"Republiken Costa Rica", "official_name:vi"=>"Cộng hoà Costa Rica"	es	64
cv	"name"=>"Cabo Verde", "name:af"=>"Kaap Verde", "name:ar"=>"الرأس الأخضر", "name:be"=>"Каба-Вердэ", "name:br"=>"Kab Glas", "name:ca"=>"Cap Verd", "name:cy"=>"Cabo Verde", "name:da"=>"Kap Verde", "name:de"=>"Kap Verde", "name:el"=>"Πράσινο Ακρωτήριο", "name:en"=>"Cape Verde", "name:eo"=>"Kabo-Verdo", "name:es"=>"Cabo Verde", "name:et"=>"Roheneemesaared", "name:fa"=>"کیپ ورد", "name:fi"=>"Kap Verde", "name:fr"=>"Cap-Vert", "name:fy"=>"Kaapverdje", "name:ga"=>"Rinn Verde", "name:gd"=>"Cape Verde", "name:he"=>"כף ורדה", "name:hr"=>"Zelenortski Otoci", "name:hu"=>"Zöld-Fok", "name:id"=>"Tanjung Verde", "name:is"=>"Grænhöfðaeyjar", "name:it"=>"Capo Verde", "name:la"=>"Promontorium Viride", "name:lb"=>"Kap Verde", "name:li"=>"Kaapverdië", "name:lt"=>"Žaliasis Kyšulys", "name:lv"=>"Kaboverde", "name:mn"=>"Кабо-Верде", "name:nl"=>"Kaapverdië", "name:pl"=>"Wyspy Zielonego Przylądka", "name:ru"=>"Кабо-Верде", "name:sl"=>"Zelenortski otoki", "name:sv"=>"Kap Verde", "name:th"=>"ประเทศเคปเวิร์ด", "name:tr"=>"Yeşil Burun Adaları", "name:uk"=>"Кабо-Верде", "name:zh"=>"佛得角", "official_name"=>"República de Cabo Verde", "official_name:be"=>"Рэспубліка Каба-Вердэ", "official_name:de"=>"Republik Kap Verde", "official_name:el"=>"Δημοκρατία του Πράσινου Ακρωτηρίου", "official_name:en"=>"Republic of Cape Verde", "official_name:es"=>"República de Cabo Verde", "official_name:he"=>"רפובליקת כֵּף וֶרְדֶּה", "official_name:lt"=>"Žaliojo Kyšulio Respublika", "official_name:lv"=>"Kaboverdes Republika", "official_name:pl"=>"Republika Zielonego Przylądka", "official_name:sl"=>"Republika Zelenortski otoki", "official_name:sv"=>"Republiken Kap Verde", "official_name:vi"=>"Cộng hòa Cabo Verde"	pt	89
gi	"name"=>"Gibraltar", "name:ar"=>"جبل طارق", "name:be"=>"Гібралтар", "name:br"=>"Gibraltar", "name:el"=>"Γιβραλτάρ", "name:eo"=>"Ĝibraltaro", "name:fa"=>"جبل‌الطارق", "name:fi"=>"Gibraltar", "name:fr"=>"Gibraltar", "name:ga"=>"Giobráltar", "name:gd"=>"Giobraltair", "name:he"=>"גיברלטר", "name:hu"=>"Gibraltár", "name:is"=>"Gíbraltar", "name:it"=>"Gibilterra", "name:la"=>"Calpe", "name:lt"=>"Gibraltaras", "name:lv"=>"Gibraltārs", "name:mn"=>"Гибралтар", "name:pl"=>"Gibraltar", "name:ru"=>"Гибралтар", "name:sk"=>"Gibraltár", "name:sv"=>"Gibraltar", "name:th"=>"ยิบรอลตาร์", "name:tr"=>"Cebelitarık", "name:uk"=>"Гібралтар", "name:zh"=>"直布罗陀", "old_name"=>"Mons Calpe", "name:zh_py"=>"Zhibuluotuo", "name:zh_pyt"=>"Zhíbùluótuó"	en	138
cz	"name"=>"Česká republika", "name:af"=>"Tsjeggië", "name:ar"=>"الجمهورية التشيكية", "name:be"=>"Чэхія", "name:br"=>"Republik Tchek", "name:ca"=>"República Txeca", "name:cs"=>"Česká republika", "name:cy"=>"Gweriniaeth Tsiec", "name:da"=>"Tjekkiet", "name:de"=>"Tschechien", "name:el"=>"Τσεχία", "name:en"=>"Czech Republic", "name:eo"=>"Ĉeĥio", "name:es"=>"República Checa", "name:et"=>"Tšehhi", "name:eu"=>"Txekiar Errepublika", "name:fa"=>"جمهوری چک", "name:fi"=>"Tšekki", "name:fr"=>"République tchèque", "name:fy"=>"Tsjechje", "name:ga"=>"Poblacht na Seice", "name:gd"=>"An t-Seic", "name:he"=>"צכיה", "name:hr"=>"Češka", "name:hu"=>"Csehország", "name:id"=>"Republik Ceko", "name:is"=>"Tékkland", "name:it"=>"Cechia", "name:ja"=>"チェコ", "name:la"=>"Bohemia", "name:lb"=>"Tschechien", "name:li"=>"Tsjechië", "name:lt"=>"Čekija", "name:lv"=>"Čehija", "name:mn"=>"Бүгд Найрамдах Чех Улс", "name:nl"=>"Tsjechië", "name:pl"=>"Czechy", "name:pt"=>"República Checa", "name:ru"=>"Чехия", "name:sk"=>"Česko", "name:sl"=>"Češka", "name:sv"=>"Tjeckien", "name:th"=>"สาธารณรัฐเช็ก", "name:tr"=>"Çek Cumhuriyeti", "name:uk"=>"Чеська Республіка", "name:vi"=>"Cộng hòa Séc", "name:zh"=>"捷克", "name:haw"=>"Lepupalika ‘o Tieka", "name:zh_py"=>"Jieke", "name:zh_pyt"=>"Jiékè", "official_name:el"=>"Τσεχική Δημοκρατία", "official_name:it"=>"Repubblica Ceca", "official_name:ja"=>"チェコ共和国", "official_name:la"=>"Res publica Bohemica", "official_name:lb"=>"Tschechesch Republik", "official_name:lt"=>"Čekijos Respublika", "official_name:lv"=>"Čehijas Republika", "official_name:pl"=>"Republika Czeska", "official_name:pt"=>"República Checa", "official_name:ru"=>"Чешская Республика", "official_name:sk"=>"Česká republika", "official_name:sv"=>"Republiken Tjeckien"	cs	124
dk	"name"=>"Danmark", "name:af"=>"Denemarke", "name:ar"=>"الدانمرك", "name:be"=>"Данія", "name:bg"=>"Дания", "name:br"=>"Danmark", "name:ca"=>"Dinamarca", "name:cy"=>"Denmarc", "name:da"=>"Danmark", "name:de"=>"Dänemark", "name:el"=>"Δανία", "name:en"=>"Denmark", "name:eo"=>"Danio", "name:es"=>"Dinamarca", "name:et"=>"Taani", "name:eu"=>"Danimarka", "name:fa"=>"دانمارک", "name:fi"=>"Tanska", "name:fr"=>"Danemark", "name:fy"=>"Denemark", "name:ga"=>"An Danmhairg", "name:gd"=>"An Danmhairg", "name:he"=>"דנמרק", "name:hr"=>"Danska", "name:hu"=>"Dánia", "name:id"=>"Denmark", "name:is"=>"Danmörk", "name:it"=>"Danimarca", "name:ja"=>"デンマーク", "name:la"=>"Dania", "name:lb"=>"Dänemark", "name:li"=>"Daenemark", "name:lt"=>"Danija", "name:lv"=>"Dānija", "name:mn"=>"Дани", "name:nl"=>"Denemarken", "name:pl"=>"Dania", "name:pt"=>"Dinamarca", "name:ru"=>"Дания", "name:sk"=>"Dánsko", "name:sl"=>"Danska", "name:sv"=>"Danmark", "name:th"=>"ประเทศเดนมาร์ก", "name:tr"=>"Danimarka", "name:uk"=>"Данія", "name:vi"=>"Đan Mạch", "name:zh"=>"丹麦", "name:nds"=>"Däänmark", "name:zh_py"=>"Danmai", "name:zh_pyt"=>"Dānmài", "official_name"=>"Kingdom of Denmark", "official_name:be"=>"Каралеўства Данія", "official_name:da"=>"Kongeriget Danmark", "official_name:el"=>"Βασίλειο της Δανίας", "official_name:fr"=>"Royaume du Danemark", "official_name:gd"=>"Rìoghachd na Danmhairg", "official_name:id"=>"Kerajaan Denmark", "official_name:ja"=>"デンマーク王国", "official_name:lb"=>"Kinneksräich Dänemark", "official_name:lt"=>"Danijos Karalystė", "official_name:pt"=>"Reino da Dinamarca", "official_name:sk"=>"Dánske kráľovstvo", "official_name:sv"=>"Konungariket Danmark", "official_name:vi"=>"Vương quốc Đan Mạch"	da	160
do	"name"=>"República Dominicana", "name:af"=>"Dominikaanse Republiek", "name:ar"=>"الجمهورية الدومينيكية", "name:br"=>"Republik Dominikan", "name:cy"=>"Gweriniaeth Dominica", "name:da"=>"Dominikanske Republik", "name:de"=>"Dominikanische Republik", "name:do"=>"República Dominicána", "name:el"=>"Δομινικανή Δημοκρατία", "name:en"=>"Dominican Republic", "name:eo"=>"Domingo", "name:et"=>"Dominikaani Vabariik", "name:fa"=>"جمهوری دومینیکن", "name:fi"=>"Dominikaaninen tasavalta", "name:fr"=>"République Dominicaine", "name:fy"=>"de Dominikaanske Republyk", "name:ga"=>"An Phoblacht Dhoiminiceach", "name:gd"=>"Poblachd Dhoiminicia", "name:he"=>"דומיניק", "name:hr"=>"Dominikanska Republika", "name:hu"=>"Dominikai Köztársaság", "name:id"=>"Republik Dominika", "name:is"=>"Dóminíska lýðveldið", "name:it"=>"Repubblica Dominicana", "name:la"=>"Respublica Dominicana", "name:lb"=>"Dominikanesch Republik", "name:li"=>"Dominicaanse Rippebliek", "name:lt"=>"Dominikos Respublika", "name:lv"=>"Dominikānas Republika", "name:mn"=>"Доминиканы Бүгд Найрамдах Улс", "name:nl"=>"Dominicaanse Republiek", "name:pl"=>"Dominikana", "name:ru"=>"Доминиканская Республика", "name:sl"=>"Dominikanska republika", "name:sv"=>"Dominikanska republiken", "name:th"=>"สาธารณรัฐโดมินิกัน", "name:tr"=>"Dominik Cumhuriyeti", "name:uk"=>"Домініканська Республіка", "name:vi"=>"Cộng hòa Dominicana", "name:zh"=>"多明尼加共和國", "official_name:pl"=>"Republika Dominikańska"	es	37
ee	"name"=>"Eesti", "name:af"=>"Estland", "name:ar"=>"إستونيا", "name:be"=>"Эстонія", "name:br"=>"Estonia", "name:ca"=>"Estònia", "name:cy"=>"Estonia", "name:da"=>"Estland", "name:de"=>"Estland", "name:el"=>"Εσθονία", "name:en"=>"Estonia", "name:eo"=>"Estonio", "name:es"=>"Estonia", "name:eu"=>"Estonia", "name:fa"=>"استونی", "name:fi"=>"Viro", "name:fr"=>"Estonie", "name:fy"=>"Estlân", "name:ga"=>"An Eastóin", "name:gd"=>"Eastòinia", "name:he"=>"אסטוניה", "name:hr"=>"Estonija", "name:hu"=>"Észtország", "name:id"=>"Estonia", "name:is"=>"Eistland", "name:it"=>"Estonia", "name:ja"=>"エストニア", "name:la"=>"Estonia", "name:lb"=>"Estland", "name:li"=>"Esland", "name:lt"=>"Estija", "name:lv"=>"Igaunija", "name:mn"=>"Эстон", "name:nl"=>"Estland", "name:pl"=>"Estonia", "name:ru"=>"Эстония", "name:sk"=>"Estónsko", "name:sl"=>"Estonija", "name:sv"=>"Estland", "name:th"=>"ประเทศเอสโตเนีย", "name:tr"=>"Estonya", "name:uk"=>"Естонія", "name:vi"=>"Estonia", "name:zh"=>"爱沙尼亚", "name:haw"=>"‘Esetonia", "name:zh_py"=>"Aishaniya", "name:zh_pyt"=>"Àishāníyà", "official_name"=>"Eesti Vabariik", "official_name:be"=>"Рэспубліка Эстонія", "official_name:el"=>"Δημοκρατία της Εσθονίας", "official_name:en"=>"Republic of Estonia", "official_name:es"=>"República de Estonia", "official_name:fr"=>"République d'Estonie", "official_name:gd"=>"Poblachd Eastòinia", "official_name:id"=>"Republik Estonia", "official_name:lb"=>"Republik Estland", "official_name:lt"=>"Estijos Respublika", "official_name:lv"=>"Igaunijas Republika", "official_name:pl"=>"Republika Estońska", "official_name:ru"=>"Эсто́нская Респу́блика", "official_name:sk"=>"Estónska republika", "official_name:sv"=>"Republiken Estland", "official_name:vi"=>"Cộng hòa Estonia"	et	125
gw	"name"=>"Guiné-Bissau", "name:af"=>"Guinee-Bissau", "name:ar"=>"غينيا-بيساو", "name:be"=>"Гвінея-Бісаў", "name:br"=>"Ginea-Bissau", "name:ca"=>"Guinea Bissau", "name:cy"=>"Guiné-Bissau", "name:da"=>"Guinea-Bissau", "name:de"=>"Guinea-Bissau", "name:el"=>"Γουινέα-Μπισσάου", "name:en"=>"Guinea-Bissau", "name:eo"=>"Gvineo Bisaŭa", "name:es"=>"Guinea-Bissau", "name:et"=>"Guinea-Bissau", "name:fa"=>"گینه بیسائو", "name:fi"=>"Guinea-Bissau", "name:fr"=>"Guinée-Bissau", "name:fy"=>"Guinee-Bissau", "name:ga"=>"Guine-Bhissau", "name:gd"=>"Gini-Bissau", "name:he"=>"גינאה ביסאו", "name:hr"=>"Gvineja Bisau", "name:hu"=>"Bissau-Guinea", "name:id"=>"Guinea-Bissau", "name:is"=>"Gínea-Bissá", "name:it"=>"Guinea-Bissau", "name:la"=>"Guinea Bissaviensis", "name:lb"=>"Guinea-Bissau", "name:li"=>"Guinee-Bissau", "name:lt"=>"Bisau Gvinėja", "name:lv"=>"Gvineja-Bisava", "name:mn"=>"Гвиней-Бисау", "name:nl"=>"Guinee-Bissau", "name:pl"=>"Gwinea Bissau", "name:ru"=>"Гвинея-Бисау", "name:sl"=>"Gvineja Bissau", "name:sv"=>"Guinea-Bissau", "name:th"=>"ประเทศกินี-บิสเซา", "name:tr"=>"Gine Bissau", "name:uk"=>"Гвінея-Бісау", "name:zh"=>"几内亚比绍", "name:zh_py"=>"Jineiya Bishao", "name:zh_pyt"=>"Jīnèiyà Bǐshào", "official_name"=>"República da Guiné-Bissau", "official_name:be"=>"Рэспубліка Гвінэя-Бісаў", "official_name:el"=>"Δημοκρατία της Γουινέας-Μπισσάου", "official_name:et"=>"Guinea-Bissau Vabariik", "official_name:gd"=>"Poblachd Ghini-Bissau", "official_name:id"=>"Republik Guinea-Bissau", "official_name:lt"=>"Bisau Gvinėjos Respublika", "official_name:lv"=>"Gvinejas-Bisavas Republika", "official_name:sv"=>"Republiken Guinea-Bissau", "official_name:vi"=>"Cộng hòa Guiné-Bissau"	pt	8
hr	"name"=>"Hrvatska", "name:af"=>"Kroasië", "name:ar"=>"كرواتيا", "name:be"=>"Харватыя", "name:br"=>"Kroatia", "name:ca"=>"Croàcia", "name:cy"=>"Croatia", "name:da"=>"Kroatien", "name:de"=>"Kroatien", "name:el"=>"Κροατία", "name:en"=>"Croatia", "name:eo"=>"Kroatio", "name:es"=>"Croacia", "name:et"=>"Horvaatia", "name:fa"=>"کرواسی", "name:fi"=>"Kroatia", "name:fr"=>"Croatie", "name:fy"=>"Kroaasje", "name:ga"=>"An Chróit", "name:gd"=>"Croàisia", "name:he"=>"קרואטיה", "name:hu"=>"Horvátország", "name:hy"=>"Խորվաթիա", "name:id"=>"Kroasia", "name:is"=>"Króatía", "name:it"=>"Croazia", "name:ja"=>"クロアチア", "name:la"=>"Croatia", "name:lb"=>"Kroatien", "name:li"=>"Kroatië", "name:lt"=>"Kroatija", "name:lv"=>"Horvātija", "name:mn"=>"Хорват", "name:nl"=>"Kroatië", "name:pl"=>"Chorwacja", "name:pt"=>"Croácia", "name:ru"=>"Хорватия", "name:sk"=>"Chorvátsko", "name:sl"=>"Hrvaška", "name:sv"=>"Kroatien", "name:th"=>"ประเทศโครเอเชีย", "name:tr"=>"Hırvatistan", "name:uk"=>"Хорватія", "name:vi"=>"Croatia", "name:zh"=>"克罗地亚", "name:haw"=>"Koloatia", "name:zh_py"=>"Keluodiya", "name:zh_pyt"=>"Kèluódìyà", "official_name"=>"Republika Hrvatska", "official_name:be"=>"Рэспубліка Харватыя", "official_name:en"=>"Republic of Croatia", "official_name:es"=>"República de Croacia", "official_name:et"=>"Horvaatia Vabariik", "official_name:id"=>"Republik Kroasia", "official_name:lt"=>"Kroatijos Respublika", "official_name:lv"=>"Horvātijas Republika", "official_name:pl"=>"Republika Chorwacji", "official_name:pt"=>"República da Croácia", "official_name:sk"=>"Chorvátska republika", "official_name:sv"=>"Republiken Kroatien", "official_name:vi"=>"Cộng hòa Croatia"	hr	92
hu	"name"=>"Magyarország", "name:af"=>"Hongarye", "name:ar"=>"هنغاريا", "name:be"=>"Венгрыя", "name:br"=>"Hungaria", "name:ca"=>"Hongria", "name:cy"=>"Hwngari", "name:da"=>"Ungarn", "name:de"=>"Ungarn", "name:el"=>"Ουγγαρία", "name:en"=>"Hungary", "name:eo"=>"Hungario", "name:es"=>"Hungría", "name:et"=>"Ungari", "name:fa"=>"مجارستان", "name:fi"=>"Unkari", "name:fr"=>"Hongrie", "name:fy"=>"Hongarije", "name:ga"=>"An Ungáir", "name:gd"=>"An Ungair", "name:he"=>"הונגריה", "name:hr"=>"Madžarska", "name:hu"=>"Magyarország", "name:hy"=>"Հունգարիա", "name:id"=>"Hongaria", "name:is"=>"Ungverjaland", "name:it"=>"Ungheria", "name:ja"=>"ハンガリー", "name:la"=>"Hungaria", "name:lb"=>"Ungarn", "name:lt"=>"Vengrija", "name:lv"=>"Ungārija", "name:mn"=>"Унгар", "name:nl"=>"Hongarije", "name:pl"=>"Węgry", "name:ro"=>"Ungaria", "name:ru"=>"Венгрия", "name:sk"=>"Maďarsko", "name:sl"=>"Madžarska", "name:sv"=>"Ungern", "name:th"=>"ประเทศฮังการี", "name:tr"=>"Macaristan", "name:uk"=>"Угорщина", "name:vi"=>"Hungary", "name:zh"=>"匈牙利", "name:haw"=>"Hunakalia", "name:zh_py"=>"Xiongyali", "name:zh_pyt"=>"Xiōngyálì", "official_name"=>"Magyar Köztársaság", "official_name:el"=>"Δημοκρατία της Ουγγαρίας", "official_name:en"=>"Republic of Hungary", "official_name:es"=>"República de Hungría", "official_name:et"=>"Ungari Vabariik", "official_name:fr"=>"République de Hongrie", "official_name:id"=>"Republik Hongaria", "official_name:it"=>"Repubblica d'Ungheria", "official_name:ja"=>"ハンガリー共和国", "official_name:lb"=>"Republik Ungarn", "official_name:lt"=>"Vengrijos Respublika", "official_name:lv"=>"Ungārijas Republika", "official_name:pl"=>"Republika Węgier", "official_name:ru"=>"Венге́рская Респу́блика", "official_name:sk"=>"Maďarská republika", "official_name:sv"=>"Republiken Ungern"	hu	45
id	"name"=>"Indonesia", "name:af"=>"Indonesië", "name:ar"=>"إندونيسيا", "name:az"=>"İndoneziya", "name:be"=>"Інданэзія", "name:br"=>"Indonezia", "name:ca"=>"Indonèsia", "name:da"=>"Indonesien", "name:de"=>"Indonesien", "name:el"=>"Ινδονησία", "name:en"=>"Indonesia", "name:eo"=>"Indonezio", "name:et"=>"Indoneesia", "name:fa"=>"اندونزی", "name:fi"=>"Indonesia", "name:fr"=>"Indonésie", "name:fy"=>"Yndoneezje", "name:ga"=>"An Indinéis", "name:gd"=>"An Innd-Innse", "name:he"=>"אינדונזיה", "name:hr"=>"Indonezija", "name:hu"=>"Indonézia", "name:is"=>"Indonesía", "name:it"=>"Indonesia", "name:ja"=>"インドネシア", "name:lb"=>"Indonesien", "name:li"=>"Indonesië", "name:lt"=>"Indonezija", "name:lv"=>"Indonēzija", "name:mn"=>"Индонез", "name:nl"=>"Indonesië", "name:pl"=>"Indonezja", "name:ru"=>"Индонезия", "name:sl"=>"Indonezija", "name:sv"=>"Indonesien", "name:th"=>"ประเทศอินโดนีเซีย", "name:tl"=>"Indonesya", "name:tr"=>"Endonezya", "name:uk"=>"Індонезія", "name:zh"=>"印度尼西亚", "name:haw"=>"‘Inidonesia", "official_name"=>"Republik Indonesia", "official_name:el"=>"Δημοκρατία της Ινδονησίας", "official_name:en"=>"Republic of Indonesia", "official_name:et"=>"Indoneesia Vabariik", "official_name:fr"=>"République d'Indonésie", "official_name:lt"=>"Indonezijos Respublika", "official_name:lv"=>"Indonēzijas Republika", "official_name:pl"=>"Republika Indonezji", "official_name:sv"=>"Republiken Indonesien", "official_name:tl"=>"Republika ng Indonesya", "official_name:vi"=>"Cộng hòa Indonesia"	id	110
il	"name"=>"ישראל", "name:af"=>"Israel", "name:ar"=>"إسرائيل", "name:be"=>"Ізраіль", "name:br"=>"Israel", "name:ca"=>"Israel", "name:cy"=>"Israel", "name:da"=>"Israel", "name:de"=>"Israel", "name:el"=>"Ισραήλ", "name:en"=>"Israel", "name:eo"=>"Israelo", "name:es"=>"Israel", "name:et"=>"Iisrael", "name:fa"=>"اسرائیل", "name:fi"=>"Israel", "name:fr"=>"Israël", "name:fy"=>"Israel", "name:ga"=>"Iosrael", "name:gd"=>"Iosrael", "name:he"=>"ישראל", "name:hr"=>"Izrael", "name:hu"=>"Izrael", "name:hy"=>"Իսրայել", "name:id"=>"Israel", "name:is"=>"Ísrael", "name:it"=>"Israele", "name:ja"=>"イスラエル", "name:la"=>"Israel", "name:lb"=>"Israel", "name:li"=>"Israël", "name:lt"=>"Izraelis", "name:lv"=>"Izraēla", "name:mn"=>"Израйль", "name:nl"=>"Israël", "name:pl"=>"Izrael", "name:pt"=>"Israel", "name:ru"=>"Израиль", "name:sl"=>"Izrael", "name:sv"=>"Israel", "name:th"=>"ประเทศอิสราเอล", "name:tr"=>"İsrail", "name:uk"=>"Ізра́їль", "name:vi"=>"Israel", "name:zh"=>"以色列", "name:haw"=>"ʻIseraʻela", "name:zh_py"=>"Yiselie", "name:zh_pyt"=>"Yǐsèliè", "official_name"=>"מדינת ישראל", "official_name:el"=>"Κράτος του Ισραήλ", "official_name:en"=>"State of Israel", "official_name:es"=>"Estado de Israel", "official_name:et"=>"Iisraeli Riik", "official_name:gd"=>"Stàit Iosrael", "official_name:ja"=>"イスラエル国", "official_name:lb"=>"Staat Israel", "official_name:lv"=>"Izraēlas Valsts", "official_name:pl"=>"Państwo Izraela", "official_name:pt"=>"Estado de Israel", "official_name:ru"=>"Государство Израиль", "official_name:sv"=>"Staten Israel"	en	65
ir	"name"=>"ایران", "name:af"=>"Iran", "name:ar"=>"إيران", "name:az"=>"İran", "name:be"=>"Іран", "name:br"=>"Iran", "name:ca"=>"Iran", "name:cy"=>"Iran", "name:da"=>"Iran", "name:de"=>"Iran", "name:el"=>"Ιράν", "name:en"=>"Iran", "name:eo"=>"Irano", "name:es"=>"Irán", "name:et"=>"Iraan", "name:fa"=>"ایران", "name:fi"=>"Iran", "name:fr"=>"Iran", "name:fy"=>"Iran", "name:ga"=>"An Iaráin", "name:gd"=>"Ioràn", "name:he"=>"אירן", "name:hr"=>"Iran", "name:hu"=>"Irán", "name:hy"=>"Իրան", "name:id"=>"Iran", "name:is"=>"Íran", "name:it"=>"Iran", "name:ja"=>"イラン", "name:la"=>"Irania", "name:lb"=>"Iran", "name:li"=>"Iraan", "name:lt"=>"Iranas", "name:lv"=>"Irāna", "name:mn"=>"Иран", "name:nl"=>"Iran", "name:pl"=>"Iran", "name:pt"=>"Irã", "name:ru"=>"Иран", "name:sl"=>"Iran", "name:sv"=>"Iran", "name:th"=>"ประเทศอิหร่าน", "name:tr"=>"İran", "name:uk"=>"Іран", "name:vi"=>"Iran", "name:zh"=>"伊朗", "name:haw"=>"‘Ilana", "name:zh_py"=>"Yilang", "name:zh_pyt"=>"Yīlǎng", "official_name"=>"جمهوری اسلامی ایران", "official_name:br"=>"Republik Islamek Iran", "official_name:ca"=>"República Islàmica de l'Iran", "official_name:el"=>"Ισλαμική Δημοκρατία του Ιράν", "official_name:en"=>"Islamic Republic of Iran", "official_name:et"=>"Iraani Islamivabariik", "official_name:id"=>"Republik Islam Iran", "official_name:it"=>"Repubblica Islamica dell'Iran", "official_name:ja"=>"イラン・イスラム共和国", "official_name:lb"=>"Islamesch Republik Iran", "official_name:pl"=>"Islamska Republika Iranu", "official_name:pt"=>"República Islâmica do Irã", "official_name:sl"=>"Islamska republika Iran", "official_name:sv"=>"Islamiska republiken Iran", "official_name:vi"=>"Cộng hòa Hồi giáo Iran"	fa	80
is	"name"=>"Ísland", "name:af"=>"Ysland", "name:ar"=>"آيسلندا", "name:be"=>"Ісландыя", "name:br"=>"Island", "name:ca"=>"Islàndia", "name:cy"=>"Gwlad yr Iâ", "name:da"=>"Island", "name:de"=>"Island", "name:el"=>"Ισλανδία", "name:en"=>"Iceland", "name:eo"=>"Islando", "name:es"=>"Islandia", "name:et"=>"Island", "name:fa"=>"ایسلند", "name:fi"=>"Islanti", "name:fr"=>"Islande", "name:fy"=>"Yslân", "name:ga"=>"An Íoslainn", "name:gd"=>"Innis Tìle", "name:he"=>"איסלנד", "name:hu"=>"Izland", "name:id"=>"Islandia", "name:is"=>"Ísland", "name:it"=>"Islanda", "name:ja"=>"アイスランド", "name:la"=>"Islandia", "name:lb"=>"Island", "name:li"=>"Iesland", "name:lt"=>"Islandija", "name:lv"=>"Īslande", "name:mn"=>"Исланд", "name:nb"=>"Island", "name:nl"=>"IJsland", "name:nn"=>"Island", "name:no"=>"Island", "name:pl"=>"Islandia", "name:ru"=>"Исландия", "name:sl"=>"Islandija", "name:sv"=>"Island", "name:th"=>"ประเทศไอซ์แลนด์", "name:tr"=>"İzlanda", "name:uk"=>"Ісландія", "name:vi"=>"Iceland", "name:zh"=>"冰岛", "name:haw"=>"‘Āina Hau", "name:zh_py"=>"Bingdao", "name:zh_pyt"=>"Bīngdǎo", "official_name"=>"Lýðveldið Ísland", "official_name:be"=>"Ісландыя", "official_name:el"=>"Δημοκρατία της Ισλανδίας", "official_name:en"=>"Republic of Iceland", "official_name:es"=>"República de Islandia", "official_name:id"=>"Republik Islandia", "official_name:it"=>"Repubblica d'Islanda", "official_name:ja"=>"アイスランド共和国", "official_name:lb"=>"Republik Island", "official_name:lt"=>"Islandijos Respublika", "official_name:lv"=>"Īslandes Republika", "official_name:pl"=>"Republika Islandii", "official_name:sv"=>"Republiken Island", "official_name:vi"=>"Cộng hòa Iceland"	is	134
lt	"name"=>"Lietuva", "name:af"=>"Litaue", "name:ar"=>"ليتوانيا", "name:be"=>"Літва", "name:br"=>"Lituania", "name:ca"=>"Lituània", "name:cy"=>"Lithwania", "name:da"=>"Litauen", "name:de"=>"Litauen", "name:el"=>"Λιθουανία", "name:en"=>"Lithuania", "name:eo"=>"Litovio", "name:es"=>"Lituania", "name:et"=>"Leedu", "name:fa"=>"لیتوانی", "name:fi"=>"Liettua", "name:fr"=>"Lituanie", "name:fy"=>"Litouwen", "name:ga"=>"An Liotuáin", "name:gd"=>"Liotuàinia", "name:he"=>"לטביה", "name:hr"=>"Litva", "name:hu"=>"Litvánia", "name:id"=>"Lituania", "name:is"=>"Litháen", "name:it"=>"Lituania", "name:ja"=>"リトアニア", "name:la"=>"Lituania", "name:lb"=>"Litauen", "name:li"=>"Litauwe", "name:lv"=>"Lietuva", "name:mn"=>"Литва", "name:nl"=>"Litouwen", "name:pl"=>"Litwa", "name:ru"=>"Литва", "name:sk"=>"Litva", "name:sl"=>"Litva", "name:sv"=>"Litauen", "name:th"=>"ประเทศลิทัวเนีย", "name:tr"=>"Litvanya", "name:uk"=>"Литва", "name:vi"=>"Litva", "name:zh"=>"立陶宛", "name:haw"=>"Lituania", "name:zh_py"=>"Litaowan", "name:zh_pyt"=>"Lìtáowǎn", "official_name"=>"Republic of Lithuania", "official_name:be"=>"Літоўская Рэспубліка", "official_name:el"=>"Δημοκρατία της Λιθουανίας", "official_name:en"=>"Republic of Lithuania", "official_name:es"=>"República de Lituania", "official_name:et"=>"Leedu Vabariik", "official_name:fr"=>"République de Lituanie", "official_name:id"=>"Republik Lituania", "official_name:it"=>"Repubblica di Lituania", "official_name:lt"=>"Lietuvos Respublika", "official_name:lv"=>"Lietuvas Republika", "official_name:pl"=>"Republika Litewska", "official_name:sk"=>"Litovská republika", "official_name:sv"=>"Republiken Litauen", "official_name:vi"=>"Cộng hòa Litva"	lt	67
lv	"name"=>"Latvija", "name:af"=>"Letland", "name:ar"=>"لاتفيا", "name:be"=>"Латвія", "name:br"=>"Latvia", "name:ca"=>"Letònia", "name:cy"=>"Latfia", "name:da"=>"Letland", "name:de"=>"Lettland", "name:el"=>"Λεττονία", "name:en"=>"Latvia", "name:eo"=>"Latvio", "name:es"=>"Letonia", "name:et"=>"Läti", "name:fa"=>"لتونی", "name:fi"=>"Latvia", "name:fr"=>"Lettonie", "name:fy"=>"Letlân", "name:ga"=>"An Laitvia", "name:gd"=>"An Laitbhe", "name:he"=>"לטביה", "name:hu"=>"Lettország", "name:id"=>"Latvia", "name:is"=>"Lettland", "name:it"=>"Lettonia", "name:ja"=>"ラトビア", "name:la"=>"Lettonia", "name:lb"=>"Lettland", "name:li"=>"Letland", "name:mn"=>"Латви", "name:nl"=>"Letland", "name:pl"=>"Łotwa", "name:ru"=>"Латвия", "name:sk"=>"Lotyšsko", "name:sv"=>"Lettland", "name:th"=>"ประเทศลัตเวีย", "name:tr"=>"Letonya", "name:uk"=>"Латвія", "name:vi"=>"Latvia", "name:zh"=>"拉脱维亚", "name:zh_py"=>"Latuoweiya", "name:zh_pyt"=>"Lātuōwéiyà", "official_name"=>"Latvijas Republika", "official_name:be"=>"Латвійская Рэспубліка", "official_name:el"=>"Δημοκρατία της Λεττονίας", "official_name:en"=>"Republic of Latvia", "official_name:es"=>"República de Letonia", "official_name:et"=>"Läti Vabariik", "official_name:id"=>"Republik Latvia", "official_name:it"=>"Repubblica di Lettonia", "official_name:lt"=>"Latvijos Respublika", "official_name:pl"=>"Republika Łotwy", "official_name:sk"=>"Lotyšská republika", "official_name:sv"=>"Republiken Lettland", "official_name:vi"=>"Cộng hòa Latvia"	lv	162
mm	"name"=>"Myanmar", "name:af"=>"Mianmar", "name:ar"=>"ميانمار", "name:be"=>"М'янма", "name:br"=>"Birmania", "name:ca"=>"Burma", "name:da"=>"Myanmar", "name:el"=>"Μιανμάρ", "name:en"=>"Myanmar", "name:eo"=>"Birmo", "name:et"=>"Birma", "name:fa"=>"میانمار", "name:fi"=>"Myanmar", "name:fr"=>"Birmanie", "name:fy"=>"Birma", "name:ga"=>"Maenmar", "name:gd"=>"Mianmar", "name:he"=>"מיאנמר", "name:hr"=>"Mijanmar (Burma)", "name:hu"=>"Mianmar", "name:is"=>"Mjanmar", "name:it"=>"Birmania", "name:la"=>"Birmania", "name:li"=>"Burma", "name:lt"=>"Mianmaras", "name:lv"=>"Mjanma", "name:mn"=>"Мьянмар", "name:pl"=>"Birma", "name:ru"=>"Мьянма", "name:sl"=>"Mjanmar", "name:sv"=>"Burma", "name:th"=>"ประเทศพม่า", "name:uk"=>"М'янма", "name:vi"=>"Myanma", "name:zh"=>"缅甸", "name:haw"=>"Puruma", "name:zh_py"=>"Miandian", "name:zh_pyt"=>"Miǎndiàn", "official_name:id"=>"Persatuan Myanmar", "official_name:it"=>"Myanmar", "official_name:lt"=>"Mianmaro Sąjunga", "official_name:lv"=>"Mjanmas Savienība", "official_name:pl"=>"Związek Myanmar", "official_name:sv"=>"Unionen Myanmar", "official_name:vi"=>"Liên bang Myanma"	my	148
mr	"name"=>"موريتانيا", "name:af"=>"Mauritanië", "name:ar"=>"موريتانيا", "name:be"=>"Маўрытанія", "name:br"=>"Maouritania", "name:ca"=>"Mauritània", "name:cy"=>"Mauritania", "name:da"=>"Mauretanien", "name:de"=>"Mauretanien", "name:el"=>"Μαυριτανία", "name:en"=>"Mauritania", "name:eo"=>"Maŭritanio", "name:es"=>"Mauritania", "name:et"=>"Mauritaania", "name:fa"=>"موریتانی", "name:fi"=>"Mauritania", "name:fr"=>"Mauritanie", "name:fy"=>"Mauritaanje", "name:ga"=>"An Mháratáin", "name:gd"=>"Moratainia", "name:he"=>"מאוריטניה", "name:hr"=>"Mauritanija", "name:hu"=>"Mauritánia", "name:id"=>"Mauritania", "name:is"=>"Máritanía", "name:it"=>"Mauritania", "name:ja"=>"モーリタニア", "name:la"=>"Mauritania", "name:lb"=>"Mauretanien", "name:li"=>"Mauretanië", "name:lt"=>"Mauritanija", "name:lv"=>"Mauritānija", "name:mn"=>"Мавритани", "name:nl"=>"Mauritanië", "name:pl"=>"Mauretania", "name:pt"=>"Mauritânia", "name:ru"=>"Мавритания", "name:sl"=>"Mavretanija", "name:sv"=>"Mauretanien", "name:th"=>"ประเทศมอริเตเนีย", "name:tr"=>"Moritanya", "name:uk"=>"Мавританія", "name:vi"=>"Mauritanie", "name:zh"=>"毛里塔尼亚", "name:haw"=>"Mauritania", "name:zh_py"=>"Maolitaniya", "name:zh_pyt"=>"Máolǐtǎníyà", "official_name"=>"الجمهورية الإسلامية الموريتانية", "official_name:be"=>"Маўрытанская Ісламская Рэспубліка", "official_name:br"=>"Republik islamek Maouritania", "official_name:ca"=>"República Islàmica de Mauritània", "official_name:el"=>"Ισλαμική Δημοκρατία της Μαυριτανίας", "official_name:en"=>"Islamic Republic of Mauritania", "official_name:et"=>"Mauritaania Islamivabariik", "official_name:id"=>"Republik Islam Mauritania", "official_name:ja"=>"モーリタニア・イスラム共和国", "official_name:lb"=>"Islamesch Republik Mauretanien", "official_name:lt"=>"Mauritanijos Islamo Respublika", "official_name:lv"=>"Mauritānijas Islāma Republika", "official_name:pt"=>"República Islâmica da Mauritânia", "official_name:sv"=>"Islamiska republiken Mauretanien", "official_name:vi"=>"Cộng hòa Hồi giáo Mauritanie"	fr	149
ms	"name"=>"Montserrat", "name:ar"=>"مونتسرات", "name:be"=>"Мансерат", "name:br"=>"Montserrat", "name:da"=>"Montserrat", "name:en"=>"Montserrat", "name:eo"=>"Moncerato", "name:es"=>"Montserrat", "name:fa"=>"مونتسرات", "name:fi"=>"Montserrat", "name:fr"=>"Montserrat", "name:ga"=>"Montsarat", "name:he"=>"מונטסראט", "name:hu"=>"Montserrat", "name:is"=>"Montserrat", "name:it"=>"Montserrat", "name:lt"=>"Montseratas", "name:lv"=>"Montserrata", "name:mn"=>"Монтсеррат", "name:pl"=>"Montserrat", "name:ru"=>"Монтсеррат", "name:sv"=>"Montserrat", "name:th"=>"มอนต์เซอร์รัต", "name:uk"=>"Монтсеррат", "name:zh"=>"蒙特塞拉特"	en	73
mx	"name"=>"México", "name:af"=>"Meksiko", "name:ar"=>"المكسيك", "name:be"=>"Мексіка", "name:br"=>"Mec’hiko", "name:ca"=>"Mèxic", "name:cy"=>"Mexico", "name:da"=>"Mexico", "name:de"=>"Mexiko", "name:el"=>"Μεξικό", "name:en"=>"Mexico", "name:eo"=>"Meksiko", "name:es"=>"México", "name:et"=>"Mehhiko", "name:fa"=>"مکزیک", "name:fi"=>"Meksiko", "name:fr"=>"Mexique", "name:fy"=>"Meksiko", "name:ga"=>"Meicsiceo", "name:gd"=>"Meagsago", "name:he"=>"מקסיקו", "name:hr"=>"Meksiko", "name:hu"=>"Mexikó", "name:id"=>"Meksiko", "name:is"=>"Mexíkó", "name:it"=>"Messico", "name:ja"=>"メキシコ", "name:la"=>"Mexicum", "name:lb"=>"Mexiko", "name:li"=>"Mexico", "name:lt"=>"Meksika", "name:lv"=>"Meksika", "name:mn"=>"Мексик", "name:nl"=>"Mexico", "name:pl"=>"Meksyk", "name:ru"=>"Мексика", "name:sl"=>"Mehika", "name:sv"=>"Mexiko", "name:th"=>"ประเทศเม็กซิโก", "name:tr"=>"Meksika", "name:uk"=>"Мексика", "name:zh"=>"墨西哥", "official_name"=>"Estados Unidos Mexicanos", "official_name:be"=>"Мексіканскія Злучаныя Штаты", "official_name:br"=>"Stadoù Unanet Mec’hiko", "official_name:el"=>"Ηνωμένες Πολιτείες του Μεξικού", "official_name:et"=>"Mehhiko Ühendriigid", "official_name:id"=>"Persatuan Negara-Negara Meksiko", "official_name:it"=>"Stati Uniti Messicani", "official_name:ja"=>"メキシコ合衆国", "official_name:lb"=>"Vereenegt mexikanesch Staaten", "official_name:lt"=>"Meksikos Jungtinės Valstijos", "official_name:lv"=>"Meksikas Savienotās Valstis", "official_name:pl"=>"Meksykańskie Stany Zjednoczone", "official_name:sv"=>"Mexikos förenta stater", "official_name:vi"=>"Liên bang México"	es	166
pe	"name"=>"Peru", "name:ar"=>"بيرو", "name:be"=>"Перу", "name:br"=>"Perou", "name:ca"=>"Perú", "name:cy"=>"Periw", "name:da"=>"Peru", "name:el"=>"Περού", "name:en"=>"Peru", "name:eo"=>"Peruo", "name:es"=>"Perú", "name:et"=>"Peruu", "name:fa"=>"پرو", "name:fi"=>"Peru", "name:fr"=>"Pérou", "name:fy"=>"Perû", "name:ga"=>"Peiriú", "name:gd"=>"Pearu", "name:he"=>"פרו", "name:hu"=>"Peru", "name:is"=>"Perú", "name:it"=>"Perù", "name:ja"=>"ペルー", "name:la"=>"Peruvia", "name:lv"=>"Peru", "name:mn"=>"Перу", "name:pl"=>"Peru", "name:ru"=>"Перу", "name:sk"=>"Peru", "name:sv"=>"Peru", "name:th"=>"ประเทศเปรู", "name:uk"=>"Перу", "name:zh"=>"秘鲁", "official_name"=>"República del Perú", "official_name:el"=>"Δημοκρατία του Περού", "official_name:et"=>"Peruu Vabariik", "official_name:fr"=>"République du Pérou", "official_name:id"=>"Republik Peru", "official_name:lb"=>"Republik Peru", "official_name:lt"=>"Peru Respublika", "official_name:lv"=>"Peru Republika", "official_name:sk"=>"Peruánska republika", "official_name:sv"=>"Republiken Peru", "official_name:vi"=>"Cộng hòa Peru"	es	51
pl	"name"=>"Polska", "name:af"=>"Pole", "name:ar"=>"بولندا", "name:be"=>"Польшча", "name:br"=>"Polonia", "name:ca"=>"Polònia", "name:cy"=>"Gwlad Pwyl", "name:da"=>"Polen", "name:de"=>"Polen", "name:el"=>"Πολωνία", "name:en"=>"Poland", "name:eo"=>"Pollando", "name:es"=>"Polonia", "name:et"=>"Poola", "name:fa"=>"لهستان", "name:fi"=>"Puola", "name:fr"=>"Pologne", "name:fy"=>"Poalen", "name:ga"=>"An Pholainn", "name:gd"=>"A' Phòlainn", "name:he"=>"פולין", "name:hr"=>"Poljska", "name:hu"=>"Lengyelország", "name:hy"=>"Լեհաստան", "name:id"=>"Polandia", "name:is"=>"Pólland", "name:it"=>"Polonia", "name:ja"=>"ポーランド", "name:la"=>"Polonia", "name:lb"=>"Polen", "name:li"=>"Pole", "name:lt"=>"Lenkija", "name:lv"=>"Polija", "name:mn"=>"Польш", "name:nl"=>"Polen", "name:no"=>"Polen", "name:pl"=>"Polska", "name:ru"=>"Польша", "name:sk"=>"Poľsko", "name:sl"=>"Poljska", "name:sv"=>"Polen", "name:th"=>"ประเทศโปแลนด์", "name:tr"=>"Polonya", "name:uk"=>"Польща", "name:vi"=>"Ba Lan", "name:zh"=>"波兰", "name:haw"=>"Pōlani", "name:zh_py"=>"Bolan", "name:zh_pyt"=>"Bōlán", "official_name"=>"Rzeczpospolita Polska", "official_name:be"=>"Рэспубліка Польшча", "official_name:el"=>"Δημοκρατία της Πολωνίας", "official_name:en"=>"Republic of Poland", "official_name:eo"=>"Pola Respubliko", "official_name:es"=>"República Polaca", "official_name:et"=>"Poola Vabariik", "official_name:fr"=>"République de Pologne", "official_name:it"=>"Repubblica di Polonia", "official_name:ja"=>"ポーランド共和国", "official_name:lt"=>"Lenkijos Respublika", "official_name:nl"=>"Republiek Polen", "official_name:ru"=>"Респу́блика По́льша", "official_name:sk"=>"Poľská republika", "official_name:sv"=>"Republiken Polen", "official_name:vi"=>"Cộng hòa Ba Lan"	pl	168
sa	"name"=>"Saudi Arabia / السعودية", "name:af"=>"Saoedi-Arabië", "name:ar"=>"المملكة العربية السعودية", "name:be"=>"Саудаўская Аравія", "name:br"=>"Arabia Saoudat", "name:ca"=>"Aràbia Saudita", "name:da"=>"Saudi-Arabien", "name:de"=>"Saudi-Arabien", "name:el"=>"Σαουδική Αραβία", "name:en"=>"Saudi Arabia", "name:eo"=>"Saŭda Arabio", "name:es"=>"Arabia Saudita", "name:et"=>"Saudi Araabia", "name:fa"=>"عربستان سعودی", "name:fi"=>"Saudi-Arabia", "name:fr"=>"Arabie saoudite", "name:fy"=>"Saûdi-Araabje", "name:ga"=>"An Araib Shádach", "name:gd"=>"Saud-Aràibia", "name:he"=>"ערב הסעודית", "name:hr"=>"Saudijska Arabija", "name:hu"=>"Szaúd-Arábia", "name:id"=>"Arab Saudi", "name:is"=>"Sádí-Arabía", "name:it"=>"Arabia Saudita", "name:ja"=>"サウジアラビア", "name:la"=>"Arabia Saudiana", "name:lb"=>"Saudi-Arabien", "name:li"=>"Saoedi-Arabië", "name:lt"=>"Saudo Arabija", "name:mn"=>"Саудын Араб", "name:nl"=>"Saoedi-Arabië", "name:pl"=>"Arabia Saudyjska", "name:pt"=>"Arábia Saudita", "name:ru"=>"Саудовская Аравия", "name:sl"=>"Saudova Arabija", "name:sv"=>"Saudiarabien", "name:th"=>"ประเทศซาอุดีอาระเบีย", "name:tr"=>"Suudi Arabistan", "name:uk"=>"Саудівська Аравія", "name:vi"=>"Ả Rập Saudi", "name:zh"=>"沙特阿拉伯", "name:haw"=>"Saudi ʻAlapia", "name:zh_py"=>"Shate Alabo", "name:zh_pyt"=>"Shātè Ālābó", "official_name:af"=>"Koninkryk van Saoedi-Arabië", "official_name:br"=>"Rouantelezh Arabia Saoudat", "official_name:el"=>"Βασίλειο της Σαουδικής Αραβίας", "official_name:en"=>"Kingdom of Saudi Arabia", "official_name:et"=>"Saudi Araabia Kuningriik", "official_name:fr"=>"Royaume d'Arabie saoudite", "official_name:id"=>"Kerajaan Arab Saudi", "official_name:it"=>"Regno arabo saudita", "official_name:lb"=>"Kinnekräich Saudi-Arabien", "official_name:lt"=>"Saudo Arabijos Karalystė", "official_name:pl"=>"Królestwo Arabii Saudyjskiej", "official_name:pt"=>"Reino da Arábia Saudita", "official_name:sv"=>"Konungariket Saudiarabien", "official_name:vi"=>"Vương quốc Ả Rập Saudi"	ar	52
sr	"name"=>"Suriname", "name:ar"=>"سورينام", "name:be"=>"Сурынам", "name:br"=>"Surinam", "name:ca"=>"Surinam", "name:da"=>"Surinam", "name:el"=>"Σουρινάμ", "name:en"=>"Suriname", "name:eo"=>"Surinamo", "name:es"=>"Surinam", "name:fa"=>"سورینام", "name:fi"=>"Suriname", "name:fr"=>"Suriname", "name:ga"=>"Suranam", "name:gd"=>"Suranam", "name:he"=>"סורינאם", "name:hr"=>"Surinam", "name:hu"=>"Suriname", "name:hy"=>"Սուրինամ", "name:is"=>"Súrínam", "name:ja"=>"スリナム", "name:la"=>"Surinamia", "name:lt"=>"Surinamas", "name:mn"=>"Суринам", "name:pl"=>"Surinam", "name:ru"=>"Суринам", "name:sl"=>"Surinam", "name:sv"=>"Surinam", "name:th"=>"ประเทศซูรินาเม", "name:tr"=>"Surinam", "name:uk"=>"Суринам", "name:zh"=>"苏里南", "official_name"=>"Republiek van Suriname", "official_name:be"=>"Рэспубліка Сурынам", "official_name:el"=>"Δημοκρατία του Σουρινάμ", "official_name:en"=>"Republic of Suriname", "official_name:es"=>"República de Surinam", "official_name:id"=>"Republik Suriname", "official_name:lb"=>"Republik Suriname", "official_name:lt"=>"Surinamo Respublika", "official_name:pl"=>"Republika Surinam", "official_name:sv"=>"Republiken Surinam"	nl	24
ss	"name"=>"South Sudan", "name:ar"=>"جنوب السودان", "name:br"=>"Soudan ar Su", "name:cs"=>"Jižní Súdán", "name:de"=>"Südsudan", "name:en"=>"South Sudan", "name:es"=>"Sudán del Sur", "name:et"=>"Lõuna-Sudaan", "name:fa"=>"سودان جنوبی", "name:fr"=>"Sud-Soudan", "name:hr"=>"Južni Sudan", "name:ku"=>"Sûdana Başûr", "name:ru"=>"Южный Судан", "name:sk"=>"Južný Sudán", "name:sl"=>"Južni Sudan", "name:tl"=>"Timog Sudan", "name:vi"=>"Nam Sudan", "name:zh"=>"南蘇丹", "int_name"=>"South Sudan", "name:ast"=>"Sudán del Sur", "official_name"=>"Republic of South Sudan", "official_name:br"=>"Republik Soudan ar Su", "official_name:cs"=>"Republika Jižní Súdán", "official_name:de"=>"Republik Südsudan", "official_name:en"=>"Republic of South Sudan", "official_name:es"=>"República de Sudán del Sur", "official_name:fr"=>"République du Sud-Soudan", "official_name:hr"=>"Republika Južni Sudan", "official_name:ku"=>"Komara Sûdana Başûr", "official_name:sk"=>"Juhosudánska republika", "official_name:tl"=>"Republika ng Timog Sudan"	en	247
sy	"name"=>"Sūriyya سوريا", "name:af"=>"Sirië", "name:ar"=>"سوريا", "name:be"=>"Сірыя", "name:br"=>"Siria", "name:ca"=>"Síria", "name:da"=>"Syrien", "name:de"=>"Syrien", "name:el"=>"Συρία", "name:en"=>"Syria", "name:eo"=>"Sirio", "name:es"=>"Siria", "name:fa"=>"سوریه", "name:fi"=>"Syyria", "name:fr"=>"Syrie", "name:fy"=>"Syrje", "name:ga"=>"An tSiria", "name:gd"=>"Siria", "name:he"=>"סוריה", "name:hr"=>"Sirija", "name:hu"=>"Szíria", "name:id"=>"Suriah", "name:is"=>"Sýrland", "name:it"=>"Siria", "name:ja"=>"シリア", "name:la"=>"Syria", "name:lb"=>"Syrien", "name:li"=>"Syrië", "name:lt"=>"Sirija", "name:lv"=>"Sīrija", "name:mn"=>"Сири", "name:nl"=>"Syrië", "name:pl"=>"Syria", "name:pt"=>"Síria", "name:ru"=>"Сирия", "name:sl"=>"Sirija", "name:sv"=>"Syrien", "name:th"=>"ประเทศซีเรีย", "name:tr"=>"Suriye", "name:uk"=>"Сирія", "name:vi"=>"Syria", "name:zh"=>"叙利亚", "name:haw"=>"Suria", "name:zh_py"=>"Xuliya", "name:zh_pyt"=>"Xùlìyà", "official_name:br"=>"Republik Arab Siria", "official_name:ca"=>"República Àrab Siriana", "official_name:el"=>"Αραβική Δημοκρατία της Συρίας", "official_name:gd"=>"Poblachd Arabach Shirianach", "official_name:id"=>"Republik Arab Suriah", "official_name:it"=>"Repubblica Araba di Siria", "official_name:lb"=>"Arabesch Republik Syrien", "official_name:lt"=>"Sirijos Arabų Respublika", "official_name:pl"=>"Syryjska Republika Arabska", "official_name:pt"=>"República Árabe da Síria", "official_name:ru"=>"Сирийская Арабская Республика", "official_name:sv"=>"Arabrepubliken Syrien"	ar	104
vn	"name"=>"Việt Nam", "name:af"=>"Viëtnam", "name:ar"=>"فييت نام", "name:be"=>"В'етнам", "name:br"=>"Viêt Nam", "name:ca"=>"Vietnam", "name:cy"=>"Fiet Nam", "name:da"=>"Vietnam", "name:de"=>"Vietnam", "name:el"=>"Βιετνάμ", "name:en"=>"Vietnam", "name:eo"=>"Vjetnamio", "name:es"=>"Vietnam", "name:et"=>"Vietnam", "name:fa"=>"ویتنام", "name:fi"=>"Vietnam", "name:fr"=>"Viêt Nam", "name:fy"=>"Fietnam", "name:ga"=>"Vítneam", "name:gd"=>"Bhiet-Nam", "name:he"=>"ויאטנם", "name:hr"=>"Vietnam", "name:hu"=>"Vietnam", "name:hy"=>"Վիետնամ", "name:id"=>"Vietnam", "name:is"=>"Víetnam", "name:it"=>"Vietnam", "name:ja"=>"ベトナム", "name:la"=>"Vietnamia", "name:lb"=>"Vietnam", "name:li"=>"Viëtnam", "name:lt"=>"Vietnamas", "name:lv"=>"Vjetnama", "name:mn"=>"Вьетнам", "name:nl"=>"Vietnam", "name:pl"=>"Wietnam", "name:pt"=>"Vietnã", "name:ru"=>"Вьетнам", "name:sl"=>"Vietnam", "name:sv"=>"Vietnam", "name:th"=>"ประเทศเวียดนาม", "name:tr"=>"Vietnam", "name:uk"=>"В'єтнам", "name:vi"=>"Việt Nam", "name:zh"=>"越南", "name:haw"=>"Wiekanama", "name:zh_py"=>"Yuenan", "name:zh_pyt"=>"Yuènán", "official_name"=>"Cộng Hòa Xã Hội Chủ Nghĩa Việt Nam", "official_name:be"=>"В'етнам ", "official_name:ca"=>"República Socialista del Vietnam", "official_name:el"=>"Σοσιαλιστική Δημοκρατία του Βιετνάμ", "official_name:et"=>"Vietnami Sotsialistlik Vabariik", "official_name:id"=>"Republik Sosialis Vietnam", "official_name:it"=>"Repubblica Socialista del Vietnam", "official_name:ja"=>"ベトナム社会主義共和国", "official_name:lb"=>"Sozialistesch Republik Vietnam", "official_name:pl"=>"Socjalistyczna Republika Wietnamu", "official_name:pt"=>"República Socialista do Vietnã", "official_name:sv"=>"Socialistiska republiken Vietnam"	vi	75
xk	"name"=>"Kosova", "name:am"=>"ኮሶቮ", "name:ar"=>"كوسوفو", "name:az"=>"Kosovo", "name:bg"=>"Косово", "name:bn"=>"কসোভো", "name:bo"=>"ཁོ་སོ་ཝོ།", "name:bs"=>"Kosovo", "name:ca"=>"Kosovo", "name:ce"=>"Косово", "name:cv"=>"Косово", "name:da"=>"Kosovo", "name:de"=>"Kosovo", "name:el"=>"Κόσοβο", "name:en"=>"Kosovo", "name:eo"=>"Kosovo", "name:eu"=>"Kosovo", "name:fr"=>"Kosovo", "name:fy"=>"Kosovo", "name:ga"=>"An Chosaiv", "name:gl"=>"Kosovo", "name:he"=>"קוסובו", "name:hr"=>"Kosovo", "name:hu"=>"Koszovó", "name:hy"=>"Կոսովոն", "name:ja"=>"コソボ", "name:ka"=>"კოსოვო", "name:kn"=>"ಕೊಸೊವೊ", "name:ko"=>"코소보", "name:mk"=>"Косово", "name:my"=>"ကိုဆိုဗို", "name:nl"=>"Kosovo", "name:ny"=>"Kosovo", "name:pl"=>"Kosowo", "name:pt"=>"Kosovo", "name:ru"=>"Косово", "name:sk"=>"Kosovo", "name:sl"=>"Kosovo", "name:sq"=>"Kosova", "name:sr"=>"Косово", "name:ta"=>"கொசோவோ", "name:tr"=>"Kosova", "name:uk"=>"Косово", "name:ur"=>"کوسووہ", "name:zh"=>"科索沃", "alt_name"=>"Dardania", "int_name"=>"Kosovo", "name:ceb"=>"Kosovo", "name:kbd"=>"Косово", "name:tzl"=>"Kosove", "name:xmf"=>"კოსოვო", "short_name"=>"Kosova", "name:zh-yue"=>"科索沃", "name:sr-Latn"=>"Kosovo", "official_name"=>"Republika e Kosovës", "short_name:en"=>"Kosovo", "official_name:de"=>"Republik Kosovo", "official_name:eo"=>"Respubliko Kosovo", "official_name:pl"=>"Republika Kosowa", "official_name:sq"=>"Republika e Kosovës"	\N	59
\.

CREATE INDEX idx_country_name_country_code ON country_name USING btree (country_code);
